ALTER PROCEDURE SP_CALC_ALL_CH(HDR_ID INTEGER)
 AS
 BEGIN EXIT; END;

/* empty dependent procedure body */
/* Clear: SP_ZS_SET_ZACHET for: SP_CALC_ALL */
ALTER PROCEDURE SP_ZS_SET_ZACHET(HDR_ID INTEGER)
 AS
 BEGIN EXIT; END;

/* empty dependent procedure body */
/* Clear: SP_ZSD_LIST_CREATE for: SP_CALC_ALL */
ALTER PROCEDURE SP_ZSD_LIST_CREATE(ZS_ID INTEGER)
 AS
 BEGIN EXIT; END;

/* Alter (SP_CALC_ALL) */
ALTER PROCEDURE SP_CALC_ALL(ZS_ID INTEGER)
 AS
declare variable TAR DM_MONEY_15_2;
declare variable DATE1 DM_DATE;
declare variable Q_U integer;
declare variable TAR_USL DM_MONEY_15_2;
declare variable TARGET integer;
declare variable IDB integer;
declare variable SUM_USLF DM_MONEY_15_2;
declare variable SEX char(1);
declare variable PTYPE integer;
declare variable AGE_Y integer;
declare variable AGE_GRP integer;
declare variable HDR_ID integer;
declare variable TROMB_CODE DM_CHAR_20;
declare variable TAR_USL_DOP DM_MONEY_15_2;
declare variable SUM_USLF_DOP DM_MONEY_15_2;
begin
  select z.date_2, z.q_u, z.target, p.sex, z.payment_type_id, extract(year from z.date_2) - extract(year from p.dr), z.hdr_id
  from zs z
  join patients p on p.id = z.patient_id
  where z.id = :zs_id
  into :date1, :q_u, :target, :sex, :ptype, :age_y, :hdr_id;

  if (:ptype in (2,3)) then exit;

  if (:target in (9,10,11,12,13,14,15,16,17)) then
  begin
   if ((select coalesce(t.days_cnt,0) from h_target t where t.id = :target) <> 0) then
   begin
    update zsd d
     set d.zachet = 1
     where d.date_1 < (:date1 - (select t.days_cnt from h_target t where t.id = :target)) and d.zs_id = :zs_id;

    update zsd d
     set d.zachet = 0
     where d.date_1 >= (:date1 - (select t.days_cnt from h_target t where t.id = :target)) and d.zs_id = :zs_id;
   end

   update zsd d
    set d.k_uslf = 0
    where (d.zachet = 1 or d.is_no_get_usl = 1) and d.zs_id = :zs_id;
  end

  update zsd d
    set d.tar_usl = null,
        d.sum_uslf = null,
        d.comment_local = null,
        d.dop_tarif = null,
        d.dop_sum = null
    where d.zs_id = :zs_id;

  update zs z
    set z.tar_usl = null,
        z.sum_usl = null,
        z.sum_uslf = null
    where z.id = :zs_id;

  if ((select coalesce(i.is_nz,0) from invoice i join zs_hdr h on h.name = i.id where h.id = :hdr_id) = 1) then
  begin
    if (target in (9,10,11,13,14,15,16,17)) then exit;

    tar = (select first 1 s.tarif from h_tarif_nz s where s.q_u = iif(:q_u = 4,2,:q_u) and :date1 between s.bp and s.epv);

    if (q_u = 1) then
      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf =:tar
      where d.zs_id = :zs_id and d.code_usl is null;
    else
      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf =:tar
      where d.zs_id = :zs_id;

    if (q_u = 4) then
      update zs z
      set z.tar_usl = :tar,
        z.sum_uslf = z.dcount*:tar
      where id = :zs_id;
    else
    if (q_u = 1) then
      update zs z
      set z.tar_usl = :tar,
        z.sum_uslf = :tar
      where id = :zs_id;
    else
      update zs z
      set z.tar_usl = :tar,
          z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
      where id = :zs_id;
    exit;
  end
   /********************,    ************************/
  if (:q_u = 2 and :target not in (9,10,11,12,13,14,15,16,17,21,22) and (:date1 < '01.01.2018')) then
  begin
    for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin

          select first 1 h.tarif, h.tarif
          from zs a
           join zsd b on a.id = b.zs_id
           join h_tarif_app_tgroup t on a.date_2 between t.bp and t.epv
           join h_tarif_app h on h.tg = t.tg
                                 and a.date_2 between h.bp and h.epv
                                 and (h.target = iif(a.for_pom = 2, 1, 0))
                                 and cast(h.code_spec as varchar(10)) = iif(coalesce(a.vbr,0) = 0, iif(b.code_spec = '16' and a.age < 18, '22', b.code_spec), 0)
           where b.id = :idb
           order by h.target nulls last
           into :tar, :sum_uslf;

          update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0)
           where b.id = :idb;
        end

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce(:sum_uslf, 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;
    exit;
  end

  if (:q_u = 2 and :target not in (9,10,11,12,13,14,15,16,17,21,22) and (:date1 >= '01.01.2018')) then
  begin
    for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin
          select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
          from zs a
           join zsd b on a.id = b.zs_id
           join h_usl u on u.code = coalesce(b.code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                           and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1
           where b.id = :idb and b.code_usl is not null and coalesce(u.sumf,0) > 0
           into :tar, :sum_uslf;

          tar_usl_dop = null;
          sum_uslf_dop = null;

          if ((select d.dop_code_usl from zsd d where d.id = :idb) is not null) then
              select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
              from zs a
               join zsd b on a.id = b.zs_id
               join h_usl u on u.code = coalesce(b.dop_code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                               and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1 and u.finans_type is not null
               where b.id = :idb and b.dop_code_usl is not null and coalesce(u.sumf,0) > 0
               into :tar_usl_dop, :sum_uslf_dop;

          if (:tar is null) then
          select first 1 h.tarif, h.tarif
          from zs a
           join zsd b on a.id = b.zs_id
           join h_tarif_app_tgroup t on a.date_2 between t.bp and t.epv
           join h_tarif_app h on h.tg = t.tg
                                 and a.date_2 between h.bp and h.epv
                                 and (h.target = iif(a.for_pom = 2, 1, 0))
           join h_tarif_app_spec n on n.name_id = h.name_id
                                 and n.code_spec_v021 = iif(coalesce(a.vbr,0) = 0, iif(b.code_spec_v021 = 39 and a.age < 18, 49, b.code_spec_v021), 0)
           where b.id = :idb
           order by h.target nulls last
           into :tar, :sum_uslf;

          update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0),
           b.dop_tarif = coalesce(:tar_usl_dop,0),
           b.dop_sum = coalesce(:sum_uslf_dop,0)
           where b.id = :idb;

          tar = null;
          sum_uslf = null;
        end

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id) + (select sum(coalesce(b.dop_sum,0)) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce(:sum_uslf, 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;
    exit;
  end  

  /********************************************/
  if (:q_u = 4) then
  begin
    tar = (select s.tarif from h_tarif_stom s where :date1 between s.bp and s.epv);

    update zsd d
    set d.tar_usl = :tar,
        d.sum_uslf = d.k_uslf*:tar
    where d.zs_id = :zs_id;
    
    update zs z
    set z.tar_usl = :tar,
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;
  end

  /******************** ************************/
  if (:q_u = 5) then
  begin
--    if (:date1 >= '01.01.2018') then tromb_code = 'A25.30.036';
--    else tromb_code = 'A25.30.035';
    tromb_code = coalesce((select first 1 code_usl from zsd d where d.zs_id = :zs_id and coalesce(code_usl, '') <> ''),'');

    tar = (select s.tarif from h_tarif_smp s where :date1 between s.bp and s.epv);
    tar_usl = coalesce((select coalesce(u.sumf,0) from h_usl u where u.code = :tromb_code
               and u.q_u containing '5' and :date1 between u.datebeg and u.dateend),0);

    update zsd d
    set d.tar_usl = iif(coalesce(d.code_usl,'') = '', :tar, :tar_usl),
        d.sum_uslf = d.k_uslf*iif(coalesce(d.code_usl,'') = '', :tar, :tar_usl)
    where d.zs_id = :zs_id;
    
    update zs z
    set z.tar_usl = (select max(tar_usl) from zsd where zs_id = :zs_id),
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;
  end

  /******************** ************************/
  if ((:q_u = 1) and ((select 1 from zs z where coalesce(z.metod_hmp,0) > 0 and id = :zs_id) = 1)) then
  begin
    select first 1 v.tarif
    from zs z
         join h_metod_hmp h on h.code = z.metod_hmp and z.date_2 between h.bp and h.epv
         join h_tarif_vmp v on v.tg = h.tg and z.date_2 between v.bp and v.epv
    where z.id = :zs_id
    into :tar;

    update zs a set
        a.tar_usl = :tar,
        a.sum_uslf = :tar,
        a.ksg = null,
        a.kslp = null
    where a.id = :zs_id;

    update zsd b set
          b.ksg = null,
          b.sum_uslf = :tar,
          b.kskp = 0,
          b.tar_usl = :tar
    where b.zs_id = :zs_id and coalesce(b.code_usl,'') = '' and b.date_1 = (select min(date_1) from zsd where zs_id = :zs_id and coalesce(code_usl,'') = '');

    exit;
  end

  /********************************************/
  if (:q_u in (1,3) and :date1 < '01.01.2018') then
    execute procedure SP_CALC_STAC(:zs_id);
  else
    if (:q_u in (1,3) and :date1 >= '01.01.2018') then
      execute procedure sp_calc_stac_2018(:zs_id);

  /****************  ***********************************************/
  if (q_u <> 4) then
  begin
  tar = null;
  sum_uslf = null;
  for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin
          select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
          from zs a
           join zsd b on a.id = b.zs_id
           join h_usl u on u.code = coalesce(b.code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                           and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1
           where b.id = :idb and b.code_usl is not null and coalesce(u.sumf,0) > 0
           into :tar, :sum_uslf;

          tar_usl_dop = null;
          sum_uslf_dop = null;

          if ((select d.dop_code_usl from zsd d where d.id = :idb) is not null) then
              select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
              from zs a
               join zsd b on a.id = b.zs_id
               join h_usl u on u.code = coalesce(b.dop_code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                               and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1 and u.finans_type is not null
               where b.id = :idb and b.dop_code_usl is not null and coalesce(u.sumf,0) > 0
               into :tar_usl_dop, :sum_uslf_dop;

          if (coalesce(:tar,0) > 0) then
          update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0),
           b.dop_tarif = coalesce(:tar_usl_dop,0),
           b.dop_sum = coalesce(:sum_uslf_dop,0)
           where b.id = :idb;

          tar = null;
          sum_uslf = null;
        end

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id) + (select sum(coalesce(b.dop_sum,0)) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce(:sum_uslf, 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;
   end

  /*********************-*********************************/
  if ((:q_u = 2) and (:target in (21,22))) then
  begin
   for select b.id
    from zsd b
    join zs z on z.id = b.zs_id
    where z.id = :zs_id
    into :idb
    do
    begin
      tar = (select first 1 t.tarif
             from zsd d
                  join h_tomo_code c on c.nms_code = d.code_usl
                  join h_tarif_tomo t on t.group_num = c.group_num and d.date_2 between t.bp and t.epv
             where d.id = :idb);

      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf = :tar
      where d.id = :idb;
    end

    update zs z
    set z.tar_usl = (select sum(tar_usl) from zsd where zs_id = :zs_id),
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;

    exit;
  end
  /******************** - 9  ************************/
  if (:q_u = 2 and :target = 9) then
  begin
    execute procedure sp_calc_app_t09(:zs_id);
    exit;
  end

  /******************** - 10,17  -  ************************/
    if (q_u = 2 and target in (10,17)) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_10 d on d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and :age_y between d.y1 and d.y2
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = coalesce(b.k_uslf * :tar, 0),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end

  /******************** - 13  ************************/
    if (q_u = 2 and target = 13) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                           and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_13_17 d on d.target = a.target
                                          and d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and d.age_grp = a.age_grp
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = coalesce(b.k_uslf * :tar, 0),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end

  /******************** - 14,15  ,  ************************/
    if (q_u = 2 and target in (14,15)) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_14_15 d on d.target = a.target
                                          and d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and d.cat_info = a.cat_info
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = coalesce(b.k_uslf * :tar, 0),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end
  /******************** - 16  ************************/
    if (q_u = 2 and target = 16) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join zs_hdr h on h.id = a.hdr_id
                   join patients p on p.id = a.patient_id
                   join h_tarif_disp_16 d on a.date_2 between d.bp and d.epv
                                          and d.sex = :sex
                                          and cast(d.code_usl as varchar(20)) = b.code_usl
                                          and d.age_l <= (h.y - extract(year from p.dr)) and d.age_r >= (h.y - extract(year from p.dr))
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = coalesce(b.k_uslf * :tar, 0),
               b.tar_base = coalesce(:tar, 0) ,
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end
end;

/* Alter (SP_CALC_ALL_CH) */
ALTER PROCEDURE SP_CALC_ALL_CH(HDR_ID INTEGER)
 AS
declare variable ZID integer;
begin

 for select z.id
  from zs z
  where z.hdr_id = :hdr_id
  into :zid
  do
    execute procedure SP_CALC_ALL(:ZID);

  update invoice i
  set i.sumv = (select sum(z.sum_uslf) from zs z where z.hdr_id = :hdr_id),
      i.sump = (select sum(z.sum_usl) from zs z where z.hdr_id = :hdr_id)
  where i.id = (select name from zs_hdr h where h.id = :hdr_id);
end;

/* empty dependent procedure body */
/* Clear: SP_CALC_STAC_2018 for: SP_CALC_STAC_KSKP_2019 */
ALTER PROCEDURE SP_CALC_STAC_2018(IDA INTEGER)
 AS
 BEGIN EXIT; END;

/* Alter (SP_CALC_STAC_KSKP_2019) */
ALTER PROCEDURE SP_CALC_STAC_KSKP_2019(IDA INTEGER,
IDB INTEGER,
KSG DM_CHAR_20,
CL_CNT INTEGER)
 RETURNS(KSKP TYPE OF DM_NUM_3_2)
 AS
declare variable KSKP1 type of DM_NUM_3_2;
declare variable KSKP2 type of DM_NUM_3_2;
declare variable KSKP3 type of DM_NUM_3_2;
declare variable KSKP4 type of DM_NUM_3_2;
declare variable KSKP5 type of DM_NUM_3_2;
declare variable KSKP6 type of DM_NUM_3_2;
declare variable KSKP7 type of DM_NUM_3_2;
declare variable KSLP12 DM_NUM_3_2;
declare variable KSLP13 DM_NUM_3_2;
declare variable KSLP14 DM_NUM_3_2;
begin

 kskp6 = 1;

 select
       --    
       iif((a.q_u = 1) and (a.age < 1) and ((select first 1 d.ksg from h_ksg_dop d where d.type_num = 2 and a.date_2 between d.bp and d.epv and d.q_u = 1 and d.ksg = :ksg) is null),
           (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 1 and a.date_2 between t.bp and t.epv), 1),
       iif((a.q_u = 1) and (a.age >= 1) and (a.age < 4), (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 2  and a.date_2 between t.bp and t.epv), 1),
       iif((a.q_u = 1) and (a.age < 4 and a.age < 18 and coalesce(a.chield_with_rop,0) = 1), (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 3  and a.date_2 between t.bp and t.epv), 1),
       iif((a.q_u = 1) and (a.age >= 75) and ((select first 1 d.ksg from h_ksg_dop d where d.type_num = 3 and a.date_2 between d.bp and d.epv and d.q_u = 1 and d.ksg = :ksg) is null),
            (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 4  and a.date_2 between t.bp and t.epv), 1),    -- 4
       iif((a.q_u = 1) and (a.ds1 <> 'R54' and a.ds2 = 'R54' and exists(select first 1 id from zsd b where b.zs_id = a.id and b.profil_k = 16) and
           ((select first 1 d.ksg from h_ksg_dop d where d.type_num = 4 and a.date_2 between d.bp and d.epv and d.q_u = 1 and d.ksg = :ksg) is null)),
            (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 5  and a.date_2 between t.bp and t.epv), 1), --5
       iif((a.q_u = 3) and exists(select b.code_usl from zsd b where b.zs_id = a.id and b.code_usl in ('A25.20.004.001', 'A11.20.019', 'A11.20.028')),
            (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 69  and a.date_2 between t.bp and t.epv), 1),
       iif((a.q_u = 3) and exists(select b.code_usl from zsd b where b.zs_id = a.id and b.code_usl in ('A11.20.017.001')),
            (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 74  and a.date_2 between t.bp and t.epv), 1),
       iif((a.q_u = 3) and exists(select b.code_usl from zsd b where b.zs_id = a.id and b.code_usl in ('A11.20.030.001')),
            (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 75  and a.date_2 between t.bp and t.epv), 1)
  from zs a
  join patients p on p.id = a.patient_id
  left join zs_hdr h on h.id = a.hdr_id
  left join invoice i on i.id = h.name
  where a.id = :ida
  into :kskp1, :kskp2, :kskp3, :kskp4, :kskp5, :kslp12, :kslp13, :kslp14;

     if (((select z.q_u from zs z where id = :ida)) = 1) then
     begin
         if (idb is not null) then
          select
                --  
                case
                  when (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) > 30 and ((select d.ksg from h_ksg_dop d where d.type_num = 5 and a.date_2 between d.bp and d.epv and d.q_u = 1 and d.ksg = :ksg) is null)) then
                        case
                          when (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) - coalesce(b.orit,0)) >= coalesce(b.orit,0) then 1 + (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) - 30) * 0.25 / 30
                          else 1 + (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) - 30) * 0.4 / 30
                        end
                  when (b.k_uslf > 45 and ((select d.ksg from h_ksg_dop d where d.type_num = 5 and a.date_2 between d.bp and d.epv and d.q_u = 1 and d.ksg = :ksg) is not null)) then
                        case
                          when (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) - coalesce(b.orit,0)) >= coalesce(b.orit,0) then 1 + (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) - 45) * 0.25 / 45
                          else 1 + (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) - 45) * 0.4 / 45
                        end
                  else 1
                end
           from zs a
           join zsd b on a.id = b.zs_id
           where b.id = :idb
           into :kskp6;
    
    
         kskp = kskp1 + (kskp2-1) + (kskp3-1) + (kskp4-1) + (kskp5-1);
         if (kskp > 1.8) then
          kskp = 1.8;
         kskp = kskp + (kskp6-1);
         
         delete from kslp_koef where zs_id = :ida and ksg = :ksg;
         
         if (:kskp1 <> 1) then
             insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
                values (1, :kskp1, :ida, :ksg);
         if (:kskp2 <> 1) then
             insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
                values (2, :kskp2, :ida, :ksg);
         if (:kskp3 <> 1) then
             insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
                values (3, :kskp3, :ida, :ksg);
         if (:kskp4 <> 1) then
             insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
                values (4, :kskp4, :ida, :ksg);
         if (:kskp5 <> 1) then
             insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
                values (5, :kskp5, :ida, :ksg);
         if (:kskp6 <> 1) then
             insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
                values (6, :kskp6, :ida, :ksg);
    end
    else
    begin
      delete from kslp_koef where zs_id = :ida and ksg = :ksg;
         
     if (:kslp12 <> 1) then
         insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
            values (69, :kslp12, :ida, :ksg);
     if (:kslp13 <> 1) then
         insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
            values (74, :kslp13, :ida, :ksg);
     if (:kslp14 <> 1) then
         insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
            values (75, :kslp14, :ida, :ksg);

     kskp = kslp12 + (kslp13-1) + (kslp14-1);
    end
    suspend;        
end;

/* empty dependent procedure body */
/* Clear: SP_CALC_STAC for: SP_KSG_GET */
ALTER PROCEDURE SP_CALC_STAC(IDA INTEGER)
 AS
 BEGIN EXIT; END;

/* Alter (SP_KSG_GET) */
ALTER PROCEDURE SP_KSG_GET(DS1 TYPE OF DM_DS,
DR DATE,
DATE2 TYPE OF DM_DATE,
CODE_USL TYPE OF DM_CHAR_20,
SEX TYPE OF DM_SEX,
K_USLF TYPE OF DM_NUM_6_2,
Q_U INTEGER,
DS2 DM_DS,
IDB INTEGER = null,
DOP_CRITERION DM_CHAR_10 = null,
DOP_CRITERION2 DM_CHAR_10 = null)
 RETURNS(KSG DM_CHAR_20,
ERR_CODE INTEGER)
 AS
declare variable TMP_GRP_ID integer;
declare variable RC integer;
declare variable NEED_STEP_1 integer;
declare variable NEED_STEP_2 type of DM_BOOLEAN;
declare variable KSG_TER DM_CHAR_20;
declare variable KSG_SURG DM_CHAR_20;
declare variable Y integer;
declare variable IDA integer;
begin
     ksg = null;
     ksg_ter = null;
     ksg_surg = null;
     err_code = null;
     tmp_grp_id = gen_id(GEN_KSG_TMP_GROUP_ID, 1);
     y = extract(year from :date2);
     ida = (select first 1 d.zs_id from zsd d where d.id = :idb);
     --- 
     if (:code_usl in ('A25.20.004.001', 'A11.20.019', 'A11.20.028', 'A11.20.031', 'A11.20.017.001', 'A11.20.030.001')) then
       code_usl = 'A11.20.017';
     /*******     00-80**************************/
--     if (y = 2018) then
--     begin
--       if ((substring(:ds1 from 1 for 1) = 'C') and (substring(:ds1 from 2 for 1) <= 8)) then
--         is_c00_c80 = 1;
--       else
--         is_c00_c80 = 0;
--     end
--     else
--       is_c00_c80 = 0;
     /**********************************************************************/

--     if (y < 2017) then
--     if (:ds1 starting 'C') then
--      if (not exists(select 1 from ksg_grp g where g.nms_code = :code_usl and g.ds <> 'C.'
--                and :date2 between g.bp and g.epv
--                and coalesce(g.age_grp,0) = iif(g.age_grp is not null, iif((:date2-:dr)/365.25 < 18, 4, 5) , 0) )) then
--        ds1 = 'C.';
--     if (y >= 2017) then
--     if (:ds1 starting 'C' and :dop_criterion is null) then
--      if (not exists(select 1 from ksg_grp g where g.nms_code = :code_usl and g.ds <> 'C.'
--                and :date2 between g.bp and g.epv
--                and coalesce(g.age_grp,0) = iif(g.age_grp is not null, iif((:date2-:dr)/365.25 < 18, 5, 6) , 0) )) then
--        ds1 = 'C.';
--------------------------------------------------------------------------------
     --       ()
     if (y < 2017) then
     select
           case
             when t1.ao_code = 'T7' then '216'
             when (t1.ao_code between 'T1' and 'T6') and (t2.ao_code between 'T1' and 'T6') and (t1.ao_code <> t2.ao_code) then '216'
             else null
           end
      from zsd b
      left join h_tarif_polytrauma t1 on t1.ds = b.ds and :date2 between t1.bp and t1.epv
      left join h_tarif_polytrauma t2 on t2.ds = b.ds2 and :date2 between t2.bp and t2.epv
      where b.id = :idb and b.ds3 in ('J94.2','J94.8','J94.9','J93','J93.0','J93.1','J93.8','J93.9', 'J96.0', 'N17', 'T79.4', 'R57.1', 'R57.8')
      into :ksg;

     if (y = 2017) then
      select
           case
             when t1.ao_code = 'T7' then '216'
             when (t1.ao_code between 'T1' and 'T6') and (t2.ao_code between 'T1' and 'T6') and (t1.ao_code <> t2.ao_code) then '220'
             else null
           end
      from zs_ds d
      left join h_tarif_polytrauma t1 on t1.ds = d.ds and :date2 between t1.bp and t1.epv
      left join h_tarif_polytrauma t2 on t2.ds = d.ds and :date2 between t2.bp and t2.epv
      where d.section = 1 and d.section_id = :ida and d.ds in ('J94.2','J94.8','J94.9','J93','J93.0','J93.1','J93.8','J93.9', 'J96.0', 'N17', 'T79.4', 'R57.1', 'R57.8')
      into :ksg;

     if (y = 2018) then
      select
           case
             when t1.ao_code = 'T7' then '216'
             when (t1.ao_code between 'T1' and 'T6') and (t2.ao_code between 'T1' and 'T6') and (t1.ao_code <> t2.ao_code) then '233'
             else null
           end
      from zs_ds d
      left join h_tarif_polytrauma t1 on t1.ds = d.ds and :date2 between t1.bp and t1.epv
      left join h_tarif_polytrauma t2 on t2.ds = d.ds and :date2 between t2.bp and t2.epv
      where d.section = 1 and d.section_id = :ida and d.ds in ('J94.2','J94.8','J94.9','J93','J93.0','J93.1','J93.8','J93.9', 'J96.0', 'N17', 'T79.4', 'R57.1', 'R57.8')
      into :ksg;

     if (y = 2019) then
      select
           case
             when t1.ao_code = 'T7' then 'st29.007'
             when (t1.ao_code between 'T1' and 'T6') and (t2.ao_code between 'T1' and 'T6') and (t1.ao_code <> t2.ao_code) then 'st29.007'
             else null
           end
      from zs_ds d
      left join h_tarif_polytrauma t1 on t1.ds = d.ds and :date2 between t1.bp and t1.epv
      left join h_tarif_polytrauma t2 on t2.ds = d.ds and :date2 between t2.bp and t2.epv
      where d.section = 1 and d.section_id = :ida and d.ds in ('J94.2','J94.8','J94.9','J93','J93.0','J93.1','J93.8','J93.9', 'J96.0', 'N17', 'T79.4', 'R57.1', 'R57.8')
      into :ksg;

     if (ksg is not null) then
     begin
       suspend;
       exit;
     end
--------------------------------------------------------------------------------

     if (:code_usl starting 'A18') then --
     begin
       ksg = null;
       exit;
     end

--------------------------------------------------------------------------------
     --  1.    
     need_step_1 = (select first 1 1 from ksg_grp m where m.ds = :ds1 and m.q_u = :q_u and :date2 between m.bp and m.epv);

     -- 1
     if (need_step_1 = 1) then
     begin
       insert into KSG_TMP (ID, KSG, NMS_CODE, KZ, GROUP_CODE, STEP_NUM, AGE_GRP, DAYS, SEX, DS, DOP_CRITERIAN, dop_criterian2)
          select h.id, h.ksg, h.nms_code, k.kz, :tmp_grp_id, 1, h.age_grp, h.days, h.sex, h.ds, h.dop_criterion, h.dop_criterion2
           from ksg_grp h
           join h_ksg k on k.ksg = h.ksg and :date2 between k.bp and k.epv
           where ((h.ds = :ds1) or ((select IS_LIKE from SP_CHECK_DS_GRP(h.ds, :ds1)) = 1))
--                 and (h.nms_code is null or h.nms_code = :code_usl)
                 and :date2 between h.bp and h.epv
                 and h.q_u = k.q_u and h.q_u = :q_u
                 and iif(h.ds2 is not null, h.ds2, :ds2) is not distinct from :ds2;

  
       rc = row_count;

       if (rc = 1) then
        ksg_ter = (select t.ksg from KSG_TMP t where t.group_code=:tmp_grp_id and t.step_num=1);
  
       --  .
       if ((rc > 1) and (:y < 2017)) then
        select ERR_CODE, KSG from SP_KSG_TMP_CRITERION(:tmp_grp_id, 1, :date2, :dr, :k_uslf, :sex)
         into :err_code, :ksg_surg;
       if ((rc > 1) and (:y >= 2017)) then
        select ERR_CODE, KSG from SP_KSG_TMP_CRITERION_2017(:tmp_grp_id,1, :date2, :dr, :k_uslf, :sex, :dop_criterion, :code_usl, :ds1, :dop_criterion2)
         into :err_code, :ksg_ter;

       /*$$IBEC$$ if (rc = 0) then
       begin
                --      " "  ...
         insert into KSG_TMP (ID, KSG, NMS_CODE, KZ, GROUP_CODE, STEP_NUM, AGE_GRP, DAYS, SEX, DS, DOP_CRITERIAN)
        select h.id, h.ksg, h.nms_code, k.kz, :tmp_grp_id, 1, h.age_grp, h.days, h.sex, h.ds, h.dop_criterion
         from ksg_grp h
         join h_ksg k on k.ksg = h.ksg and :date2 between k.bp and k.epv
         where ((h.ds = :ds1) or (h.ds = iif(:is_c00_c80 = 1, 'C00-C80', :ds1)))
               and (h.nms_code is not distinct from :code_usl)
               and :date2 between h.bp and h.epv
               and h.q_u = k.q_u and h.q_u = :q_u
               and iif(h.ds2 is not null, h.ds2, :ds2) is not distinct from :ds2;
  
         rc = row_count;
         if (rc = 0) then
          err_code = 1;  --      
       end $$IBEC$$*/
  

     end
--------------------------------------------------------------------------------
     -- 2 ,    ...
     if ((err_code is not null and code_usl is not null) and
        exists(select first 1 1 from ksg_grp m where m.nms_code = :code_usl
               and m.q_u = :q_u and :date2 between m.bp and m.epv)) then
       err_code = null;

     need_step_2 = iif(err_code is null and code_usl is not null, 1, 0);
--      ...        ,  2  
     if (need_step_2 = 1) then
      if (:code_usl = (select t.nms_code from KSG_TMP t where t.group_code = :tmp_grp_id)) then
       need_step_2 = 0;

     --  2.    
     if (need_step_2 = 1) then
     begin
       insert into KSG_TMP (ID, KSG, NMS_CODE, KZ, GROUP_CODE, STEP_NUM, AGE_GRP, DAYS, SEX, DS, DOP_CRITERIAN, dop_criterian2)
        select h.id, h.ksg, h.nms_code, k.kz, :tmp_grp_id, 2, h.age_grp, h.days, h.sex, h.ds, h.dop_criterion, h.dop_criterion2
         from ksg_grp h
         join h_ksg k on k.ksg = h.ksg and :date2 between k.bp and k.epv
--         join ksg_factors kf on kf.ksg_id = k.id and kf.q_u = k.q_u
         where h.nms_code = :code_usl --and (h.ds is null or h.ds = :ds1)
               and :date2 between h.bp and h.epv
               and h.q_u = k.q_u and h.q_u  = :q_u
               and iif(h.ds2 is not null, h.ds2, :ds2) is not distinct from :ds2;

       rc = row_count;
       if (rc = 1) then
        ksg_surg = (select t.ksg from KSG_TMP t where t.group_code=:tmp_grp_id and t.step_num=2);

       --    
       if ((rc > 1) and (:y < 2017)) then
        select ERR_CODE, KSG from SP_KSG_TMP_CRITERION(:tmp_grp_id, 2, :date2, :dr, :k_uslf, :sex)
         into :err_code, :ksg_surg;
       if ((rc > 1) and (:y >= 2017)) then
        select ERR_CODE, KSG from SP_KSG_TMP_CRITERION_2017(:tmp_grp_id, 2, :date2, :dr, :k_uslf, :sex, :dop_criterion, :code_usl,:ds1, :dop_criterion2)
         into :err_code, :ksg_surg;
     end
--------------------------------------------------------------------------------
    --  3   

    if ((ksg_surg is not null) or (ksg_ter is not null)) then
    begin
      rc = (select count(*) from KSG_TMP t where t.group_code = :tmp_grp_id);
      if (rc = 1) then
       ksg = coalesce(ksg_ter, ksg_surg);
      if (rc = 2) then
      begin
        --   .  .  -  .
        if (exists(select 1 from ksg_dont_choice d
                    where d.ksg_ter = :ksg_ter and d.ksg_surg = :ksg_surg and :date2 between d.bp and d.epv) and (:q_u = 1)) then
         ksg = ksg_surg; else
         -- ...   . 
         ksg = (select first 1 t.ksg from KSG_TMP t where t.group_code=:tmp_grp_id
                 order by t.kz desc);
      end 

      err_code = null;
    end
--------------------------------------------------------------------------------
     -- 216.      
     if (ksg is null and err_code is null and ((select first 1 id from h_tarif_dializ d where :date2 between d.bp and d.epv and d.code_usl = :code_usl) is null)) then
      err_code = 1;

     delete from KSG_TMP t
      where t.group_code = :tmp_grp_id;

     if (err_code is not null) then
         update zsd d
         set d.comment_local = (select name from h_errors where ID = :err_code)
         where d.id = :idb;

     suspend;
end;

/* Alter (SP_ZS_SET_ZACHET) */
ALTER PROCEDURE SP_ZS_SET_ZACHET(HDR_ID INTEGER)
 AS
declare variable ZS_ID integer;
declare variable DATE1 DM_DATE;
begin
  for select z.id, z.date_1
      from zs z
      where z.hdr_id = :hdr_id
      into :zs_id, :date1
      do
      begin
        update zsd d
         set d.zachet = 1
         where d.zs_id = :zs_id and d.date_1 < :date1;

        execute procedure SP_CALC_ALL(:ZS_ID);
      end
end;

/* Alter (SP_ZSD_LIST_CREATE) */
ALTER PROCEDURE SP_ZSD_LIST_CREATE(ZS_ID INTEGER)
 AS
declare variable TARGET integer;
begin
  target = (select target from zs where id = :zs_id);

  if (exists (select id from zsd where zs_id = :zs_id)) then
   exit;

  if (target = 9) then
  begin
      insert into zsd(zs_id, code_usl, is_chield, pmd_close, date_1, date_2, sum_uslf, tar_usl, k_uslf, ds, IS_TEMP)
      select z.id, d.code_usl, 0, 0, z.date_1, z.date_1, d.tarif, d.tarif, 1, 'Z00.8', 1
       from zs z
            join patients p on p.id = z.patient_id
            join h_tarif_disp_09 d on d.stage = z.disp_stage and d.age = extract(year from z.date_1) - extract(year from p.dr)
                                      and d.sex = p.sex and z.date_2 between d.bp and d.epv
       where z.id = :zs_id and d.code_usl is not null and d.tarif is not null;
  end

  if (target in (10,17)) then
  begin
      insert into zsd(zs_id, code_usl, is_chield, pmd_close, date_1, date_2, sum_uslf, tar_usl, k_uslf, ds, IS_TEMP)
      select z.id, d.usl_code, 0, 0, z.date_1, z.date_1, d.tarif, d.tarif, 1, iif(z.age < 3, 'Z00.1', iif(z.age >= 3 and z.age < 15, 'Z00.2', 'Z00.3')), 1
       from zs z
            join patients p on p.id = z.patient_id
            join h_tarif_disp_10 d on d.stage = z.disp_stage and d.sex = p.sex
                                          and z.date_2 between d.bp and d.epv
                                          and z.age between d.y1 and d.y2
       where z.id = :zs_id and d.tarif is not null;
  end

  if (target = 13) then
  begin
      insert into zsd(zs_id, code_usl, is_chield, pmd_close, date_1, date_2, sum_uslf, tar_usl, k_uslf, ds, IS_TEMP)
      select z.id, d.usl_code, 0, 0, z.date_1, z.date_1, d.tarif, d.tarif, 1, iif(z.age < 3, 'Z00.1', iif(z.age >= 3 and z.age < 15, 'Z00.2', 'Z00.3')), 1
       from zs z
            join patients p on p.id = z.patient_id
            join h_tarif_disp_13_17 d on d.target = z.target
                                          and d.stage = z.disp_stage and d.sex = p.sex
                                          and z.date_2 between d.bp and d.epv
                                          and d.age_grp = z.age_grp
       where z.id = :zs_id and d.tarif is not null;
  end

  if (target in (14,15)) then
  begin
      insert into zsd(zs_id, code_usl, is_chield, pmd_close, date_1, date_2, sum_uslf, tar_usl, k_uslf, ds, IS_TEMP)
      select z.id, d.usl_code, 0, 0, z.date_1, z.date_1, d.tarif, d.tarif, 1, iif(z.age < 3, 'Z00.1', iif(z.age >= 3 and z.age < 15, 'Z00.2', 'Z00.3')),1
       from zs z
            join patients p on p.id = z.patient_id
            join h_tarif_disp_14_15 d on d.target = z.target
                                          and d.stage = z.disp_stage and d.sex = p.sex
                                          and z.date_2 between d.bp and d.epv
                                          and d.cat_info = z.cat_info
       where z.id = :zs_id and d.tarif is not null;
  end

  if (target = 16) then
  begin
      insert into zsd(zs_id, code_usl, is_chield, pmd_close, date_1, date_2, sum_uslf, tar_usl, k_uslf, ds, IS_TEMP)
      select z.id, d.code_usl, 0, 0, z.date_1, z.date_1, d.tarif, d.tarif, 1, 'Z00.8', 1
       from zs z
            join patients p on p.id = z.patient_id
            join zs_hdr h on h.id = z.hdr_id
            join h_tarif_disp_16 d on z.date_2 between d.bp and d.epv
                                          and d.sex = p.sex
                                          and d.age_l <= (h.y - extract(year from p.dr)) and d.age_r >= (h.y - extract(year from p.dr))
       where z.id = :zs_id and d.tarif is not null;
  end

  insert into ZS_DS (DS, DS_TYPE, SECTION, SECTION_ID, PR, IS_TEMP)
    select d.ds, 1, 2, d.id, 0, 1
    from zsd d
    where d.zs_id = :zs_id;

  execute procedure SP_CALC_ALL(:ZS_ID);
end;

/* Restore proc. body: SP_CALC_STAC */
ALTER PROCEDURE SP_CALC_STAC(IDA INTEGER)
 AS
declare variable KSG type of DM_CHAR_50;
declare variable DS type of DM_DS;
declare variable IDB integer;
declare variable SUM_USLF type of DM_MONEY;
declare variable KSKP type of DM_NUM_3_2;
declare variable Q_U integer;
declare variable FINE_KOEF type of DM_NUM_3_2;
declare variable TARIF numeric(15,6);
declare variable Y integer;
declare variable TARIF_USL DM_MONEY;
declare variable DATE2 date;
declare variable IS_TRANSFER DM_INT;
declare variable CL_CNT integer;
declare variable ERR_CODE integer;
declare variable K_DOWN DM_NUM_6_2;
begin
     cl_cnt = (select count(distinct b.ds_class) from ZSD b where b.ZS_ID = :ida);
     is_transfer = (select sum(iif(b.code_usl is null, 1, 0)) from ZSD b where b.ZS_ID = :ida);

     select a.q_u, extract(year from a.date_2), a.date_2
      from zs a
      where a.id = :ida
      into :q_u, :y, :date2;

     for select sp.KSG, sp.ERR_CODE, b.ds, b.id, coalesce(bs.tarif * k.k_down * k.kz *
                iif((select 1 from h_ksg_dop d where d.type_num = 1 and a.date_2 between d.bp and d.epv and d.q_u = a.q_u and d.ksg = sp.ksg) IS NULL , lf.kus, 1.0), 0)
      from zs a
      join zsd b on a.id = b.zs_id
      join patients p on p.id = a.patient_id
      join lpu_factors lf on lf.q_u = a.q_u and a.date_2 between lf.bp and lf.epv
      join h_tarif_bs bs on bs.q_u = a.q_u and a.date_2 between bs.bp and bs.epv
      left join sp_ksg_get(b.ds, p.dr, a.date_2, b.code_usl, p.sex, b.k_uslf, a.q_u, b.ds2, b.id) sp on 1=1
      left join h_ksg k on k.ksg = sp.ksg and a.date_2 between k.bp and k.epv and k.q_u = a.q_u
      where b.zs_id = :ida
      into :ksg, :err_code, :ds, :idb, :tarif
      do
      begin
        kskp = 1;
        fine_koef = null;

        if ((q_u = 1) and (y < 2017)) then
          kskp = (select KSKP from SP_CALC_STAC_KSKP(:ida, :idb, :ksg, :cl_cnt));
        if ((q_u = 1) and (y >= 2017) and (y < 2018)) then
          kskp = (select KSKP from sp_calc_stac_kskp_2017(:ida, :idb, :ksg, :cl_cnt));
--        if ((q_u = 1) and (y >= 2018)) then
--          kskp = (select KSKP from sp_calc_stac_kskp_2018(:ida, :idb, :ksg, :cl_cnt));

        fine_koef = (select FINE_KOEF from sp_calc_stac_fine(:ida, :idb, :ksg, :cl_cnt));

        sum_uslf = cast(tarif * kskp * fine_koef as int);

        update zsd b set
         b.ksg_base = :ksg,
         b.tar_base = cast(:tarif as integer),
         b.sum_base = :sum_uslf,
         b.kskp_base = :kskp
         where b.id = :idb;
      end 
--------------------------------------------------------------------------------
      --    6  + 
      if (q_u = 1) then
       if (exists (select 1 from zsd b where b.zs_id = :ida and ((b.ksg in (2) and b.k_uslf >= 6) or (b.ksg in ('O14.1','O34.2','O36.3','O36.4','O42.2') and b.k_uslf >= 2) ))
          and exists (select 1 from zsd b where b.zs_id = :ida and b.ksg in (4, 5))) then
          begin
            --    
            select first 1 b.ksg_base, b.ds
            from zs a
             join zsd b on a.id = b.zs_id
             where b.zs_id = :ida and b.ksg in (4, 5)
             into :ksg, :ds;
       
            update zsd d
            set d.tar_usl = d.tar_base,
                d.sum_uslf = d.sum_base,
                d.ksg = d.ksg_base,
                d.kskp = d.kskp_base
            where d.zs_id = :ida;

            --   
            select coalesce(sum(b.sum_uslf), 0) from zsd b where b.zs_id = :ida
             into :sum_uslf;
    
            update zs a set
             a.tar_usl = :tarif,
             a.sum_uslf = :sum_uslf,
             a.sum_usl = :sum_uslf,
             a.ksg = :ksg,
             a.ds1 = :ds,
             a.kslp = :kskp
             where a.id = :ida;

            exit;
          end
--------------------------------------------------------------------------------
      if ((is_transfer < 2) or (cl_cnt < 2))  then  --   
      begin
        --     
        select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base
         from zsd b
         where b.zs_id = :ida
         order by b.tar_base desc
         into :idb, :ksg, :sum_uslf, :tarif;

         --      
         update zsd b set
          b.ksg = :ksg, 
          b.sum_uslf = :sum_uslf,
          b.kskp = b.kskp_base,
          b.tar_usl = b.tar_base
          where b.id = :idb;

         update zsd b set
          b.ksg = null,
          b.sum_uslf = 0,
          b.kskp = 1,
          b.tar_usl = 0
          where b.id <> :idb and b.zs_id = :ida;
 
         update zs a set
          a.tar_usl = :tarif,
          a.sum_uslf = :sum_uslf,
          a.sum_usl = :sum_uslf,
          a.ksg = :ksg,
          a.kslp = :kskp
          where a.id = :ida;
 
      end else
      begin
        select first 1 b.ksg_base, b.sum_base
        from zs a
         join zsd b on a.id = b.zs_id
         where b.zs_id = :ida and b.ksg is not null and b.ds = a.ds1
         order by b.sum_base desc
         into :ksg, :sum_uslf;

        update zsd d
         set d.tar_usl = d.tar_base,
             d.sum_uslf = d.sum_base,
             d.ksg = d.ksg_base,
             d.kskp = d.kskp_base
         where d.zs_id = :ida;
   
        select coalesce(sum(b.sum_uslf), 0), coalesce(sum(b.tar_base), 0) from zsd b
         join zs a on a.id = b.zs_id
         where b.zs_id = :ida and b.ksg is not null
         into :sum_uslf, :tarif;

        update zs a set
         a.tar_usl = :tarif,
         a.sum_uslf = :sum_uslf,
         a.sum_usl = :sum_uslf,
         a.ksg = :ksg,
         a.kslp = :kskp
         where a.id = :ida;
 
      end

      ---------------------------------------------------------------------------------
      --   2016 
      if (exists(select first 1 1 from zsd b
                  join h_tarif_dializ d on d.code_usl = b.code_usl and b.date_2 between d.bp and d.epv
                  and d.q_u containing :q_u where b.zs_id = :ida) and :y = 2016) then
      begin
         for select d.tarif, b.id
             from zsd b
                  join h_tarif_dializ d on d.code_usl = b.code_usl and d.bp <= :date2 and d.epv >= :date2 and d.q_u containing :q_u
             where b.zs_id = :ida
             into :tarif_usl, :idb
             do
             begin
               update zsd b
               set b.sum_uslf = :tarif_usl,
                   b.tar_usl = :tarif_usl
               where b.id = :idb;

               update zs a set
                  a.tar_usl = iif (coalesce(a.tar_usl,0) = 0, :sum_uslf, a.tar_usl),
                  a.sum_uslf = a.sum_uslf + :tarif_usl,
                  a.sum_usl = a.sum_usl + :tarif_usl
                  where a.id = :ida;
 
               update zs a set
                  a.tar_usl = cast(a.sum_uslf/coalesce(a.k_uslf, 1) as integer)
                  where a.id = :ida;

             end
         exit;
      end

end;

/* Restore proc. body: SP_CALC_STAC_2018 */
ALTER PROCEDURE SP_CALC_STAC_2018(IDA INTEGER)
 AS
declare variable KSG type of DM_CHAR_50;
declare variable DS type of DM_DS;
declare variable IDB integer;
declare variable SUM_USLF type of DM_MONEY;
declare variable KSKP type of DM_NUM_3_2;
declare variable Q_U integer;
declare variable FINE_KOEF type of DM_NUM_3_2;
declare variable TARIF numeric(15,6);
declare variable Y integer;
declare variable TARIF_USL DM_MONEY;
declare variable DATE2 date;
declare variable IS_TRANSFER DM_INT;
declare variable CL_CNT integer;
declare variable ERR_CODE integer;
declare variable K_DOWN DM_NUM_6_2;
declare variable DS_CLASS DM_CHAR_10;
declare variable KZ DM_NUM_2_5;
declare variable KD DM_NUM_2_5;
declare variable KUS DM_NUM_2_5;
declare variable BS DM_NUM_6_2;
declare variable PROF_NUM integer;
declare variable DATE1 date;
declare variable CODE_USL DM_CHAR_20;
declare variable FINE_KOEF_SET_DOCTOR DM_BOOLEAN;
declare variable IS_ROUND_JANAO integer;
begin
    if (((select first 1 c.org_code from contragents c where c.type_id = 1))  starting '83' ) then
      is_round_janao = 1;

    update zsd d
      set d.ds_class = (select MKB_CLASS from SP_GET_MKB_CLASS(D.ds))
      where d.zs_id = :ida;

    update zsd d
     set d.ksg = null, 
         d.ksg_base = null,
         d.tar_base = null,
         d.sum_base = null,
         d.kskp_base = null,
         d.sum_uslf = 0,
         d.tar_usl = 0,
         d.comment_local = null
     where d.zs_id = :ida;

     cl_cnt = (select count(distinct b.ds_class) from ZSD b where b.ZS_ID = :ida);
     is_transfer = (select sum(iif(b.code_usl is null, 1, 0)) from ZSD b where b.ZS_ID = :ida);
     delete from kslp_koef where zs_id = :ida ;

     select a.q_u, extract(year from a.date_2), a.date_2, coalesce(a.fine_koef_set_doctor,0)
      from zs a
      where a.id = :ida
      into :q_u, :y, :date2, :fine_koef_set_doctor;

     for select sp.KSG, sp.ERR_CODE, b.ds, b.id, coalesce(cast(bs.tarif * kd.kd as int) * k.k_down * k.kz *
                iif((select 1 from h_ksg_dop d where d.type_num = 1 and a.date_2 between d.bp and d.epv and d.q_u = a.q_u and d.ksg = sp.ksg) IS NULL , lf.kus, 1.0), 0),
                k.kz, kd.kd,
                iif((select 1 from h_ksg_dop d where d.type_num = 1 and a.date_2 between d.bp and d.epv and d.q_u = a.q_u and d.ksg = sp.ksg) IS NULL , lf.kus, 1.0),
                bs.tarif, k.k_down, k.prof_num, b.date_1, coalesce(b.code_usl,''), coalesce(b.fine_koef,1)
      from zs a
      join zsd b on a.id = b.zs_id
      join patients p on p.id = a.patient_id
      join lpu_factors lf on lf.q_u = a.q_u and a.date_2 between lf.bp and lf.epv
      join h_tarif_bs bs on bs.q_u = a.q_u and a.date_2 between bs.bp and bs.epv
      join h_tarif_kd kd on a.date_2 between kd.bp and kd.epv
      left join sp_ksg_get(b.ds, p.dr, a.date_2, b.code_usl, p.sex,
                           (select sum(b1.k_uslf) from ZSD b1 where b1.ZS_ID = :ida and b1.ds_class = b.ds_class and b1.code_usl is null), -- -     
                           a.q_u, b.ds2, b.id, b.ksg_criterion,b.ksg_criterion2) sp on 1=1
      left join h_ksg k on k.ksg = sp.ksg and a.date_2 between k.bp and k.epv and k.q_u = a.q_u
      where b.zs_id = :ida
      order by b.code_usl
      into :ksg, :err_code, :ds, :idb, :tarif, :kz, :kd, :kus, :bs, :k_down, :prof_num, :date1, :code_usl, :fine_koef
      do
      begin
        kskp = 1;
--        fine_koef = null;

        if ((q_u = 1) and (err_code is null) and (date2 < '01.01.2019')) then
          kskp = (select KSKP from sp_calc_stac_kskp_2018(:ida, :idb, :ksg, :cl_cnt));

        if ((q_u in (1,3)) and (err_code is null) and (date2 >= '01.01.2019')) then
          kskp = (select KSKP from sp_calc_stac_kskp_2019(:ida, :idb, :ksg, :cl_cnt));

        if (fine_koef_set_doctor = 0) then
          fine_koef = (select FINE_KOEF from sp_calc_stac_fine_2018(:ida, :idb, :ksg, :cl_cnt));

        if (is_round_janao = 1) then
          sum_uslf = cast(cast(tarif * kskp as int) * fine_koef as int);
        else
          sum_uslf = tarif * kskp * fine_koef;

        if (:ksg is not null) then
        begin
            if (:code_usl <> '') then
            begin
                select first 1 d.id, iif(:fine_koef_set_doctor = 1, d.fine_koef, :fine_koef)
                from zs z
                     join zsd d on d.zs_id = z.id
                where d.zs_id = :ida and coalesce(d.code_usl,'') = ''
                       and :date1 between d.date_1 and d.date_2
                       and not exists(select id from zsd d2 where d2.zs_id = :ida and coalesce(d2.code_usl,'') = '' and d2.date_1 = d.date_2)
                into :idb, :fine_koef;

                if (is_round_janao = 1) then
                  sum_uslf = cast(cast(tarif * kskp as int) * fine_koef as int);
                else
                  sum_uslf = tarif * kskp * fine_koef;
            end

            if ((select first 1 d.id from zsd d where d.zs_id = :ida and d.ksg_base = :ksg) is null) then
            update zsd b set
             b.ksg_base = :ksg,
             b.tar_base = iif(:date2 >= '01.05.2018', iif(:is_round_janao = 1, cast(:tarif * coalesce(kskp,1) as int), :tarif * coalesce(kskp,1)), iif(:is_round_janao = 1, cast(:tarif as integer), :tarif)),
             b.sum_base = :sum_uslf,
             b.kskp_base = :kskp,
             b.koef_z = :kz, 
             b.koef_d = :kd,
             b.koef_u = :kus,
             b.bs = :bs,
             b.koef_up = :k_down,
             b.reab = iif(:prof_num = 37,1,null),
             b.fine_koef = :fine_koef
             where b.id = :idb;
         end
      end 
--------------------------------------------------------------------------------
      --    6  + 
      if (q_u = 1) then
       if (exists (select 1 from zsd b where b.zs_id = :ida and ((b.ksg in ('2','st02.001') and b.k_uslf >= 6) or (b.ksg in ('O14.1','O34.2','O36.3','O36.4','O42.2') and b.k_uslf >= 2) ))
          and exists (select 1 from zsd b where b.zs_id = :ida and b.ksg in ('4', '5', 'st02.003', 'st02.004'))) then
          begin
            --    
            select first 1 b.ksg_base, b.ds
            from zs a
             join zsd b on a.id = b.zs_id
             where b.zs_id = :ida and b.ksg in ('4', '5', 'st02.003', 'st02.004')
             into :ksg, :ds;
       
            update zsd d
            set d.tar_usl = d.tar_base,
                d.sum_uslf = d.sum_base,
                d.ksg = d.ksg_base,
                d.kskp = d.kskp_base
            where d.zs_id = :ida;

            --   
            select coalesce(sum(b.sum_uslf), 0) from zsd b where b.zs_id = :ida
             into :sum_uslf;
    
            update zs a set
             a.tar_usl = :tarif,
             a.sum_uslf = :sum_uslf,
             a.sum_usl = :sum_uslf,
             a.ksg = :ksg,
             a.ds1 = :ds,
             a.kslp = :kskp
             where a.id = :ida;

            exit;
          end
--------------------------------------------------------------------------------
      if ((is_transfer < 2) or (cl_cnt < 2))  then  --   
      begin
        --     ,   
        ksg = null;
        select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base
             from zsd b
             where b.zs_id = :ida and b.ksg_base is not null and ((:q_u = 1 and b.ksg_base >= '325' and b.ksg_base <= '343') or
                                                                                                  (:q_u = 3 and b.ksg_base >= '123' and b.ksg_base <= '134'))
             order by b.code_usl desc, b.sum_base desc
             into :idb, :ksg, :sum_uslf, :tarif;

        if (:ksg is null)  then
         select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base
             from zsd b
             where b.zs_id = :ida and b.ksg_base is not null
             order by b.code_usl desc, b.sum_base desc
             into :idb, :ksg, :sum_uslf, :tarif;

         --      
         update zsd b set
          b.ksg = :ksg, 
          b.sum_uslf = :sum_uslf,
          b.kskp = b.kskp_base,
          b.tar_usl = b.tar_base
          where b.id = :idb;

         update zsd b set
          b.ksg = null,
          b.sum_uslf = 0,
          b.kskp = 1,
          b.tar_usl = 0
          where b.id <> :idb and b.zs_id = :ida;
 
         update zs a set
          a.tar_usl = :tarif,
          a.sum_uslf = :sum_uslf,
          a.sum_usl = :sum_uslf,
          a.ksg = :ksg,
          a.kslp = :kskp
          where a.id = :ida;
 
      end else
      begin
        for select d.ds_class
         from zsd d
         where d.zs_id = :ida
         group by 1
         into :ds_class
         do
         begin
            if (((select count(dc.id) from ksg_dont_choice dc join zsd z on z.ksg_base = dc.ksg_ter or z.ksg_base = dc.ksg_surg
                    where z.zs_id = :ida and z.ds_class = :ds_class and :date2 between dc.bp and dc.epv) > 0) and (:q_u = 1)) then
               --    
            select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base
             from zsd b
             where b.zs_id = :ida and b.ksg_base is not null and b.ds_class = :ds_class and b.code_usl is not null
             order by b.code_usl desc, b.sum_base desc
             into :idb, :ksg, :sum_uslf, :tarif;
            else
               --     
            select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base
             from zsd b
             where b.zs_id = :ida and b.ksg_base is not null and b.ds_class = :ds_class
             order by b.code_usl desc, b.sum_base desc
             into :idb, :ksg, :sum_uslf, :tarif;
    
             --      
             update zsd b set
              b.ksg = :ksg, 
              b.sum_uslf = :sum_uslf,
              b.kskp = b.kskp_base,
              b.tar_usl = b.tar_base
              where b.id = :idb;
    
             update zsd b set
              b.ksg = null,
              b.sum_uslf = 0,
              b.kskp = 1,
              b.tar_usl = 0
              where b.id <> :idb and b.zs_id = :ida and b.ds_class = :ds_class;
         end

        select first 1 b.ksg_base, b.sum_base
        from zs a
         join zsd b on a.id = b.zs_id
         where b.zs_id = :ida and b.ksg is not null and b.ds = a.ds1
         order by b.sum_base desc
         into :ksg, :sum_uslf;

--        update zsd d
--         set d.tar_usl = d.tar_base,
--             d.sum_uslf = d.sum_base,
--             d.ksg = d.ksg_base,
--             d.kskp = d.kskp_base
--         where d.zs_id = :ida;
   
        select coalesce(sum(b.sum_uslf), 0), coalesce(sum(b.tar_base), 0)
         from zsd b
         join zs a on a.id = b.zs_id
         where b.zs_id = :ida and b.ksg is not null
         into :sum_uslf, :tarif;

        update zs a set
         a.tar_usl = :tarif,
         a.sum_uslf = :sum_uslf,
         a.sum_usl = :sum_uslf,
         a.ksg = :ksg,
         a.kslp = :kskp
         where a.id = :ida;
 
      end
end;

/* Alter Procedure... */
/* empty dependent procedure body */
/* Clear: SP_CALC_ALL for: SP_CALC_STAC */
ALTER PROCEDURE SP_CALC_ALL(ZS_ID INTEGER)
 AS
 BEGIN EXIT; END;

/* Alter (SP_CALC_STAC) */
ALTER PROCEDURE SP_CALC_STAC(IDA INTEGER)
 AS
declare variable KSG type of DM_CHAR_50;
declare variable DS type of DM_DS;
declare variable IDB integer;
declare variable SUM_USLF type of DM_MONEY;
declare variable KSKP type of DM_NUM_3_2;
declare variable Q_U integer;
declare variable FINE_KOEF type of DM_NUM_3_2;
declare variable TARIF numeric(15,6);
declare variable Y integer;
declare variable TARIF_USL DM_MONEY;
declare variable DATE2 date;
declare variable IS_TRANSFER DM_INT;
declare variable CL_CNT integer;
declare variable ERR_CODE integer;
declare variable K_DOWN DM_NUM_6_2;
begin
     cl_cnt = (select count(distinct b.ds_class) from ZSD b where b.ZS_ID = :ida);
     is_transfer = (select sum(iif(b.code_usl is null, 1, 0)) from ZSD b where b.ZS_ID = :ida);

     select a.q_u, extract(year from a.date_2), a.date_2
      from zs a
      where a.id = :ida
      into :q_u, :y, :date2;

     for select sp.KSG, sp.ERR_CODE, b.ds, b.id, coalesce(bs.tarif * k.k_down * k.kz *
                iif((select 1 from h_ksg_dop d where d.type_num = 1 and a.date_2 between d.bp and d.epv and d.q_u = a.q_u and d.ksg = sp.ksg) IS NULL , lf.kus, 1.0), 0)
      from zs a
      join zsd b on a.id = b.zs_id
      join patients p on p.id = a.patient_id
      join lpu_factors lf on lf.q_u = a.q_u and a.date_2 between lf.bp and lf.epv
      join h_tarif_bs bs on bs.q_u = a.q_u and a.date_2 between bs.bp and bs.epv
      left join sp_ksg_get(b.ds, p.dr, a.date_2, b.code_usl, p.sex, b.k_uslf, a.q_u, b.ds2, b.id) sp on 1=1
      left join h_ksg k on k.ksg = sp.ksg and a.date_2 between k.bp and k.epv and k.q_u = a.q_u
      where b.zs_id = :ida
      into :ksg, :err_code, :ds, :idb, :tarif
      do
      begin
        kskp = 1;
        fine_koef = null;

        if ((q_u = 1) and (y < 2017)) then
          kskp = (select KSKP from SP_CALC_STAC_KSKP(:ida, :idb, :ksg, :cl_cnt));
        if ((q_u = 1) and (y >= 2017) and (y < 2018)) then
          kskp = (select KSKP from sp_calc_stac_kskp_2017(:ida, :idb, :ksg, :cl_cnt));
--        if ((q_u = 1) and (y >= 2018)) then
--          kskp = (select KSKP from sp_calc_stac_kskp_2018(:ida, :idb, :ksg, :cl_cnt));

        fine_koef = (select FINE_KOEF from sp_calc_stac_fine(:ida, :idb, :ksg, :cl_cnt));

        sum_uslf = cast(tarif * kskp * fine_koef as int);

        update zsd b set
         b.ksg_base = :ksg,
         b.tar_base = cast(:tarif as integer),
         b.sum_base = :sum_uslf,
         b.kskp_base = :kskp
         where b.id = :idb;
      end 
--------------------------------------------------------------------------------
      --    6  + 
      if (q_u = 1) then
       if (exists (select 1 from zsd b where b.zs_id = :ida and ((b.ksg in (2) and b.k_uslf >= 6) or (b.ksg in ('O14.1','O34.2','O36.3','O36.4','O42.2') and b.k_uslf >= 2) ))
          and exists (select 1 from zsd b where b.zs_id = :ida and b.ksg in (4, 5))) then
          begin
            --    
            select first 1 b.ksg_base, b.ds
            from zs a
             join zsd b on a.id = b.zs_id
             where b.zs_id = :ida and b.ksg in (4, 5)
             into :ksg, :ds;
       
            update zsd d
            set d.tar_usl = d.tar_base,
                d.sum_uslf = d.sum_base,
                d.ksg = d.ksg_base,
                d.kskp = d.kskp_base
            where d.zs_id = :ida;

            --   
            select coalesce(sum(b.sum_uslf), 0) from zsd b where b.zs_id = :ida
             into :sum_uslf;
    
            update zs a set
             a.tar_usl = :tarif,
             a.sum_uslf = :sum_uslf,
             a.sum_usl = :sum_uslf,
             a.ksg = :ksg,
             a.ds1 = :ds,
             a.kslp = :kskp
             where a.id = :ida;

            exit;
          end
--------------------------------------------------------------------------------
      if ((is_transfer < 2) or (cl_cnt < 2))  then  --   
      begin
        --     
        select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base
         from zsd b
         where b.zs_id = :ida
         order by b.tar_base desc
         into :idb, :ksg, :sum_uslf, :tarif;

         --      
         update zsd b set
          b.ksg = :ksg, 
          b.sum_uslf = :sum_uslf,
          b.kskp = b.kskp_base,
          b.tar_usl = b.tar_base
          where b.id = :idb;

         update zsd b set
          b.ksg = null,
          b.sum_uslf = 0,
          b.kskp = 1,
          b.tar_usl = 0
          where b.id <> :idb and b.zs_id = :ida;
 
         update zs a set
          a.tar_usl = :tarif,
          a.sum_uslf = :sum_uslf,
          a.sum_usl = :sum_uslf,
          a.ksg = :ksg,
          a.kslp = :kskp
          where a.id = :ida;
 
      end else
      begin
        select first 1 b.ksg_base, b.sum_base
        from zs a
         join zsd b on a.id = b.zs_id
         where b.zs_id = :ida and b.ksg is not null and b.ds = a.ds1
         order by b.sum_base desc
         into :ksg, :sum_uslf;

        update zsd d
         set d.tar_usl = d.tar_base,
             d.sum_uslf = d.sum_base,
             d.ksg = d.ksg_base,
             d.kskp = d.kskp_base
         where d.zs_id = :ida;
   
        select coalesce(sum(b.sum_uslf), 0), coalesce(sum(b.tar_base), 0) from zsd b
         join zs a on a.id = b.zs_id
         where b.zs_id = :ida and b.ksg is not null
         into :sum_uslf, :tarif;

        update zs a set
         a.tar_usl = :tarif,
         a.sum_uslf = :sum_uslf,
         a.sum_usl = :sum_uslf,
         a.ksg = :ksg,
         a.kslp = :kskp
         where a.id = :ida;
 
      end

      ---------------------------------------------------------------------------------
      --   2016 
      if (exists(select first 1 1 from zsd b
                  join h_tarif_dializ d on d.code_usl = b.code_usl and b.date_2 between d.bp and d.epv
                  and d.q_u containing :q_u where b.zs_id = :ida) and :y = 2016) then
      begin
         for select d.tarif, b.id
             from zsd b
                  join h_tarif_dializ d on d.code_usl = b.code_usl and d.bp <= :date2 and d.epv >= :date2 and d.q_u containing :q_u
             where b.zs_id = :ida
             into :tarif_usl, :idb
             do
             begin
               update zsd b
               set b.sum_uslf = :tarif_usl,
                   b.tar_usl = :tarif_usl
               where b.id = :idb;

               update zs a set
                  a.tar_usl = iif (coalesce(a.tar_usl,0) = 0, :sum_uslf, a.tar_usl),
                  a.sum_uslf = a.sum_uslf + :tarif_usl,
                  a.sum_usl = a.sum_usl + :tarif_usl
                  where a.id = :ida;
 
               update zs a set
                  a.tar_usl = cast(a.sum_uslf/coalesce(a.k_uslf, 1) as integer)
                  where a.id = :ida;

             end
         exit;
      end

end;

/* Alter (SP_CALC_STAC_2018) */
ALTER PROCEDURE SP_CALC_STAC_2018(IDA INTEGER)
 AS
declare variable KSG type of DM_CHAR_50;
declare variable DS type of DM_DS;
declare variable IDB integer;
declare variable SUM_USLF type of DM_MONEY;
declare variable KSKP type of DM_NUM_3_2;
declare variable Q_U integer;
declare variable FINE_KOEF type of DM_NUM_3_2;
declare variable TARIF numeric(15,6);
declare variable Y integer;
declare variable TARIF_USL DM_MONEY;
declare variable DATE2 date;
declare variable IS_TRANSFER DM_INT;
declare variable CL_CNT integer;
declare variable ERR_CODE integer;
declare variable K_DOWN DM_NUM_6_2;
declare variable DS_CLASS DM_CHAR_10;
declare variable KZ DM_NUM_2_5;
declare variable KD DM_NUM_2_5;
declare variable KUS DM_NUM_2_5;
declare variable BS DM_NUM_6_2;
declare variable PROF_NUM integer;
declare variable DATE1 date;
declare variable CODE_USL DM_CHAR_20;
declare variable FINE_KOEF_SET_DOCTOR DM_BOOLEAN;
declare variable IS_ROUND_JANAO integer;
begin
    if (((select first 1 c.org_code from contragents c where c.type_id = 1))  starting '83' ) then
      is_round_janao = 1;

    update zsd d
      set d.ds_class = (select MKB_CLASS from SP_GET_MKB_CLASS(D.ds))
      where d.zs_id = :ida;

    update zsd d
     set d.ksg = null, 
         d.ksg_base = null,
         d.tar_base = null,
         d.sum_base = null,
         d.kskp_base = null,
         d.sum_uslf = 0,
         d.tar_usl = 0,
         d.comment_local = null
     where d.zs_id = :ida;

     cl_cnt = (select count(distinct b.ds_class) from ZSD b where b.ZS_ID = :ida);
     is_transfer = (select sum(iif(b.code_usl is null, 1, 0)) from ZSD b where b.ZS_ID = :ida);
     delete from kslp_koef where zs_id = :ida ;

     select a.q_u, extract(year from a.date_2), a.date_2, coalesce(a.fine_koef_set_doctor,0)
      from zs a
      where a.id = :ida
      into :q_u, :y, :date2, :fine_koef_set_doctor;

     for select sp.KSG, sp.ERR_CODE, b.ds, b.id, coalesce(cast(bs.tarif * kd.kd as int) * k.k_down * k.kz *
                iif((select 1 from h_ksg_dop d where d.type_num = 1 and a.date_2 between d.bp and d.epv and d.q_u = a.q_u and d.ksg = sp.ksg) IS NULL , lf.kus, 1.0), 0),
                k.kz, kd.kd,
                iif((select 1 from h_ksg_dop d where d.type_num = 1 and a.date_2 between d.bp and d.epv and d.q_u = a.q_u and d.ksg = sp.ksg) IS NULL , lf.kus, 1.0),
                bs.tarif, k.k_down, k.prof_num, b.date_1, coalesce(b.code_usl,''), coalesce(b.fine_koef,1)
      from zs a
      join zsd b on a.id = b.zs_id
      join patients p on p.id = a.patient_id
      join lpu_factors lf on lf.q_u = a.q_u and a.date_2 between lf.bp and lf.epv
      join h_tarif_bs bs on bs.q_u = a.q_u and a.date_2 between bs.bp and bs.epv
      join h_tarif_kd kd on a.date_2 between kd.bp and kd.epv
      left join sp_ksg_get(b.ds, p.dr, a.date_2, b.code_usl, p.sex,
                           (select sum(b1.k_uslf) from ZSD b1 where b1.ZS_ID = :ida and b1.ds_class = b.ds_class and b1.code_usl is null), -- -     
                           a.q_u, b.ds2, b.id, b.ksg_criterion,b.ksg_criterion2) sp on 1=1
      left join h_ksg k on k.ksg = sp.ksg and a.date_2 between k.bp and k.epv and k.q_u = a.q_u
      where b.zs_id = :ida
      order by b.code_usl
      into :ksg, :err_code, :ds, :idb, :tarif, :kz, :kd, :kus, :bs, :k_down, :prof_num, :date1, :code_usl, :fine_koef
      do
      begin
        kskp = 1;
--        fine_koef = null;

        if ((q_u = 1) and (err_code is null) and (date2 < '01.01.2019')) then
          kskp = (select KSKP from sp_calc_stac_kskp_2018(:ida, :idb, :ksg, :cl_cnt));

        if ((q_u in (1,3)) and (err_code is null) and (date2 >= '01.01.2019')) then
          kskp = (select KSKP from sp_calc_stac_kskp_2019(:ida, :idb, :ksg, :cl_cnt));

        if (fine_koef_set_doctor = 0) then
          fine_koef = (select FINE_KOEF from sp_calc_stac_fine_2018(:ida, :idb, :ksg, :cl_cnt));

        if (is_round_janao = 1) then
          sum_uslf = cast(cast(tarif * kskp as int) * fine_koef as int);
        else
          sum_uslf = tarif * kskp * fine_koef;

        if (:ksg is not null) then
        begin
            if (:code_usl <> '') then
            begin
                select first 1 d.id, iif(:fine_koef_set_doctor = 1, d.fine_koef, :fine_koef)
                from zs z
                     join zsd d on d.zs_id = z.id
                where d.zs_id = :ida and coalesce(d.code_usl,'') = ''
                       and :date1 between d.date_1 and d.date_2
                       and not exists(select id from zsd d2 where d2.zs_id = :ida and coalesce(d2.code_usl,'') = '' and d2.date_1 = d.date_2)
                into :idb, :fine_koef;

                if (is_round_janao = 1) then
                  sum_uslf = cast(cast(tarif * kskp as int) * fine_koef as int);
                else
                  sum_uslf = tarif * kskp * fine_koef;
            end

            if ((select first 1 d.id from zsd d where d.zs_id = :ida and d.ksg_base = :ksg) is null) then
            update zsd b set
             b.ksg_base = :ksg,
             b.tar_base = iif(:date2 >= '01.05.2018', iif(:is_round_janao = 1, cast(:tarif * coalesce(kskp,1) as int), :tarif * coalesce(kskp,1)), iif(:is_round_janao = 1, cast(:tarif as integer), :tarif)),
             b.sum_base = :sum_uslf,
             b.kskp_base = :kskp,
             b.koef_z = :kz, 
             b.koef_d = :kd,
             b.koef_u = :kus,
             b.bs = :bs,
             b.koef_up = :k_down,
             b.reab = iif(:prof_num = 37,1,null),
             b.fine_koef = :fine_koef
             where b.id = :idb;
         end
      end 
--------------------------------------------------------------------------------
      --    6  + 
      if (q_u = 1) then
       if (exists (select 1 from zsd b where b.zs_id = :ida and ((b.ksg in ('2','st02.001') and b.k_uslf >= 6) or (b.ksg in ('O14.1','O34.2','O36.3','O36.4','O42.2') and b.k_uslf >= 2) ))
          and exists (select 1 from zsd b where b.zs_id = :ida and b.ksg in ('4', '5', 'st02.003', 'st02.004'))) then
          begin
            --    
            select first 1 b.ksg_base, b.ds
            from zs a
             join zsd b on a.id = b.zs_id
             where b.zs_id = :ida and b.ksg in ('4', '5', 'st02.003', 'st02.004')
             into :ksg, :ds;
       
            update zsd d
            set d.tar_usl = d.tar_base,
                d.sum_uslf = d.sum_base,
                d.ksg = d.ksg_base,
                d.kskp = d.kskp_base
            where d.zs_id = :ida;

            --   
            select coalesce(sum(b.sum_uslf), 0) from zsd b where b.zs_id = :ida
             into :sum_uslf;
    
            update zs a set
             a.tar_usl = :tarif,
             a.sum_uslf = :sum_uslf,
             a.sum_usl = :sum_uslf,
             a.ksg = :ksg,
             a.ds1 = :ds,
             a.kslp = :kskp
             where a.id = :ida;

            exit;
          end
--------------------------------------------------------------------------------
      if ((is_transfer < 2) or (cl_cnt < 2))  then  --   
      begin
        --     ,   
        ksg = null;
        select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base
             from zsd b
             where b.zs_id = :ida and b.ksg_base is not null and ((:q_u = 1 and b.ksg_base >= '325' and b.ksg_base <= '343') or
                                                                                                  (:q_u = 3 and b.ksg_base >= '123' and b.ksg_base <= '134'))
             order by b.code_usl desc, b.sum_base desc
             into :idb, :ksg, :sum_uslf, :tarif;

        if (:ksg is null)  then
         select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base
             from zsd b
             where b.zs_id = :ida and b.ksg_base is not null
             order by b.code_usl desc, b.sum_base desc
             into :idb, :ksg, :sum_uslf, :tarif;

         --      
         update zsd b set
          b.ksg = :ksg, 
          b.sum_uslf = :sum_uslf,
          b.kskp = b.kskp_base,
          b.tar_usl = b.tar_base
          where b.id = :idb;

         update zsd b set
          b.ksg = null,
          b.sum_uslf = 0,
          b.kskp = 1,
          b.tar_usl = 0
          where b.id <> :idb and b.zs_id = :ida;
 
         update zs a set
          a.tar_usl = :tarif,
          a.sum_uslf = :sum_uslf,
          a.sum_usl = :sum_uslf,
          a.ksg = :ksg,
          a.kslp = :kskp
          where a.id = :ida;
 
      end else
      begin
        for select d.ds_class
         from zsd d
         where d.zs_id = :ida
         group by 1
         into :ds_class
         do
         begin
            if (((select count(dc.id) from ksg_dont_choice dc join zsd z on z.ksg_base = dc.ksg_ter or z.ksg_base = dc.ksg_surg
                    where z.zs_id = :ida and z.ds_class = :ds_class and :date2 between dc.bp and dc.epv) > 0) and (:q_u = 1)) then
               --    
            select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base
             from zsd b
             where b.zs_id = :ida and b.ksg_base is not null and b.ds_class = :ds_class and b.code_usl is not null
             order by b.code_usl desc, b.sum_base desc
             into :idb, :ksg, :sum_uslf, :tarif;
            else
               --     
            select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base
             from zsd b
             where b.zs_id = :ida and b.ksg_base is not null and b.ds_class = :ds_class
             order by b.code_usl desc, b.sum_base desc
             into :idb, :ksg, :sum_uslf, :tarif;
    
             --      
             update zsd b set
              b.ksg = :ksg, 
              b.sum_uslf = :sum_uslf,
              b.kskp = b.kskp_base,
              b.tar_usl = b.tar_base
              where b.id = :idb;
    
             update zsd b set
              b.ksg = null,
              b.sum_uslf = 0,
              b.kskp = 1,
              b.tar_usl = 0
              where b.id <> :idb and b.zs_id = :ida and b.ds_class = :ds_class;
         end

        select first 1 b.ksg_base, b.sum_base
        from zs a
         join zsd b on a.id = b.zs_id
         where b.zs_id = :ida and b.ksg is not null and b.ds = a.ds1
         order by b.sum_base desc
         into :ksg, :sum_uslf;

--        update zsd d
--         set d.tar_usl = d.tar_base,
--             d.sum_uslf = d.sum_base,
--             d.ksg = d.ksg_base,
--             d.kskp = d.kskp_base
--         where d.zs_id = :ida;
   
        select coalesce(sum(b.sum_uslf), 0), coalesce(sum(b.tar_base), 0)
         from zsd b
         join zs a on a.id = b.zs_id
         where b.zs_id = :ida and b.ksg is not null
         into :sum_uslf, :tarif;

        update zs a set
         a.tar_usl = :tarif,
         a.sum_uslf = :sum_uslf,
         a.sum_usl = :sum_uslf,
         a.ksg = :ksg,
         a.kslp = :kskp
         where a.id = :ida;
 
      end
end;

/* Restore proc. body: SP_CALC_ALL */
ALTER PROCEDURE SP_CALC_ALL(ZS_ID INTEGER)
 AS
declare variable TAR DM_MONEY_15_2;
declare variable DATE1 DM_DATE;
declare variable Q_U integer;
declare variable TAR_USL DM_MONEY_15_2;
declare variable TARGET integer;
declare variable IDB integer;
declare variable SUM_USLF DM_MONEY_15_2;
declare variable SEX char(1);
declare variable PTYPE integer;
declare variable AGE_Y integer;
declare variable AGE_GRP integer;
declare variable HDR_ID integer;
declare variable TROMB_CODE DM_CHAR_20;
declare variable TAR_USL_DOP DM_MONEY_15_2;
declare variable SUM_USLF_DOP DM_MONEY_15_2;
begin
  select z.date_2, z.q_u, z.target, p.sex, z.payment_type_id, extract(year from z.date_2) - extract(year from p.dr), z.hdr_id
  from zs z
  join patients p on p.id = z.patient_id
  where z.id = :zs_id
  into :date1, :q_u, :target, :sex, :ptype, :age_y, :hdr_id;

  if (:ptype in (2,3)) then exit;

  if (:target in (9,10,11,12,13,14,15,16,17)) then
  begin
   if ((select coalesce(t.days_cnt,0) from h_target t where t.id = :target) <> 0) then
   begin
    update zsd d
     set d.zachet = 1
     where d.date_1 < (:date1 - (select t.days_cnt from h_target t where t.id = :target)) and d.zs_id = :zs_id;

    update zsd d
     set d.zachet = 0
     where d.date_1 >= (:date1 - (select t.days_cnt from h_target t where t.id = :target)) and d.zs_id = :zs_id;
   end

   update zsd d
    set d.k_uslf = 0
    where (d.zachet = 1 or d.is_no_get_usl = 1) and d.zs_id = :zs_id;
  end

  update zsd d
    set d.tar_usl = null,
        d.sum_uslf = null,
        d.comment_local = null,
        d.dop_tarif = null,
        d.dop_sum = null
    where d.zs_id = :zs_id;

  update zs z
    set z.tar_usl = null,
        z.sum_usl = null,
        z.sum_uslf = null
    where z.id = :zs_id;

  if ((select coalesce(i.is_nz,0) from invoice i join zs_hdr h on h.name = i.id where h.id = :hdr_id) = 1) then
  begin
    if (target in (9,10,11,13,14,15,16,17)) then exit;

    tar = (select first 1 s.tarif from h_tarif_nz s where s.q_u = iif(:q_u = 4,2,:q_u) and :date1 between s.bp and s.epv);

    if (q_u = 1) then
      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf =:tar
      where d.zs_id = :zs_id and d.code_usl is null;
    else
      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf =:tar
      where d.zs_id = :zs_id;

    if (q_u = 4) then
      update zs z
      set z.tar_usl = :tar,
        z.sum_uslf = z.dcount*:tar
      where id = :zs_id;
    else
    if (q_u = 1) then
      update zs z
      set z.tar_usl = :tar,
        z.sum_uslf = :tar
      where id = :zs_id;
    else
      update zs z
      set z.tar_usl = :tar,
          z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
      where id = :zs_id;
    exit;
  end
   /********************,    ************************/
  if (:q_u = 2 and :target not in (9,10,11,12,13,14,15,16,17,21,22) and (:date1 < '01.01.2018')) then
  begin
    for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin

          select first 1 h.tarif, h.tarif
          from zs a
           join zsd b on a.id = b.zs_id
           join h_tarif_app_tgroup t on a.date_2 between t.bp and t.epv
           join h_tarif_app h on h.tg = t.tg
                                 and a.date_2 between h.bp and h.epv
                                 and (h.target = iif(a.for_pom = 2, 1, 0))
                                 and cast(h.code_spec as varchar(10)) = iif(coalesce(a.vbr,0) = 0, iif(b.code_spec = '16' and a.age < 18, '22', b.code_spec), 0)
           where b.id = :idb
           order by h.target nulls last
           into :tar, :sum_uslf;

          update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0)
           where b.id = :idb;
        end

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce(:sum_uslf, 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;
    exit;
  end

  if (:q_u = 2 and :target not in (9,10,11,12,13,14,15,16,17,21,22) and (:date1 >= '01.01.2018')) then
  begin
    for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin
          select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
          from zs a
           join zsd b on a.id = b.zs_id
           join h_usl u on u.code = coalesce(b.code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                           and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1
           where b.id = :idb and b.code_usl is not null and coalesce(u.sumf,0) > 0
           into :tar, :sum_uslf;

          tar_usl_dop = null;
          sum_uslf_dop = null;

          if ((select d.dop_code_usl from zsd d where d.id = :idb) is not null) then
              select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
              from zs a
               join zsd b on a.id = b.zs_id
               join h_usl u on u.code = coalesce(b.dop_code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                               and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1 and u.finans_type is not null
               where b.id = :idb and b.dop_code_usl is not null and coalesce(u.sumf,0) > 0
               into :tar_usl_dop, :sum_uslf_dop;

          if (:tar is null) then
          select first 1 h.tarif, h.tarif
          from zs a
           join zsd b on a.id = b.zs_id
           join h_tarif_app_tgroup t on a.date_2 between t.bp and t.epv
           join h_tarif_app h on h.tg = t.tg
                                 and a.date_2 between h.bp and h.epv
                                 and (h.target = iif(a.for_pom = 2, 1, 0))
           join h_tarif_app_spec n on n.name_id = h.name_id
                                 and n.code_spec_v021 = iif(coalesce(a.vbr,0) = 0, iif(b.code_spec_v021 = 39 and a.age < 18, 49, b.code_spec_v021), 0)
           where b.id = :idb
           order by h.target nulls last
           into :tar, :sum_uslf;

          update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0),
           b.dop_tarif = coalesce(:tar_usl_dop,0),
           b.dop_sum = coalesce(:sum_uslf_dop,0)
           where b.id = :idb;

          tar = null;
          sum_uslf = null;
        end

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id) + (select sum(coalesce(b.dop_sum,0)) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce(:sum_uslf, 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;
    exit;
  end  

  /********************************************/
  if (:q_u = 4) then
  begin
    tar = (select s.tarif from h_tarif_stom s where :date1 between s.bp and s.epv);

    update zsd d
    set d.tar_usl = :tar,
        d.sum_uslf = d.k_uslf*:tar
    where d.zs_id = :zs_id;
    
    update zs z
    set z.tar_usl = :tar,
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;
  end

  /******************** ************************/
  if (:q_u = 5) then
  begin
--    if (:date1 >= '01.01.2018') then tromb_code = 'A25.30.036';
--    else tromb_code = 'A25.30.035';
    tromb_code = coalesce((select first 1 code_usl from zsd d where d.zs_id = :zs_id and coalesce(code_usl, '') <> ''),'');

    tar = (select s.tarif from h_tarif_smp s where :date1 between s.bp and s.epv);
    tar_usl = coalesce((select coalesce(u.sumf,0) from h_usl u where u.code = :tromb_code
               and u.q_u containing '5' and :date1 between u.datebeg and u.dateend),0);

    update zsd d
    set d.tar_usl = iif(coalesce(d.code_usl,'') = '', :tar, :tar_usl),
        d.sum_uslf = d.k_uslf*iif(coalesce(d.code_usl,'') = '', :tar, :tar_usl)
    where d.zs_id = :zs_id;
    
    update zs z
    set z.tar_usl = (select max(tar_usl) from zsd where zs_id = :zs_id),
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;
  end

  /******************** ************************/
  if ((:q_u = 1) and ((select 1 from zs z where coalesce(z.metod_hmp,0) > 0 and id = :zs_id) = 1)) then
  begin
    select first 1 v.tarif
    from zs z
         join h_metod_hmp h on h.code = z.metod_hmp and z.date_2 between h.bp and h.epv
         join h_tarif_vmp v on v.tg = h.tg and z.date_2 between v.bp and v.epv
    where z.id = :zs_id
    into :tar;

    update zs a set
        a.tar_usl = :tar,
        a.sum_uslf = :tar,
        a.ksg = null,
        a.kslp = null
    where a.id = :zs_id;

    update zsd b set
          b.ksg = null,
          b.sum_uslf = :tar,
          b.kskp = 0,
          b.tar_usl = :tar
    where b.zs_id = :zs_id and coalesce(b.code_usl,'') = '' and b.date_1 = (select min(date_1) from zsd where zs_id = :zs_id and coalesce(code_usl,'') = '');

    exit;
  end

  /********************************************/
  if (:q_u in (1,3) and :date1 < '01.01.2018') then
    execute procedure SP_CALC_STAC(:zs_id);
  else
    if (:q_u in (1,3) and :date1 >= '01.01.2018') then
      execute procedure sp_calc_stac_2018(:zs_id);

  /****************  ***********************************************/
  if (q_u <> 4) then
  begin
  tar = null;
  sum_uslf = null;
  for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin
          select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
          from zs a
           join zsd b on a.id = b.zs_id
           join h_usl u on u.code = coalesce(b.code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                           and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1
           where b.id = :idb and b.code_usl is not null and coalesce(u.sumf,0) > 0
           into :tar, :sum_uslf;

          tar_usl_dop = null;
          sum_uslf_dop = null;

          if ((select d.dop_code_usl from zsd d where d.id = :idb) is not null) then
              select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
              from zs a
               join zsd b on a.id = b.zs_id
               join h_usl u on u.code = coalesce(b.dop_code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                               and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1 and u.finans_type is not null
               where b.id = :idb and b.dop_code_usl is not null and coalesce(u.sumf,0) > 0
               into :tar_usl_dop, :sum_uslf_dop;

          if (coalesce(:tar,0) > 0) then
          update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0),
           b.dop_tarif = coalesce(:tar_usl_dop,0),
           b.dop_sum = coalesce(:sum_uslf_dop,0)
           where b.id = :idb;

          tar = null;
          sum_uslf = null;
        end

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id) + (select sum(coalesce(b.dop_sum,0)) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce(:sum_uslf, 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;
   end

  /*********************-*********************************/
  if ((:q_u = 2) and (:target in (21,22))) then
  begin
   for select b.id
    from zsd b
    join zs z on z.id = b.zs_id
    where z.id = :zs_id
    into :idb
    do
    begin
      tar = (select first 1 t.tarif
             from zsd d
                  join h_tomo_code c on c.nms_code = d.code_usl
                  join h_tarif_tomo t on t.group_num = c.group_num and d.date_2 between t.bp and t.epv
             where d.id = :idb);

      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf = :tar
      where d.id = :idb;
    end

    update zs z
    set z.tar_usl = (select sum(tar_usl) from zsd where zs_id = :zs_id),
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;

    exit;
  end
  /******************** - 9  ************************/
  if (:q_u = 2 and :target = 9) then
  begin
    execute procedure sp_calc_app_t09(:zs_id);
    exit;
  end

  /******************** - 10,17  -  ************************/
    if (q_u = 2 and target in (10,17)) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_10 d on d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and :age_y between d.y1 and d.y2
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = coalesce(b.k_uslf * :tar, 0),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end

  /******************** - 13  ************************/
    if (q_u = 2 and target = 13) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                           and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_13_17 d on d.target = a.target
                                          and d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and d.age_grp = a.age_grp
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = coalesce(b.k_uslf * :tar, 0),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end

  /******************** - 14,15  ,  ************************/
    if (q_u = 2 and target in (14,15)) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_14_15 d on d.target = a.target
                                          and d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and d.cat_info = a.cat_info
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = coalesce(b.k_uslf * :tar, 0),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end
  /******************** - 16  ************************/
    if (q_u = 2 and target = 16) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join zs_hdr h on h.id = a.hdr_id
                   join patients p on p.id = a.patient_id
                   join h_tarif_disp_16 d on a.date_2 between d.bp and d.epv
                                          and d.sex = :sex
                                          and cast(d.code_usl as varchar(20)) = b.code_usl
                                          and d.age_l <= (h.y - extract(year from p.dr)) and d.age_r >= (h.y - extract(year from p.dr))
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = coalesce(b.k_uslf * :tar, 0),
               b.tar_base = coalesce(:tar, 0) ,
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end
end;

