ALTER PROCEDURE SP_CALC_ALL(ZS_ID INTEGER)
 AS
 BEGIN EXIT; END;

/* Alter (SP_CALC_STAC_2018) */
ALTER PROCEDURE SP_CALC_STAC_2018(IDA INTEGER)
 AS
declare variable KSG type of DM_CHAR_50;
declare variable DS type of DM_DS;
declare variable IDB integer;
declare variable SUM_USLF type of DM_MONEY;
declare variable KSKP type of DM_NUM_3_2;
declare variable Q_U integer;
declare variable FINE_KOEF type of DM_NUM_3_2;
declare variable TARIF numeric(15,6);
declare variable Y integer;
declare variable TARIF_USL DM_MONEY;
declare variable DATE2 date;
declare variable IS_TRANSFER DM_INT;
declare variable CL_CNT integer;
declare variable ERR_CODE integer;
declare variable K_DOWN DM_NUM_6_2;
declare variable DS_CLASS DM_CHAR_10;
declare variable KZ DM_NUM_2_5;
declare variable KD DM_NUM_2_5;
declare variable KUS DM_NUM_2_5;
declare variable BS DM_NUM_6_2;
declare variable PROF_NUM integer;
declare variable DATE1 date;
declare variable CODE_USL DM_CHAR_20;
declare variable FINE_KOEF_SET_DOCTOR DM_BOOLEAN;
declare variable IS_ROUND_JANAO integer;
begin
    if (((select first 1 c.org_code from contragents c where c.type_id = 1))  starting '83' ) then
      is_round_janao = 1;

    update zsd d
      set d.ds_class = (select MKB_CLASS from SP_GET_MKB_CLASS(D.ds))
      where d.zs_id = :ida;

    update zsd d
     set d.ksg = null, 
         d.ksg_base = null,
         d.tar_base = null,
         d.sum_base = null,
         d.kskp_base = null,
         d.sum_uslf = 0,
         d.tar_usl = 0,
         d.comment_local = null
     where d.zs_id = :ida;

     cl_cnt = (select count(distinct b.ds_class) from ZSD b where b.ZS_ID = :ida);
     is_transfer = (select sum(iif(b.code_usl is null, 1, 0)) from ZSD b where b.ZS_ID = :ida);
     delete from kslp_koef where zs_id = :ida ;

     select a.q_u, extract(year from a.date_2), a.date_2, coalesce(a.fine_koef_set_doctor,0)
      from zs a
      where a.id = :ida
      into :q_u, :y, :date2, :fine_koef_set_doctor;

     for select sp.KSG, sp.ERR_CODE, b.ds, b.id, iif(:is_round_janao = 1,
                coalesce(bs.tarif * kd.kd * k.k_down * k.kz *
                iif((select 1 from h_ksg_dop d where d.type_num = 1 and a.date_2 between d.bp and d.epv and d.q_u = a.q_u and d.ksg = sp.ksg) IS NULL , lf.kus, 1.0), 0),
                cast(coalesce(bs.tarif * kd.kd * k.k_down * k.kz *
                iif((select 1 from h_ksg_dop d where d.type_num = 1 and a.date_2 between d.bp and d.epv and d.q_u = a.q_u and d.ksg = sp.ksg) IS NULL , lf.kus, 1.0), 0) as dm_num_6_2)),
                k.kz, kd.kd,
                iif((select 1 from h_ksg_dop d where d.type_num = 1 and a.date_2 between d.bp and d.epv and d.q_u = a.q_u and d.ksg = sp.ksg) IS NULL , lf.kus, 1.0),
                bs.tarif, k.k_down, k.prof_num, b.date_1, coalesce(b.code_usl,''), coalesce(b.fine_koef,1)
      from zs a
      join zsd b on a.id = b.zs_id
      join patients p on p.id = a.patient_id
      join lpu_factors lf on lf.q_u = a.q_u and a.date_2 between lf.bp and lf.epv
      join h_tarif_bs bs on bs.q_u = a.q_u and a.date_2 between bs.bp and bs.epv
      join h_tarif_kd kd on a.date_2 between kd.bp and kd.epv
      left join sp_ksg_get(b.ds, p.dr, a.date_2, b.code_usl, p.sex,
                           (select sum(b1.k_uslf) from ZSD b1 where b1.ZS_ID = :ida and b1.ds_class = b.ds_class and b1.code_usl is null), -- -     
                           a.q_u, b.ds2, b.id, b.ksg_criterion,b.ksg_criterion2) sp on 1=1
      left join h_ksg k on k.ksg = sp.ksg and a.date_2 between k.bp and k.epv and k.q_u = a.q_u
      where b.zs_id = :ida
      order by b.code_usl
      into :ksg, :err_code, :ds, :idb, :tarif, :kz, :kd, :kus, :bs, :k_down, :prof_num, :date1, :code_usl, :fine_koef
      do
      begin
        kskp = 1;
--        fine_koef = null;

        if ((q_u = 1) and (err_code is null) and (date2 < '01.01.2019')) then
          kskp = (select KSKP from sp_calc_stac_kskp_2018(:ida, :idb, :ksg, :cl_cnt));

        if ((q_u in (1,3)) and (err_code is null) and (date2 >= '01.01.2019')) then
          kskp = (select KSKP from sp_calc_stac_kskp_2019(:ida, :idb, :ksg, :cl_cnt));

        if (fine_koef_set_doctor = 0) then
          fine_koef = (select FINE_KOEF from sp_calc_stac_fine_2018(:ida, :idb, :ksg, :cl_cnt));

        if (is_round_janao = 1) then
          sum_uslf = cast(cast(tarif * kskp as int) * fine_koef as int);
        else
          sum_uslf = tarif * kskp * fine_koef;

        if (:ksg is not null) then
        begin
            if (:code_usl <> '') then
            begin
                select first 1 d.id, iif(:fine_koef_set_doctor = 1, d.fine_koef, :fine_koef)
                from zs z
                     join zsd d on d.zs_id = z.id
                where d.zs_id = :ida and coalesce(d.code_usl,'') = ''
                       and :date1 between d.date_1 and d.date_2
                       and not exists(select id from zsd d2 where d2.zs_id = :ida and coalesce(d2.code_usl,'') = '' and d2.date_1 = d.date_2)
                into :idb, :fine_koef;

                if (is_round_janao = 1) then
                  sum_uslf = cast(cast(tarif * kskp as int) * fine_koef as int);
                else
                  sum_uslf = tarif * kskp * fine_koef;
            end

            if ((select first 1 d.id from zsd d where d.zs_id = :ida and d.ksg_base = :ksg) is null) then
            update zsd b set
             b.ksg_base = :ksg,
             b.tar_base = iif(:date2 >= '01.05.2018', iif(:is_round_janao = 1, cast(:tarif * coalesce(kskp,1) as int), :tarif * coalesce(kskp,1)), iif(:is_round_janao = 1, cast(:tarif as integer), :tarif)),
             b.sum_base = :sum_uslf,
             b.kskp_base = :kskp,
             b.koef_z = :kz, 
             b.koef_d = :kd,
             b.koef_u = :kus,
             b.bs = :bs,
             b.koef_up = :k_down,
             b.reab = iif(:prof_num = 37,1,null),
             b.fine_koef = :fine_koef
             where b.id = :idb;
         end
      end 
--------------------------------------------------------------------------------
      --    6  + 
      if (q_u = 1) then
       if (exists (select 1 from zsd b where b.zs_id = :ida and ((b.ksg in ('2','st02.001') and b.k_uslf >= 6) or (b.ksg in ('O14.1','O34.2','O36.3','O36.4','O42.2') and b.k_uslf >= 2) ))
          and exists (select 1 from zsd b where b.zs_id = :ida and b.ksg in ('4', '5', 'st02.003', 'st02.004'))) then
          begin
            --    
            select first 1 b.ksg_base, b.ds
            from zs a
             join zsd b on a.id = b.zs_id
             where b.zs_id = :ida and b.ksg in ('4', '5', 'st02.003', 'st02.004')
             into :ksg, :ds;
       
            update zsd d
            set d.tar_usl = d.tar_base,
                d.sum_uslf = d.sum_base,
                d.ksg = d.ksg_base,
                d.kskp = d.kskp_base
            where d.zs_id = :ida;

            --   
            select coalesce(sum(b.sum_uslf), 0) from zsd b where b.zs_id = :ida
             into :sum_uslf;
    
            update zs a set
             a.tar_usl = :tarif,
             a.sum_uslf = :sum_uslf,
             a.sum_usl = :sum_uslf,
             a.ksg = :ksg,
             a.ds1 = :ds,
             a.kslp = :kskp
             where a.id = :ida;

            exit;
          end
--------------------------------------------------------------------------------
      if ((is_transfer < 2) or (cl_cnt < 2))  then  --   
      begin
        --     ,   
        ksg = null;
        select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base
             from zsd b
             where b.zs_id = :ida and b.ksg_base is not null and ((:q_u = 1 and b.ksg_base >= '325' and b.ksg_base <= '343') or
                                                                                                  (:q_u = 3 and b.ksg_base >= '123' and b.ksg_base <= '134'))
             order by b.code_usl desc, b.sum_base desc
             into :idb, :ksg, :sum_uslf, :tarif;

        if (:ksg is null)  then
         select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base
             from zsd b
             where b.zs_id = :ida and b.ksg_base is not null
             order by b.code_usl desc, b.sum_base desc
             into :idb, :ksg, :sum_uslf, :tarif;

         --      
         update zsd b set
          b.ksg = :ksg, 
          b.sum_uslf = :sum_uslf,
          b.kskp = b.kskp_base,
          b.tar_usl = b.tar_base
          where b.id = :idb;

         update zsd b set
          b.ksg = null,
          b.sum_uslf = 0,
          b.kskp = 1,
          b.tar_usl = 0
          where b.id <> :idb and b.zs_id = :ida;
 
         update zs a set
          a.tar_usl = :tarif,
          a.sum_uslf = :sum_uslf,
          a.sum_usl = :sum_uslf,
          a.ksg = :ksg,
          a.kslp = :kskp
          where a.id = :ida;
 
      end else
      begin
        for select d.ds_class
         from zsd d
         where d.zs_id = :ida
         group by 1
         into :ds_class
         do
         begin
            if (((select count(dc.id) from ksg_dont_choice dc join zsd z on z.ksg_base = dc.ksg_ter or z.ksg_base = dc.ksg_surg
                    where z.zs_id = :ida and z.ds_class = :ds_class and :date2 between dc.bp and dc.epv) > 0) and (:q_u = 1)) then
               --    
            select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base
             from zsd b
             where b.zs_id = :ida and b.ksg_base is not null and b.ds_class = :ds_class and b.code_usl is not null
             order by b.code_usl desc, b.sum_base desc
             into :idb, :ksg, :sum_uslf, :tarif;
            else
               --     
            select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base
             from zsd b
             where b.zs_id = :ida and b.ksg_base is not null and b.ds_class = :ds_class
             order by b.code_usl desc, b.sum_base desc
             into :idb, :ksg, :sum_uslf, :tarif;
    
             --      
             update zsd b set
              b.ksg = :ksg, 
              b.sum_uslf = :sum_uslf,
              b.kskp = b.kskp_base,
              b.tar_usl = b.tar_base
              where b.id = :idb;
    
             update zsd b set
              b.ksg = null,
              b.sum_uslf = 0,
              b.kskp = 1,
              b.tar_usl = 0
              where b.id <> :idb and b.zs_id = :ida and b.ds_class = :ds_class;
         end

        select first 1 b.ksg_base, b.sum_base
        from zs a
         join zsd b on a.id = b.zs_id
         where b.zs_id = :ida and b.ksg is not null and b.ds = a.ds1
         order by b.sum_base desc
         into :ksg, :sum_uslf;

--        update zsd d
--         set d.tar_usl = d.tar_base,
--             d.sum_uslf = d.sum_base,
--             d.ksg = d.ksg_base,
--             d.kskp = d.kskp_base
--         where d.zs_id = :ida;
   
        select coalesce(sum(b.sum_uslf), 0), coalesce(sum(b.tar_base), 0)
         from zsd b
         join zs a on a.id = b.zs_id
         where b.zs_id = :ida and b.ksg is not null
         into :sum_uslf, :tarif;

        update zs a set
         a.tar_usl = :tarif,
         a.sum_uslf = :sum_uslf,
         a.sum_usl = :sum_uslf,
         a.ksg = :ksg,
         a.kslp = :kskp
         where a.id = :ida;
 
      end
end;

/* empty dependent procedure body */
/* Clear: SP_CALC_STAC_2018 for: SP_CALC_STAC_KSKP_2019 */
ALTER PROCEDURE SP_CALC_STAC_2018(IDA INTEGER)
 AS
 BEGIN EXIT; END;

/* Alter (SP_CALC_STAC_KSKP_2019) */
ALTER PROCEDURE SP_CALC_STAC_KSKP_2019(IDA INTEGER,
IDB INTEGER,
KSG DM_CHAR_20,
CL_CNT INTEGER)
 RETURNS(KSKP TYPE OF DM_NUM_3_2)
 AS
declare variable KSKP1 type of DM_NUM_3_2;
declare variable KSKP2 type of DM_NUM_3_2;
declare variable KSKP3 type of DM_NUM_3_2;
declare variable KSKP4 type of DM_NUM_3_2;
declare variable KSKP5 type of DM_NUM_3_2;
declare variable KSKP6 type of DM_NUM_3_2;
declare variable KSKP7 type of DM_NUM_3_2;
declare variable KSLP12 DM_NUM_3_2;
declare variable KSLP13 DM_NUM_3_2;
declare variable KSLP14 DM_NUM_3_2;
begin

 kskp6 = 1;

 select
       --    
       iif((a.q_u = 1) and (a.age < 1) and ((select first 1 d.ksg from h_ksg_dop d where d.type_num = 2 and a.date_2 between d.bp and d.epv and d.q_u = 1 and d.ksg = :ksg) is null),
           (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 1 and a.date_2 between t.bp and t.epv), 1),
       iif((a.q_u = 1) and (a.age >= 1) and (a.age < 4), (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 2  and a.date_2 between t.bp and t.epv), 1),
       iif((a.q_u = 1) and (a.age < 4 and a.age < 18 and coalesce(a.chield_with_rop,0) = 1), (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 3  and a.date_2 between t.bp and t.epv), 1),
       iif((a.q_u = 1) and (a.age >= 75) and ((select first 1 d.ksg from h_ksg_dop d where d.type_num = 3 and a.date_2 between d.bp and d.epv and d.q_u = 1 and d.ksg = :ksg) is null),
            (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 4  and a.date_2 between t.bp and t.epv), 1),    -- 4
       iif((a.q_u = 1) and (a.ds1 <> 'R54' and a.ds2 = 'R54' and exists(select first 1 id from zsd b where b.zs_id = a.id and b.profil_k = 16) and
           ((select first 1 d.ksg from h_ksg_dop d where d.type_num = 4 and a.date_2 between d.bp and d.epv and d.q_u = 1 and d.ksg = :ksg) is null)),
            (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 5  and a.date_2 between t.bp and t.epv), 1), --5
       iif((a.q_u = 3) and exists(select b.code_usl from zsd b where b.zs_id = a.id and b.code_usl in ('A11.20.017')),
            (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 316  and a.date_2 between t.bp and t.epv), 1),
       iif((a.q_u = 3) and exists(select b.code_usl from zsd b where b.zs_id = a.id and b.code_usl in ('A11.20.017.083')),
            (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 319  and a.date_2 between t.bp and t.epv), 1),
       iif((a.q_u = 3) and exists(select b.code_usl from zsd b where b.zs_id = a.id and b.code_usl in ('A11.20.030.001')),
            (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 75  and a.date_2 between t.bp and t.epv), 1)
  from zs a
  join patients p on p.id = a.patient_id
  left join zs_hdr h on h.id = a.hdr_id
  left join invoice i on i.id = h.name
  where a.id = :ida
  into :kskp1, :kskp2, :kskp3, :kskp4, :kskp5, :kslp12, :kslp13, :kslp14;

     if (((select z.q_u from zs z where id = :ida)) = 1) then
     begin
         if (idb is not null) then
          select
                --  
                case
                  when (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) > 30 and ((select d.ksg from h_ksg_dop d where d.type_num = 5 and a.date_2 between d.bp and d.epv and d.q_u = 1 and d.ksg = :ksg) is null)) then
                        case
                          when (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) - coalesce(b.orit,0)) >= coalesce(b.orit,0) then 1 + (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) - 30) * 0.25 / 30
                          else 1 + (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) - 30) * 0.4 / 30
                        end
                  when (b.k_uslf > 45 and ((select d.ksg from h_ksg_dop d where d.type_num = 5 and a.date_2 between d.bp and d.epv and d.q_u = 1 and d.ksg = :ksg) is not null)) then
                        case
                          when (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) - coalesce(b.orit,0)) >= coalesce(b.orit,0) then 1 + (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) - 45) * 0.25 / 45
                          else 1 + (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) - 45) * 0.4 / 45
                        end
                  else 1
                end
           from zs a
           join zsd b on a.id = b.zs_id
           where b.id = :idb
           into :kskp6;
    
    
         kskp = kskp1 + (kskp2-1) + (kskp3-1) + (kskp4-1) + (kskp5-1);
         if (kskp > 1.8) then
          kskp = 1.8;
         kskp = kskp + (kskp6-1);
         
         delete from kslp_koef where zs_id = :ida and ksg = :ksg;
         
         if (:kskp1 <> 1) then
             insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
                values (1, :kskp1, :ida, :ksg);
         if (:kskp2 <> 1) then
             insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
                values (2, :kskp2, :ida, :ksg);
         if (:kskp3 <> 1) then
             insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
                values (3, :kskp3, :ida, :ksg);
         if (:kskp4 <> 1) then
             insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
                values (4, :kskp4, :ida, :ksg);
         if (:kskp5 <> 1) then
             insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
                values (5, :kskp5, :ida, :ksg);
         if (:kskp6 <> 1) then
             insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
                values (6, :kskp6, :ida, :ksg);
    end
    else
    begin
      delete from kslp_koef where zs_id = :ida and ksg = :ksg;
         
     if (:kslp12 <> 1) then
         insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
            values (69, :kslp12, :ida, :ksg);
     if (:kslp13 <> 1) then
         insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
            values (74, :kslp13, :ida, :ksg);
     if (:kslp14 <> 1) then
         insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
            values (75, :kslp14, :ida, :ksg);

     kskp = kslp12 + (kslp13-1) + (kslp14-1);
    end
    suspend;        
end;

/* Alter (SP_CHECK_DS_AS_ONK) */
ALTER PROCEDURE SP_CHECK_DS_AS_ONK(ZSD_ID INTEGER)
 RETURNS(IS_ONK INTEGER)
 AS
begin
  select first 1 coalesce(id,0)
   from zs_ds d
   where d.section = 2 and d.section_id = :zsd_id and
         (
          ((d.ds starting 'C' or d.ds starting 'D0') and (d.ds_type = 1)) or
          ((d.ds = 'D70') and (d.ds_type = 1) and
            exists(select first 1 id from zs_ds d2 where d2.section = 2 and d2.section_id = :zsd_id and d2.ds_type = 2 and
                                              (((d2.ds starting 'C') and not(d2.ds starting 'C9')) or (d2.ds = 'C97'))
                   )
           )
          )
   into :is_onk;

   if ((select z.target from zs z where z.id = (select zs_id from zsd where id = :zsd_id)) not in (1,2,3,4,26)) then
     is_onk = 0;

  suspend;
end;

/* Alter (SP_GET_CODE_USL_DOP) */
ALTER PROCEDURE SP_GET_CODE_USL_DOP(ZSD_ID INTEGER,
IS_MAIN_RECORD INTEGER)
 RETURNS(CODE_USL_DOP DM_CHAR_20,
CODE_USL_DOP6 DM_CHAR_20)
 AS
declare variable DET integer;
declare variable CODE_USL DM_CHAR_20;
declare variable Q_U integer;
declare variable DIAL integer;
declare variable ZS_ID integer;
declare variable DS DM_DS;
declare variable DS2 DM_DS;
begin
  select iif((z.date_2 - p.dr) < 18, 1, 0), iif((coalesce(d.ksg,'') <> '') or (:is_main_record = 1), '', d.code_usl), z.q_u, z.id,
         z.ds1, z.ds2
   from zs z
        join zsd d on d.zs_id = z.id
        join patients p on p.id = z.patient_id
   where d.id = :zsd_id
   into :det, :code_usl, :q_u, :zs_id, :ds, :ds2;

if (exists(select first 1 id from zsd d where d.zs_id = :zs_id and d.code_usl starting 'A18.30')) then dial = 2;
  else dial = 1;

  if (ds starting 'N18') then
begin
  if (coalesce(:code_usl,'') = '') then
  begin
      select d.uf_id, d.uf_id6
       from h_code_usl_dop d
       where d.typed = :det and d.param_ex not containing 'MEDUS'
             and d.funicum = iif(:q_u = 2,1,2)
             and d.param_ex containing 'DIAL=' || cast(:dial as char)
       into :code_usl_dop, :code_usl_dop6;
  end
  else
  begin
       code_usl = replace(code_usl, '', 'A');
       select d.uf_id, d.uf_id6
       from h_code_usl_dop d
       where d.typed = :det and (d.param_ex containing :code_usl || ','
                                 or d.param_ex containing :code_usl || '}')
             and d.funicum = iif(:q_u = 2,1,2)
             and d.param_ex containing 'DIAL=' || cast(:dial as char)
       into :code_usl_dop, :code_usl_dop6;
  end
end

  if ((select IS_ONK from SP_CHECK_DS_AS_ONK2(:DS, :DS2)) = 1) then
  select d.uf_id, d.uf_id6
       from h_code_usl_dop d
       where d.typed = :det
             and d.funicum = iif(:q_u = 2,1,2)
             and d.param_ex containing 'ONCO=1'
       into :code_usl_dop, :code_usl_dop6;

  suspend;
end;

/* Restore proc. body: SP_CALC_ALL */
ALTER PROCEDURE SP_CALC_ALL(ZS_ID INTEGER)
 AS
declare variable TAR DM_MONEY_15_2;
declare variable DATE1 DM_DATE;
declare variable Q_U integer;
declare variable TAR_USL DM_MONEY_15_2;
declare variable TARGET integer;
declare variable IDB integer;
declare variable SUM_USLF DM_MONEY_15_2;
declare variable SEX char(1);
declare variable PTYPE integer;
declare variable AGE_Y integer;
declare variable AGE_GRP integer;
declare variable HDR_ID integer;
declare variable TROMB_CODE DM_CHAR_20;
declare variable TAR_USL_DOP DM_MONEY_15_2;
declare variable SUM_USLF_DOP DM_MONEY_15_2;
begin
  select z.date_2, z.q_u, z.target, p.sex, z.payment_type_id, extract(year from z.date_2) - extract(year from p.dr), z.hdr_id
  from zs z
  join patients p on p.id = z.patient_id
  where z.id = :zs_id
  into :date1, :q_u, :target, :sex, :ptype, :age_y, :hdr_id;

  if (:ptype in (2,3)) then exit;

  if (:target in (9,10,11,12,13,14,15,16,17)) then
  begin
   if ((select coalesce(t.days_cnt,0) from h_target t where t.id = :target) <> 0) then
   begin
    update zsd d
     set d.zachet = 1
     where d.date_1 < (:date1 - (select t.days_cnt from h_target t where t.id = :target)) and d.zs_id = :zs_id;

    update zsd d
     set d.zachet = 0
     where d.date_1 >= (:date1 - (select t.days_cnt from h_target t where t.id = :target)) and d.zs_id = :zs_id;
   end

   update zsd d
    set d.k_uslf = 0
    where (d.zachet = 1 or d.is_no_get_usl = 1) and d.zs_id = :zs_id;
  end

  update zsd d
    set d.tar_usl = null,
        d.sum_uslf = null,
        d.comment_local = null,
        d.dop_tarif = null,
        d.dop_sum = null
    where d.zs_id = :zs_id;

  update zs z
    set z.tar_usl = null,
        z.sum_usl = null,
        z.sum_uslf = null
    where z.id = :zs_id;

  if ((select coalesce(i.is_nz,0) from invoice i join zs_hdr h on h.name = i.id where h.id = :hdr_id) = 1) then
  begin
    if (target in (9,10,11,13,14,15,16,17)) then exit;

    tar = (select first 1 s.tarif from h_tarif_nz s where s.q_u = iif(:q_u = 4,2,:q_u) and :date1 between s.bp and s.epv);

    if (q_u = 1) then
      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf =:tar
      where d.zs_id = :zs_id and d.code_usl is null;
    else
      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf =:tar
      where d.zs_id = :zs_id;

    if (q_u = 4) then
      update zs z
      set z.tar_usl = :tar,
        z.sum_uslf = z.dcount*:tar
      where id = :zs_id;
    else
    if (q_u = 1) then
      update zs z
      set z.tar_usl = :tar,
        z.sum_uslf = :tar
      where id = :zs_id;
    else
      update zs z
      set z.tar_usl = :tar,
          z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
      where id = :zs_id;
    exit;
  end
   /********************,    ************************/
  if (:q_u = 2 and :target not in (9,10,11,12,13,14,15,16,17,21,22) and (:date1 < '01.01.2018')) then
  begin
    for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin

          select first 1 h.tarif, h.tarif
          from zs a
           join zsd b on a.id = b.zs_id
           join h_tarif_app_tgroup t on a.date_2 between t.bp and t.epv
           join h_tarif_app h on h.tg = t.tg
                                 and a.date_2 between h.bp and h.epv
                                 and (h.target = iif(a.for_pom = 2, 1, 0))
                                 and cast(h.code_spec as varchar(10)) = iif(coalesce(a.vbr,0) = 0, iif(b.code_spec = '16' and a.age < 18, '22', b.code_spec), 0)
           where b.id = :idb
           order by h.target nulls last
           into :tar, :sum_uslf;

          update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0)
           where b.id = :idb;
        end

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce(:sum_uslf, 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;
    exit;
  end

  if (:q_u = 2 and :target not in (9,10,11,12,13,14,15,16,17,21,22) and (:date1 >= '01.01.2018')) then
  begin
    for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin
          select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
          from zs a
           join zsd b on a.id = b.zs_id
           join h_usl u on u.code = coalesce(b.code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                           and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1
           where b.id = :idb and b.code_usl is not null and coalesce(u.sumf,0) > 0
           into :tar, :sum_uslf;

          tar_usl_dop = null;
          sum_uslf_dop = null;

          if ((select d.dop_code_usl from zsd d where d.id = :idb) is not null) then
              select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
              from zs a
               join zsd b on a.id = b.zs_id
               join h_usl u on u.code = coalesce(b.dop_code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                               and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1 and u.finans_type is not null
               where b.id = :idb and b.dop_code_usl is not null and coalesce(u.sumf,0) > 0
               into :tar_usl_dop, :sum_uslf_dop;

          if (:tar is null) then
          select first 1 h.tarif, h.tarif
          from zs a
           join zsd b on a.id = b.zs_id
           join h_tarif_app_tgroup t on a.date_2 between t.bp and t.epv
           join h_tarif_app h on h.tg = t.tg
                                 and a.date_2 between h.bp and h.epv
                                 and (h.target = iif(a.for_pom = 2, 1, 0))
           join h_tarif_app_spec n on n.name_id = h.name_id
                                 and n.code_spec_v021 = iif(coalesce(a.vbr,0) = 0, iif(b.code_spec_v021 = 39 and a.age < 18, 49, b.code_spec_v021), 0)
           where b.id = :idb
           order by h.target nulls last
           into :tar, :sum_uslf;

          update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0),
           b.dop_tarif = coalesce(:tar_usl_dop,0),
           b.dop_sum = coalesce(:sum_uslf_dop,0)
           where b.id = :idb;

          tar = null;
          sum_uslf = null;
        end

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id) + (select sum(coalesce(b.dop_sum,0)) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce(:sum_uslf, 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;
    exit;
  end  

  /********************************************/
  if (:q_u = 4) then
  begin
    tar = (select s.tarif from h_tarif_stom s where :date1 between s.bp and s.epv);

    update zsd d
    set d.tar_usl = :tar,
        d.sum_uslf = d.k_uslf*:tar
    where d.zs_id = :zs_id;
    
    update zs z
    set z.tar_usl = :tar,
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;
  end

  /******************** ************************/
  if (:q_u = 5) then
  begin
--    if (:date1 >= '01.01.2018') then tromb_code = 'A25.30.036';
--    else tromb_code = 'A25.30.035';
    tromb_code = coalesce((select first 1 code_usl from zsd d where d.zs_id = :zs_id and coalesce(code_usl, '') <> ''),'');

    tar = (select s.tarif from h_tarif_smp s where :date1 between s.bp and s.epv);
    tar_usl = coalesce((select coalesce(u.sumf,0) from h_usl u where u.code = :tromb_code
               and u.q_u containing '5' and :date1 between u.datebeg and u.dateend),0);

    update zsd d
    set d.tar_usl = iif(coalesce(d.code_usl,'') = '', :tar, :tar_usl),
        d.sum_uslf = d.k_uslf*iif(coalesce(d.code_usl,'') = '', :tar, :tar_usl)
    where d.zs_id = :zs_id;
    
    update zs z
    set z.tar_usl = (select max(tar_usl) from zsd where zs_id = :zs_id),
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;
  end

  /******************** ************************/
  if ((:q_u = 1) and ((select 1 from zs z where coalesce(z.metod_hmp,0) > 0 and id = :zs_id) = 1)) then
  begin
    select first 1 v.tarif
    from zs z
         join h_metod_hmp h on h.code = z.metod_hmp and z.date_2 between h.bp and h.epv
         join h_tarif_vmp v on v.tg = h.tg and z.date_2 between v.bp and v.epv
    where z.id = :zs_id
    into :tar;

    update zs a set
        a.tar_usl = :tar,
        a.sum_uslf = :tar,
        a.ksg = null,
        a.kslp = null
    where a.id = :zs_id;

    update zsd b set
          b.ksg = null,
          b.sum_uslf = :tar,
          b.kskp = 0,
          b.tar_usl = :tar
    where b.zs_id = :zs_id and coalesce(b.code_usl,'') = '' and b.date_1 = (select min(date_1) from zsd where zs_id = :zs_id and coalesce(code_usl,'') = '');

    exit;
  end

  /********************************************/
  if (:q_u in (1,3) and :date1 < '01.01.2018') then
    execute procedure SP_CALC_STAC(:zs_id);
  else
    if (:q_u in (1,3) and :date1 >= '01.01.2018') then
      execute procedure sp_calc_stac_2018(:zs_id);

  /****************  ***********************************************/
  if (q_u <> 4) then
  begin
  tar = null;
  sum_uslf = null;
  for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin
          select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
          from zs a
           join zsd b on a.id = b.zs_id
           join h_usl u on u.code = coalesce(b.code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                           and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1
           where b.id = :idb and b.code_usl is not null and coalesce(u.sumf,0) > 0
           into :tar, :sum_uslf;

          tar_usl_dop = null;
          sum_uslf_dop = null;

          if ((select d.dop_code_usl from zsd d where d.id = :idb) is not null) then
              select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
              from zs a
               join zsd b on a.id = b.zs_id
               join h_usl u on u.code = coalesce(b.dop_code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                               and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1 and u.finans_type is not null
               where b.id = :idb and b.dop_code_usl is not null and coalesce(u.sumf,0) > 0
               into :tar_usl_dop, :sum_uslf_dop;

          if (coalesce(:tar,0) > 0) then
          update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0),
           b.dop_tarif = coalesce(:tar_usl_dop,0),
           b.dop_sum = coalesce(:sum_uslf_dop,0)
           where b.id = :idb;

          tar = null;
          sum_uslf = null;
        end

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id) + (select sum(coalesce(b.dop_sum,0)) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce(:sum_uslf, 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;
   end

  /*********************-*********************************/
  if ((:q_u = 2) and (:target in (21,22))) then
  begin
   for select b.id
    from zsd b
    join zs z on z.id = b.zs_id
    where z.id = :zs_id
    into :idb
    do
    begin
      tar = (select first 1 t.tarif
             from zsd d
                  join h_tomo_code c on c.nms_code = d.code_usl
                  join h_tarif_tomo t on t.group_num = c.group_num and d.date_2 between t.bp and t.epv
             where d.id = :idb);

      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf = :tar
      where d.id = :idb;
    end

    update zs z
    set z.tar_usl = (select sum(tar_usl) from zsd where zs_id = :zs_id),
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;

    exit;
  end
  /******************** - 9  ************************/
  if (:q_u = 2 and :target = 9) then
  begin
    execute procedure sp_calc_app_t09(:zs_id);
    exit;
  end

  /******************** - 10,17  -  ************************/
    if (q_u = 2 and target in (10,17)) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_10 d on d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and :age_y between d.y1 and d.y2
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = coalesce(b.k_uslf * :tar, 0),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end

  /******************** - 13  ************************/
    if (q_u = 2 and target = 13) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                           and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_13_17 d on d.target = a.target
                                          and d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and d.age_grp = a.age_grp
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = coalesce(b.k_uslf * :tar, 0),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end

  /******************** - 14,15  ,  ************************/
    if (q_u = 2 and target in (14,15)) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_14_15 d on d.target = a.target
                                          and d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and d.cat_info = a.cat_info
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = coalesce(b.k_uslf * :tar, 0),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end
  /******************** - 16  ************************/
    if (q_u = 2 and target = 16) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join zs_hdr h on h.id = a.hdr_id
                   join patients p on p.id = a.patient_id
                   join h_tarif_disp_16 d on a.date_2 between d.bp and d.epv
                                          and d.sex = :sex
                                          and cast(d.code_usl as varchar(20)) = b.code_usl
                                          and d.age_l <= (h.y - extract(year from p.dr)) and d.age_r >= (h.y - extract(year from p.dr))
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = coalesce(b.k_uslf * :tar, 0),
               b.tar_base = coalesce(:tar, 0) ,
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end
end;

/* Restore proc. body: SP_CALC_STAC_2018 */
ALTER PROCEDURE SP_CALC_STAC_2018(IDA INTEGER)
 AS
declare variable KSG type of DM_CHAR_50;
declare variable DS type of DM_DS;
declare variable IDB integer;
declare variable SUM_USLF type of DM_MONEY;
declare variable KSKP type of DM_NUM_3_2;
declare variable Q_U integer;
declare variable FINE_KOEF type of DM_NUM_3_2;
declare variable TARIF numeric(15,6);
declare variable Y integer;
declare variable TARIF_USL DM_MONEY;
declare variable DATE2 date;
declare variable IS_TRANSFER DM_INT;
declare variable CL_CNT integer;
declare variable ERR_CODE integer;
declare variable K_DOWN DM_NUM_6_2;
declare variable DS_CLASS DM_CHAR_10;
declare variable KZ DM_NUM_2_5;
declare variable KD DM_NUM_2_5;
declare variable KUS DM_NUM_2_5;
declare variable BS DM_NUM_6_2;
declare variable PROF_NUM integer;
declare variable DATE1 date;
declare variable CODE_USL DM_CHAR_20;
declare variable FINE_KOEF_SET_DOCTOR DM_BOOLEAN;
declare variable IS_ROUND_JANAO integer;
begin
    if (((select first 1 c.org_code from contragents c where c.type_id = 1))  starting '83' ) then
      is_round_janao = 1;

    update zsd d
      set d.ds_class = (select MKB_CLASS from SP_GET_MKB_CLASS(D.ds))
      where d.zs_id = :ida;

    update zsd d
     set d.ksg = null, 
         d.ksg_base = null,
         d.tar_base = null,
         d.sum_base = null,
         d.kskp_base = null,
         d.sum_uslf = 0,
         d.tar_usl = 0,
         d.comment_local = null
     where d.zs_id = :ida;

     cl_cnt = (select count(distinct b.ds_class) from ZSD b where b.ZS_ID = :ida);
     is_transfer = (select sum(iif(b.code_usl is null, 1, 0)) from ZSD b where b.ZS_ID = :ida);
     delete from kslp_koef where zs_id = :ida ;

     select a.q_u, extract(year from a.date_2), a.date_2, coalesce(a.fine_koef_set_doctor,0)
      from zs a
      where a.id = :ida
      into :q_u, :y, :date2, :fine_koef_set_doctor;

     for select sp.KSG, sp.ERR_CODE, b.ds, b.id, iif(:is_round_janao = 1,
                coalesce(bs.tarif * kd.kd * k.k_down * k.kz *
                iif((select 1 from h_ksg_dop d where d.type_num = 1 and a.date_2 between d.bp and d.epv and d.q_u = a.q_u and d.ksg = sp.ksg) IS NULL , lf.kus, 1.0), 0),
                cast(coalesce(bs.tarif * kd.kd * k.k_down * k.kz *
                iif((select 1 from h_ksg_dop d where d.type_num = 1 and a.date_2 between d.bp and d.epv and d.q_u = a.q_u and d.ksg = sp.ksg) IS NULL , lf.kus, 1.0), 0) as dm_num_6_2)),
                k.kz, kd.kd,
                iif((select 1 from h_ksg_dop d where d.type_num = 1 and a.date_2 between d.bp and d.epv and d.q_u = a.q_u and d.ksg = sp.ksg) IS NULL , lf.kus, 1.0),
                bs.tarif, k.k_down, k.prof_num, b.date_1, coalesce(b.code_usl,''), coalesce(b.fine_koef,1)
      from zs a
      join zsd b on a.id = b.zs_id
      join patients p on p.id = a.patient_id
      join lpu_factors lf on lf.q_u = a.q_u and a.date_2 between lf.bp and lf.epv
      join h_tarif_bs bs on bs.q_u = a.q_u and a.date_2 between bs.bp and bs.epv
      join h_tarif_kd kd on a.date_2 between kd.bp and kd.epv
      left join sp_ksg_get(b.ds, p.dr, a.date_2, b.code_usl, p.sex,
                           (select sum(b1.k_uslf) from ZSD b1 where b1.ZS_ID = :ida and b1.ds_class = b.ds_class and b1.code_usl is null), -- -     
                           a.q_u, b.ds2, b.id, b.ksg_criterion,b.ksg_criterion2) sp on 1=1
      left join h_ksg k on k.ksg = sp.ksg and a.date_2 between k.bp and k.epv and k.q_u = a.q_u
      where b.zs_id = :ida
      order by b.code_usl
      into :ksg, :err_code, :ds, :idb, :tarif, :kz, :kd, :kus, :bs, :k_down, :prof_num, :date1, :code_usl, :fine_koef
      do
      begin
        kskp = 1;
--        fine_koef = null;

        if ((q_u = 1) and (err_code is null) and (date2 < '01.01.2019')) then
          kskp = (select KSKP from sp_calc_stac_kskp_2018(:ida, :idb, :ksg, :cl_cnt));

        if ((q_u in (1,3)) and (err_code is null) and (date2 >= '01.01.2019')) then
          kskp = (select KSKP from sp_calc_stac_kskp_2019(:ida, :idb, :ksg, :cl_cnt));

        if (fine_koef_set_doctor = 0) then
          fine_koef = (select FINE_KOEF from sp_calc_stac_fine_2018(:ida, :idb, :ksg, :cl_cnt));

        if (is_round_janao = 1) then
          sum_uslf = cast(cast(tarif * kskp as int) * fine_koef as int);
        else
          sum_uslf = tarif * kskp * fine_koef;

        if (:ksg is not null) then
        begin
            if (:code_usl <> '') then
            begin
                select first 1 d.id, iif(:fine_koef_set_doctor = 1, d.fine_koef, :fine_koef)
                from zs z
                     join zsd d on d.zs_id = z.id
                where d.zs_id = :ida and coalesce(d.code_usl,'') = ''
                       and :date1 between d.date_1 and d.date_2
                       and not exists(select id from zsd d2 where d2.zs_id = :ida and coalesce(d2.code_usl,'') = '' and d2.date_1 = d.date_2)
                into :idb, :fine_koef;

                if (is_round_janao = 1) then
                  sum_uslf = cast(cast(tarif * kskp as int) * fine_koef as int);
                else
                  sum_uslf = tarif * kskp * fine_koef;
            end

            if ((select first 1 d.id from zsd d where d.zs_id = :ida and d.ksg_base = :ksg) is null) then
            update zsd b set
             b.ksg_base = :ksg,
             b.tar_base = iif(:date2 >= '01.05.2018', iif(:is_round_janao = 1, cast(:tarif * coalesce(kskp,1) as int), :tarif * coalesce(kskp,1)), iif(:is_round_janao = 1, cast(:tarif as integer), :tarif)),
             b.sum_base = :sum_uslf,
             b.kskp_base = :kskp,
             b.koef_z = :kz, 
             b.koef_d = :kd,
             b.koef_u = :kus,
             b.bs = :bs,
             b.koef_up = :k_down,
             b.reab = iif(:prof_num = 37,1,null),
             b.fine_koef = :fine_koef
             where b.id = :idb;
         end
      end 
--------------------------------------------------------------------------------
      --    6  + 
      if (q_u = 1) then
       if (exists (select 1 from zsd b where b.zs_id = :ida and ((b.ksg in ('2','st02.001') and b.k_uslf >= 6) or (b.ksg in ('O14.1','O34.2','O36.3','O36.4','O42.2') and b.k_uslf >= 2) ))
          and exists (select 1 from zsd b where b.zs_id = :ida and b.ksg in ('4', '5', 'st02.003', 'st02.004'))) then
          begin
            --    
            select first 1 b.ksg_base, b.ds
            from zs a
             join zsd b on a.id = b.zs_id
             where b.zs_id = :ida and b.ksg in ('4', '5', 'st02.003', 'st02.004')
             into :ksg, :ds;
       
            update zsd d
            set d.tar_usl = d.tar_base,
                d.sum_uslf = d.sum_base,
                d.ksg = d.ksg_base,
                d.kskp = d.kskp_base
            where d.zs_id = :ida;

            --   
            select coalesce(sum(b.sum_uslf), 0) from zsd b where b.zs_id = :ida
             into :sum_uslf;
    
            update zs a set
             a.tar_usl = :tarif,
             a.sum_uslf = :sum_uslf,
             a.sum_usl = :sum_uslf,
             a.ksg = :ksg,
             a.ds1 = :ds,
             a.kslp = :kskp
             where a.id = :ida;

            exit;
          end
--------------------------------------------------------------------------------
      if ((is_transfer < 2) or (cl_cnt < 2))  then  --   
      begin
        --     ,   
        ksg = null;
        select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base
             from zsd b
             where b.zs_id = :ida and b.ksg_base is not null and ((:q_u = 1 and b.ksg_base >= '325' and b.ksg_base <= '343') or
                                                                                                  (:q_u = 3 and b.ksg_base >= '123' and b.ksg_base <= '134'))
             order by b.code_usl desc, b.sum_base desc
             into :idb, :ksg, :sum_uslf, :tarif;

        if (:ksg is null)  then
         select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base
             from zsd b
             where b.zs_id = :ida and b.ksg_base is not null
             order by b.code_usl desc, b.sum_base desc
             into :idb, :ksg, :sum_uslf, :tarif;

         --      
         update zsd b set
          b.ksg = :ksg, 
          b.sum_uslf = :sum_uslf,
          b.kskp = b.kskp_base,
          b.tar_usl = b.tar_base
          where b.id = :idb;

         update zsd b set
          b.ksg = null,
          b.sum_uslf = 0,
          b.kskp = 1,
          b.tar_usl = 0
          where b.id <> :idb and b.zs_id = :ida;
 
         update zs a set
          a.tar_usl = :tarif,
          a.sum_uslf = :sum_uslf,
          a.sum_usl = :sum_uslf,
          a.ksg = :ksg,
          a.kslp = :kskp
          where a.id = :ida;
 
      end else
      begin
        for select d.ds_class
         from zsd d
         where d.zs_id = :ida
         group by 1
         into :ds_class
         do
         begin
            if (((select count(dc.id) from ksg_dont_choice dc join zsd z on z.ksg_base = dc.ksg_ter or z.ksg_base = dc.ksg_surg
                    where z.zs_id = :ida and z.ds_class = :ds_class and :date2 between dc.bp and dc.epv) > 0) and (:q_u = 1)) then
               --    
            select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base
             from zsd b
             where b.zs_id = :ida and b.ksg_base is not null and b.ds_class = :ds_class and b.code_usl is not null
             order by b.code_usl desc, b.sum_base desc
             into :idb, :ksg, :sum_uslf, :tarif;
            else
               --     
            select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base
             from zsd b
             where b.zs_id = :ida and b.ksg_base is not null and b.ds_class = :ds_class
             order by b.code_usl desc, b.sum_base desc
             into :idb, :ksg, :sum_uslf, :tarif;
    
             --      
             update zsd b set
              b.ksg = :ksg, 
              b.sum_uslf = :sum_uslf,
              b.kskp = b.kskp_base,
              b.tar_usl = b.tar_base
              where b.id = :idb;
    
             update zsd b set
              b.ksg = null,
              b.sum_uslf = 0,
              b.kskp = 1,
              b.tar_usl = 0
              where b.id <> :idb and b.zs_id = :ida and b.ds_class = :ds_class;
         end

        select first 1 b.ksg_base, b.sum_base
        from zs a
         join zsd b on a.id = b.zs_id
         where b.zs_id = :ida and b.ksg is not null and b.ds = a.ds1
         order by b.sum_base desc
         into :ksg, :sum_uslf;

--        update zsd d
--         set d.tar_usl = d.tar_base,
--             d.sum_uslf = d.sum_base,
--             d.ksg = d.ksg_base,
--             d.kskp = d.kskp_base
--         where d.zs_id = :ida;
   
        select coalesce(sum(b.sum_uslf), 0), coalesce(sum(b.tar_base), 0)
         from zsd b
         join zs a on a.id = b.zs_id
         where b.zs_id = :ida and b.ksg is not null
         into :sum_uslf, :tarif;

        update zs a set
         a.tar_usl = :tarif,
         a.sum_uslf = :sum_uslf,
         a.sum_usl = :sum_uslf,
         a.ksg = :ksg,
         a.kslp = :kskp
         where a.id = :ida;
 
      end
end;

/* Altering existing trigger... */
ALTER TRIGGER ZS_BIU0
AS
declare variable hdr integer;
declare variable dr date;
begin
  if (new.n_zap is null) then
    new.n_zap = new.id;

  if (new.id_case is null) then
    new.id_case = new.id;

  if (new.id_pac is null) then
    new.id_pac = new.id;

  if (new.payment_type_id is null) then
    new.payment_type_id = 1;

  if (bin_and(new.extra_info, 1) = 1) then
    new.chield_with_rop = 1;

  if (new.date_1 is null) then
  begin
    new.date_1 = current_date;
    new.date_2 = current_date;
  end

  if (new.hdr_id is null) then
  begin
    hdr = (select id from zs_hdr h where h.y = extract(year from new.date_2) and h.m = extract(month from new.date_2)
         and h.name = h.m and is_delete = 0);

    if (hdr is not null) then
      new.hdr_id = hdr;
    else
    begin
      execute procedure ADD_PERIOD_HDR(extract(month from new.date_2), extract(year from new.date_2),
                                       (select M2 from SP_MONTH_TO_STRING(extract(month from new.date_2))),
                                       cast(extract(year from new.date_2) as varchar(4))) ;
      hdr = (select id from zs_hdr h where h.y = extract(year from new.date_2) and h.m = extract(month from new.date_2));
      new.hdr_id = :hdr;
    end
  end

  if ((new.n_hist is null) or (new.n_hist = '')) then
  begin
--    new.n_hist_num = (select max(coalesce(n_hist_num,0)) from zs z where z.patient_id = new.patient_id) + 1;
    new.n_hist = cast(gen_id(gen_nhist, 1) as varchar(50));
  end

  if (new.is_chield is null) then
    new.is_chield = 0;

  if ((new.q_u_2016 is not null) and (new.q_u is null)) then
  begin
      if (new.q_u_2016 = 4 and extract(year from new.date_2) > 2015 ) then
        new.q_u = 5;
      else
      if (new.q_u_2016 = 5 and extract(year from new.date_2) > 2015 ) then
        new.q_u = 4;
      else
      if (new.q_u_2016 = 2 and extract(year from new.date_2) > 2015 ) then
        new.q_u = 3;
      else
      if (new.q_u_2016 = 3 and extract(year from new.date_2) > 2015 ) then
      begin
       if (new.idsp = 9) then
       begin
        new.q_u = 4;
        new.q_u_2016 = 5;
       end
       else
        new.q_u = 2;
      end
      else new.q_u = 1;
  end
  else
  if ((new.q_u is not null)) then
  begin
      if (new.q_u = 4 and extract(year from new.date_2) > 2015 ) then
        new.q_u_2016 = 5;
      else
      if (new.q_u = 5 and extract(year from new.date_2) > 2015 ) then
        new.q_u_2016 = 4;
      else
      if (new.q_u = 2 and extract(year from new.date_2) > 2015 ) then
        new.q_u_2016 = 3;
      else
      if (new.q_u = 3 and extract(year from new.date_2) > 2015 ) then
        new.q_u_2016 = 2;
      else new.q_u_2016 = 1;
  end

  if (new.target in (9,10,11,12,13,14,15,16,17)) then
  begin
    if (new.disp_h_group is null) then
    begin
      new.disp_h_group = case
                           when (new.rslt_d in (1)) then '1'
                           when (new.rslt_d in (2)) then '2'
                           when (new.rslt_d in (3)) then '3'
                           when (new.rslt_d in (31)) then '3'
                           when (new.rslt_d in (32)) then '3'
                           when (new.rslt_d in (4)) then '4'
                           when (new.rslt_d in (5)) then '5'
                           when (new.rslt_d in (11)) then '1'
                           when (new.rslt_d in (12)) then '2'
                           when (new.rslt_d in (14)) then '3'
                           when (new.rslt_d in (15)) then '3'
                         end;
    end
  end
  
  if (not inserting) then
  begin
  if (new.q_u = 1) then
    new.k_uslf = iif(new.date_1 = new.date_2, 1, new.date_2 - new.date_1);
    else
    if (new.q_u = 3) then
    begin
      if (coalesce(new.ksg,'') = '') then
        new.k_uslf = (select sum(d.k_uslf) from zsd d where d.zs_id = new.id and coalesce(d.ksg,'') = '');
      else
        new.k_uslf = (select max(d.k_uslf) from zsd d where d.zs_id = new.id and coalesce(d.ksg,'') <> '');
        --iif(new.date_1 = new.date_2, 1, new.date_2 - new.date_1 + 1);
    end
      else
      if (new.q_u in (4,5)) then
        new.k_uslf = (select sum(d.k_uslf) from zsd d where d.zs_id = new.id);
        else
        if (new.q_u = 2) then
          new.k_uslf = (select sum(d.k_uslf)
                        from zsd d left join h_usl u on u.code = d.code_usl
                                                        and u.q_u containing new.q_u
                                                        and new.date_1 between u.datebeg and u.dateend
                                                        and u.payment_type_id = new.payment_type_id
                        where d.zs_id = new.id and coalesce(u.is_usl,0) <> 1);
  end

  if (coalesce(new.idsp_not_auto,0) = 0) then
  new.idsp = case
             when (new.q_u = 1) then 33
             when (new.q_u = 3) then 33
             when (new.q_u in (2,4)) and ((new.target < 9) or (new.target = 26)) and (new.for_pom = 3) and new.k_uslf = 1 then 29
             when (new.q_u in (2,4)) and ((new.target < 9) or (new.target = 26)) and (new.for_pom = 3) and new.k_uslf > 1 then 30
             when (new.q_u = 2) and (new.target in (9,10,17,13,14,15,16)) then 30
             when (new.q_u = 2) and (new.target in (21,22,23)) then 28
             when (new.q_u = 5) then 24
             end;

  dr = (select dr from patients where id = new.patient_id);

  if ((coalesce(new.age_grp_not_auto,0) = 0) and (new.target = 13)) then
    new.age_grp = (select AGE_GRP from SP_CALC_AGE_GRP(:dr, new.date_1));
             
  if (new.chield_with_rop = 1) then
    new.extra_info = 1;
  if (new.extra_info = 1) then
    new.chield_with_rop = 1;


end;

/* Altering existing trigger... */
ALTER TRIGGER ZSD_BIU0
AS
declare variable mp integer;
declare variable q_u integer;
declare variable tar numeric(15,2);
begin
  q_u = (select q_u from zs where id = new.zs_id);

--  mp = (select mp from doctors_spec s where s.doctor_id = new.phys_id and s.code_spec = new.code_spec);
--   if (:mp is not null) then
--     new.mp = :mp;

--   new.ds_class = (SELECT first 1 MKB_CLASS_NUM FROM H_MKB WHERE CODE = NEW.DS);

  if (new.pmd_close = 1) then
    update zsd
    set pmd_close = 0
    where zs_id = new.zs_id;

  if (new.pmd_close is null) then
    new.pmd_close = 1;

  if ((select z.payment_type_id from zs z where z.id = new.zs_id) in (3,2)) then
  begin
      tar = (select coalesce(u.sumf,0) from h_usl u where u.code = new.code_usl and u.q_u containing :q_u and u.payment_type_id = (select z.payment_type_id from zs z where z.id = new.zs_id));
    
      if (tar > 0) then
      begin
        NEW.sum_uslf = :tar * new.k_uslf;
        NEW.tar_usl = :tar;
      END
  end
--  else
--    if (new.tar_usl = 0 and new.sum_uslf = 0) then new.k_uslf = 0;

  if (new.phys_id is not null and new.code_spec_v021 is null) then
    new.code_spec_v021 = (select first 1 s.code_v021 from doctors_spec s where s.doctor_id = new.phys_id);

  if (new.phys_id is not null and new.mp is null and new.code_spec_v021 is not null) then
    new.mp = (select first 1 m.mp from doctors_spec m where m.doctor_id = new.phys_id and m.code_v021 = new.code_spec_v021);

  if (new.phys_id is not null and new.code_prof is null) then
    new.code_prof = (select first 1 p.prof from doctors_prof p where p.doctor_id = new.phys_id and p.code_spec =
                     (select first 1 s.code_v021 from doctors_spec s where s.doctor_id = new.phys_id));

--  if (new.code_spec is not null) then
--    new.code_spec_v021 = (select first 1 s.code_v021 from h_v015_v021 s where cast(s.code_v015 as varchar(10)) = new.code_spec);
--  else
  if (new.code_spec_v021 is not null) then
    new.code_spec = cast((select first 1 s.code_v015 from h_v015_v021 s where s.code_v021 = new.code_spec_v021) as varchar(10));

--  if (inserting) then
--  update or insert into DOCTORS_SPEC (DOCTOR_ID, CODE_V021, MP)
--    values (new.phys_id, new.code_spec_v021, new.mp)
--    matching (DOCTOR_ID, CODE_V021, MP);
  if (coalesce(new.ds,'') = '') then
    new.ds = (select d.ds from zs_ds d where d.section = 2 and d.section_id = new.id and d.ds_type = 1);
end;

/* Alter Procedure... */
/* empty dependent procedure body */
/* Clear: SP_CALC_ALL_CH for: SP_CALC_ALL */
ALTER PROCEDURE SP_CALC_ALL_CH(HDR_ID INTEGER)
 AS
 BEGIN EXIT; END;

/* empty dependent procedure body */
/* Clear: SP_ZS_SET_ZACHET for: SP_CALC_ALL */
ALTER PROCEDURE SP_ZS_SET_ZACHET(HDR_ID INTEGER)
 AS
 BEGIN EXIT; END;

/* empty dependent procedure body */
/* Clear: SP_ZSD_LIST_CREATE for: SP_CALC_ALL */
ALTER PROCEDURE SP_ZSD_LIST_CREATE(ZS_ID INTEGER)
 AS
 BEGIN EXIT; END;

/* Alter (SP_CALC_ALL) */
ALTER PROCEDURE SP_CALC_ALL(ZS_ID INTEGER)
 AS
declare variable TAR DM_MONEY_15_2;
declare variable DATE1 DM_DATE;
declare variable Q_U integer;
declare variable TAR_USL DM_MONEY_15_2;
declare variable TARGET integer;
declare variable IDB integer;
declare variable SUM_USLF DM_MONEY_15_2;
declare variable SEX char(1);
declare variable PTYPE integer;
declare variable AGE_Y integer;
declare variable AGE_GRP integer;
declare variable HDR_ID integer;
declare variable TROMB_CODE DM_CHAR_20;
declare variable TAR_USL_DOP DM_MONEY_15_2;
declare variable SUM_USLF_DOP DM_MONEY_15_2;
begin
  select z.date_2, z.q_u, z.target, p.sex, z.payment_type_id, extract(year from z.date_2) - extract(year from p.dr), z.hdr_id
  from zs z
  join patients p on p.id = z.patient_id
  where z.id = :zs_id
  into :date1, :q_u, :target, :sex, :ptype, :age_y, :hdr_id;

  if (:ptype in (2,3)) then exit;

  if (:target in (9,10,11,12,13,14,15,16,17)) then
  begin
   if ((select coalesce(t.days_cnt,0) from h_target t where t.id = :target) <> 0) then
   begin
    update zsd d
     set d.zachet = 1
     where d.date_1 < (:date1 - (select t.days_cnt from h_target t where t.id = :target)) and d.zs_id = :zs_id;

    update zsd d
     set d.zachet = 0
     where d.date_1 >= (:date1 - (select t.days_cnt from h_target t where t.id = :target)) and d.zs_id = :zs_id;
   end

   update zsd d
    set d.k_uslf = 0
    where (d.zachet = 1 or d.is_no_get_usl = 1) and d.zs_id = :zs_id;
  end

  update zsd d
    set d.tar_usl = null,
        d.sum_uslf = null,
        d.comment_local = null,
        d.dop_tarif = null,
        d.dop_sum = null
    where d.zs_id = :zs_id;

  update zs z
    set z.tar_usl = null,
        z.sum_usl = null,
        z.sum_uslf = null
    where z.id = :zs_id;

  if ((select coalesce(i.is_nz,0) from invoice i join zs_hdr h on h.name = i.id where h.id = :hdr_id) = 1) then
  begin
    if (target in (9,10,11,13,14,15,16,17)) then exit;

    tar = (select first 1 s.tarif from h_tarif_nz s where s.q_u = iif(:q_u = 4,2,:q_u) and :date1 between s.bp and s.epv);

    if (q_u = 1) then
      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf =:tar
      where d.zs_id = :zs_id and d.code_usl is null;
    else
      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf =:tar
      where d.zs_id = :zs_id;

    if (q_u = 4) then
      update zs z
      set z.tar_usl = :tar,
        z.sum_uslf = z.dcount*:tar
      where id = :zs_id;
    else
    if (q_u = 1) then
      update zs z
      set z.tar_usl = :tar,
        z.sum_uslf = :tar
      where id = :zs_id;
    else
      update zs z
      set z.tar_usl = :tar,
          z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
      where id = :zs_id;
    exit;
  end
   /********************,    ************************/
  if (:q_u = 2 and :target not in (9,10,11,12,13,14,15,16,17,21,22) and (:date1 < '01.01.2018')) then
  begin
    for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin

          select first 1 h.tarif, h.tarif
          from zs a
           join zsd b on a.id = b.zs_id
           join h_tarif_app_tgroup t on a.date_2 between t.bp and t.epv
           join h_tarif_app h on h.tg = t.tg
                                 and a.date_2 between h.bp and h.epv
                                 and (h.target = iif(a.for_pom = 2, 1, 0))
                                 and cast(h.code_spec as varchar(10)) = iif(coalesce(a.vbr,0) = 0, iif(b.code_spec = '16' and a.age < 18, '22', b.code_spec), 0)
           where b.id = :idb
           order by h.target nulls last
           into :tar, :sum_uslf;

          update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0)
           where b.id = :idb;
        end

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce(:sum_uslf, 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;
    exit;
  end

  if (:q_u = 2 and :target not in (9,10,11,12,13,14,15,16,17,21,22) and (:date1 >= '01.01.2018')) then
  begin
    for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin
          select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
          from zs a
           join zsd b on a.id = b.zs_id
           join h_usl u on u.code = coalesce(b.code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                           and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1
           where b.id = :idb and b.code_usl is not null and coalesce(u.sumf,0) > 0
           into :tar, :sum_uslf;

          tar_usl_dop = null;
          sum_uslf_dop = null;

          if ((select d.dop_code_usl from zsd d where d.id = :idb) is not null) then
              select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
              from zs a
               join zsd b on a.id = b.zs_id
               join h_usl u on u.code = coalesce(b.dop_code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                               and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1 and u.finans_type is not null
               where b.id = :idb and b.dop_code_usl is not null and coalesce(u.sumf,0) > 0
               into :tar_usl_dop, :sum_uslf_dop;

          if (:tar is null) then
          select first 1 h.tarif, h.tarif
          from zs a
           join zsd b on a.id = b.zs_id
           join h_tarif_app_tgroup t on a.date_2 between t.bp and t.epv
           join h_tarif_app h on h.tg = t.tg
                                 and a.date_2 between h.bp and h.epv
                                 and (h.target = iif(a.for_pom = 2, 1, 0))
           join h_tarif_app_spec n on n.name_id = h.name_id
                                 and n.code_spec_v021 = iif(coalesce(a.vbr,0) = 0, iif(b.code_spec_v021 = 39 and a.age < 18, 49, b.code_spec_v021), 0)
           where b.id = :idb
           order by h.target nulls last
           into :tar, :sum_uslf;

          update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0),
           b.dop_tarif = coalesce(:tar_usl_dop,0),
           b.dop_sum = coalesce(:sum_uslf_dop,0)
           where b.id = :idb;

          tar = null;
          sum_uslf = null;
        end

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id) + (select sum(coalesce(b.dop_sum,0)) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce(:sum_uslf, 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;
    exit;
  end  

  /********************************************/
  if (:q_u = 4) then
  begin
    tar = (select s.tarif from h_tarif_stom s where :date1 between s.bp and s.epv);

    update zsd d
    set d.tar_usl = :tar,
        d.sum_uslf = d.k_uslf*:tar
    where d.zs_id = :zs_id;
    
    update zs z
    set z.tar_usl = :tar,
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;
  end

  /******************** ************************/
  if (:q_u = 5) then
  begin
--    if (:date1 >= '01.01.2018') then tromb_code = 'A25.30.036';
--    else tromb_code = 'A25.30.035';
    tromb_code = coalesce((select first 1 code_usl from zsd d where d.zs_id = :zs_id and coalesce(code_usl, '') <> ''),'');

    tar = (select s.tarif from h_tarif_smp s where :date1 between s.bp and s.epv);
    tar_usl = coalesce((select coalesce(u.sumf,0) from h_usl u where u.code = :tromb_code
               and u.q_u containing '5' and :date1 between u.datebeg and u.dateend),0);

    update zsd d
    set d.tar_usl = iif(coalesce(d.code_usl,'') = '', :tar, :tar_usl),
        d.sum_uslf = d.k_uslf*iif(coalesce(d.code_usl,'') = '', :tar, :tar_usl)
    where d.zs_id = :zs_id;
    
    update zs z
    set z.tar_usl = (select max(tar_usl) from zsd where zs_id = :zs_id),
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;
  end

  /******************** ************************/
  if ((:q_u = 1) and ((select 1 from zs z where coalesce(z.metod_hmp,0) > 0 and id = :zs_id) = 1)) then
  begin
    select first 1 v.tarif
    from zs z
         join h_metod_hmp h on h.code = z.metod_hmp and z.date_2 between h.bp and h.epv
         join h_tarif_vmp v on v.tg = h.tg and z.date_2 between v.bp and v.epv
    where z.id = :zs_id
    into :tar;

    update zs a set
        a.tar_usl = :tar,
        a.sum_uslf = :tar,
        a.ksg = null,
        a.kslp = null
    where a.id = :zs_id;

    update zsd b set
          b.ksg = null,
          b.sum_uslf = :tar,
          b.kskp = 0,
          b.tar_usl = :tar
    where b.zs_id = :zs_id and coalesce(b.code_usl,'') = '' and b.date_1 = (select min(date_1) from zsd where zs_id = :zs_id and coalesce(code_usl,'') = '');

    exit;
  end

  /********************************************/
  if (:q_u in (1,3) and :date1 < '01.01.2018') then
    execute procedure SP_CALC_STAC(:zs_id);
  else
    if (:q_u in (1,3) and :date1 >= '01.01.2018') then
      execute procedure sp_calc_stac_2018(:zs_id);

  /****************  ***********************************************/
  if (q_u <> 4) then
  begin
  tar = null;
  sum_uslf = null;
  for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin
          select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
          from zs a
           join zsd b on a.id = b.zs_id
           join h_usl u on u.code = coalesce(b.code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                           and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1
           where b.id = :idb and b.code_usl is not null and coalesce(u.sumf,0) > 0
           into :tar, :sum_uslf;

          tar_usl_dop = null;
          sum_uslf_dop = null;

          if ((select d.dop_code_usl from zsd d where d.id = :idb) is not null) then
              select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
              from zs a
               join zsd b on a.id = b.zs_id
               join h_usl u on u.code = coalesce(b.dop_code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                               and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1 and u.finans_type is not null
               where b.id = :idb and b.dop_code_usl is not null and coalesce(u.sumf,0) > 0
               into :tar_usl_dop, :sum_uslf_dop;

          if (coalesce(:tar,0) > 0) then
          update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0),
           b.dop_tarif = coalesce(:tar_usl_dop,0),
           b.dop_sum = coalesce(:sum_uslf_dop,0)
           where b.id = :idb;

          tar = null;
          sum_uslf = null;
        end

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id) + (select sum(coalesce(b.dop_sum,0)) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce(:sum_uslf, 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;
   end

  /*********************-*********************************/
  if ((:q_u = 2) and (:target in (21,22))) then
  begin
   for select b.id
    from zsd b
    join zs z on z.id = b.zs_id
    where z.id = :zs_id
    into :idb
    do
    begin
      tar = (select first 1 t.tarif
             from zsd d
                  join h_tomo_code c on c.nms_code = d.code_usl
                  join h_tarif_tomo t on t.group_num = c.group_num and d.date_2 between t.bp and t.epv
             where d.id = :idb);

      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf = :tar
      where d.id = :idb;
    end

    update zs z
    set z.tar_usl = (select sum(tar_usl) from zsd where zs_id = :zs_id),
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;

    exit;
  end
  /******************** - 9  ************************/
  if (:q_u = 2 and :target = 9) then
  begin
    execute procedure sp_calc_app_t09(:zs_id);
    exit;
  end

  /******************** - 10,17  -  ************************/
    if (q_u = 2 and target in (10,17)) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_10 d on d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and :age_y between d.y1 and d.y2
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = coalesce(b.k_uslf * :tar, 0),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end

  /******************** - 13  ************************/
    if (q_u = 2 and target = 13) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                           and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_13_17 d on d.target = a.target
                                          and d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and d.age_grp = a.age_grp
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = coalesce(b.k_uslf * :tar, 0),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end

  /******************** - 14,15  ,  ************************/
    if (q_u = 2 and target in (14,15)) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_14_15 d on d.target = a.target
                                          and d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and d.cat_info = a.cat_info
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = coalesce(b.k_uslf * :tar, 0),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end
  /******************** - 16  ************************/
    if (q_u = 2 and target = 16) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join zs_hdr h on h.id = a.hdr_id
                   join patients p on p.id = a.patient_id
                   join h_tarif_disp_16 d on a.date_2 between d.bp and d.epv
                                          and d.sex = :sex
                                          and cast(d.code_usl as varchar(20)) = b.code_usl
                                          and d.age_l <= (h.y - extract(year from p.dr)) and d.age_r >= (h.y - extract(year from p.dr))
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = coalesce(b.k_uslf * :tar, 0),
               b.tar_base = coalesce(:tar, 0) ,
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end
end;

/* Alter (SP_CALC_ALL_CH) */
ALTER PROCEDURE SP_CALC_ALL_CH(HDR_ID INTEGER)
 AS
declare variable ZID integer;
begin

 for select z.id
  from zs z
  where z.hdr_id = :hdr_id
  into :zid
  do
    execute procedure SP_CALC_ALL(:ZID);

  update invoice i
  set i.sumv = (select sum(z.sum_uslf) from zs z where z.hdr_id = :hdr_id),
      i.sump = (select sum(z.sum_usl) from zs z where z.hdr_id = :hdr_id)
  where i.id = (select name from zs_hdr h where h.id = :hdr_id);
end;

/* Alter (SP_CALC_STAC_2018) */
ALTER PROCEDURE SP_CALC_STAC_2018(IDA INTEGER)
 AS
declare variable KSG type of DM_CHAR_50;
declare variable DS type of DM_DS;
declare variable IDB integer;
declare variable SUM_USLF type of DM_MONEY;
declare variable KSKP type of DM_NUM_3_2;
declare variable Q_U integer;
declare variable FINE_KOEF type of DM_NUM_3_2;
declare variable TARIF numeric(15,6);
declare variable Y integer;
declare variable TARIF_USL DM_MONEY;
declare variable DATE2 date;
declare variable IS_TRANSFER DM_INT;
declare variable CL_CNT integer;
declare variable ERR_CODE integer;
declare variable K_DOWN DM_NUM_6_2;
declare variable DS_CLASS DM_CHAR_10;
declare variable KZ DM_NUM_2_5;
declare variable KD DM_NUM_2_5;
declare variable KUS DM_NUM_2_5;
declare variable BS DM_NUM_6_2;
declare variable PROF_NUM integer;
declare variable DATE1 date;
declare variable CODE_USL DM_CHAR_20;
declare variable FINE_KOEF_SET_DOCTOR DM_BOOLEAN;
declare variable IS_ROUND_JANAO integer;
begin
    if (((select first 1 c.org_code from contragents c where c.type_id = 1))  starting '83' ) then
      is_round_janao = 1;

    update zsd d
      set d.ds_class = (select MKB_CLASS from SP_GET_MKB_CLASS(D.ds))
      where d.zs_id = :ida;

    update zsd d
     set d.ksg = null, 
         d.ksg_base = null,
         d.tar_base = null,
         d.sum_base = null,
         d.kskp_base = null,
         d.sum_uslf = 0,
         d.tar_usl = 0,
         d.comment_local = null
     where d.zs_id = :ida;

     cl_cnt = (select count(distinct b.ds_class) from ZSD b where b.ZS_ID = :ida);
     is_transfer = (select sum(iif(b.code_usl is null, 1, 0)) from ZSD b where b.ZS_ID = :ida);
     delete from kslp_koef where zs_id = :ida ;

     select a.q_u, extract(year from a.date_2), a.date_2, coalesce(a.fine_koef_set_doctor,0)
      from zs a
      where a.id = :ida
      into :q_u, :y, :date2, :fine_koef_set_doctor;

     for select sp.KSG, sp.ERR_CODE, b.ds, b.id, iif(:is_round_janao = 1,
                coalesce(bs.tarif * kd.kd * k.k_down * k.kz *
                iif((select 1 from h_ksg_dop d where d.type_num = 1 and a.date_2 between d.bp and d.epv and d.q_u = a.q_u and d.ksg = sp.ksg) IS NULL , lf.kus, 1.0), 0),
                cast(coalesce(bs.tarif * kd.kd * k.k_down * k.kz *
                iif((select 1 from h_ksg_dop d where d.type_num = 1 and a.date_2 between d.bp and d.epv and d.q_u = a.q_u and d.ksg = sp.ksg) IS NULL , lf.kus, 1.0), 0) as dm_num_6_2)),
                k.kz, kd.kd,
                iif((select 1 from h_ksg_dop d where d.type_num = 1 and a.date_2 between d.bp and d.epv and d.q_u = a.q_u and d.ksg = sp.ksg) IS NULL , lf.kus, 1.0),
                bs.tarif, k.k_down, k.prof_num, b.date_1, coalesce(b.code_usl,''), coalesce(b.fine_koef,1)
      from zs a
      join zsd b on a.id = b.zs_id
      join patients p on p.id = a.patient_id
      join lpu_factors lf on lf.q_u = a.q_u and a.date_2 between lf.bp and lf.epv
      join h_tarif_bs bs on bs.q_u = a.q_u and a.date_2 between bs.bp and bs.epv
      join h_tarif_kd kd on a.date_2 between kd.bp and kd.epv
      left join sp_ksg_get(b.ds, p.dr, a.date_2, b.code_usl, p.sex,
                           (select sum(b1.k_uslf) from ZSD b1 where b1.ZS_ID = :ida and b1.ds_class = b.ds_class and b1.code_usl is null), -- -     
                           a.q_u, b.ds2, b.id, b.ksg_criterion,b.ksg_criterion2) sp on 1=1
      left join h_ksg k on k.ksg = sp.ksg and a.date_2 between k.bp and k.epv and k.q_u = a.q_u
      where b.zs_id = :ida
      order by b.code_usl
      into :ksg, :err_code, :ds, :idb, :tarif, :kz, :kd, :kus, :bs, :k_down, :prof_num, :date1, :code_usl, :fine_koef
      do
      begin
        kskp = 1;
--        fine_koef = null;

        if ((q_u = 1) and (err_code is null) and (date2 < '01.01.2019')) then
          kskp = (select KSKP from sp_calc_stac_kskp_2018(:ida, :idb, :ksg, :cl_cnt));

        if ((q_u in (1,3)) and (err_code is null) and (date2 >= '01.01.2019')) then
          kskp = (select KSKP from sp_calc_stac_kskp_2019(:ida, :idb, :ksg, :cl_cnt));

        if (fine_koef_set_doctor = 0) then
          fine_koef = (select FINE_KOEF from sp_calc_stac_fine_2018(:ida, :idb, :ksg, :cl_cnt));

        if (is_round_janao = 1) then
          sum_uslf = cast(cast(tarif * kskp as int) * fine_koef as int);
        else
          sum_uslf = tarif * kskp * fine_koef;

        if (:ksg is not null) then
        begin
            if (:code_usl <> '') then
            begin
                select first 1 d.id, iif(:fine_koef_set_doctor = 1, d.fine_koef, :fine_koef)
                from zs z
                     join zsd d on d.zs_id = z.id
                where d.zs_id = :ida and coalesce(d.code_usl,'') = ''
                       and :date1 between d.date_1 and d.date_2
                       and not exists(select id from zsd d2 where d2.zs_id = :ida and coalesce(d2.code_usl,'') = '' and d2.date_1 = d.date_2)
                into :idb, :fine_koef;

                if (is_round_janao = 1) then
                  sum_uslf = cast(cast(tarif * kskp as int) * fine_koef as int);
                else
                  sum_uslf = tarif * kskp * fine_koef;
            end

            if ((select first 1 d.id from zsd d where d.zs_id = :ida and d.ksg_base = :ksg) is null) then
            update zsd b set
             b.ksg_base = :ksg,
             b.tar_base = iif(:date2 >= '01.05.2018', iif(:is_round_janao = 1, cast(:tarif * coalesce(kskp,1) as int), :tarif * coalesce(kskp,1)), iif(:is_round_janao = 1, cast(:tarif as integer), :tarif)),
             b.sum_base = :sum_uslf,
             b.kskp_base = :kskp,
             b.koef_z = :kz, 
             b.koef_d = :kd,
             b.koef_u = :kus,
             b.bs = :bs,
             b.koef_up = :k_down,
             b.reab = iif(:prof_num = 37,1,null),
             b.fine_koef = :fine_koef
             where b.id = :idb;
         end
      end 
--------------------------------------------------------------------------------
      --    6  + 
      if (q_u = 1) then
       if (exists (select 1 from zsd b where b.zs_id = :ida and ((b.ksg in ('2','st02.001') and b.k_uslf >= 6) or (b.ksg in ('O14.1','O34.2','O36.3','O36.4','O42.2') and b.k_uslf >= 2) ))
          and exists (select 1 from zsd b where b.zs_id = :ida and b.ksg in ('4', '5', 'st02.003', 'st02.004'))) then
          begin
            --    
            select first 1 b.ksg_base, b.ds
            from zs a
             join zsd b on a.id = b.zs_id
             where b.zs_id = :ida and b.ksg in ('4', '5', 'st02.003', 'st02.004')
             into :ksg, :ds;
       
            update zsd d
            set d.tar_usl = d.tar_base,
                d.sum_uslf = d.sum_base,
                d.ksg = d.ksg_base,
                d.kskp = d.kskp_base
            where d.zs_id = :ida;

            --   
            select coalesce(sum(b.sum_uslf), 0) from zsd b where b.zs_id = :ida
             into :sum_uslf;
    
            update zs a set
             a.tar_usl = :tarif,
             a.sum_uslf = :sum_uslf,
             a.sum_usl = :sum_uslf,
             a.ksg = :ksg,
             a.ds1 = :ds,
             a.kslp = :kskp
             where a.id = :ida;

            exit;
          end
--------------------------------------------------------------------------------
      if ((is_transfer < 2) or (cl_cnt < 2))  then  --   
      begin
        --     ,   
        ksg = null;
        select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base
             from zsd b
             where b.zs_id = :ida and b.ksg_base is not null and ((:q_u = 1 and b.ksg_base >= '325' and b.ksg_base <= '343') or
                                                                                                  (:q_u = 3 and b.ksg_base >= '123' and b.ksg_base <= '134'))
             order by b.code_usl desc, b.sum_base desc
             into :idb, :ksg, :sum_uslf, :tarif;

        if (:ksg is null)  then
         select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base
             from zsd b
             where b.zs_id = :ida and b.ksg_base is not null
             order by b.code_usl desc, b.sum_base desc
             into :idb, :ksg, :sum_uslf, :tarif;

         --      
         update zsd b set
          b.ksg = :ksg, 
          b.sum_uslf = :sum_uslf,
          b.kskp = b.kskp_base,
          b.tar_usl = b.tar_base
          where b.id = :idb;

         update zsd b set
          b.ksg = null,
          b.sum_uslf = 0,
          b.kskp = 1,
          b.tar_usl = 0
          where b.id <> :idb and b.zs_id = :ida;
 
         update zs a set
          a.tar_usl = :tarif,
          a.sum_uslf = :sum_uslf,
          a.sum_usl = :sum_uslf,
          a.ksg = :ksg,
          a.kslp = :kskp
          where a.id = :ida;
 
      end else
      begin
        for select d.ds_class
         from zsd d
         where d.zs_id = :ida
         group by 1
         into :ds_class
         do
         begin
            if (((select count(dc.id) from ksg_dont_choice dc join zsd z on z.ksg_base = dc.ksg_ter or z.ksg_base = dc.ksg_surg
                    where z.zs_id = :ida and z.ds_class = :ds_class and :date2 between dc.bp and dc.epv) > 0) and (:q_u = 1)) then
               --    
            select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base
             from zsd b
             where b.zs_id = :ida and b.ksg_base is not null and b.ds_class = :ds_class and b.code_usl is not null
             order by b.code_usl desc, b.sum_base desc
             into :idb, :ksg, :sum_uslf, :tarif;
            else
               --     
            select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base
             from zsd b
             where b.zs_id = :ida and b.ksg_base is not null and b.ds_class = :ds_class
             order by b.code_usl desc, b.sum_base desc
             into :idb, :ksg, :sum_uslf, :tarif;
    
             --      
             update zsd b set
              b.ksg = :ksg, 
              b.sum_uslf = :sum_uslf,
              b.kskp = b.kskp_base,
              b.tar_usl = b.tar_base
              where b.id = :idb;
    
             update zsd b set
              b.ksg = null,
              b.sum_uslf = 0,
              b.kskp = 1,
              b.tar_usl = 0
              where b.id <> :idb and b.zs_id = :ida and b.ds_class = :ds_class;
         end

        select first 1 b.ksg_base, b.sum_base
        from zs a
         join zsd b on a.id = b.zs_id
         where b.zs_id = :ida and b.ksg is not null and b.ds = a.ds1
         order by b.sum_base desc
         into :ksg, :sum_uslf;

--        update zsd d
--         set d.tar_usl = d.tar_base,
--             d.sum_uslf = d.sum_base,
--             d.ksg = d.ksg_base,
--             d.kskp = d.kskp_base
--         where d.zs_id = :ida;
   
        select coalesce(sum(b.sum_uslf), 0), coalesce(sum(b.tar_base), 0)
         from zsd b
         join zs a on a.id = b.zs_id
         where b.zs_id = :ida and b.ksg is not null
         into :sum_uslf, :tarif;

        update zs a set
         a.tar_usl = :tarif,
         a.sum_uslf = :sum_uslf,
         a.sum_usl = :sum_uslf,
         a.ksg = :ksg,
         a.kslp = :kskp
         where a.id = :ida;
 
      end
end;

/* Alter (SP_ZS_SET_ZACHET) */
ALTER PROCEDURE SP_ZS_SET_ZACHET(HDR_ID INTEGER)
 AS
declare variable ZS_ID integer;
declare variable DATE1 DM_DATE;
begin
  for select z.id, z.date_1
      from zs z
      where z.hdr_id = :hdr_id
      into :zs_id, :date1
      do
      begin
        update zsd d
         set d.zachet = 1
         where d.zs_id = :zs_id and d.date_1 < :date1;

        execute procedure SP_CALC_ALL(:ZS_ID);
      end
end;

/* Alter (SP_ZSD_LIST_CREATE) */
ALTER PROCEDURE SP_ZSD_LIST_CREATE(ZS_ID INTEGER)
 AS
declare variable TARGET integer;
begin
  target = (select target from zs where id = :zs_id);

  if (exists (select id from zsd where zs_id = :zs_id)) then
   exit;

  if (target = 9) then
  begin
      insert into zsd(zs_id, code_usl, is_chield, pmd_close, date_1, date_2, sum_uslf, tar_usl, k_uslf, ds, IS_TEMP)
      select z.id, d.code_usl, 0, 0, z.date_1, z.date_1, d.tarif, d.tarif, 1, 'Z00.8', 1
       from zs z
            join patients p on p.id = z.patient_id
            join h_tarif_disp_09 d on d.stage = z.disp_stage and d.age = extract(year from z.date_1) - extract(year from p.dr)
                                      and d.sex = p.sex and z.date_2 between d.bp and d.epv
       where z.id = :zs_id and d.code_usl is not null and d.tarif is not null;
  end

  if (target in (10,17)) then
  begin
      insert into zsd(zs_id, code_usl, is_chield, pmd_close, date_1, date_2, sum_uslf, tar_usl, k_uslf, ds, IS_TEMP)
      select z.id, d.usl_code, 0, 0, z.date_1, z.date_1, d.tarif, d.tarif, 1, iif(z.age < 3, 'Z00.1', iif(z.age >= 3 and z.age < 15, 'Z00.2', 'Z00.3')), 1
       from zs z
            join patients p on p.id = z.patient_id
            join h_tarif_disp_10 d on d.stage = z.disp_stage and d.sex = p.sex
                                          and z.date_2 between d.bp and d.epv
                                          and z.age between d.y1 and d.y2
       where z.id = :zs_id and d.tarif is not null;
  end

  if (target = 13) then
  begin
      insert into zsd(zs_id, code_usl, is_chield, pmd_close, date_1, date_2, sum_uslf, tar_usl, k_uslf, ds, IS_TEMP)
      select z.id, d.usl_code, 0, 0, z.date_1, z.date_1, d.tarif, d.tarif, 1, iif(z.age < 3, 'Z00.1', iif(z.age >= 3 and z.age < 15, 'Z00.2', 'Z00.3')), 1
       from zs z
            join patients p on p.id = z.patient_id
            join h_tarif_disp_13_17 d on d.target = z.target
                                          and d.stage = z.disp_stage and d.sex = p.sex
                                          and z.date_2 between d.bp and d.epv
                                          and d.age_grp = z.age_grp
       where z.id = :zs_id and d.tarif is not null;
  end

  if (target in (14,15)) then
  begin
      insert into zsd(zs_id, code_usl, is_chield, pmd_close, date_1, date_2, sum_uslf, tar_usl, k_uslf, ds, IS_TEMP)
      select z.id, d.usl_code, 0, 0, z.date_1, z.date_1, d.tarif, d.tarif, 1, iif(z.age < 3, 'Z00.1', iif(z.age >= 3 and z.age < 15, 'Z00.2', 'Z00.3')),1
       from zs z
            join patients p on p.id = z.patient_id
            join h_tarif_disp_14_15 d on d.target = z.target
                                          and d.stage = z.disp_stage and d.sex = p.sex
                                          and z.date_2 between d.bp and d.epv
                                          and d.cat_info = z.cat_info
       where z.id = :zs_id and d.tarif is not null;
  end

  if (target = 16) then
  begin
      insert into zsd(zs_id, code_usl, is_chield, pmd_close, date_1, date_2, sum_uslf, tar_usl, k_uslf, ds, IS_TEMP)
      select z.id, d.code_usl, 0, 0, z.date_1, z.date_1, d.tarif, d.tarif, 1, 'Z00.8', 1
       from zs z
            join patients p on p.id = z.patient_id
            join zs_hdr h on h.id = z.hdr_id
            join h_tarif_disp_16 d on z.date_2 between d.bp and d.epv
                                          and d.sex = p.sex
                                          and d.age_l <= (h.y - extract(year from p.dr)) and d.age_r >= (h.y - extract(year from p.dr))
       where z.id = :zs_id and d.tarif is not null;
  end

  insert into ZS_DS (DS, DS_TYPE, SECTION, SECTION_ID, PR, IS_TEMP)
    select d.ds, 1, 2, d.id, 0, 1
    from zsd d
    where d.zs_id = :zs_id;

  execute procedure SP_CALC_ALL(:ZS_ID);
end;

