/* Alter View (Drop, Create)... */
/* Drop altered view: V_ZS */
DROP VIEW V_ZS;

/* Create altered view: V_ZS */
/* Create view: V_ZS */
CREATE VIEW V_ZS(
ID,
Q_U,
MP,
ORDER_V,
CODE_SPEC,
CODE_PROF,
OTD_PROF,
IS_CHIELD,
N_HIST,
DATE_1,
DATE_2,
DS0,
DS1,
DS2,
TAR_USL,
K_USLF,
K_USL,
IDSP,
TARGET,
RESULT,
PATIENT_ID,
FAM,
IM,
OT,
Q_U_NAME,
TARGET_NAME,
SUM_USLF,
HDR_ID,
DIRECTION_NUM,
DIRECTION_DATE,
DH_INFO,
MES_CODE,
SMP_BRIG,
DS3,
DCOUNT,
UID,
PHYS_ID,
CATEGORY,
DISP_STAGE,
DISP_WORK_STATE,
DISP_RESULT,
DISP_H_GROUP,
OUTCOME,
KSG,
CAT_INFO,
IDSP_NAME,
MP_NAME,
ORDER_V_NAME,
DH_INFO_NAME,
CODE_SPEC_NAME,
CODE_PROF_NAME,
IS_CHIELD_NAME,
SMP_BRIG_NAME,
RESULT_NAME,
OUTCOME_NAME,
FOR_POM,
VID_HMP,
METOD_HMP,
AGE_GRP,
CHIELD_WITH_ROP,
FOR_POM_NAME,
REGISTRY_ID,
PAYMENT_TYPE_ID,
PAYMENT_NAME,
REGISTRY_NAME,
SUM_USL,
DOCTOR_FIO,
DOCTOR_COD,
NUM_SP,
IDCASE,
Q_U_2016,
HAS_ERRORS,
CODE_MES1,
COMENTSL,
SMO,
OKATO_SMO,
OKATO_G,
OKATO_P,
SUM_OPL,
N_ZAP,
ZSP_VPOLIS,
ZSP_SPOLIS,
ZSP_NPOLIS,
ZSP_POLIS_BP,
ZSP_POLIS_EP,
ZSP_SMO_OGRN,
ZSP_SMO_CODE,
ZSP_ENP,
ZSP_SEND_DATE,
ZSP_RESP_DATE,
AGE,
DR,
DOC_SER,
DOC_NUM,
SEX,
PODR,
KSLP,
REG_DATE,
AGE_NAME,
M,
Y,
CH_NUM,
INV_STATE,
KSG_NUM,
KSG_PROF_NUM,
NPR_MO,
PER,
VBR,
TAL_D,
TAL_P,
INV,
RSLT_D,
NAZR,
NAZ_SP,
NAZ_V,
NAZ_PMP,
NAZ_PK,
IDSP_NOT_AUTO,
AGE_GRP_NOT_AUTO,
USER_ID,
USER_FIO,
MSE,
BARTHEL_IDX,
CODE_SPEC_V021,
ID_PAC,
DISP,
P_CEL,
C_ZAB)
 AS 
select z.id,
       z.q_u,
       z.mp,
       z.order_v,
       z.code_spec,
       z.code_prof,
       z.otd_prof,
       z.is_chield,
       z.n_hist,
       z.date_1,
       z.date_2,
       z.ds0,
       z.ds1,
       z.ds2,
       z.tar_usl,
       z.k_uslf,
       z.k_usl,
       z.idsp,
       z.target,
       z.result,  
       z.patient_id,
       p.fam,
       p.im,
       p.ot,
       q_u.name as q_u_name,
       t.name as target_name,
       z.sum_uslf,
       z.hdr_id,
       z.direction_num,
       z.direction_date,
       z.dh_info as dh_info,
       z.mes_code,
       z.smp_brig,
       z.ds3,
       Z.DCOUNT,
       z.uid,
       z.phys_id,
       z.category,
       z.disp_stage,
       z.disp_work_state,
       z.disp_result,
       z.disp_h_group,
       z.outcome,
       z.ksg,
       z.cat_info,
       i.name as idsp_name,
       m.name as mp_name,
       o.name as order_v_name,
       dh.name as dh_info_name,
       iif(z.date_2 >= '01.05.2018', (select name from h_spec_v021 where code = z.code_spec_v021), (select name from h_spec_v015 where code = z.code_spec)) as code_spec_name,
       co.name as code_prof_name,
       iif(z.is_chield = 1, '', '') as is_chield_name,
       sb.name as smp_brig_name,
       r.name as result_name,
       oc.name as outcome_name,
       z.for_pom,
       z.vid_hmp,
       z.metod_hmp,
       z.age_grp,
       z.chield_with_rop,
       fp.name,
       z.registry_id,
       Z.payment_type_id,
       pt.name,
       reg.name,
       z.sum_usl,
       df.fio,
       DF.pcod,
       p.num_sp,  --iif(z.payment_type_id <> 2, p.num_sp, (select ins.ser || ' ' || ins.num from patients_insurance ins where ins.patients_id = p.id and z.date_1 between ins.db and ins.de)),
       z.id_case,
       z.q_u_2016,
       0,--(select first 1 1 from error_list_local err where err.reestr_hdr_id = z.hdr_id and err.uid = z.uid),
       z.mes_code,
       z.comentsl,
       p.smo,
       p.okato_smo,
       p.okato_l,
       p.okato_r,
       z.sum_usl, --(select sum(pi.sum_opl) from patients_invoice pi where pi.zs_id = z.id),
       z.n_zap n_zap,
       zpr.vpolis,
       zpr.spolis,
       zpr.npolis,
       zpr.polis_bp,
       zpr.polis_ep,
       zpr.smo_ogrn,
       zpr.smo_code,
       zpr.enp,
       zp.send_date,
       zpr.resp_date,
       z.age,
       p.dr,
       p.doc_ser,
       p.doc_num,
       p.sex,
       z.podr,
       z.kslp,
       reg.reg_date,
       cast(floor(z.age) as varchar(3)) || '  ' ||
            cast(iif(extract(day from z.date_1) < extract(day from p.dr),
                 iif(extract(month from z.date_1) > extract(month from p.dr), extract(month from z.date_1) - extract(month from p.dr),
                             iif(extract(month from z.date_1) < extract(month from p.dr), 12 - extract(month from p.dr) + extract(month from z.date_1) - 1,
                                 11)),
                 iif(extract(month from z.date_1) > extract(month from p.dr), extract(month from z.date_1) - extract(month from p.dr),
                             iif(extract(month from z.date_1) < extract(month from p.dr), 12 - extract(month from p.dr) + extract(month from z.date_1),
                                   0))) as varchar(2)) || ' ',
       h.m,
       h.y, 
       h.full_name,
       coalesce(inv.status_id,0),
       ksg.ksg_name,
       ksg.prof_name,
       z.npr_mo,
       z.per,
       z.vbr,
       z.tal_d,
       z.tal_p,
       z.inv,
       Z.rslt_d,
       z.nazr,
       z.naz_sp,
       z.naz_v,
       z.naz_pmp,
       z.naz_pk,
       z.idsp_not_auto,
       Z.age_grp_not_auto,
       z.user_id,
       s.fio,
       z.mse,
       z.barthel_idx ,
       z.code_spec_v021,
       z.id_pac,
       Z.disp,
       z.p_cel,
       z.c_zab
from zs z
join patients p on p.id = z.patient_id
join zs_hdr h on h.id = z.hdr_id
left join invoice inv on inv.id = h.name
left join h_q_u q_u on q_u.id = z.q_u
left join h_target t on t.id = z.target
left join h_idsp i on i.id = z.idsp
left join h_mp m on m.code = z.mp
left join h_order_v o on o.id = z.order_v
left join h_dh_info dh on dh.id = z.dh_info
left join h_spec_v015 cs on cs.code = z.code_spec
left join h_code_otd co on co.code = z.code_prof
left join h_smp_brig sb on sb.id = z.smp_brig
left join h_result r on r.code = z.result
left join h_outcome oc on oc.code = z.outcome
left join h_for_pom fp on fp.code = z.for_pom
left join h_payment_type pt on pt.id = z.payment_type_id
left join v_registry reg on reg.id = z.registry_id
left join doctors_fio df on df.id = z.phys_id
left join zsp zp on zp.zs_id = z.id
left join zsp_resp zpr on zpr.zsp_id = zp.id
left join h_ksg ksg on (cast(ksg.ksg as varchar(50))) = z.ksg and z.q_u = ksg.q_u and z.date_2 between ksg.bp and ksg.epv
left join users s on s.id = z.user_id
where h.is_delete <> 1
;

/* Alter Procedure... */
/* Alter (SP_REESTR_EXTRACT_FOR_V2018) */

ALTER PROCEDURE SP_REESTR_EXTRACT_FOR_V2018(H_ID INTEGER)
 AS
declare variable D_ID integer;
declare variable ZS_ID integer;
declare variable DATE1 date;
declare variable DATE2 date;
declare variable PHYS_ID integer;
declare variable CODE_SPEC integer;
declare variable HDR_ID integer;
declare variable STAGE integer;
begin
for select h.id
    from zs_hdr h
    where h.id = :h_id or (h.parent_id = :h_id)
    into :hdr_id
    do
    begin
      update zs z
       set z.vb_p = 1
       where z.hdr_id = :hdr_id and (select count(id) from zsd d where d.zs_id = z.id and z.q_u in (1,3) and coalesce(d.code_usl,'') = '') > 1;
      /******************************************************************/
      for select d.id, z.id, d.date_1, d.date_2
          from zs z
               join zsd d on d.zs_id = z.id
          where z.hdr_id = :hdr_id and z.q_u in (1,3) and coalesce(d.code_usl,'') = ''
          into :d_id, :zs_id, :date1, :date2
          do
          begin
            update zsd d
             set d.zsd_id = :d_id
             where d.id = :d_id;
    
            update zsd d
             set d.zsd_id = :d_id
             where d.zs_id = :zs_id and coalesce(d.code_usl,'') <> ''
                   and d.date_1 between :date1 and :date2
                   and not exists(select id from zsd d2 where d2.zs_id = :zs_id and coalesce(d2.code_usl,'') = '' and d2.date_1 = :date2);
          end

      for select d.id, z.id, d.date_1, d.date_2
          from zs z
               join zsd d on d.zs_id = z.id
          where z.hdr_id = :hdr_id and z.q_u in (1,3) and not exists(select dd.id from zsd dd where dd.zs_id = z.id and coalesce(dd.code_usl,'') = '')
          order by d.ksg desc
          into :d_id, :zs_id, :date1, :date2
          do
          begin
            update zsd d
             set d.zsd_id = :d_id
             where d.id = :d_id;
    
            update zsd d
             set d.zsd_id = :d_id
             where d.zs_id = :zs_id and coalesce(d.code_usl,'') <> ''
                   and d.date_1 between :date1 and :date2
                   and not exists(select id from zsd d2 where d2.zs_id = :zs_id and coalesce(d2.code_usl,'') = '' and d2.date_1 = :date2)
                   and d.ksg is null;
          end
      /***********  ***********************************************/
      for select z.id, d.phys_id, d.code_spec_v021, z.date_1, z.date_2
          from zs z
               join zsd d on d.zs_id = z.id
          where z.hdr_id = :hdr_id and z.q_u in (2,4,5) and z.target not in (9,10,11,12,13,14,15,16,17,21,22)
          group by 1,2,3,4,5
          into :zs_id, :phys_id, :code_spec, :date1, :date2
          do
          begin
            d_id = (select first 1 id from zsd d where d.zs_id = :zs_id /*and d.phys_id = :phys_id*/ and d.code_spec_v021 = :code_spec and d.date_1 between :date1 and :date2 order by d.date_1 desc);
    
            update zsd d
             set d.zsd_id = :d_id
             where d.zs_id = :zs_id and d.date_1 between :date1 and :date2 /*and d.phys_id = :phys_id*/ and d.code_spec_v021 = :code_spec;
            d_id = null;
          end
      /***********  ***********************************************/
      for select z.id, z.disp_stage
          from zs z
--               join zsd d on d.zs_id = z.id
          where z.hdr_id = :hdr_id and z.q_u in (2) and z.target in (9,10,11,12,13,14,15,16,17) --and d.code_usl in ('1','16')
          group by 1,2
          into :zs_id, :stage
          do
          begin
            d_id = (select first 1 id from zsd d where d.zs_id = :zs_id and (d.code_usl in ('1','16','66','67','68','69') or :stage = 2) order by d.date_1);
            update zsd d
             set d.zsd_id = :d_id
             where d.zs_id = :zs_id;
            d_id = null;
          end
      /***********-***********************************************/
      for select z.id
          from zs z
--               join zsd d on d.zs_id = z.id
          where z.hdr_id = :hdr_id and z.q_u = 2 and z.target in (21,22)
          group by 1
          into :zs_id
          do
          begin
            d_id = (select first 1 id from zsd d where d.zs_id = :zs_id order by d.date_1);
            update zsd d
             set d.zsd_id = :d_id
             where d.zs_id = :zs_id;
            d_id = null;
          end
    end
end;

