ALTER PROCEDURE SP_ZS_UPDATE_FROM_ZSP(ZS_ID INTEGER)
 AS
declare variable PID integer;
declare variable POLIS_TYPE integer;
declare variable SER_SP DM_SER_SP;
declare variable NUM_SP DM_NUM_SP;
declare variable SMO DM_SMO;
declare variable OKATO_SMO DM_OKATO_11;
declare variable SMO_OGRN DM_OGRN;
declare variable ENP DM_ENP;
declare variable RID integer;
begin
  for select r.id, z.patient_id, r.vpolis, r.spolis, r.npolis, r.smo_code,
             r.smo_okato, r.enp, r.smo_ogrn
      from zsp zp
      join zsp_resp r on r.zsp_id = zp.id
      join zs z on z.id = zp.zs_id
      where zp.zs_id = :zs_id
      into :rid, :pid, :polis_type, :ser_sp, :num_sp, :smo, :okato_smo, :enp,:smo_ogrn
      do
      begin
        if (:rid is not null) then
        update PATIENTS
        set POLIS_TYPE = :POLIS_TYPE,
--            SER_SP = :SER_SP,
            NUM_SP = :enp,
            SMO = :SMO,
            OKATO_SMO = :OKATO_SMO,
            ENP = :ENP,
            SMO_OGRN = :SMO_OGRN
        where (ID = :PID);
        
        rid = null;
      end
end;


