/* Alter View (Drop, Create)... */
/* Drop altered view: V_INVOICES */
DROP VIEW V_INVOICES;

/* Create altered view: V_INVOICES */
/* Create view: V_INVOICES */
CREATE VIEW V_INVOICES(
ID,
INVOICE_NAME,
LPU,
M,
Y,
CONTRAGENT_ID,
CONTRAGENT_CODE,
INV_ID)
 AS 
select z.id,  COALESCE(z.full_name,'') || '/ ' ||COALESCE(c.short_name,'') || '/ ' || COALESCE(c2.short_name,''),
       i.lpu, z.m, z.y, i.contragent_id, c2.org_code, i.id
from zs_hdr z left join invoice i on i.id = z.name
     left join contragents c on c.org_code = i.lpu
     left join contragents c2 on c2.id = i.contragent_id
where z.is_delete = 0
;


