UPDATE OR INSERT INTO MEK_RULES (ID, NAME, SQL_TEXT, IS_ACTIVE, ERR_ID, KOMMENT, MEK_TABLES_ID, USL_TEXT, SQL_TEXT_SLUCH, TFOMS_CODE)
                         VALUES (48, '  V021', :h00000000_000001C6, 1, 97, '    /,   ( PRVS)    V021       USL', 2, 'not exists (select first 1 1 from h_spec_v021 h where h.code =   D.CODE_SPEC_V021   and  d.DATE_2 between datebeg and epv)', :h000001C6_000001D5, '1')
                       MATCHING (ID);
UPDATE OR INSERT INTO MEK_RULES (ID, NAME, SQL_TEXT, IS_ACTIVE, ERR_ID, KOMMENT, MEK_TABLES_ID, USL_TEXT, SQL_TEXT_SLUCH, TFOMS_CODE)
                         VALUES (64, '     ', :h0000039B_0000017E, 1, 31, '     RSLT  :      (407, 408, 409, 410, 411, 412, 413, 414, 415, 416) ', 1, '  Z.Q_U = 5 and  Z.RESULT in (407, 408, 409, 410, 411, 412, 413, 414, 415, 416)', :h00000519_0000018D, '148')
                       MATCHING (ID);
UPDATE OR INSERT INTO MEK_RULES (ID, NAME, SQL_TEXT, IS_ACTIVE, ERR_ID, KOMMENT, MEK_TABLES_ID, USL_TEXT, SQL_TEXT_SLUCH, TFOMS_CODE)
                         VALUES (66, '      ', :h000006A6_0000023C, 1, 33, '        -  : USL_OK = 1 - FOR_POM   (1, 2, 3) USL_OK = 2 - FOR_POM   (2, 3) USL_OK = 3 - FOR_POM   (2, 3) USL_OK = 4 - FOR_POM   (1, 2)', 1, 'not ( (Z.Q_U in (2,4) and  Z.FOR_POM in (2,3)) or ( Z.Q_U  = 5 and  Z.FOR_POM  in (1,2)) or (q_u = 1 and z.for_pom in (1,2,3))  or (q_u = 3 and z.for_pom in (2,3)))', :h000008E2_0000024B, '121')
                       MATCHING (ID);
UPDATE OR INSERT INTO MEK_RULES (ID, NAME, SQL_TEXT, IS_ACTIVE, ERR_ID, KOMMENT, MEK_TABLES_ID, USL_TEXT, SQL_TEXT_SLUCH, TFOMS_CODE)
                         VALUES (6, '   PODR    ', :h00000B2D_00000113, 1, 44, ' PODR   ', 2, ' Z.Q_U in (1,3) and COALESCE(D.PODR,'''') = '''' and coalesce(D.CODE_USL,'''') = ''''', :h00000C40_00000122, '20')
                       MATCHING (ID);
UPDATE OR INSERT INTO MEK_RULES (ID, NAME, SQL_TEXT, IS_ACTIVE, ERR_ID, KOMMENT, MEK_TABLES_ID, USL_TEXT, SQL_TEXT_SLUCH, TFOMS_CODE)
                         VALUES (104, '    ', :h00000D62_000001F3, 1, 113, '       :          (USL_OK=3)  IDSP<>30  P_CEL<>3.0   SL     1   .', 2, '(z.q_u = 2) and (z.idsp <> 30 and D.P_CEL <> ''3.0'') and  (Z.K_USLF > 1) and ((target >=9 and target <=17))', :h00000F55_00000202, '95')
                       MATCHING (ID);
UPDATE OR INSERT INTO MEK_RULES (ID, NAME, SQL_TEXT, IS_ACTIVE, ERR_ID, KOMMENT, MEK_TABLES_ID, USL_TEXT, SQL_TEXT_SLUCH, TFOMS_CODE)
                         VALUES (103, '      ', :h00001157_0000031E, 1, 111, '   VIDPOM  USL_OK -  :         (USL_OK = 1) VIDPOM   (3, 31, 33)       (USL_OK = 1) VIDPOM   (3, 32, 33) ', 1, '(( Z.Q_U = 1 and  Z.MP not in (3,31,33) and  coalesce(Z.METOD_HMP,0) = 0) or ( Z.Q_U in (1,3) and  Z.MP not in (3,32,33) and  coalesce(Z.METOD_HMP,0) > 0) or ( Z.Q_U = 3 and  Z.MP not in (12,13,14,31) and  coalesce(Z.METOD_HMP,0) = 0) or ( Z.Q_U in (2,4) and (target >=9 and target <=17) and  Z.MP not in (1, 11, 12, 13,14))  or  ( Z.Q_U = 5 and  Z.MP not in (2,22,23)))', :h00001475_0000032D, '94')
                       MATCHING (ID);
UPDATE OR INSERT INTO MEK_RULES (ID, NAME, SQL_TEXT, IS_ACTIVE, ERR_ID, KOMMENT, MEK_TABLES_ID, USL_TEXT, SQL_TEXT_SLUCH, TFOMS_CODE)
                         VALUES (46, '    ', :h000017A2_00000136, 1, 78, '   ', 1, '  (select 1 from h_idsp t where t.code = Z.IDSP   and   Z.DATE_2 between t.datebeg and t.epv) is null', :h000018D8_00000145, '37')
                       MATCHING (ID);
UPDATE OR INSERT INTO MEK_RULES (ID, NAME, SQL_TEXT, IS_ACTIVE, ERR_ID, KOMMENT, MEK_TABLES_ID, USL_TEXT, SQL_TEXT_SLUCH, TFOMS_CODE)
                         VALUES (106, 'C      ', :h00001A1D_00000338, 1, 112, '   USL_OK  IDSP -  :          (USL_OK = 1) IDSP = 33       (USL_OK = 1) (USL_OK = 1) IDSP = 32     ', 1, '( (Z.Q_U = 1 and  Z.METOD_HMP is null and  Z.IDSP not in (33)) or  (Z.Q_U = 1 and  Z.METOD_HMP is not null and  Z.IDSP not in (32)) or (Z.Q_U = 3 and  Z.METOD_HMP is null and  Z.IDSP not in (28,33)) or  (Z.Q_U = 3 and  Z.METOD_HMP is not null and  Z.IDSP not in (32)) or (Z.Q_U in (2) and (target >=9 and target <=17) and  Z.IDSP not in (28,29,30)) or  (Z.Q_U = 5 and Z.IDSP not in (24,28,36))  )', :h00001D55_00000347, '95')
                       MATCHING (ID);
UPDATE OR INSERT INTO MEK_RULES (ID, NAME, SQL_TEXT, IS_ACTIVE, ERR_ID, KOMMENT, MEK_TABLES_ID, USL_TEXT, SQL_TEXT_SLUCH, TFOMS_CODE)
                         VALUES (123, '    ', :h0000209C_00000168, 1, 19, '    ', 1, '(not exists (select first 1 1 from h_v016 h where h.code =    Z.DISP  and  z.DATE_2 between BP and epv) and (coalesce(Z.disp,'''') <> ''''))', :h00002204_00000177, '7')
                       MATCHING (ID);
UPDATE OR INSERT INTO MEK_RULES (ID, NAME, SQL_TEXT, IS_ACTIVE, ERR_ID, KOMMENT, MEK_TABLES_ID, USL_TEXT, SQL_TEXT_SLUCH, TFOMS_CODE)
                         VALUES (125, '  RSLT_D    v017    ', :h0000237B_000001B0, 1, 92, '    -  RSLT_D  V017    .', 1, '(not exists (select first 1 1 from H_DISP_RESULT h where h.code =    Z.RSLT_D  and  z.DATE_2 between BP and epv) and (coalesce( Z.RSLT_D ,'''') <> ''''))', :h0000252B_000001BF, '15')
                       MATCHING (ID);
UPDATE OR INSERT INTO MEK_RULES (ID, NAME, SQL_TEXT, IS_ACTIVE, ERR_ID, KOMMENT, MEK_TABLES_ID, USL_TEXT, SQL_TEXT_SLUCH, TFOMS_CODE)
                         VALUES (124, '  CRIT  SL_ID,     V024', :h000026EA_0000025F, 1, 19, '  CRIT  SL_ID,     V024', 2, '( ((coalesce(D.KSG_CRITERION,'''') <> '''') and (not exists (select first 1 1 from h_ksg_dop_criterian h where h.code =    D.KSG_CRITERION  and   Z.DATE_2  between datebeg and epv))) or
((coalesce(D.KSG_CRITERION2,'''') <> '''') and (not exists (select first 1 1 from h_ksg_dop_criterian h where h.code =    D.KSG_CRITERION2  and  Z.DATE_2 between datebeg and epv))) )', :h00002949_0000026E, '13')
                       MATCHING (ID);
UPDATE OR INSERT INTO MEK_RULES (ID, NAME, SQL_TEXT, IS_ACTIVE, ERR_ID, KOMMENT, MEK_TABLES_ID, USL_TEXT, SQL_TEXT_SLUCH, TFOMS_CODE)
                         VALUES (126, '  RSLT    v009    ', :h00002BB7_000001AA, 1, 93, '    -  RSLT  V009    .', 1, '(not exists (select first 1 1 from H_RESULT h where h.code =     Z.RESULT  and  z.DATE_2 between datebeg and epv) and (coalesce( Z.RESULT  ,'''') <> ''''))', :h00002D61_000001B9, '16')
                       MATCHING (ID);
UPDATE OR INSERT INTO MEK_RULES (ID, NAME, SQL_TEXT, IS_ACTIVE, ERR_ID, KOMMENT, MEK_TABLES_ID, USL_TEXT, SQL_TEXT_SLUCH, TFOMS_CODE)
                         VALUES (127, ' VIDPOM     v008    ', :h00002F1A_000001A9, 1, 94, '      -  VIDPOM  v008    .', 1, '(not exists (select first 1 1 from H_MP h where h.code =   Z.MP  and  z.DATE_2 between datebeg and epv) and (coalesce(  Z.MP  ,'''') <> ''''))', :h000030C3_000001B8, '25')
                       MATCHING (ID);
UPDATE OR INSERT INTO MEK_RULES (ID, NAME, SQL_TEXT, IS_ACTIVE, ERR_ID, KOMMENT, MEK_TABLES_ID, USL_TEXT, SQL_TEXT_SLUCH, TFOMS_CODE)
                         VALUES (128, ' FOR_POM     v014    ', :h0000327B_000001C6, 1, 95, '       -  FOR_POM  v014    .', 1, '(not exists (select first 1 1 from H_FOR_POM  h where h.code =   Z.FOR_POM   and  z.DATE_2 between datebeg and epv) and (coalesce(  Z.FOR_POM   ,'''') <> ''''))', :h00003441_000001D5, '26')
                       MATCHING (ID);
UPDATE OR INSERT INTO MEK_RULES (ID, NAME, SQL_TEXT, IS_ACTIVE, ERR_ID, KOMMENT, MEK_TABLES_ID, USL_TEXT, SQL_TEXT_SLUCH, TFOMS_CODE)
                         VALUES (129, ' NPR_MO     f003', :h00003616_000001A1, 1, 96, '    ,    (, , ) -  NPR_MO  F003.', 1, '(not exists (select first 1 1 from H_LPU  h where h.code =   Z.NPR_MO) and (coalesce(  Z.NPR_MO  ,'''') <> ''''))', :h000037B7_000001B0, '27')
                       MATCHING (ID);
UPDATE OR INSERT INTO MEK_RULES (ID, NAME, SQL_TEXT, IS_ACTIVE, ERR_ID, KOMMENT, MEK_TABLES_ID, USL_TEXT, SQL_TEXT_SLUCH, TFOMS_CODE)
                         VALUES (130, ' NPR_DATE           ', :h00003967_000001A7, 1, 15, '    NPR_DATE (    (, , ))  : (USL_OK = 1   FOR_POM = 3)  USL_OK = 2.', 1, '( (Z.DIRECTION_DATE is null) and ((q_u = 3) or ((q_u = 1) and (for_pom = 3))))', :h00003B0E_000001B6, '30')
                       MATCHING (ID);
UPDATE OR INSERT INTO MEK_RULES (ID, NAME, SQL_TEXT, IS_ACTIVE, ERR_ID, KOMMENT, MEK_TABLES_ID, USL_TEXT, SQL_TEXT_SLUCH, TFOMS_CODE)
                         VALUES (131, ' NPR_MO           ', :h00003CC4_000001A2, 1, 15, '    NPR_MO ( ,    (, , ))  : (USL_OK = 1   FOR_POM = 3)  USL_OK = 2.', 1, '( ( Z.NPR_MO  is null) and ((q_u = 3) or ((q_u = 1) and (for_pom = 3))))', :h00003E66_000001B1, '31')
                       MATCHING (ID);
UPDATE OR INSERT INTO MEK_RULES (ID, NAME, SQL_TEXT, IS_ACTIVE, ERR_ID, KOMMENT, MEK_TABLES_ID, USL_TEXT, SQL_TEXT_SLUCH, TFOMS_CODE)
                         VALUES (132, '  PROFIL    v002    ', :h00004017_00000196, 1, 98, '       -  PROFIL  V002       SL.', 2, '  (select 1 from h_code_otd t where t.code =  Z.CODE_PROF   and   Z.DATE_2 between t.datebeg and t.epv) is null', :h000041AD_000001A5, '40')
                       MATCHING (ID);
UPDATE OR INSERT INTO MEK_RULES (ID, NAME, SQL_TEXT, IS_ACTIVE, ERR_ID, KOMMENT, MEK_TABLES_ID, USL_TEXT, SQL_TEXT_SLUCH, TFOMS_CODE)
                         VALUES (133, '   PROFIL     v002    ', :h00004352_00000198, 1, 99, '      -  PROFIL  v010       USL.', 2, '  (select 1 from h_code_otd t where t.code =  D.CODE_PROF   and   Z.DATE_2 between t.datebeg and t.epv) is null', :h000044EA_000001A7, '41')
                       MATCHING (ID);
UPDATE OR INSERT INTO MEK_RULES (ID, NAME, SQL_TEXT, IS_ACTIVE, ERR_ID, KOMMENT, MEK_TABLES_ID, USL_TEXT, SQL_TEXT_SLUCH, TFOMS_CODE)
                         VALUES (134, '  PROFIL_K     v020    ', :h00004691_000001B2, 1, 100, '      -  PROFIL_K  V002      (USL_OK = 1  USL_OK = 2).', 2, '(q_u in (1,3)) and (  (select 1 from H_PROFIL_K t where t.code =  D.PROFIL_K  and Z.DATE_2 between t.datebeg and t.epv) is null)', :h00004843_000001C1, '42')
                       MATCHING (ID);
UPDATE OR INSERT INTO MEK_RULES (ID, NAME, SQL_TEXT, IS_ACTIVE, ERR_ID, KOMMENT, MEK_TABLES_ID, USL_TEXT, SQL_TEXT_SLUCH, TFOMS_CODE)
                         VALUES (135, '  P_CEL     v025    ', :h00004A04_0000019E, 1, 101, '  P_CEL     v025    ', 2, '(not exists (select first 1 1 from H_TARGET_V025 h where h.code =   D.P_CEL  and  z.DATE_2 between datebeg and epv) and (coalesce(  D.P_CEL ,'''') <> ''''))', :h00004BA2_000001AD, '43')
                       MATCHING (ID);
UPDATE OR INSERT INTO MEK_RULES (ID, NAME, SQL_TEXT, IS_ACTIVE, ERR_ID, KOMMENT, MEK_TABLES_ID, USL_TEXT, SQL_TEXT_SLUCH, TFOMS_CODE)
                         VALUES (136, ' DN   ,  P_CEL=1.3', :h00004D4F_000001A5, 1, 102, '     -  DN  :  DN           (USL_OK = 3  P_CEL = 1.3).', 2, '((q_u in (2,4)) and ( D.P_CEL = ''1.3'' ) and  (coalesce(D.DN,'''') = '''')) ', :h00004EF4_000001B4, '48')
                       MATCHING (ID);
UPDATE OR INSERT INTO MEK_RULES (ID, NAME, SQL_TEXT, IS_ACTIVE, ERR_ID, KOMMENT, MEK_TABLES_ID, USL_TEXT, SQL_TEXT_SLUCH, TFOMS_CODE)
                         VALUES (137, ' DN    ,  {1,2,4,6}', :h000050A8_0000019C, 1, 103, '      -  DN  :  DN      {1,2,4,6}        (USL_OK = 3).', 2, '(coalesce( D.DN,0) <> 0) and (d.dn not in (1,2,4,6))', :h00005244_000001AB, '50')
                       MATCHING (ID);
UPDATE OR INSERT INTO MEK_RULES (ID, NAME, SQL_TEXT, IS_ACTIVE, ERR_ID, KOMMENT, MEK_TABLES_ID, USL_TEXT, SQL_TEXT_SLUCH, TFOMS_CODE)
                         VALUES (138, ' P_PER,        ', :h000053EF_000001A0, 1, 104, '     / -  P_PER  :  P_PER             .', 2, '(( coalesce(D.P_PER,0) = 0) and (q_u in (1,3)))', :h0000558F_000001AF, '67')
                       MATCHING (ID);
UPDATE OR INSERT INTO MEK_RULES (ID, NAME, SQL_TEXT, IS_ACTIVE, ERR_ID, KOMMENT, MEK_TABLES_ID, USL_TEXT, SQL_TEXT_SLUCH, TFOMS_CODE)
                         VALUES (139, '    P_PER,  {1,2,3,4}', :h0000573E_000001C4, 1, 105, '     / -  P_PER  :  P_PER      {1,2,3,4}          .', 2, '(( coalesce(D.P_PER,0) not in (1,2,3,4)) and (q_u in (1,3)))', :h00005902_000001D3, '68')
                       MATCHING (ID);
UPDATE OR INSERT INTO MEK_RULES (ID, NAME, SQL_TEXT, IS_ACTIVE, ERR_ID, KOMMENT, MEK_TABLES_ID, USL_TEXT, SQL_TEXT_SLUCH, TFOMS_CODE)
                         VALUES (140, '    ED_COL       !', :h00005AD5_00000184, 1, 106, '       -  ED_COL  :   ED_COL    1  USL_OK = 3  FOR_POM = 2', 1, '( (Z.K_USLF <> 1) and (q_u =2 and  Z.FOR_POM = 2))', :h00005C59_00000193, '71')
                       MATCHING (ID);
UPDATE OR INSERT INTO MEK_RULES (ID, NAME, SQL_TEXT, IS_ACTIVE, ERR_ID, KOMMENT, MEK_TABLES_ID, USL_TEXT, SQL_TEXT_SLUCH, TFOMS_CODE)
                         VALUES (141, '       ', :h00005DEC_00000158, 1, 107, '    -  P_CEL  : USL_OK=3  FOR_POM=2    1.1 .', 2, '((q_u in (2,4)) and ( Z.FOR_POM = 2) and ( D.P_CEL  <> ''1.1''))', :h00005F44_00000167, '82')
                       MATCHING (ID);
UPDATE OR INSERT INTO MEK_RULES (ID, NAME, SQL_TEXT, IS_ACTIVE, ERR_ID, KOMMENT, MEK_TABLES_ID, USL_TEXT, SQL_TEXT_SLUCH, TFOMS_CODE)
                         VALUES (142, '     P_CEL    ', :h000060AB_0000019C, 1, 108, '          -  : USL_OK=3  P_CEL = 3.0            2.', 2, '(q_u = 2) and ( D.P_CEL  = ''3.0'') and ( Z.K_USLF < 2)', :h00006247_000001AB, '83')
                       MATCHING (ID);
UPDATE OR INSERT INTO MEK_RULES (ID, NAME, SQL_TEXT, IS_ACTIVE, ERR_ID, KOMMENT, MEK_TABLES_ID, USL_TEXT, SQL_TEXT_SLUCH, TFOMS_CODE)
                         VALUES (144, '        ', :h000063F2_00000160, 1, 110, '       -      ( ds02.005)', 1, '(q_u <> 3) and exists(select id from kslp_koef where zs_id = z.id)', :h00006552_0000016F, '92')
                       MATCHING (ID);
UPDATE OR INSERT INTO MEK_RULES (ID, NAME, SQL_TEXT, IS_ACTIVE, ERR_ID, KOMMENT, MEK_TABLES_ID, USL_TEXT, SQL_TEXT_SLUCH, TFOMS_CODE)
                         VALUES (143, '  ED_COL     KOL_USL   /', :h000066C1_000001C0, 1, 109, '   ED_COL (    )       KOL_USL (  ( ))     .', 1, ' Z.TARGET in (21,22) and  (Z.K_USLF <>  (select sum(K_USLF) from zsd where zs_id = Z.id))', :h00006881_000001CF, '89')
                       MATCHING (ID);
UPDATE OR INSERT INTO MEK_RULES (ID, NAME, SQL_TEXT, IS_ACTIVE, ERR_ID, KOMMENT, MEK_TABLES_ID, USL_TEXT, SQL_TEXT_SLUCH, TFOMS_CODE)
                         VALUES (145, '    P_CEL   RSLT    IDSP', :h00006A50_00000147, 1, 114, '  RS002', 2, '((q_u in (2,4)) and  (not exists (select 1 from mek_sprav s where s.kod1 =  Z.IDSP  and s.kod2 =  D.P_CEL and s.mek_rules_id = 145)))', :h00006B97_00000156, '97')
                       MATCHING (ID);
UPDATE OR INSERT INTO MEK_RULES (ID, NAME, SQL_TEXT, IS_ACTIVE, ERR_ID, KOMMENT, MEK_TABLES_ID, USL_TEXT, SQL_TEXT_SLUCH, TFOMS_CODE)
                         VALUES (146, '    P_CEL   RSLT    IDSP', :h00006CED_0000014A, 1, 114, '  RS006', 2, '((q_u in (2,4)) and (not exists (select 1 from mek_sprav s where s.kod1 =  D.P_CEL  and s.kod2 =  Z.RESULT  and s.mek_rules_id = 146 )))', :h00006E37_00000159, '97_2')
                       MATCHING (ID);
UPDATE OR INSERT INTO MEK_RULES (ID, NAME, SQL_TEXT, IS_ACTIVE, ERR_ID, KOMMENT, MEK_TABLES_ID, USL_TEXT, SQL_TEXT_SLUCH, TFOMS_CODE)
                         VALUES (147, '        " "', :h00006F90_0000015A, 1, 115, '        " " -  :  IDSP=28    .', 2, '(( Z.Q_U = 28) and  (coalesce(D.CODE_USL,'''') = '''')) ', :h000070EA_00000169, '98')
                       MATCHING (ID);
UPDATE OR INSERT INTO MEK_RULES (ID, NAME, SQL_TEXT, IS_ACTIVE, ERR_ID, KOMMENT, MEK_TABLES_ID, USL_TEXT, SQL_TEXT_SLUCH, TFOMS_CODE)
                         VALUES (148, '    ', :h00007253_000001B2, 1, 116, '       (VIDPOM) -  :     VIDPOM = 4 ( )   ,  ,    VIDPOM = 22 ( - ) .', 2, '(( D.MP = 4) or (z.q_u <> 5 and d.mp = 22))', :h00007405_000001C1, '99')
                       MATCHING (ID);
UPDATE OR INSERT INTO MEK_RULES (ID, NAME, SQL_TEXT, IS_ACTIVE, ERR_ID, KOMMENT, MEK_TABLES_ID, USL_TEXT, SQL_TEXT_SLUCH, TFOMS_CODE)
                         VALUES (149, '     ', :h000075C6_0000015D, 1, 15, '       -  PROFIL_K  :          .', 2, '( D.PROFIL_K is null) ', :h00007723_0000016C, '102')
                       MATCHING (ID);
UPDATE OR INSERT INTO MEK_RULES (ID, NAME, SQL_TEXT, IS_ACTIVE, ERR_ID, KOMMENT, MEK_TABLES_ID, USL_TEXT, SQL_TEXT_SLUCH, TFOMS_CODE)
                         VALUES (150, '         . ', :h0000788F_00000167, 1, 117, '      -  IDSP  :     .   IDSP = 30.', 1, '(target >=9 and target <=17) and (idsp <> 30)', :h000079F6_00000176, '103')
                       MATCHING (ID);
UPDATE OR INSERT INTO MEK_RULES (ID, NAME, SQL_TEXT, IS_ACTIVE, ERR_ID, KOMMENT, MEK_TABLES_ID, USL_TEXT, SQL_TEXT_SLUCH, TFOMS_CODE)
                         VALUES (151, '   RSLT_D     . ', :h00007B6C_00000201, 1, 118, '   RSLT_D     .  -  :      .   RSLT_D   (1, 2, 3, 4, 5, 12, 14, 15, 16, 17, 18, 19, 31, 32)', 1, '(target >=9 and target <=17) and ( Z.RSLT_D not in (1, 2, 3, 4, 5, 12, 14, 15, 16, 17, 18, 19, 31, 32))', :h00007D6D_00000210, '104')
                       MATCHING (ID);
UPDATE OR INSERT INTO MEK_RULES (ID, NAME, SQL_TEXT, IS_ACTIVE, ERR_ID, KOMMENT, MEK_TABLES_ID, USL_TEXT, SQL_TEXT_SLUCH, TFOMS_CODE)
                         VALUES (152, '     ', :h00007F7D_0000011E, 1, 119, '     / -   "1.0"', 2, '(target in (21,22)) and ( D.P_CEL  <> ''1.0'')', :h0000809B_0000012D, '109')
                       MATCHING (ID);
UPDATE OR INSERT INTO MEK_RULES (ID, NAME, SQL_TEXT, IS_ACTIVE, ERR_ID, KOMMENT, MEK_TABLES_ID, USL_TEXT, SQL_TEXT_SLUCH, TFOMS_CODE)
                         VALUES (153, '       SL ', :h000081C8_00000136, 1, 120, '     / -  PRVS = "60"', 2, '(target in (21,22)) and ( D.CODE_SPEC_V021  <> 60)', :h000082FE_00000145, '110')
                       MATCHING (ID);
UPDATE OR INSERT INTO MEK_RULES (ID, NAME, SQL_TEXT, IS_ACTIVE, ERR_ID, KOMMENT, MEK_TABLES_ID, USL_TEXT, SQL_TEXT_SLUCH, TFOMS_CODE)
                         VALUES (154, '       SL ', :h00008443_0000012E, 1, 121, '     / -  PROFIL = 78 ', 2, '(target in (21,22)) and ( D.CODE_PROF  <> ''78'')', :h00008571_0000013D, '112')
                       MATCHING (ID);
UPDATE OR INSERT INTO MEK_RULES (ID, NAME, SQL_TEXT, IS_ACTIVE, ERR_ID, KOMMENT, MEK_TABLES_ID, USL_TEXT, SQL_TEXT_SLUCH, TFOMS_CODE)
                         VALUES (155, '    IDSP      ', :h000086AE_00000176, 1, 122, '            -   "30"', 2, '(q_u = 2) and (idsp <> 30) and (target < 9) and (select count(id) from zsd where zs_id = z.id) > 1', :h00008824_00000185, '116')
                       MATCHING (ID);
UPDATE OR INSERT INTO MEK_RULES (ID, NAME, SQL_TEXT, IS_ACTIVE, ERR_ID, KOMMENT, MEK_TABLES_ID, USL_TEXT, SQL_TEXT_SLUCH, TFOMS_CODE)
                         VALUES (156, '     CODE_USL  PRVS      ', :h000089A9_00000258, 1, 123, '               -    "        (  )"', 2, 'not exists (select 1 from mek_sprav s where s.kod1 =  D.CODE_SPEC_V021  and s.kod2 =    D.CODE_USL  and s.mek_rules_id = 156) and (q_u = 2) and ((select count(id) from zsd where zs_id = z.id) > 1)', :h00008C01_00000267, '119')
                       MATCHING (ID);
UPDATE OR INSERT INTO MEK_RULES (ID, NAME, SQL_TEXT, IS_ACTIVE, ERR_ID, KOMMENT, MEK_TABLES_ID, USL_TEXT, SQL_TEXT_SLUCH, TFOMS_CODE)
                         VALUES (157, '   P_CEL  IDSP', :h00008E68_00000258, 1, 124, '        -  :      IDSP=28  P_CEL   (1.0,3.0) IDSP=29  P_CEL   (1.0,1.1,1.2,1.3,2.3,2.5,2.6,3.1) IDSP=30  P_CEL   (3.0,2.6)', 2, ' ((idsp = 28 and  D.P_CEL not in (''1.0'',''3.0'')) or (idsp = 29 and  D.P_CEL not in (''1.0'',''1.1'',''1.2'',''1.3'',''2.3'',''2.5'',''2.6'',''3.1'')) or (idsp = 30 and  D.P_CEL not in (''2.6'',''3.0'')))', :h000090C0_00000267, '122')
                       MATCHING (ID);
UPDATE OR INSERT INTO MEK_RULES (ID, NAME, SQL_TEXT, IS_ACTIVE, ERR_ID, KOMMENT, MEK_TABLES_ID, USL_TEXT, SQL_TEXT_SLUCH, TFOMS_CODE)
                         VALUES (158, '       .', :h00009327_0000017F, 1, 125, '         -   NPR_DATE        (   ).', 1, ' (Z.DIRECTION_DATE >  Z.DATE_1 )', :h000094A6_0000018E, '139')
                       MATCHING (ID);
UPDATE OR INSERT INTO MEK_RULES (ID, NAME, SQL_TEXT, IS_ACTIVE, ERR_ID, KOMMENT, MEK_TABLES_ID, USL_TEXT, SQL_TEXT_SLUCH, TFOMS_CODE)
                         VALUES (159, '       ', :h00009634_00000145, 1, 126, '           .         .', 1, '( Z.DATE_1 > Z.DATE_2 )', :h00009779_00000154, '140')
                       MATCHING (ID);
UPDATE OR INSERT INTO MEK_RULES (ID, NAME, SQL_TEXT, IS_ACTIVE, ERR_ID, KOMMENT, MEK_TABLES_ID, USL_TEXT, SQL_TEXT_SLUCH, TFOMS_CODE)
                         VALUES (160, '         ', :h000098CD_00000184, 1, 127, '     :          ,      . ', 2, '(( D.DS =  D.DS2 ) or ( D.DS =  D.DS3 ))', :h00009A51_00000193, '143')
                       MATCHING (ID);
UPDATE OR INSERT INTO MEK_RULES (ID, NAME, SQL_TEXT, IS_ACTIVE, ERR_ID, KOMMENT, MEK_TABLES_ID, USL_TEXT, SQL_TEXT_SLUCH, TFOMS_CODE)
                         VALUES (161, '      ', :h00009BE4_0000022D, 1, 128, '     -   IDSP  :USL_OK=3  PROFIL   (85, 86, 87, 88, 89, 90, 140, 171)  PRVS   (68, 69, 70, 71, 72, 208, 209, 233)     (29, 30).', 2, '(( Z.Q_U =5) and ( D.CODE_PROF in (''85'', ''86'', ''87'', ''88'', ''89'', ''90'', ''140'', ''171'')) and ( D.CODE_SPEC_V021  in (68, 69, 70, 71, 72, 208, 209, 233)) and (z.idsp not in (29,30)))', :h00009E11_0000023C, '146')
                       MATCHING (ID);
UPDATE OR INSERT INTO MEK_RULES (ID, NAME, SQL_TEXT, IS_ACTIVE, ERR_ID, KOMMENT, MEK_TABLES_ID, USL_TEXT, SQL_TEXT_SLUCH, TFOMS_CODE)
                         VALUES (162, '           ', :h0000A04D_00000234, 1, 129, '          :          (USL_OK=3)    SL   >1  USL    IDSP<>30  P_CEL<>3.0.   ', 2, '(q_u = 2) and ((select count(id) from zsd where zs_id = z.id and coalesce(code_usl,'''') <> '''') > 1) and ((idsp <> 30) or ( D.P_CEL <> ''3.0''))', :h0000A281_00000243, '152')
                       MATCHING (ID);
UPDATE OR INSERT INTO MEK_RULES (ID, NAME, SQL_TEXT, IS_ACTIVE, ERR_ID, KOMMENT, MEK_TABLES_ID, USL_TEXT, SQL_TEXT_SLUCH, TFOMS_CODE)
                         VALUES (163, '       ', :h0000A4C4_00000167, 1, 130, '     :       SL         .', 2, '(q_u = 4) and ( D.DATE_1 <>  D.DATE_2)', :h0000A62B_00000176, '153')
                       MATCHING (ID);
UPDATE OR INSERT INTO MEK_RULES (ID, NAME, SQL_TEXT, IS_ACTIVE, ERR_ID, KOMMENT, MEK_TABLES_ID, USL_TEXT, SQL_TEXT_SLUCH, TFOMS_CODE)
                         VALUES (164, '       ', :h0000A7A1_0000012F, 1, 131, '    :   1.1     "2".', 2, '( D.P_CEL = ''1.1'') and ( Z.FOR_POM <> 2)', :h0000A8D0_0000013E, '163')
                       MATCHING (ID);

COMMIT WORK;
