UPDATE OR INSERT INTO POPUP_SETTING (ID, NAME, SELECT_STMT, UPDATE_STMT)
                             VALUES (1, '  ', 'select id, id || '' '' || name name from h_target', 'update zs set target = :id where id = :zs_id')
                           MATCHING (ID);
UPDATE OR INSERT INTO POPUP_SETTING (ID, NAME, SELECT_STMT, UPDATE_STMT)
                             VALUES (2, '   ', 'select id, id || '' '' || name name from h_for_pom', 'update zs set for_pom = :id where id = :zs_id')
                           MATCHING (ID);
UPDATE OR INSERT INTO POPUP_SETTING (ID, NAME, SELECT_STMT, UPDATE_STMT)
                             VALUES (11, ' ', 'select code_v021 id, code_v021 || '' '' || spec_name name from DOCTORS_SPEC where code_v021 is not null group by 1,2', 'update zsd set code_spec_v021 = :id where zs_id = :zs_id and code_spec_v021 = (select code_spec_v021 from zs where id = :zs_id)')
                           MATCHING (ID);
UPDATE OR INSERT INTO POPUP_SETTING (ID, NAME, SELECT_STMT, UPDATE_STMT)
                             VALUES (12, '  ', 'select code id, code || '' '' || name name from h_idsp where current_date between datebeg and epv', 'update zs set idsp = :id, idsp_not_auto = 1 where id = :zs_id')
                           MATCHING (ID);
UPDATE OR INSERT INTO POPUP_SETTING (ID, NAME, SELECT_STMT, UPDATE_STMT)
                             VALUES (13, '  ', 'select idcz id, n_cz name from h_v027', 'update  zsd set c_zab = :id where zs_id = :zs_id')
                           MATCHING (ID);
UPDATE OR INSERT INTO POPUP_SETTING (ID, NAME, SELECT_STMT, UPDATE_STMT)
                             VALUES (14, '  ', 'select code id, code || '' '' || name name from h_dn where current_date between datebeg and epv', 'update  zsd set dn = :id where zs_id = :zs_id')
                           MATCHING (ID);
UPDATE OR INSERT INTO POPUP_SETTING (ID, NAME, SELECT_STMT, UPDATE_STMT)
                             VALUES (8, '  ', 'select code id, code || '' '' || name name from h_p_per', 'update zsd set p_per = :id where zs_id = :zs_id')
                           MATCHING (ID);
UPDATE OR INSERT INTO POPUP_SETTING (ID, NAME, SELECT_STMT, UPDATE_STMT)
                             VALUES (9, ' ', 'select id, idotd || '' '' || name name from h_podr where lpu = (select org_code from contragents where type_id = 1)', 'update zsd set podr = (select idotd from h_podr where id = :id) where zs_id = :zs_id')
                           MATCHING (ID);
UPDATE OR INSERT INTO POPUP_SETTING (ID, NAME, SELECT_STMT, UPDATE_STMT)
                             VALUES (3, '  ', 'select code id, code || '' '' || name name from h_result', 'update zs set result = :id where id = :zs_id')
                           MATCHING (ID);
UPDATE OR INSERT INTO POPUP_SETTING (ID, NAME, SELECT_STMT, UPDATE_STMT)
                             VALUES (4, '  ', 'select code id, code || '' '' || name name from h_outcome', 'update zs set outcome = :id where id = :zs_id')
                           MATCHING (ID);
UPDATE OR INSERT INTO POPUP_SETTING (ID, NAME, SELECT_STMT, UPDATE_STMT)
                             VALUES (5, '  ', 'select id, id || '' '' || name name from h_target_v025', 'update zsd set p_cel = (select code from h_target_v025 where id = :id) where zs_id = :zs_id')
                           MATCHING (ID);
UPDATE OR INSERT INTO POPUP_SETTING (ID, NAME, SELECT_STMT, UPDATE_STMT)
                             VALUES (6, '  ', 'select code id, code || '' '' || name name from h_code_otd', 'update zsd set code_prof = :id where zs_id = :zs_id')
                           MATCHING (ID);
UPDATE OR INSERT INTO POPUP_SETTING (ID, NAME, SELECT_STMT, UPDATE_STMT)
                             VALUES (7, '  ', 'select code id, code || '' '' || name name from h_profil_k', 'update zsd set profil_k = :id where zs_id = :zs_id')
                           MATCHING (ID);
UPDATE OR INSERT INTO POPUP_SETTING (ID, NAME, SELECT_STMT, UPDATE_STMT)
                             VALUES (15, '  ', 'select id, code || '' '' || name name from h_v016 where current_date between bp and epv', 'update zs set disp = (select code from h_v016 where id = :id) where id = :zs_id')
                           MATCHING (ID);
UPDATE OR INSERT INTO POPUP_SETTING (ID, NAME, SELECT_STMT, UPDATE_STMT)
                             VALUES (16, '  ', 'select code id, code || '' '' || name name from h_okato', 'update patients set okato_smo = :id where id = (select patient_id from zs where id = :zs_id)')
                           MATCHING (ID);
UPDATE OR INSERT INTO POPUP_SETTING (ID, NAME, SELECT_STMT, UPDATE_STMT)
                             VALUES (10, '  ', 'select code id, code || '' '' || name name from h_mp', 'update zsd set mp = :id where zs_id = :zs_id')
                           MATCHING (ID);

COMMIT WORK;
