CREATE OR ALTER TRIGGER ZSD_BU0 FOR ZSD
ACTIVE AFTER INSERT OR UPDATE OR DELETE POSITION 0
AS
declare variable spec varchar(10);
declare variable otd_prof varchar(20);
declare variable phys integer;
declare variable child integer;
declare variable prof varchar(10);
declare variable podr varchar(12);
declare variable mp integer ;
declare variable spec_v021 integer;
begin
  update zs
  set --k_uslf = (select sum(k_uslf) from zsd where zs_id = new.zs_id),
--      ds0 = (select first 1 zz.ds from zsd zz where zz.zs_id = new.zs_id and zz.date_1 =
--              (select min(date_1) from zsd where zs_id = new.zs_id)),
      dcount = (select count(distinct z.date_1) from zsd z where z.zs_id = new.zs_id)
    where id = new.zs_id;

    if ((select min(date_1) from zsd where zs_id = new.zs_id and coalesce(zachet,0) <> 1) is not null) then
    update zs
    set date_1 = (select min(date_1) from zsd where zs_id = new.zs_id and coalesce(zachet,0) <> 1),
        date_2 = (select max(date_2) from zsd where zs_id = new.zs_id and coalesce(zachet,0) <> 1)
    where id = new.zs_id;



  if (((new.date_2 >= (select date_2 from zs where id = new.zs_id))
      and ((select count(id) from zsd where zs_id = new.zs_id and coalesce(pmd_close,0) = 1) = 0)
      and (new.code_spec_v021 in (49,76)))
     or (new.pmd_close = 1))
  then
   begin
     update zs
     set code_spec = new.code_spec,
         code_spec_v021 = new.code_spec_v021,
         otd_prof = new.otd_prof,
--         ds1 = iif(coalesce(new.ds,'') = '', ds1, new.ds),
         phys_id = new.phys_id,
         is_chield = new.is_chield,
         code_prof = new.code_prof,
         podr = new.podr,
         mp = new.mp,
         ds1 = new.ds,
         ds2 = new.ds2,
         ds_onk = new.ds_onk,
         p_cel = new.p_cel,
         c_zab = new.c_zab,
         ksg_criterion = new.ksg_criterion,
         dn = new.dn
      where id = new.zs_id;
    end
   else
   if (((new.date_2 >= (select date_2 from zs where id = new.zs_id))
      and ((select count(id) from zsd where zs_id = new.zs_id and coalesce(pmd_close,0) = 1) = 0)
      and not exists(select id from zsd where zs_id =new.zs_id and date_2 = new.date_2 and (code_spec_v021 in (49,76))) )
     or (new.pmd_close = 1))
  then
   begin
     update zs
     set code_spec = new.code_spec,
         code_spec_v021 = new.code_spec_v021,
         otd_prof = new.otd_prof,
--         ds1 = iif(coalesce(new.ds,'') = '', ds1, new.ds),
         phys_id = new.phys_id,
         is_chield = new.is_chield,
         code_prof = new.code_prof,
         podr = new.podr,
         mp = new.mp,
         ds1 = new.ds,
         ds2 = new.ds2,
         ds_onk = new.ds_onk,
         p_cel = new.p_cel,
         c_zab = new.c_zab,
         ksg_criterion = new.ksg_criterion,
         dn = new.dn
      where id = new.zs_id;
    end
   else
    begin
      if (new.pmd_close = 0 and old.pmd_close = 1) then
      begin
      for select z.code_spec, z.otd_prof, z.phys_id, z.is_chield, z.code_prof, z.podr, z.mp, z.code_spec_v021 from zsd z
          where  (z.id = (select max(id) from zsd d where d.zs_id = new.zs_id and
                         (d.date_2 = (select max(date_2) from zsd where zs_id = new.zs_id))))
          into :spec, :otd_prof, :phys, :child, :prof, :podr, :mp, :spec_v021
      do
          update zs
          set code_spec = :spec,
              code_spec_v021 = :spec_v021,
             otd_prof = :otd_prof,
--             ds1 = iif(coalesce(:ds1,'') = '', ds1, :ds1),
             phys_id = :phys,
             is_chield = :child,
             code_prof = :prof,
             podr = :podr,
             mp = :mp,
             ds1 = new.ds,
             ds2 = new.ds2,
             ds_onk = new.ds_onk,
             p_cel = new.p_cel,
             c_zab = new.c_zab,
             ksg_criterion = new.ksg_criterion
          where id = new.zs_id;
      end
     end

    if ((select z.payment_type_id from zs z where z.id = new.zs_id) in (3,2)) then
    begin
        update zs
        set sum_uslf = (select sum(sum_uslf) from zsd where zs_id = new.zs_id),
            sum_usl = coalesce((select sum(i.sum_opl) from patients_invoice i where i.zs_id = new.zs_id), 0),
            tar_usl = null
        where id = new.zs_id and payment_type_id <> 1;
    end
    else
    if (((select q_u from zs where id = new.zs_id) = 2) and (coalesce(new.code_usl,'') <> '')
       and ((select target from zs where id = new.zs_id) = 1))  then
       if (exists(select id from h_usl where code = new.code_usl and q_u containing '4' and payment_type_id = 1 and new.date_2 between datebeg and dateend)) then
        update zs z
         set z.q_u = 4
         where id = new.zs_id;

--   if (coalesce(new.code_usl,'') <> '') then
--    if ((select first 1 1 from h_tomo_code c where c.nms_code = new.code_usl) = 1) then
--      update zs z
--       set z.target = iif((select first 1 c.group_num from h_tomo_code c where c.nms_code = new.code_usl) in (1,2), 21, 22)
--       where z.id = new.zs_id and z.q_u = 2;
end;
