ALTER PROCEDURE SP_CALC_AGE_GRP(DR DM_DATE,
DATE_1 DM_DATE)
 RETURNS(AGE_GRP INTEGER)
 AS
declare variable Y_DR integer;
declare variable M_DR integer;
declare variable Y_DATE1 integer;
declare variable M_DATE1 integer;
declare variable I integer;
begin
  y_dr = extract(year from :dr);
  m_dr = extract(month from :dr);
  y_date1 = extract(year from :date_1);
  m_date1 = extract(month from :date_1);

  if ((y_dr = y_date1) and (m_dr = m_date1)) then -- 1 
   age_grp = 1;
  else
  if ((y_dr = y_date1) and (m_dr <> m_date1)) then -- 2-12 
    age_grp = m_date1 - m_dr + 1;
  else
  if (((y_date1 - y_dr) = 1) and (m_date1 <= m_dr)) then -- 2-13 
    age_grp = 12 - m_dr + m_date1 + 1;
  else
  if (((y_date1 - y_dr) > 0) and ((y_date1 - y_dr) <= 3)) then -- 15-18 
  begin
    i = ((y_date1 - y_dr)*12 - m_dr + m_date1);
    age_grp =  case
                when (i = 15) then 15
                when (i = 18) then 16
                when (i = 21) then 17
--                when (i = 30) then 19
                else null
              end;

    if ((age_grp is null) and ((y_date1 - y_dr) = 2)) then
      age_grp = 18;
    else
    if ((age_grp is null) and ((y_date1 - y_dr) = 3)) then
      age_grp = 20;

    if (age_grp is null and i < 15) then age_grp = 13;
    else
    if (age_grp is null and i > 15 and i < 18) then age_grp = 15;
    else
    if (age_grp is null and i > 18 and i < 21) then age_grp = 16;
    else
    if (age_grp is null and i > 21 and i < 24) then age_grp = 17;
  end
  else
  if ((y_date1 - y_dr) > 3) then
    age_grp = :y_date1 - :y_dr + 17;

  if (age_grp = 35) then age_grp = 34;
  suspend;
end;

/* Alter (SP_GEN_DISP09_TARIF) */
ALTER PROCEDURE SP_GEN_DISP09_TARIF(STAGE INTEGER,
SEX DM_SEX,
BP DM_DATE,
EP DM_DATE,
CODE_USL DM_CHAR_50)
 AS
declare variable AGE integer;
begin
  age = 21;

  if (:stage = 2) then
  begin
    update or insert into H_TARIF_DISP_09 (STAGE, AGE, SEX, BP, EP, CODE_USL)
         values (:STAGE, 1, :SEX, :BP, :EP, :CODE_USL)
         matching (STAGE, AGE, SEX, BP, CODE_USL);
    exit;
  end
      while (age <= 99) do
      begin
        update or insert into H_TARIF_DISP_09 (STAGE, AGE, SEX, BP, EP, CODE_USL)
         values (:STAGE, :AGE, :SEX, :BP, :EP, :CODE_USL)
         matching (STAGE, AGE, SEX, BP, CODE_USL);
        age = age + 3;
      end

       update or insert into H_TARIF_DISP_09 (STAGE, AGE, SEX, BP, EP, CODE_USL)
         values (:STAGE, 49, :SEX, :BP, :EP, :CODE_USL)
         matching (STAGE, AGE, SEX, BP, CODE_USL);

        update or insert into H_TARIF_DISP_09 (STAGE, AGE, SEX, BP, EP, CODE_USL)
         values (:STAGE, 53, :SEX, :BP, :EP, :CODE_USL)
         matching (STAGE, AGE, SEX, BP, CODE_USL);

       update or insert into H_TARIF_DISP_09 (STAGE, AGE, SEX, BP, EP, CODE_USL)
         values (:STAGE, 55, :SEX, :BP, :EP, :CODE_USL)
         matching (STAGE, AGE, SEX, BP, CODE_USL);

        update or insert into H_TARIF_DISP_09 (STAGE, AGE, SEX, BP, EP, CODE_USL)
         values (:STAGE, 59, :SEX, :BP, :EP, :CODE_USL)
         matching (STAGE, AGE, SEX, BP, CODE_USL);

       update or insert into H_TARIF_DISP_09 (STAGE, AGE, SEX, BP, EP, CODE_USL)
         values (:STAGE, 61, :SEX, :BP, :EP, :CODE_USL)
         matching (STAGE, AGE, SEX, BP, CODE_USL);

        update or insert into H_TARIF_DISP_09 (STAGE, AGE, SEX, BP, EP, CODE_USL)
         values (:STAGE, 65, :SEX, :BP, :EP, :CODE_USL)
         matching (STAGE, AGE, SEX, BP, CODE_USL);

       update or insert into H_TARIF_DISP_09 (STAGE, AGE, SEX, BP, EP, CODE_USL)
         values (:STAGE, 67, :SEX, :BP, :EP, :CODE_USL)
         matching (STAGE, AGE, SEX, BP, CODE_USL);

        update or insert into H_TARIF_DISP_09 (STAGE, AGE, SEX, BP, EP, CODE_USL)
         values (:STAGE, 71, :SEX, :BP, :EP, :CODE_USL)
         matching (STAGE, AGE, SEX, BP, CODE_USL);

        update or insert into H_TARIF_DISP_09 (STAGE, AGE, SEX, BP, EP, CODE_USL)
         values (:STAGE, 73, :SEX, :BP, :EP, :CODE_USL)
         matching (STAGE, AGE, SEX, BP, CODE_USL);

        update or insert into H_TARIF_DISP_09 (STAGE, AGE, SEX, BP, EP, CODE_USL)
         values (:STAGE, 50, :SEX, :BP, :EP, :CODE_USL)
         matching (STAGE, AGE, SEX, BP, CODE_USL);

       update or insert into H_TARIF_DISP_09 (STAGE, AGE, SEX, BP, EP, CODE_USL)
         values (:STAGE, 52, :SEX, :BP, :EP, :CODE_USL)
         matching (STAGE, AGE, SEX, BP, CODE_USL);

        update or insert into H_TARIF_DISP_09 (STAGE, AGE, SEX, BP, EP, CODE_USL)
         values (:STAGE, 56, :SEX, :BP, :EP, :CODE_USL)
         matching (STAGE, AGE, SEX, BP, CODE_USL);

       update or insert into H_TARIF_DISP_09 (STAGE, AGE, SEX, BP, EP, CODE_USL)
         values (:STAGE, 58, :SEX, :BP, :EP, :CODE_USL)
         matching (STAGE, AGE, SEX, BP, CODE_USL);

        update or insert into H_TARIF_DISP_09 (STAGE, AGE, SEX, BP, EP, CODE_USL)
         values (:STAGE, 62, :SEX, :BP, :EP, :CODE_USL)
         matching (STAGE, AGE, SEX, BP, CODE_USL);

       update or insert into H_TARIF_DISP_09 (STAGE, AGE, SEX, BP, EP, CODE_USL)
         values (:STAGE, 64, :SEX, :BP, :EP, :CODE_USL)
         matching (STAGE, AGE, SEX, BP, CODE_USL);

        update or insert into H_TARIF_DISP_09 (STAGE, AGE, SEX, BP, EP, CODE_USL)
         values (:STAGE, 68, :SEX, :BP, :EP, :CODE_USL)
         matching (STAGE, AGE, SEX, BP, CODE_USL);

       update or insert into H_TARIF_DISP_09 (STAGE, AGE, SEX, BP, EP, CODE_USL)
         values (:STAGE, 70, :SEX, :BP, :EP, :CODE_USL)
         matching (STAGE, AGE, SEX, BP, CODE_USL);
end;

