ALTER TABLE ACTIONS ADD WITH_OTHER_DISCOUNTS DM_BOOLEAN;

DESCRIBE FIELD WITH_OTHER_DISCOUNTS TABLE ACTIONS
'   ';

ALTER TABLE DISPATCHS ADD TEMPLATE_TEXT DM_CHAR_500;

ALTER TABLE H_KSLP_TYPE ADD Z_SL DM_NUM_3_2;

ALTER TABLE H_KSLP_TYPE ADD Q_U DM_INT;

ALTER TABLE H_KSLP_TYPE ADD TF_OKATO DM_OKATO;

ALTER TABLE KSG_GRP ADD DOP_CRITERION2 DM_CHAR_10;

ALTER TABLE KSG_TMP ADD DOP_CRITERIAN2 DM_CHAR_10;

ALTER TABLE ZS ADD FINE_KOEF_SET_DOCTOR DM_BOOLEAN;

ALTER TABLE ZSD ADD FINE_KOEF DM_NUM_6_2;


ALTER TRIGGER DOCTORS_PROF_BIU0
 AS Declare variable I integer;
BEGIN I = 0; END;

ALTER TABLE DOCTORS_PROF ALTER COLUMN PROF_NAME TYPE DM_CHAR_500;

/* Empty SP_CALC_STAC for drop H_KSG_DOP(KSG) */

ALTER PROCEDURE SP_CALC_STAC(IDA INTEGER)
 AS
 BEGIN EXIT; END;

/* Empty SP_CALC_STAC_2018 for drop H_KSG_DOP(KSG) */
ALTER PROCEDURE SP_CALC_STAC_2018(IDA INTEGER)
 AS
 BEGIN EXIT; END;

/* Empty SP_CALC_STAC_FINE for drop H_KSG_DOP(KSG) */
ALTER PROCEDURE SP_CALC_STAC_FINE(IDA INTEGER,
IDB INTEGER,
KSG INTEGER,
CL_CNT INTEGER)
 RETURNS(FINE_KOEF /* TYPE OF DM_NUM_3_2 */ NUMERIC(3,2))
 AS
 BEGIN SUSPEND; END;

/* Empty SP_CALC_STAC_FINE_2018 for drop H_KSG_DOP(KSG) */
ALTER PROCEDURE SP_CALC_STAC_FINE_2018(IDA INTEGER,
IDB INTEGER,
KSG INTEGER,
CL_CNT INTEGER)
 RETURNS(FINE_KOEF /* TYPE OF DM_NUM_3_2 */ NUMERIC(3,2))
 AS
 BEGIN SUSPEND; END;

/* Empty SP_CALC_STAC_KSKP_2017 for drop H_KSG_DOP(KSG) */
ALTER PROCEDURE SP_CALC_STAC_KSKP_2017(IDA INTEGER,
IDB INTEGER,
KSG INTEGER,
CL_CNT INTEGER)
 RETURNS(KSKP /* TYPE OF DM_NUM_3_2 */ NUMERIC(3,2))
 AS
 BEGIN SUSPEND; END;

/* Empty SP_CALC_STAC_KSKP_2018 for drop H_KSG_DOP(KSG) */
ALTER PROCEDURE SP_CALC_STAC_KSKP_2018(IDA INTEGER,
IDB INTEGER,
KSG INTEGER,
CL_CNT INTEGER)
 RETURNS(KSKP /* TYPE OF DM_NUM_3_2 */ NUMERIC(3,2))
 AS
 BEGIN SUSPEND; END;

ALTER TABLE H_KSG_DOP ALTER COLUMN KSG TYPE DM_CHAR_20;

ALTER TABLE H_KSLP_TYPE ALTER COLUMN NAME TYPE DM_CHAR_500;

/* Empty SP_KSG_GET for drop KSG_DONT_CHOICE(KSG_TER) */

ALTER PROCEDURE SP_KSG_GET(DS1 /* TYPE OF DM_DS */ VARCHAR(7),
DR DATE,
DATE2 /* TYPE OF DM_DATE */ DATE,
CODE_USL /* TYPE OF DM_CHAR_20 */ VARCHAR(20),
SEX /* TYPE OF DM_SEX */ VARCHAR(1),
K_USLF /* TYPE OF DM_NUM_6_2 */ NUMERIC(6,2),
Q_U INTEGER,
DS2 /* DM_DS */ VARCHAR(7),
IDB INTEGER = null,
DOP_CRITERION /* DM_CHAR_10 */ VARCHAR(10) = null)
 RETURNS(KSG INTEGER,
ERR_CODE INTEGER)
 AS
 BEGIN SUSPEND; END;

ALTER TABLE KSG_DONT_CHOICE ALTER COLUMN KSG_TER TYPE DM_CHAR_20;

ALTER TABLE KSG_DONT_CHOICE ALTER COLUMN KSG_SURG TYPE DM_CHAR_20;

/* Empty SP_KSG_TMP_CRITERION for drop KSG_TMP(KSG) */

ALTER PROCEDURE SP_KSG_TMP_CRITERION(GROUP_CODE INTEGER,
STEP_NUM INTEGER,
DATE2 DATE,
DR DATE,
K_USLF /* DM_NUM_6_2 */ NUMERIC(6,2),
SEX /* TYPE OF DM_SEX */ VARCHAR(1))
 RETURNS(ERR_CODE INTEGER,
KSG INTEGER)
 AS
 BEGIN SUSPEND; END;

/* Empty SP_KSG_TMP_CRITERION_2017 for drop KSG_TMP(KSG) */
ALTER PROCEDURE SP_KSG_TMP_CRITERION_2017(GROUP_CODE INTEGER,
STEP_NUM INTEGER,
DATE2 DATE,
DR DATE,
K_USLF /* DM_NUM_6_2 */ NUMERIC(6,2),
SEX /* TYPE OF DM_SEX */ VARCHAR(1),
DOP_CRITERIAN /* DM_CHAR_10 */ VARCHAR(10) = null,
CODE_USL /* DM_CHAR_50 */ VARCHAR(50) = null,
DS /* DM_DS */ VARCHAR(7) = null)
 RETURNS(ERR_CODE INTEGER,
KSG INTEGER)
 AS
 BEGIN SUSPEND; END;

ALTER TABLE KSG_TMP ALTER COLUMN KSG TYPE DM_CHAR_20;

/* Drop table-fields... */
DROP VIEW V_DISPATCHS;

DROP VIEW V_DISPATCHS_PATIENTS;

ALTER TABLE DISPATCHS DROP TEMPLATE_ID;


/* Create Procedure... */

CREATE PROCEDURE SP_CALC_STAC_KSKP_2019(IDA INTEGER,
IDB INTEGER,
KSG DM_CHAR_20,
CL_CNT INTEGER)
 RETURNS(KSKP TYPE OF DM_NUM_3_2)
 AS
 BEGIN SUSPEND; END;

CREATE PROCEDURE SP_CHECK_DS_GRP(DS DM_DS,
DS_CHECK DM_DS)
 RETURNS(IS_LIKE DM_BOOL)
 AS
 BEGIN SUSPEND; END;

CREATE PROCEDURE SP_GET_PATIENTS_DISCOUNT_TYPE(PAT_ID INTEGER,
DISCOUNT_TYPE INTEGER)
 RETURNS(DISCOUNT DM_NUM_6_2)
 AS
 BEGIN SUSPEND; END;


/* Create Views... */
/* Create view: V_DISPATCHS */

CREATE VIEW V_DISPATCHS(
ID,
NAME,
DISPATCH_TYPE,
ACTION_ID,
USER_ID,
NOTE,
USER_FIO,
TEMPLATE_TEXT,
ACTION_NAME,
DISPATCH_TYPE_NAME)
 AS 
select D.ID,
       D.NAME,
       D.DISPATCH_TYPE,
--       D.TEMPLATE_ID,
       D.ACTION_ID,
       D.USER_ID,
       D.NOTE,
       u.fio user_fio,
       d.template_text,
       a.name action_name,
       iif(d.dispatch_type = 0, '', 'EMail')
from DISPATCHS D  
     left join users u on u.id = d.user_id
     left join actions a on a.id = d.action_id
;

/* Create view: V_DISPATCHS_PATIENTS */
CREATE VIEW V_DISPATCHS_PATIENTS(
ID,
DISPATCH_ID,
PATIENT_ID,
PATIENT_FIO,
DR,
PHONES,
EMAIL,
DISPATCH_NAME,
RESULT_ID,
RESULT_NAME,
NOTE)
 AS 
select DP.ID,
       DP.DISPATCH_ID,
       DP.PATIENT_ID,
       coalesce(p.fam,'') || ' ' || coalesce(p.im,'') || ' ' || coalesce(p.ot,''),
       p.dr,
       p.phones,
       p.email,
       d.name,
       dp.result_id,
       dr.name,
       dp.note
from DISPATCHS_PATIENTS DP
     left join patients p on p.id = dp.patient_id
     left join dispatchs d on d.id = dp.dispatch_id
     LEFT join h_dispatch_results dr on dr.id = dp.result_id
;


/* Alter View (Drop, Create)... */
/* Drop altered view: V_ZSD */
DROP VIEW V_ZSD;

/* Create altered view: V_ZSD */
/* Create view: V_ZSD */
CREATE VIEW V_ZSD(
ID,
ZS_ID,
DATE_1,
DATE_2,
CODE_SPEC,
CODE_PROF,
USL_TYPE,
OTD_PROF,
IS_CHIELD,
DS,
DS2,
SRVPLACE,
CODE_USL,
K_USLF,
PHYS_ID,
MES_CODE,
FIO,
SPEC_NAME,
SRVPLACE1,
DCOUNT,
KSG,
PCOD,
TAR_USL,
PMD_CLOSE,
SUM_USLF,
ORIT,
MP,
USL_NAME,
Q_U,
TARGET,
DISP_STAGE,
DATE_1_ZS,
TOOTH,
ZACHET,
IS_NO_GET_USL,
KSG_BASE,
SUM_BASE,
TAR_BASE,
KSKP_BASE,
COMMENT_LOCAL,
PODR,
TOOTH_LIST,
PROF_NAME,
FAM,
IM,
OT,
DR,
PHONES,
EMAIL,
Q_U_NAME,
KSG_CRITERION,
ZSD_ID,
P_CEL,
DN,
PROFIL_K,
P_PER,
DS_ONK,
KSG_CRITERION2,
CODE_SPEC_V021,
SER_SP,
NUM_SP,
C_ZAB,
FINE_KOEF_SET_DOCTOR)
 AS 
select zz.ID, zz.zs_id, zz.DATE_1, zz.DATE_2, iif(z.date_2 >= '01.05.2018', zz.code_spec_v021, zz.code_spec), zz.CODE_prof, zz.usl_type,
       zz.OTD_PROF, zz.IS_CHIELD,
       zz.DS, zz.DS2, zz.SRVPLACE, zz.CODE_USL, zz.K_USLF, 
       zz.PHYS_ID, z.mes_code, 
       iif(zz.phys_id = '', '', (select fio from doctors_fio where id = zz.phys_id)) as fio,
       iif(z.date_2 >= '01.05.2018', (select name from h_spec_v021 where code = zz.code_spec_v021), (select name from h_spec_v015 where code = zz.code_spec)) as spec_name, pl.name as srvplace,
       zz.dcount,zz.ksg, iif(zz.phys_id = '', '', (select pcod from doctors_fio where id = zz.phys_id)) as pcod,
       zz.tar_usl, coalesce(zz.pmd_close,0), zz.sum_uslf, zz.orit, zz.mp,
       (select first 1 name from h_usl u where u.code = zz.code_usl
        and u.q_u containing cast(z.q_u as varchar(1)) and u.payment_type_id = z.payment_type_id
        and z.date_1 between u.datebeg and u.dateend),
       z.q_u, z.target, z.disp_stage, z.date_1, zz.tooth_id, coalesce(zz.zachet,0), coalesce(ZZ.is_no_get_usl,0),
       zz.ksg_base, zz.sum_base, zz.tar_base, zz.kskp_base, zz.comment_local, zz.podr,
       iif((coalesce(zz.tooth_id,0) = 0 or coalesce(zz.tooth_list,'')='') and z.q_u = 4, zz.tooth_id, zz.tooth_list),
       o.name, p.fam, p.im, p.ot, p.dr, p.phones, p.email, q.name, zz.ksg_criterion, zz.zsd_id,
       zz.p_cel, zz.dn, zz.profil_k, zz.p_per, zz.ds_onk, zz.ksg_criterion2, zz.code_spec_v021,
       p.ser_sp, p.num_sp, zz.c_zab, z.fine_koef_set_doctor
from ZSd zz
     left join zs z on z.id = zz.zs_id
     left join patients p on p.id = z.patient_id
--     left join h_spec_v015 cs on cs.code = zz.code_spec
--     left join h_spec_v021 cs2 on cs2.code = zz.code_spec_v021
     left join h_srvplace pl on pl.id = zz.srvplace
     left join h_code_otd o on o.code = zz.code_prof
     left join h_q_u q on q.id = z.q_u
;

/* Create index... */
CREATE INDEX KSG_GRP_IDX1 ON KSG_GRP(KSG, BP, Q_U);

CREATE INDEX KSG_GRP_IDX2 ON KSG_GRP(DS);

CREATE INDEX KSG_GRP_IDX3 ON KSG_GRP(NMS_CODE);


/* Alter empty procedure SP_CALC_STAC_FINE_2018 with new param-list */

ALTER PROCEDURE SP_CALC_STAC_FINE_2018(IDA INTEGER,
IDB INTEGER,
KSG DM_CHAR_20,
CL_CNT INTEGER)
 RETURNS(FINE_KOEF TYPE OF DM_NUM_3_2)
 AS
 BEGIN SUSPEND; END;

/* Alter empty procedure SP_CALC_STAC_KSKP_2018 with new param-list */
ALTER PROCEDURE SP_CALC_STAC_KSKP_2018(IDA INTEGER,
IDB INTEGER,
KSG DM_CHAR_20,
CL_CNT INTEGER)
 RETURNS(KSKP TYPE OF DM_NUM_3_2)
 AS
 BEGIN SUSPEND; END;

/* Alter empty procedure SP_KSG_GET with new param-list */
ALTER PROCEDURE SP_KSG_GET(DS1 TYPE OF DM_DS,
DR DATE,
DATE2 TYPE OF DM_DATE,
CODE_USL TYPE OF DM_CHAR_20,
SEX TYPE OF DM_SEX,
K_USLF TYPE OF DM_NUM_6_2,
Q_U INTEGER,
DS2 DM_DS,
IDB INTEGER = null,
DOP_CRITERION DM_CHAR_10 = null,
DOP_CRITERION2 DM_CHAR_10 = null)
 RETURNS(KSG DM_CHAR_20,
ERR_CODE INTEGER)
 AS
 BEGIN SUSPEND; END;

/* Alter empty procedure SP_KSG_TMP_CRITERION_2017 with new param-list */
ALTER PROCEDURE SP_KSG_TMP_CRITERION_2017(GROUP_CODE INTEGER,
STEP_NUM INTEGER,
DATE2 DATE,
DR DATE,
K_USLF DM_NUM_6_2,
SEX TYPE OF DM_SEX,
DOP_CRITERIAN DM_CHAR_10 = null,
CODE_USL DM_CHAR_50 = null,
DS DM_DS = null,
DOP_CRITERIAN2 DM_CHAR_10 = null)
 RETURNS(ERR_CODE INTEGER,
KSG DM_CHAR_20)
 AS
 BEGIN SUSPEND; END;

/* Alter Procedure... */
/* Alter (SP_ADD_PATIENTS_INVOICE) */
ALTER PROCEDURE SP_ADD_PATIENTS_INVOICE(ZS_ID INTEGER)
 RETURNS(INV_ID INTEGER)
 AS
declare variable USL_ID integer;
declare variable USL_CNT DM_NUM_6_2;
declare variable TARIF DM_MONEY_15_2;
declare variable SUM_USLF DM_MONEY_15_2;
declare variable DENT_LIST DM_CHAR_250;
declare variable PAT_ID integer;
declare variable DATE2 DM_DATE;
declare variable DISCOUNT DM_MONEY_15_2;
declare variable ACTION_ID integer;
declare variable WITH_OTHER_DISCOUNTS integer;
begin
  pat_id = (select patient_id from zs where id = :zs_id);

  insert into PATIENTS_INVOICE (CH_DATE, ZS_ID, PATIENT_ID, registry_id, doctor_id, is_temp)
  values (current_date, :ZS_ID, :pat_id, (select registry_id from zs where id = :zs_id), (select phys_id from zs where id = :zs_id), 1)
  returning id
  into :inv_id;

  usl_cnt = 1;
  tarif = 0;
  with_other_discounts = 1;

  for select u.id, d.tar_usl, d.k_uslf, d.sum_uslf, coalesce(d.tooth_list, d.tooth_id), d.date_2
      from zsd d
           join zs h on h.id = d.zs_id
           join h_usl u on u.code = d.code_usl and u.q_u containing h.q_u and u.payment_type_id = h.payment_type_id
      where d.zs_id = :zs_id
--      group by 1, 2
      into :usl_id, :tarif, :usl_cnt, :sum_uslf, :dent_list, :date2
      do
      begin
        select first 1 coalesce((iif(a.discount_type = 0, :sum_uslf/100*a.discount, a.discount)),0), a.id, coalesce(c.with_other_discounts,0)
         from actions_usl a
             join actions c on c.id = a.action_id
         where a.usl_id = :usl_id and :date2 between a.bp and a.ep
         order by 1 desc
         into :discount, :action_id, :with_other_discounts;

        insert into PATIENTS_INVOICE_USL (HDR_ID, USL_ID, TARIF, K_USLF, DISCOUNT, DISCOUNT_PROC, SUM_USLF, tooth_list)
        values (:INV_ID, :USL_ID, :TARIF, :usl_cnt,
                :discount,100*:discount/:sum_uslf,
                :sum_uslf - :discount,
                :dent_list);

        if (:action_id is not null) then
        update patients_invoice i
         set i.action_id = :action_id
         where i.id = :inv_id;

        if (:with_other_discounts = 1) then
          update patients_invoice i
           set i.discount_type = (select DISCOUNT_TYPE from SP_GET_PATIENTS_DISCOUNT(:PAT_ID)),
               i.discount_proc = (select DISCOUNT from SP_GET_PATIENTS_DISCOUNT(:PAT_ID))
           where i.id = :inv_id;
      end

  suspend;
end;

/* empty dependent procedure body */
/* Clear: SP_CALC_ALL for: SP_CALC_STAC */
ALTER PROCEDURE SP_CALC_ALL(ZS_ID INTEGER)
 AS
 BEGIN EXIT; END;

ALTER PROCEDURE SP_KSG_GET(DS1 TYPE OF DM_DS,
DR DATE,
DATE2 TYPE OF DM_DATE,
CODE_USL TYPE OF DM_CHAR_20,
SEX TYPE OF DM_SEX,
K_USLF TYPE OF DM_NUM_6_2,
Q_U INTEGER,
DS2 DM_DS,
IDB INTEGER = null,
DOP_CRITERION DM_CHAR_10 = null,
DOP_CRITERION2 DM_CHAR_10 = null)
 RETURNS(KSG DM_CHAR_20,
ERR_CODE INTEGER)
 AS
declare variable TMP_GRP_ID integer;
declare variable RC integer;
declare variable NEED_STEP_1 integer;
declare variable NEED_STEP_2 type of DM_BOOLEAN;
declare variable KSG_TER DM_CHAR_20;
declare variable KSG_SURG DM_CHAR_20;
declare variable Y integer;
declare variable IDA integer;
begin
     ksg = null;
     ksg_ter = null;
     ksg_surg = null;
     err_code = null;
     tmp_grp_id = gen_id(GEN_KSG_TMP_GROUP_ID, 1);
     y = extract(year from :date2);
     ida = (select first 1 d.zs_id from zsd d where d.id = :idb);

     /*******     00-80**************************/
--     if (y = 2018) then
--     begin
--       if ((substring(:ds1 from 1 for 1) = 'C') and (substring(:ds1 from 2 for 1) <= 8)) then
--         is_c00_c80 = 1;
--       else
--         is_c00_c80 = 0;
--     end
--     else
--       is_c00_c80 = 0;
     /**********************************************************************/

--     if (y < 2017) then
--     if (:ds1 starting 'C') then
--      if (not exists(select 1 from ksg_grp g where g.nms_code = :code_usl and g.ds <> 'C.'
--                and :date2 between g.bp and g.epv
--                and coalesce(g.age_grp,0) = iif(g.age_grp is not null, iif((:date2-:dr)/365.25 < 18, 4, 5) , 0) )) then
--        ds1 = 'C.';
--     if (y >= 2017) then
--     if (:ds1 starting 'C' and :dop_criterion is null) then
--      if (not exists(select 1 from ksg_grp g where g.nms_code = :code_usl and g.ds <> 'C.'
--                and :date2 between g.bp and g.epv
--                and coalesce(g.age_grp,0) = iif(g.age_grp is not null, iif((:date2-:dr)/365.25 < 18, 5, 6) , 0) )) then
--        ds1 = 'C.';
--------------------------------------------------------------------------------
     --       ()
     if (y < 2017) then
     select
           case
             when t1.ao_code = 'T7' then '216'
             when (t1.ao_code between 'T1' and 'T6') and (t2.ao_code between 'T1' and 'T6') and (t1.ao_code <> t2.ao_code) then '216'
             else null
           end
      from zsd b
      left join h_tarif_polytrauma t1 on t1.ds = b.ds and :date2 between t1.bp and t1.epv
      left join h_tarif_polytrauma t2 on t2.ds = b.ds2 and :date2 between t2.bp and t2.epv
      where b.id = :idb and b.ds3 in ('J94.2','J94.8','J94.9','J93','J93.0','J93.1','J93.8','J93.9', 'J96.0', 'N17', 'T79.4', 'R57.1', 'R57.8')
      into :ksg;

     if (y = 2017) then
      select
           case
             when t1.ao_code = 'T7' then '216'
             when (t1.ao_code between 'T1' and 'T6') and (t2.ao_code between 'T1' and 'T6') and (t1.ao_code <> t2.ao_code) then '220'
             else null
           end
      from zs_ds d
      left join h_tarif_polytrauma t1 on t1.ds = d.ds and :date2 between t1.bp and t1.epv
      left join h_tarif_polytrauma t2 on t2.ds = d.ds and :date2 between t2.bp and t2.epv
      where d.section = 1 and d.section_id = :ida and d.ds in ('J94.2','J94.8','J94.9','J93','J93.0','J93.1','J93.8','J93.9', 'J96.0', 'N17', 'T79.4', 'R57.1', 'R57.8')
      into :ksg;

     if (y = 2018) then
      select
           case
             when t1.ao_code = 'T7' then '216'
             when (t1.ao_code between 'T1' and 'T6') and (t2.ao_code between 'T1' and 'T6') and (t1.ao_code <> t2.ao_code) then '233'
             else null
           end
      from zs_ds d
      left join h_tarif_polytrauma t1 on t1.ds = d.ds and :date2 between t1.bp and t1.epv
      left join h_tarif_polytrauma t2 on t2.ds = d.ds and :date2 between t2.bp and t2.epv
      where d.section = 1 and d.section_id = :ida and d.ds in ('J94.2','J94.8','J94.9','J93','J93.0','J93.1','J93.8','J93.9', 'J96.0', 'N17', 'T79.4', 'R57.1', 'R57.8')
      into :ksg;

     if (y = 2019) then
      select
           case
             when t1.ao_code = 'T7' then 'st29.007'
             when (t1.ao_code between 'T1' and 'T6') and (t2.ao_code between 'T1' and 'T6') and (t1.ao_code <> t2.ao_code) then 'st29.007'
             else null
           end
      from zs_ds d
      left join h_tarif_polytrauma t1 on t1.ds = d.ds and :date2 between t1.bp and t1.epv
      left join h_tarif_polytrauma t2 on t2.ds = d.ds and :date2 between t2.bp and t2.epv
      where d.section = 1 and d.section_id = :ida and d.ds in ('J94.2','J94.8','J94.9','J93','J93.0','J93.1','J93.8','J93.9', 'J96.0', 'N17', 'T79.4', 'R57.1', 'R57.8')
      into :ksg;

     if (ksg is not null) then
     begin
       suspend;
       exit;
     end
--------------------------------------------------------------------------------

--     if ((select first 1 id from h_tarif_dializ d where :date2 between d.bp and d.epv and d.code_usl = :code_usl) is not null) then
--     begin
--       ksg = null;
--       exit;
--     end

--------------------------------------------------------------------------------
     --  1.    
     need_step_1 = (select first 1 1 from ksg_grp m where m.ds = :ds1 and m.q_u = :q_u and :date2 between m.bp and m.epv);

     -- 1
     if (need_step_1 = 1) then
     begin
       insert into KSG_TMP (ID, KSG, NMS_CODE, KZ, GROUP_CODE, STEP_NUM, AGE_GRP, DAYS, SEX, DS, DOP_CRITERIAN, dop_criterian2)
          select h.id, h.ksg, h.nms_code, k.kz, :tmp_grp_id, 1, h.age_grp, h.days, h.sex, h.ds, h.dop_criterion, h.dop_criterion2
           from ksg_grp h
           join h_ksg k on k.ksg = h.ksg and :date2 between k.bp and k.epv
           where ((h.ds = :ds1) or ((select IS_LIKE from SP_CHECK_DS_GRP(h.ds, :ds1)) = 1))
--                 and (h.nms_code is null or h.nms_code = :code_usl)
                 and :date2 between h.bp and h.epv
                 and h.q_u = k.q_u and h.q_u = :q_u
                 and iif(h.ds2 is not null, h.ds2, :ds2) is not distinct from :ds2;

  
       rc = row_count;

       if (rc = 1) then
        ksg_ter = (select t.ksg from KSG_TMP t where t.group_code=:tmp_grp_id and t.step_num=1);
  
       --  .
       if ((rc > 1) and (:y < 2017)) then
        select ERR_CODE, KSG from SP_KSG_TMP_CRITERION(:tmp_grp_id, 1, :date2, :dr, :k_uslf, :sex)
         into :err_code, :ksg_surg;
       if ((rc > 1) and (:y >= 2017)) then
        select ERR_CODE, KSG from SP_KSG_TMP_CRITERION_2017(:tmp_grp_id,1, :date2, :dr, :k_uslf, :sex, :dop_criterion, :code_usl, :ds1, :dop_criterion2)
         into :err_code, :ksg_ter;

       /*$$IBEC$$ if (rc = 0) then
       begin
                --      " "  ...
         insert into KSG_TMP (ID, KSG, NMS_CODE, KZ, GROUP_CODE, STEP_NUM, AGE_GRP, DAYS, SEX, DS, DOP_CRITERIAN)
        select h.id, h.ksg, h.nms_code, k.kz, :tmp_grp_id, 1, h.age_grp, h.days, h.sex, h.ds, h.dop_criterion
         from ksg_grp h
         join h_ksg k on k.ksg = h.ksg and :date2 between k.bp and k.epv
         where ((h.ds = :ds1) or (h.ds = iif(:is_c00_c80 = 1, 'C00-C80', :ds1)))
               and (h.nms_code is not distinct from :code_usl)
               and :date2 between h.bp and h.epv
               and h.q_u = k.q_u and h.q_u = :q_u
               and iif(h.ds2 is not null, h.ds2, :ds2) is not distinct from :ds2;
  
         rc = row_count;
         if (rc = 0) then
          err_code = 1;  --      
       end $$IBEC$$*/
  

     end
--------------------------------------------------------------------------------
     -- 2 ,    ...
     if ((err_code is not null and code_usl is not null) and
        exists(select first 1 1 from ksg_grp m where m.nms_code = :code_usl
               and m.q_u = :q_u and :date2 between m.bp and m.epv)) then
       err_code = null;

     need_step_2 = iif(err_code is null and code_usl is not null, 1, 0);
--      ...        ,  2  
     if (need_step_2 = 1) then
      if (:code_usl = (select t.nms_code from KSG_TMP t where t.group_code = :tmp_grp_id)) then
       need_step_2 = 0;

     --  2.    
     if (need_step_2 = 1) then
     begin
       insert into KSG_TMP (ID, KSG, NMS_CODE, KZ, GROUP_CODE, STEP_NUM, AGE_GRP, DAYS, SEX, DS, DOP_CRITERIAN, dop_criterian2)
        select h.id, h.ksg, h.nms_code, k.kz, :tmp_grp_id, 2, h.age_grp, h.days, h.sex, h.ds, h.dop_criterion, h.dop_criterion2
         from ksg_grp h
         join h_ksg k on k.ksg = h.ksg and :date2 between k.bp and k.epv
--         join ksg_factors kf on kf.ksg_id = k.id and kf.q_u = k.q_u
         where h.nms_code = :code_usl --and (h.ds is null or h.ds = :ds1)
               and :date2 between h.bp and h.epv
               and h.q_u = k.q_u and h.q_u  = :q_u
               and iif(h.ds2 is not null, h.ds2, :ds2) is not distinct from :ds2;

       rc = row_count;
       if (rc = 1) then
        ksg_surg = (select t.ksg from KSG_TMP t where t.group_code=:tmp_grp_id and t.step_num=2);

       --    
       if ((rc > 1) and (:y < 2017)) then
        select ERR_CODE, KSG from SP_KSG_TMP_CRITERION(:tmp_grp_id, 2, :date2, :dr, :k_uslf, :sex)
         into :err_code, :ksg_surg;
       if ((rc > 1) and (:y >= 2017)) then
        select ERR_CODE, KSG from SP_KSG_TMP_CRITERION_2017(:tmp_grp_id, 2, :date2, :dr, :k_uslf, :sex, :dop_criterion, :code_usl,:ds1, :dop_criterion2)
         into :err_code, :ksg_surg;
     end
--------------------------------------------------------------------------------
    --  3   

    if ((ksg_surg is not null) or (ksg_ter is not null)) then
    begin
      rc = (select count(*) from KSG_TMP t where t.group_code = :tmp_grp_id);
      if (rc = 1) then
       ksg = coalesce(ksg_ter, ksg_surg);
      if (rc = 2) then
      begin
        --   .  .  -  .
        if (exists(select 1 from ksg_dont_choice d
                    where d.ksg_ter = :ksg_ter and d.ksg_surg = :ksg_surg and :date2 between d.bp and d.epv) and (:q_u = 1)) then
         ksg = ksg_surg; else
         -- ...   . 
         ksg = (select first 1 t.ksg from KSG_TMP t where t.group_code=:tmp_grp_id
                 order by t.kz desc);
      end 

      err_code = null;
    end
--------------------------------------------------------------------------------
     -- 216.      
     if (ksg is null and err_code is null and ((select first 1 id from h_tarif_dializ d where :date2 between d.bp and d.epv and d.code_usl = :code_usl) is null)) then
      err_code = 1;

     delete from KSG_TMP t
      where t.group_code = :tmp_grp_id;

     if (err_code is not null) then
         update zsd d
         set d.comment_local = (select name from h_errors where ID = :err_code)
         where d.id = :idb;

     suspend;
end;

/* Alter (SP_CALC_STAC) */
ALTER PROCEDURE SP_CALC_STAC(IDA INTEGER)
 AS
declare variable KSG type of DM_CHAR_50;
declare variable DS type of DM_DS;
declare variable IDB integer;
declare variable SUM_USLF type of DM_MONEY;
declare variable KSKP type of DM_NUM_3_2;
declare variable Q_U integer;
declare variable FINE_KOEF type of DM_NUM_3_2;
declare variable TARIF numeric(15,6);
declare variable Y integer;
declare variable TARIF_USL DM_MONEY;
declare variable DATE2 date;
declare variable IS_TRANSFER DM_INT;
declare variable CL_CNT integer;
declare variable ERR_CODE integer;
declare variable K_DOWN DM_NUM_6_2;
begin
     cl_cnt = (select count(distinct b.ds_class) from ZSD b where b.ZS_ID = :ida);
     is_transfer = (select sum(iif(b.code_usl is null, 1, 0)) from ZSD b where b.ZS_ID = :ida);

     select a.q_u, extract(year from a.date_2), a.date_2
      from zs a
      where a.id = :ida
      into :q_u, :y, :date2;

     for select sp.KSG, sp.ERR_CODE, b.ds, b.id, coalesce(bs.tarif * k.k_down * k.kz *
                iif((select 1 from h_ksg_dop d where d.type_num = 1 and a.date_2 between d.bp and d.epv and d.q_u = a.q_u and d.ksg = sp.ksg) IS NULL , lf.kus, 1.0), 0)
      from zs a
      join zsd b on a.id = b.zs_id
      join patients p on p.id = a.patient_id
      join lpu_factors lf on lf.q_u = a.q_u and a.date_2 between lf.bp and lf.epv
      join h_tarif_bs bs on bs.q_u = a.q_u and a.date_2 between bs.bp and bs.epv
      left join sp_ksg_get(b.ds, p.dr, a.date_2, b.code_usl, p.sex, b.k_uslf, a.q_u, b.ds2, b.id) sp on 1=1
      left join h_ksg k on k.ksg = sp.ksg and a.date_2 between k.bp and k.epv and k.q_u = a.q_u
      where b.zs_id = :ida
      into :ksg, :err_code, :ds, :idb, :tarif
      do
      begin
        kskp = 1;
        fine_koef = null;

        if ((q_u = 1) and (y < 2017)) then
          kskp = (select KSKP from SP_CALC_STAC_KSKP(:ida, :idb, :ksg, :cl_cnt));
        if ((q_u = 1) and (y >= 2017) and (y < 2018)) then
          kskp = (select KSKP from sp_calc_stac_kskp_2017(:ida, :idb, :ksg, :cl_cnt));
--        if ((q_u = 1) and (y >= 2018)) then
--          kskp = (select KSKP from sp_calc_stac_kskp_2018(:ida, :idb, :ksg, :cl_cnt));

        fine_koef = (select FINE_KOEF from sp_calc_stac_fine(:ida, :idb, :ksg, :cl_cnt));

        sum_uslf = cast(tarif * kskp * fine_koef as int);

        update zsd b set
         b.ksg_base = :ksg,
         b.tar_base = cast(:tarif as integer),
         b.sum_base = :sum_uslf,
         b.kskp_base = :kskp
         where b.id = :idb;
      end 
--------------------------------------------------------------------------------
      --    6  + 
      if (q_u = 1) then
       if (exists (select 1 from zsd b where b.zs_id = :ida and ((b.ksg in (2) and b.k_uslf >= 6) or (b.ksg in ('O14.1','O34.2','O36.3','O36.4','O42.2') and b.k_uslf >= 2) ))
          and exists (select 1 from zsd b where b.zs_id = :ida and b.ksg in (4, 5))) then
          begin
            --    
            select first 1 b.ksg_base, b.ds
            from zs a
             join zsd b on a.id = b.zs_id
             where b.zs_id = :ida and b.ksg in (4, 5)
             into :ksg, :ds;
       
            update zsd d
            set d.tar_usl = d.tar_base,
                d.sum_uslf = d.sum_base,
                d.ksg = d.ksg_base,
                d.kskp = d.kskp_base
            where d.zs_id = :ida;

            --   
            select coalesce(sum(b.sum_uslf), 0) from zsd b where b.zs_id = :ida
             into :sum_uslf;
    
            update zs a set
             a.tar_usl = :tarif,
             a.sum_uslf = :sum_uslf,
             a.sum_usl = :sum_uslf,
             a.ksg = :ksg,
             a.ds1 = :ds,
             a.kslp = :kskp
             where a.id = :ida;

            exit;
          end
--------------------------------------------------------------------------------
      if ((is_transfer < 2) or (cl_cnt < 2))  then  --   
      begin
        --     
        select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base
         from zsd b
         where b.zs_id = :ida
         order by b.tar_base desc
         into :idb, :ksg, :sum_uslf, :tarif;

         --      
         update zsd b set
          b.ksg = :ksg, 
          b.sum_uslf = :sum_uslf,
          b.kskp = b.kskp_base,
          b.tar_usl = b.tar_base
          where b.id = :idb;

         update zsd b set
          b.ksg = null,
          b.sum_uslf = 0,
          b.kskp = 1,
          b.tar_usl = 0
          where b.id <> :idb and b.zs_id = :ida;
 
         update zs a set
          a.tar_usl = :tarif,
          a.sum_uslf = :sum_uslf,
          a.sum_usl = :sum_uslf,
          a.ksg = :ksg,
          a.kslp = :kskp
          where a.id = :ida;
 
      end else
      begin
        select first 1 b.ksg_base, b.sum_base
        from zs a
         join zsd b on a.id = b.zs_id
         where b.zs_id = :ida and b.ksg is not null and b.ds = a.ds1
         order by b.sum_base desc
         into :ksg, :sum_uslf;

        update zsd d
         set d.tar_usl = d.tar_base,
             d.sum_uslf = d.sum_base,
             d.ksg = d.ksg_base,
             d.kskp = d.kskp_base
         where d.zs_id = :ida;
   
        select coalesce(sum(b.sum_uslf), 0), coalesce(sum(b.tar_base), 0) from zsd b
         join zs a on a.id = b.zs_id
         where b.zs_id = :ida and b.ksg is not null
         into :sum_uslf, :tarif;

        update zs a set
         a.tar_usl = :tarif,
         a.sum_uslf = :sum_uslf,
         a.sum_usl = :sum_uslf,
         a.ksg = :ksg,
         a.kslp = :kskp
         where a.id = :ida;
 
      end

      ---------------------------------------------------------------------------------
      --   2016 
      if (exists(select first 1 1 from zsd b
                  join h_tarif_dializ d on d.code_usl = b.code_usl and b.date_2 between d.bp and d.epv
                  and d.q_u containing :q_u where b.zs_id = :ida) and :y = 2016) then
      begin
         for select d.tarif, b.id
             from zsd b
                  join h_tarif_dializ d on d.code_usl = b.code_usl and d.bp <= :date2 and d.epv >= :date2 and d.q_u containing :q_u
             where b.zs_id = :ida
             into :tarif_usl, :idb
             do
             begin
               update zsd b
               set b.sum_uslf = :tarif_usl,
                   b.tar_usl = :tarif_usl
               where b.id = :idb;

               update zs a set
                  a.tar_usl = iif (coalesce(a.tar_usl,0) = 0, :sum_uslf, a.tar_usl),
                  a.sum_uslf = a.sum_uslf + :tarif_usl,
                  a.sum_usl = a.sum_usl + :tarif_usl
                  where a.id = :ida;
 
               update zs a set
                  a.tar_usl = cast(a.sum_uslf/coalesce(a.k_uslf, 1) as integer)
                  where a.id = :ida;

             end
         exit;
      end

end;

ALTER PROCEDURE SP_CALC_STAC_KSKP_2018(IDA INTEGER,
IDB INTEGER,
KSG DM_CHAR_20,
CL_CNT INTEGER)
 RETURNS(KSKP TYPE OF DM_NUM_3_2)
 AS
declare variable KSKP1 type of DM_NUM_3_2;
declare variable KSKP2 type of DM_NUM_3_2;
declare variable KSKP3 type of DM_NUM_3_2;
declare variable KSKP4 type of DM_NUM_3_2;
declare variable KSKP5 type of DM_NUM_3_2;
declare variable KSKP6 type of DM_NUM_3_2;
declare variable KSKP7 type of DM_NUM_3_2;
begin
     kskp6 = 1;

     select
           --    
           iif((a.age < 1) and ((select first 1 d.ksg from h_ksg_dop d where d.type_num = 2 and a.date_2 between d.bp and d.epv and d.q_u = 1 and d.ksg = :ksg) is null), 1.1, 1),
           iif((a.age >= 1) and (a.age < 4), 1.1, 1),
           iif((a.age < 4 and a.age < 18 and coalesce(a.chield_with_rop,0) = 1), 1.1, 1),
           iif((a.age >= 75) and ((select first 1 d.ksg from h_ksg_dop d where d.type_num = 3 and a.date_2 between d.bp and d.epv and d.q_u = 1 and d.ksg = :ksg) is null), 1.1, 1),    -- 4
           iif((a.age >= 60 and coalesce(a.barthel_idx,0) <= 60 and
               ((select first 1 d.ksg from h_ksg_dop d where d.type_num = 4 and a.date_2 between d.bp and d.epv and d.q_u = 1 and d.ksg = :ksg) is null)), 1.1, 1), --5
           iif(ok.id is not null, 1.8, 1)
      from zs a
      join patients p on p.id = a.patient_id
      left join zs_hdr h on h.id = a.hdr_id
      left join invoice i on i.id = h.name
      left join h_okato_full ok on ok.okato = p.okato_l
                                and i.lpu in ('830005','830016','830015','830008','830007')
                                and ok.kskp_tundra = 1
      where a.id = :ida
      into :kskp1, :kskp2, :kskp3, :kskp4, :kskp5, :kskp7;

     if (idb is not null) then
      select
            --  
            case
              when (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) > 30 and ((select d.ksg from h_ksg_dop d where d.type_num = 5 and a.date_2 between d.bp and d.epv and d.q_u = 1 and d.ksg = :ksg) is null)) then
                    case
                      when (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) - coalesce(b.orit,0)) >= coalesce(b.orit,0) then 1 + (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) - 30) * 0.25 / 30
                      else 1 + (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) - 30) * 0.4 / 30
                    end
              when (b.k_uslf > 45 and ((select d.ksg from h_ksg_dop d where d.type_num = 5 and a.date_2 between d.bp and d.epv and d.q_u = 1 and d.ksg = :ksg) is not null)) then
                    case
                      when (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) - coalesce(b.orit,0)) >= coalesce(b.orit,0) then 1 + (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) - 45) * 0.25 / 45
                      else 1 + (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) - 45) * 0.4 / 45
                    end
              else 1
            end
       from zs a
       join zsd b on a.id = b.zs_id
       where b.id = :idb
       into :kskp6;


     kskp = kskp1 + (kskp2-1) + (kskp3-1) + (kskp4-1) + (kskp5-1) + (kskp7-1);
     if (kskp > 1.8) then
      kskp = 1.8;
     kskp = kskp + (kskp6-1);
     
     delete from kslp_koef where zs_id = :ida and ksg = :ksg;
     
     if (:kskp1 > 1) then
         insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
            values (1, :kskp1, :ida, :ksg);
     if (:kskp2 > 1) then       
         insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
            values (2, :kskp2, :ida, :ksg);
     if (:kskp3 > 1) then
         insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
            values (3, :kskp3, :ida, :ksg);
     if (:kskp4 > 1) then
         insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
            values (4, :kskp4, :ida, :ksg);
     if (:kskp5 > 1) then
         insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
            values (5, :kskp5, :ida, :ksg);
     if (:kskp7 > 1) then
         insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
            values (7, :kskp7, :ida, :ksg);
     if (:kskp6 > 1) then
         insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
            values (6, :kskp6, :ida, :ksg);
            
    suspend;        
end;

ALTER PROCEDURE SP_CALC_STAC_FINE_2018(IDA INTEGER,
IDB INTEGER,
KSG DM_CHAR_20,
CL_CNT INTEGER)
 RETURNS(FINE_KOEF TYPE OF DM_NUM_3_2)
 AS
declare variable Q_U integer;
declare variable DATE_2 DM_DATE;
declare variable PERCENT_VALUE DM_NUM_3_2;
begin
     select q_u, date_2 from zs
     where id = :ida
     into :q_u, :date_2;

     fine_koef = 1;
     percent_value = (select min(d.type_num) from h_ksg_dop d where d.type_num in (50,80,100) and :date_2 between d.bp and d.epv and d.q_u = :q_u and d.ksg = :ksg);

     if (percent_value is not null) then
     begin
         if (idb is not null) then
          select
                case
                  when a.q_u = 1 and iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) <= 3 then :percent_value/100
                  when a.q_u = 3 and iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) <= 3 then :percent_value/100
                  else 1
                end
           from zs a
           join zsd b on a.id = b.zs_id
           where b.id = :idb
           into :fine_koef;
      end

     suspend;
end;

/* Alter (SP_CALC_STAC_2018) */
ALTER PROCEDURE SP_CALC_STAC_2018(IDA INTEGER)
 AS
declare variable KSG type of DM_CHAR_50;
declare variable DS type of DM_DS;
declare variable IDB integer;
declare variable SUM_USLF type of DM_MONEY;
declare variable KSKP type of DM_NUM_3_2;
declare variable Q_U integer;
declare variable FINE_KOEF type of DM_NUM_3_2;
declare variable TARIF numeric(15,6);
declare variable Y integer;
declare variable TARIF_USL DM_MONEY;
declare variable DATE2 date;
declare variable IS_TRANSFER DM_INT;
declare variable CL_CNT integer;
declare variable ERR_CODE integer;
declare variable K_DOWN DM_NUM_6_2;
declare variable DS_CLASS DM_CHAR_10;
declare variable KZ DM_NUM_2_5;
declare variable KD DM_NUM_2_5;
declare variable KUS DM_NUM_2_5;
declare variable BS DM_NUM_6_2;
declare variable PROF_NUM integer;
declare variable DATE1 date;
declare variable CODE_USL DM_CHAR_20;
declare variable FINE_KOEF_SET_DOCTOR DM_BOOLEAN;
begin
    update zsd d
      set d.ds_class = (select MKB_CLASS from SP_GET_MKB_CLASS(D.ds))
      where d.zs_id = :ida;

    update zsd d
     set d.ksg = null, 
         d.ksg_base = null,
         d.tar_base = null,
         d.sum_base = null,
         d.kskp_base = null,
         d.sum_uslf = 0,
         d.tar_usl = 0,
         d.comment_local = null
     where d.zs_id = :ida;

     cl_cnt = (select count(distinct b.ds_class) from ZSD b where b.ZS_ID = :ida);
     is_transfer = (select sum(iif(b.code_usl is null, 1, 0)) from ZSD b where b.ZS_ID = :ida);

     select a.q_u, extract(year from a.date_2), a.date_2, coalesce(a.fine_koef_set_doctor,0)
      from zs a
      where a.id = :ida
      into :q_u, :y, :date2, :fine_koef_set_doctor;

     for select sp.KSG, sp.ERR_CODE, b.ds, b.id, coalesce(bs.tarif * kd.kd * k.k_down * k.kz *
                iif((select 1 from h_ksg_dop d where d.type_num = 1 and a.date_2 between d.bp and d.epv and d.q_u = a.q_u and d.ksg = sp.ksg) IS NULL , lf.kus, 1.0), 0),
                k.kz, kd.kd,
                iif((select 1 from h_ksg_dop d where d.type_num = 1 and a.date_2 between d.bp and d.epv and d.q_u = a.q_u and d.ksg = sp.ksg) IS NULL , lf.kus, 1.0),
                bs.tarif, k.k_down, k.prof_num, b.date_1, coalesce(b.code_usl,''), coalesce(b.fine_koef,1)
      from zs a
      join zsd b on a.id = b.zs_id
      join patients p on p.id = a.patient_id
      join lpu_factors lf on lf.q_u = a.q_u and a.date_2 between lf.bp and lf.epv
      join h_tarif_bs bs on bs.q_u = a.q_u and a.date_2 between bs.bp and bs.epv
      join h_tarif_kd kd on a.date_2 between kd.bp and kd.epv
      left join sp_ksg_get(b.ds, p.dr, a.date_2, b.code_usl, p.sex,
                           (select sum(b1.k_uslf) from ZSD b1 where b1.ZS_ID = :ida and b1.ds_class = b.ds_class and b1.code_usl is null), -- -     
                           a.q_u, b.ds2, b.id, b.ksg_criterion,b.ksg_criterion2) sp on 1=1
      left join h_ksg k on k.ksg = sp.ksg and a.date_2 between k.bp and k.epv and k.q_u = a.q_u
      where b.zs_id = :ida
      order by b.code_usl
      into :ksg, :err_code, :ds, :idb, :tarif, :kz, :kd, :kus, :bs, :k_down, :prof_num, :date1, :code_usl, :fine_koef
      do
      begin
        kskp = 1;
--        fine_koef = null;

        if ((q_u = 1) and (err_code is null) and (date2 < '01.01.2019')) then
          kskp = (select KSKP from sp_calc_stac_kskp_2018(:ida, :idb, :ksg, :cl_cnt));

        if ((q_u in (1,3)) and (err_code is null) and (date2 >= '01.01.2019')) then
          kskp = (select KSKP from sp_calc_stac_kskp_2019(:ida, :idb, :ksg, :cl_cnt));

        if (fine_koef_set_doctor = 0) then
          fine_koef = (select FINE_KOEF from sp_calc_stac_fine_2018(:ida, :idb, :ksg, :cl_cnt));

        sum_uslf = cast(tarif * kskp * fine_koef as int);

        if (:ksg is not null) then
        begin
            if (:code_usl <> '') then
            begin
                select first 1 d.id, iif(:fine_koef_set_doctor = 1, d.fine_koef, :fine_koef)
                from zs z
                     join zsd d on d.zs_id = z.id
                where d.zs_id = :ida and coalesce(d.code_usl,'') = ''
                       and :date1 between d.date_1 and d.date_2
                       and not exists(select id from zsd d2 where d2.zs_id = :ida and coalesce(d2.code_usl,'') = '' and d2.date_1 = d.date_2)
                into :idb, :fine_koef;

                sum_uslf = cast(tarif * kskp * fine_koef as int);
            end

            if ((select first 1 d.id from zsd d where d.zs_id = :ida and d.ksg_base = :ksg) is null) then
            update zsd b set
             b.ksg_base = :ksg,
             b.tar_base = iif(:date2 >= '01.05.2018', cast(:tarif * coalesce(kskp,1) as int), cast(:tarif as integer)),
             b.sum_base = :sum_uslf,
             b.kskp_base = :kskp,
             b.koef_z = :kz, 
             b.koef_d = :kd,
             b.koef_u = :kus,
             b.bs = :bs,
             b.koef_up = :k_down,
             b.reab = iif(:prof_num = 37,1,null),
             b.fine_koef = :fine_koef
             where b.id = :idb;
         end
      end 
--------------------------------------------------------------------------------
      --    6  + 
      if (q_u = 1) then
       if (exists (select 1 from zsd b where b.zs_id = :ida and ((b.ksg in ('2','st02.001') and b.k_uslf >= 6) or (b.ksg in ('O14.1','O34.2','O36.3','O36.4','O42.2') and b.k_uslf >= 2) ))
          and exists (select 1 from zsd b where b.zs_id = :ida and b.ksg in ('4', '5', 'st02.003', 'st02.004'))) then
          begin
            --    
            select first 1 b.ksg_base, b.ds
            from zs a
             join zsd b on a.id = b.zs_id
             where b.zs_id = :ida and b.ksg in ('4', '5', 'st02.003', 'st02.004')
             into :ksg, :ds;
       
            update zsd d
            set d.tar_usl = d.tar_base,
                d.sum_uslf = d.sum_base,
                d.ksg = d.ksg_base,
                d.kskp = d.kskp_base
            where d.zs_id = :ida;

            --   
            select coalesce(sum(b.sum_uslf), 0) from zsd b where b.zs_id = :ida
             into :sum_uslf;
    
            update zs a set
             a.tar_usl = :tarif,
             a.sum_uslf = :sum_uslf,
             a.sum_usl = :sum_uslf,
             a.ksg = :ksg,
             a.ds1 = :ds,
             a.kslp = :kskp
             where a.id = :ida;

            exit;
          end
--------------------------------------------------------------------------------
      if ((is_transfer < 2) or (cl_cnt < 2))  then  --   
      begin
        --     ,   
        ksg = null;
        select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base
             from zsd b
             where b.zs_id = :ida and b.ksg_base is not null and ((:q_u = 1 and b.ksg_base >= '325' and b.ksg_base <= '343') or
                                                                                                  (:q_u = 3 and b.ksg_base >= '123' and b.ksg_base <= '134'))
             order by b.code_usl desc, b.sum_base desc
             into :idb, :ksg, :sum_uslf, :tarif;

        if (:ksg is null)  then
         select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base
             from zsd b
             where b.zs_id = :ida and b.ksg_base is not null
             order by b.code_usl desc, b.sum_base desc
             into :idb, :ksg, :sum_uslf, :tarif;

         --      
         update zsd b set
          b.ksg = :ksg, 
          b.sum_uslf = :sum_uslf,
          b.kskp = b.kskp_base,
          b.tar_usl = b.tar_base
          where b.id = :idb;

         update zsd b set
          b.ksg = null,
          b.sum_uslf = 0,
          b.kskp = 1,
          b.tar_usl = 0
          where b.id <> :idb and b.zs_id = :ida;
 
         update zs a set
          a.tar_usl = :tarif,
          a.sum_uslf = :sum_uslf,
          a.sum_usl = :sum_uslf,
          a.ksg = :ksg,
          a.kslp = :kskp
          where a.id = :ida;
 
      end else
      begin
        for select d.ds_class
         from zsd d
         where d.zs_id = :ida
         group by 1
         into :ds_class
         do
         begin
            if (((select count(dc.id) from ksg_dont_choice dc join zsd z on z.ksg_base = dc.ksg_ter or z.ksg_base = dc.ksg_surg
                    where z.zs_id = :ida and z.ds_class = :ds_class and :date2 between dc.bp and dc.epv) > 0) and (:q_u = 1)) then
               --    
            select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base
             from zsd b
             where b.zs_id = :ida and b.ksg_base is not null and b.ds_class = :ds_class and b.code_usl is not null
             order by b.code_usl desc, b.sum_base desc
             into :idb, :ksg, :sum_uslf, :tarif;
            else
               --     
            select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base
             from zsd b
             where b.zs_id = :ida and b.ksg_base is not null and b.ds_class = :ds_class
             order by b.code_usl desc, b.sum_base desc
             into :idb, :ksg, :sum_uslf, :tarif;
    
             --      
             update zsd b set
              b.ksg = :ksg, 
              b.sum_uslf = :sum_uslf,
              b.kskp = b.kskp_base,
              b.tar_usl = b.tar_base
              where b.id = :idb;
    
             update zsd b set
              b.ksg = null,
              b.sum_uslf = 0,
              b.kskp = 1,
              b.tar_usl = 0
              where b.id <> :idb and b.zs_id = :ida and b.ds_class = :ds_class;
         end

        select first 1 b.ksg_base, b.sum_base
        from zs a
         join zsd b on a.id = b.zs_id
         where b.zs_id = :ida and b.ksg is not null and b.ds = a.ds1
         order by b.sum_base desc
         into :ksg, :sum_uslf;

--        update zsd d
--         set d.tar_usl = d.tar_base,
--             d.sum_uslf = d.sum_base,
--             d.ksg = d.ksg_base,
--             d.kskp = d.kskp_base
--         where d.zs_id = :ida;
   
        select coalesce(sum(b.sum_uslf), 0), coalesce(sum(b.tar_base), 0)
         from zsd b
         join zs a on a.id = b.zs_id
         where b.zs_id = :ida and b.ksg is not null
         into :sum_uslf, :tarif;

        update zs a set
         a.tar_usl = :tarif,
         a.sum_uslf = :sum_uslf,
         a.sum_usl = :sum_uslf,
         a.ksg = :ksg,
         a.kslp = :kskp
         where a.id = :ida;
 
      end
end;

/* Alter (SP_CALC_STAC_FINE) */
ALTER PROCEDURE SP_CALC_STAC_FINE(IDA INTEGER,
IDB INTEGER,
KSG INTEGER,
CL_CNT INTEGER)
 RETURNS(FINE_KOEF TYPE OF DM_NUM_3_2)
 AS
declare variable HAS_OPER type of DM_BOOLEAN;
declare variable Q_U integer;
declare variable DATE_2 DM_DATE;
begin
     select q_u, date_2 from zs
     where id = :ida
     into :q_u, :date_2;

     if ((select 1 from h_ksg_dop d where d.type_num = 2 and :date_2 between d.bp and d.epv and d.q_u = :q_u and d.ksg = :ksg) is null) then
     begin
         if (idb is not null) then
          select
                case
                  when a.q_u = 1 and iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) <= 3 and coalesce(b.code_usl,'') = '' then 0.5
                  when a.q_u = 3 and iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) <= 5 and coalesce(b.code_usl,'') = '' then 0.5
                  when a.q_u = 1 and iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) <= 3 and coalesce(b.code_usl,'') <> '' then 0.8
                   when a.q_u = 3 and iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) <= 5 and coalesce(b.code_usl,'') <> '' then 0.8
                  else 1
                end
           from zs a
           join zsd b on a.id = b.zs_id
           where b.id = :idb
           into :fine_koef;
      end
      else
        fine_koef = 1;

     suspend;
end;

/* Alter (SP_CALC_STAC_KSKP_2017) */
ALTER PROCEDURE SP_CALC_STAC_KSKP_2017(IDA INTEGER,
IDB INTEGER,
KSG INTEGER,
CL_CNT INTEGER)
 RETURNS(KSKP TYPE OF DM_NUM_3_2)
 AS
declare variable KSKP1 type of DM_NUM_3_2;
declare variable KSKP2 type of DM_NUM_3_2;
declare variable KSKP3 type of DM_NUM_3_2;
declare variable ORIT integer;
declare variable KSKP4 DM_NUM_3_2;
declare variable KSKP5 DM_NUM_3_2;
declare variable KSKP8 DM_NUM_3_2;
declare variable KSKP10 DM_NUM_3_2;
declare variable KSKP13 DM_NUM_3_2;
begin
     kskp10 = 1;

     select
           --    
           iif((a.age < 1) and ((select first 1 d.ksg from h_ksg_dop d where d.type_num = 3 and a.date_2 between d.bp and d.epv and d.q_u = 1 and d.ksg = :ksg) is null), 1.1, 1),
           iif((a.age >= 1) and (a.age < 4), 1.1, 1),
           iif((a.age < 4 and coalesce(a.chield_with_rop,0) = 1), 1.1, 1),
           iif((a.age >= 75), 1.1, 1),
           iif((a.age >= 75 and coalesce(a.chield_with_rop,0) = 1), 1.1, 1),
           iif((a.age >= 4 and coalesce(a.chield_with_rop,0) = 1), 1.1, 1),
           iif(ok.id is not null, 1.8, 1)
      from zs a
      join patients p on p.id = a.patient_id
      left join zs_hdr h on h.id = a.hdr_id
      left join invoice i on i.id = h.name
      left join h_okato_full ok on ok.okato = p.okato_l
                                and i.lpu in ('830005','830016','830015','830008','830007')
                                and ok.kskp_tundra = 1
      where a.id = :ida
      into :kskp1, :kskp2, :kskp3, :kskp4, :kskp5, :kskp8, :kskp13;

     if (idb is not null) then
      select
            --  
            case
              when (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) > 30 and ((select d.ksg from h_ksg_dop d where d.type_num = 4 and a.date_2 between d.bp and d.epv and d.q_u = 1 and d.ksg = :ksg) is null)) then
                    case
                      when (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) - coalesce(b.orit,0)) >= coalesce(b.orit,0) then 1 + (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) - 30) * 0.25 / 30
                      else 1 + (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) - 30) * 0.4 / 30
                    end
              when (b.k_uslf > 45 and ((select d.ksg from h_ksg_dop d where d.type_num = 4 and a.date_2 between d.bp and d.epv and d.q_u = 1 and d.ksg = :ksg) is not null)) then
                    case
                      when (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) - coalesce(b.orit,0)) >= coalesce(b.orit,0) then 1 + (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) - 45) * 0.25 / 45
                      else 1 + (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) - 45) * 0.4 / 45
                    end
              else 1
            end
       from zs a
       join zsd b on a.id = b.zs_id
       where b.id = :idb
       into :kskp10;


     kskp = kskp1 + (kskp2-1) + (kskp3-1) + (kskp4-1) + (kskp5-1) + (kskp8-1) + (kskp13-1);
     if (kskp > 1.8) then
      kskp = 1.8;
     kskp = kskp + (kskp10-1);
     
     delete from kslp_koef where zs_id = :ida;
     
     if (:kskp1 > 1) then
         insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID)
            values (1, :kskp1, :ida);
     if (:kskp2 > 1) then       
         insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID)
            values (2, :kskp2, :ida);
     if (:kskp3 > 1) then
         insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID)
            values (3, :kskp3, :ida);
     if (:kskp4 > 1) then
         insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID)
            values (4, :kskp4, :ida);
     if (:kskp5 > 1) then
         insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID)
            values (5, :kskp5, :ida);
     if (:kskp8 > 1) then
         insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID)
            values (8, :kskp8, :ida);
     if (:kskp10 > 1) then
         insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID)
            values (10, :kskp10, :ida);
     if (:kskp13 > 1) then
         insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID)
            values (13, :kskp13, :ida);
            
    suspend;        
end;

/* empty dependent procedure body */
/* Clear: SP_ADD_PATIENTS_INVOICE for: SP_GET_PATIENTS_DISCOUNT */
ALTER PROCEDURE SP_ADD_PATIENTS_INVOICE(ZS_ID INTEGER)
 RETURNS(INV_ID INTEGER)
 AS
 BEGIN SUSPEND; END;

/* empty dependent procedure body */
/* Clear: SP_ADD_PATIENTS_INVOICE_ANALIZ for: SP_GET_PATIENTS_DISCOUNT */
ALTER PROCEDURE SP_ADD_PATIENTS_INVOICE_ANALIZ(PAT_ANALIZ_ID INTEGER,
PATIENT_ID INTEGER)
 RETURNS(INV_ID INTEGER)
 AS
 BEGIN SUSPEND; END;

/* empty dependent procedure body */
/* Clear: SP_ADD_PATIENTS_INVOICE_REG for: SP_GET_PATIENTS_DISCOUNT */
ALTER PROCEDURE SP_ADD_PATIENTS_INVOICE_REG(REG_ID INTEGER,
PATIENT_ID INTEGER)
 RETURNS(INV_ID INTEGER)
 AS
 BEGIN SUSPEND; END;

/* Alter (SP_GET_PATIENTS_DISCOUNT) */
ALTER PROCEDURE SP_GET_PATIENTS_DISCOUNT(PAT_ID INTEGER)
 RETURNS(DISCOUNT DM_NUM_6_2,
DISCOUNT_TYPE INTEGER)
 AS
declare variable SUM_ALL DM_MONEY_15_2;
declare variable DISCOUNT1 DM_NUM_6_2;
declare variable DISCOUNT2 DM_NUM_6_2;
declare variable PATIENT_TYPE integer;
begin
  sum_all = (select sum(coalesce(i.sum_opl,0)) from patients_invoice i where i.patient_id = :pat_id);
  patient_type = (select coalesce(p.patient_type,0) from patients p where id = :pat_id);

  discount1 = (select first 1 coalesce(s.discount, 0) from discount_setting s
                where (s.min_sum <= :sum_all) and s.discount_type = 1 order by s.min_sum desc);

  select first 1 s.discount_type, s.discount
                from patients p, discount_setting s
                where ((extract(day from p.dr) = extract(day from current_date) and extract(month from p.dr) = extract(month from current_date) and s.discount_type = 3)
                      or (coalesce(p.patient_type,0) = coalesce(s.patient_type,0) and s.discount_type = 2))
                      and s.discount_type <> 1
                      and p.id = :pat_id
                order by s.discount desc
                into :discount_type, :discount2;

  if ((coalesce(discount1,0) <> 0) or (coalesce(discount2,0) <> 0)) then
  begin
      if (coalesce(discount1,0) >= coalesce(discount2,0)) then
      begin
        discount = coalesce(discount1,0);
        discount_type = 1;
      end
      else
      if (coalesce(discount1,0) < coalesce(discount2,0)) then
      begin
        discount = coalesce(discount2,0);
      end
  end
  else
  begin
    discount = 0;
    discount_type = 0;
  end
  suspend;
end;

/* Alter (SP_KSG_TMP_CRITERION) */
ALTER PROCEDURE SP_KSG_TMP_CRITERION(GROUP_CODE INTEGER,
STEP_NUM INTEGER,
DATE2 DATE,
DR DATE,
K_USLF DM_NUM_6_2,
SEX TYPE OF DM_SEX)
 RETURNS(ERR_CODE INTEGER,
KSG INTEGER)
 AS
declare variable RC integer;
declare variable GRP_ID integer;
declare variable AGE_GRP integer;
declare variable DAYS integer;
declare variable USE_CONDITION type of DM_BOOLEAN;
begin
     age_grp = case
                 when (date2-dr) <= 28 then 1
                 when (date2-dr) between 29 and 90 then 2
                 when (date2-dr) between 91 and 365 then 3
                 when (date2-dr) / 365.25 < 18 then 4
                 when (date2-dr) / 365.25 >= 18 then 5
                 else null
               end;

     if (not exists(select first 1 1 from KSG_TMP t where t.group_code=:group_code and t.age_grp in (1,2,3)
                    and :age_grp = t.age_grp) and
         :age_grp in (1,2,3)) then
         age_grp = case
                     when (date2-dr) / 365.25 < 18 then 4
                     when (date2-dr) / 365.25 >= 18 then 5
                     else null
                   end;

     days = case
              when k_uslf <= 3 then 1
              else null
            end;

     use_condition = 1;

     --   ..
     select count(*) from (select t.id, t.ksg from KSG_TMP t
                           where t.group_code=:group_code and t.age_grp=:age_grp and t.step_num=:step_num
                           union
                           select t.id, t.ksg from KSG_TMP t
                           where t.group_code=:group_code and t.days=:days and t.step_num=:step_num
                           union
                           select t.id, t.ksg from KSG_TMP t
                           where t.group_code=:group_code and t.sex=:sex and t.step_num=:step_num)
      into :rc;

    if (rc = 0) then
    begin
      --   
      select count(*) from (select t.id, t.ksg from KSG_TMP t
                            where t.group_code=:group_code and t.step_num=:step_num
                                  and t.sex is null and t.age_grp is null and t.days is null)
       into :rc;
 
      if (rc = 1) then
       use_condition = 0;

      if (rc = 0) then
       err_code = 1;  --      
    end

    if (rc > 1) then
      err_code = 2;  --    

    if (err_code is null and ksg is null) then
    begin
      --   

      if (use_condition = 1) then
       select id, ksg from (select t.id, t.ksg from KSG_TMP t
                            where t.group_code=:group_code and t.age_grp=:age_grp and t.step_num=:step_num
                            union
                            select t.id, t.ksg from KSG_TMP t
                            where t.group_code=:group_code and t.days=:days and t.step_num=:step_num
                            union
                            select t.id, t.ksg from KSG_TMP t
                            where t.group_code=:group_code and t.sex=:sex and t.step_num=:step_num)
        into :grp_id, :ksg;

      if (use_condition = 0) then
       select id, ksg from (select t.id, t.ksg from KSG_TMP t
                            where t.group_code=:group_code and t.step_num=:step_num
                                  and t.sex is null and t.age_grp is null and t.days is null)
        into :grp_id, :ksg;
    end

    --  
    if (grp_id is not null) then
     delete from KSG_TMP t
      where t.group_code=:group_code and t.step_num=:step_num and t.id <> :grp_id;

    suspend;
end;

/* Alter (SP_KSG_TMP_CRITERION_2017) */
ALTER PROCEDURE SP_KSG_TMP_CRITERION_2017(GROUP_CODE INTEGER,
STEP_NUM INTEGER,
DATE2 DATE,
DR DATE,
K_USLF DM_NUM_6_2,
SEX TYPE OF DM_SEX,
DOP_CRITERIAN DM_CHAR_10 = null,
CODE_USL DM_CHAR_50 = null,
DS DM_DS = null,
DOP_CRITERIAN2 DM_CHAR_10 = null)
 RETURNS(ERR_CODE INTEGER,
KSG DM_CHAR_20)
 AS
declare variable RC integer;
declare variable GRP_ID integer;
declare variable AGE_GRP integer;
declare variable DAYS integer;
declare variable USE_CONDITION type of DM_BOOLEAN;
begin
     age_grp = case
                 when (date2-dr) <= 28 then 1
                 when (date2-dr) between 29 and 90 then 2
                 when (date2-dr) between 91 and 365 then 3
                 when (date2-dr) / 365.25 < 2 then 4
                 when (date2-dr) / 365.25 < 18 then 5
                 when (date2-dr) / 365.25 >= 18 then 6
                 else null
               end;

     if (:age_grp in (1,2,3,4,5)) then
     begin
         if (not exists(select first 1 1 from KSG_TMP t where t.group_code=:group_code and t.age_grp in (1,2,3)
                        and :age_grp = t.age_grp)) then
         begin
           if (exists(select first 1 1 from KSG_TMP t where t.group_code=:group_code and t.age_grp =4)) then
               age_grp = 4;
           else
               age_grp = 5;
         end
     end

     if ((select first 1 id from ksg_tmp t where t.sex = :sex) is null) then
       sex = null;

     days = case
              when k_uslf <= 3 then 1
              else null
            end;

     if (((select first 1 id from ksg_tmp t where t.days = :days  and (t.group_code = :group_code) and (t.step_num = :step_num)) is null) and (:days is not null)) then
       days = null;

     if (((select first 1 id from ksg_tmp t where t.age_grp = :age_grp and (t.group_code = :group_code) and (t.step_num = :step_num)) is null) and (:age_grp is not null)) then
       age_grp = null;

     if (((select first 1 id from ksg_tmp t where t.ds = :ds and (t.group_code = :group_code) and (t.step_num = :step_num))  is null)  and (:ds is not null)) then
       ds = null;

     if (((select first 1 id from ksg_tmp t where t.nms_code = :code_usl and (t.group_code = :group_code) and (t.step_num = :step_num)) is null) and (:code_usl is not null)) then
       code_usl = null;

     use_condition = 1;

     --   ..
     select count(*) from (select t.id, t.ksg from KSG_TMP t
                           where t.group_code=:group_code and t.age_grp=:age_grp and t.step_num=:step_num
                           union
                           select t.id, t.ksg from KSG_TMP t
                           where t.group_code=:group_code and t.days=:days and t.step_num=:step_num
                           union
                           select t.id, t.ksg from KSG_TMP t
                           where t.group_code=:group_code and t.sex=:sex and t.step_num=:step_num
                           union
                           select t.id, t.ksg from KSG_TMP t
                           where t.group_code=:group_code and t.dop_criterian=:dop_criterian and t.step_num=:step_num
                           union
                           select t.id, t.ksg from KSG_TMP t
                           where t.group_code=:group_code and t.dop_criterian2=:dop_criterian2 and t.step_num=:step_num
                           union
                           select t.id, t.ksg from KSG_TMP t
                           where t.group_code=:group_code and t.nms_code=:code_usl and t.step_num=:step_num
                           union
                           select t.id, t.ksg from KSG_TMP t
                           where t.group_code=:group_code and ((select IS_LIKE from SP_CHECK_DS_GRP(t.ds, :ds)) = 1) and t.step_num=:step_num)
      into :rc;

    if (rc > 1) then   ---   
    begin
      select count(*) from (select t.id, t.ksg from KSG_TMP t
                           where t.group_code=:group_code and (t.age_grp is not distinct from :age_grp)
                           and (t.days is not distinct from :days)
                           and (t.sex is not distinct from :sex)
                           and (t.dop_criterian is not distinct from :dop_criterian)
                           and (t.dop_criterian2 is not distinct from :dop_criterian2)
                           and (t.nms_code is not distinct from :code_usl)
                           and ((t.ds is not distinct from :ds) or ((select IS_LIKE from SP_CHECK_DS_GRP(t.ds, :ds)) = 1))  and t.step_num=:step_num)
      into :rc;

      if (rc = 1) then
       use_condition = 2;
    end

    if (rc = 0) then
    begin
      --   
      if (:step_num = 1) then
        select count(*) from (select t.id, t.ksg from KSG_TMP t
                            where t.group_code=:group_code and t.step_num=:step_num
                                  and t.sex is null and t.age_grp is null and t.days is null and t.dop_criterian is null and t.nms_code is null and t.dop_criterian2 is null)
       into :rc;
 
      if (:step_num = 2) then
        select count(*) from (select t.id, t.ksg from KSG_TMP t
                            where t.group_code=:group_code and t.step_num=:step_num
                                  and t.sex is null and t.age_grp is null and t.days is null and t.dop_criterian is null and t.ds is null and t.dop_criterian2 is null)
       into :rc;

      if (rc = 1) then
       use_condition = 0;

      if (rc = 0) then
       err_code = 1;  --      
    end

    if (rc > 1) then
      err_code = 2;  --    

    if (err_code is null and ksg is null) then
    begin
      --   

      if (use_condition = 1) then
       select id, ksg from (select t.id, t.ksg from KSG_TMP t
                            where t.group_code=:group_code and t.age_grp=:age_grp and t.step_num=:step_num
                            union
                            select t.id, t.ksg from KSG_TMP t
                            where t.group_code=:group_code and t.days=:days and t.step_num=:step_num
                            union
                            select t.id, t.ksg from KSG_TMP t
                            where t.group_code=:group_code and t.sex=:sex and t.step_num=:step_num
                            union
                            select t.id, t.ksg from KSG_TMP t
                            where t.group_code=:group_code and t.dop_criterian=:dop_criterian
                            union
                            select t.id, t.ksg from KSG_TMP t
                            where t.group_code=:group_code and t.dop_criterian2=:dop_criterian2
                            union
                            select t.id, t.ksg from KSG_TMP t
                            where t.group_code=:group_code and t.nms_code=:code_usl and t.step_num=:step_num
                            union
                            select t.id, t.ksg from KSG_TMP t
                            where t.group_code=:group_code and t.ds=:ds and t.step_num=:step_num)
        into :grp_id, :ksg;

      if (use_condition = 2) then
       select t.id, t.ksg from KSG_TMP t
                           where t.group_code=:group_code and (t.age_grp is not distinct from :age_grp)
                           and (t.days is not distinct from :days)
                           and (t.sex is not distinct from :sex)
                           and (t.dop_criterian is not distinct from :dop_criterian)
                           and (t.dop_criterian2 is not distinct from :dop_criterian2)
                           and (t.nms_code is not distinct from :code_usl)
                           and ((t.ds is not distinct from :ds) or ((select IS_LIKE from SP_CHECK_DS_GRP(t.ds, :ds)) = 1))  and t.step_num=:step_num
       into :grp_id, :ksg;

      if (use_condition = 0) then
      if (:step_num = 1) then
        select t.id, t.ksg from KSG_TMP t
                            where t.group_code=:group_code and t.step_num=:step_num
                                  and t.sex is null and t.age_grp is null and t.days is null and t.dop_criterian is null and t.nms_code is null and t.dop_criterian2 is null
       into :grp_id, :ksg;
 
      if (:step_num = 2) then
        select t.id, t.ksg from KSG_TMP t
                            where t.group_code=:group_code and t.step_num=:step_num
                                  and t.sex is null and t.age_grp is null and t.days is null and t.dop_criterian is null and t.ds is null and t.dop_criterian2 is null
       into :grp_id, :ksg;
    end

    --  
    if (grp_id is not null) then
     delete from KSG_TMP t
      where t.group_code=:group_code and t.step_num=:step_num and t.id <> :grp_id;
    else
     delete from KSG_TMP t
      where t.group_code=:group_code and t.step_num=:step_num;

    suspend;
end;

/* Restore proc. body: SP_ADD_PATIENTS_INVOICE */
ALTER PROCEDURE SP_ADD_PATIENTS_INVOICE(ZS_ID INTEGER)
 RETURNS(INV_ID INTEGER)
 AS
declare variable USL_ID integer;
declare variable USL_CNT DM_NUM_6_2;
declare variable TARIF DM_MONEY_15_2;
declare variable SUM_USLF DM_MONEY_15_2;
declare variable DENT_LIST DM_CHAR_250;
declare variable PAT_ID integer;
declare variable DATE2 DM_DATE;
declare variable DISCOUNT DM_MONEY_15_2;
declare variable ACTION_ID integer;
declare variable WITH_OTHER_DISCOUNTS integer;
begin
  pat_id = (select patient_id from zs where id = :zs_id);

  insert into PATIENTS_INVOICE (CH_DATE, ZS_ID, PATIENT_ID, registry_id, doctor_id, is_temp)
  values (current_date, :ZS_ID, :pat_id, (select registry_id from zs where id = :zs_id), (select phys_id from zs where id = :zs_id), 1)
  returning id
  into :inv_id;

  usl_cnt = 1;
  tarif = 0;
  with_other_discounts = 1;

  for select u.id, d.tar_usl, d.k_uslf, d.sum_uslf, coalesce(d.tooth_list, d.tooth_id), d.date_2
      from zsd d
           join zs h on h.id = d.zs_id
           join h_usl u on u.code = d.code_usl and u.q_u containing h.q_u and u.payment_type_id = h.payment_type_id
      where d.zs_id = :zs_id
--      group by 1, 2
      into :usl_id, :tarif, :usl_cnt, :sum_uslf, :dent_list, :date2
      do
      begin
        select first 1 coalesce((iif(a.discount_type = 0, :sum_uslf/100*a.discount, a.discount)),0), a.id, coalesce(c.with_other_discounts,0)
         from actions_usl a
             join actions c on c.id = a.action_id
         where a.usl_id = :usl_id and :date2 between a.bp and a.ep
         order by 1 desc
         into :discount, :action_id, :with_other_discounts;

        insert into PATIENTS_INVOICE_USL (HDR_ID, USL_ID, TARIF, K_USLF, DISCOUNT, DISCOUNT_PROC, SUM_USLF, tooth_list)
        values (:INV_ID, :USL_ID, :TARIF, :usl_cnt,
                :discount,100*:discount/:sum_uslf,
                :sum_uslf - :discount,
                :dent_list);

        if (:action_id is not null) then
        update patients_invoice i
         set i.action_id = :action_id
         where i.id = :inv_id;

        if (:with_other_discounts = 1) then
          update patients_invoice i
           set i.discount_type = (select DISCOUNT_TYPE from SP_GET_PATIENTS_DISCOUNT(:PAT_ID)),
               i.discount_proc = (select DISCOUNT from SP_GET_PATIENTS_DISCOUNT(:PAT_ID))
           where i.id = :inv_id;
      end

  suspend;
end;

/* Restore proc. body: SP_ADD_PATIENTS_INVOICE_ANALIZ */
ALTER PROCEDURE SP_ADD_PATIENTS_INVOICE_ANALIZ(PAT_ANALIZ_ID INTEGER,
PATIENT_ID INTEGER)
 RETURNS(INV_ID INTEGER)
 AS
begin
  insert into PATIENTS_INVOICE (CH_DATE, ZS_ID, PATIENT_ID, doctor_id, is_temp, discount_proc, discount_type, analiz_id)
  values (current_date, null, :patient_id, (select a.doctor_id from patients_analiz a where a.id = :pat_analiz_id), 1,
          (select DISCOUNT from SP_GET_PATIENTS_DISCOUNT(:patient_id)), (select DISCOUNT_TYPE from SP_GET_PATIENTS_DISCOUNT(:patient_id)), :pat_analiz_id)
  returning id
  into :inv_id;

  insert into PATIENTS_INVOICE_USL (HDR_ID, TARIF, K_USLF, SUM_USLF, USL_ID)
    select :inv_id, u.sumf, 1, u.sumf, a.analiz_id
    from patients_analiz a
         join h_usl u on u.id = a.analiz_id
    where a.id = :pat_analiz_id;

  suspend;
end;

/* Restore proc. body: SP_ADD_PATIENTS_INVOICE_REG */
ALTER PROCEDURE SP_ADD_PATIENTS_INVOICE_REG(REG_ID INTEGER,
PATIENT_ID INTEGER)
 RETURNS(INV_ID INTEGER)
 AS
declare variable USL_ID integer;
declare variable USL_CNT DM_NUM_6_2;
declare variable TARIF DM_MONEY_15_2;
declare variable SUM_USLF DM_MONEY_15_2;
declare variable DENT_ID integer;
declare variable ZS_ID integer;
begin
  zs_id = (select first 1 z.id from zs z where z.registry_id = :reg_id order by id desc);

  insert into PATIENTS_INVOICE (CH_DATE, ZS_ID, PATIENT_ID, registry_id, doctor_id, discount_proc, is_temp, discount_type)
  values (current_date, :zs_id, :patient_id, :reg_id, (select doctors_id from registry where id = :reg_id),
          (select DISCOUNT from SP_GET_PATIENTS_DISCOUNT(:patient_id)), 1, (select DISCOUNT_TYPE from SP_GET_PATIENTS_DISCOUNT(:patient_id)))
  returning id
  into :inv_id;

  usl_cnt = 1;
  tarif = 0;

  insert into PATIENTS_INVOICE_USL (HDR_ID, TARIF, K_USLF, SUM_USLF, LAB_PRODUCT_ID)
    select :inv_id, SUM_TOTAL, 1, SUM_TOTAL, PRODUCT_ID
    from LAB_ORDER_PRODUCTS p
         join lab_orders o on o.id = p.order_id
    where o.registry_id = :reg_id;
--
  insert into PATIENTS_INVOICE_USL (HDR_ID, USL_ID, TARIF, K_USLF, SUM_USLF, dent_id)
    select :inv_id, u.id, d.tar_usl, d.k_uslf, d.sum_uslf, d.tooth_id
      from zs h
           join zsd d on d.zs_id = h.id
           join h_usl u on u.code = d.code_usl and u.q_u containing h.q_u
      where h.id = :zs_id;


  suspend;
end;

/* Restore proc. body: SP_CALC_ALL */
ALTER PROCEDURE SP_CALC_ALL(ZS_ID INTEGER)
 AS
declare variable TAR DM_MONEY_15_2;
declare variable DATE1 DM_DATE;
declare variable Q_U integer;
declare variable TAR_USL DM_MONEY_15_2;
declare variable TARGET integer;
declare variable IDB integer;
declare variable SUM_USLF DM_MONEY_15_2;
declare variable SEX char(1);
declare variable PTYPE integer;
declare variable AGE_Y integer;
declare variable AGE_GRP integer;
declare variable HDR_ID integer;
declare variable TROMB_CODE DM_CHAR_20;
begin
  select z.date_2, z.q_u, z.target, p.sex, z.payment_type_id, extract(year from z.date_2) - extract(year from p.dr), z.hdr_id
  from zs z
  join patients p on p.id = z.patient_id
  where z.id = :zs_id
  into :date1, :q_u, :target, :sex, :ptype, :age_y, :hdr_id;

  if (:ptype in (2,3)) then exit;

  if (:target in (9,10,11,12,13,14,15,16,17)) then
  begin
   if ((select coalesce(t.days_cnt,0) from h_target t where t.id = :target) <> 0) then
   begin
    update zsd d
     set d.zachet = 1
     where d.date_1 < (:date1 - (select t.days_cnt from h_target t where t.id = :target)) and d.zs_id = :zs_id;

    update zsd d
     set d.zachet = 0
     where d.date_1 >= (:date1 - (select t.days_cnt from h_target t where t.id = :target)) and d.zs_id = :zs_id;
   end

   update zsd d
    set d.k_uslf = 0
    where (d.zachet = 1 or d.is_no_get_usl = 1) and d.zs_id = :zs_id;
  end

  update zsd d
    set d.tar_usl = null,
        d.sum_uslf = null,
        d.comment_local = null
    where d.zs_id = :zs_id;

  update zs z
    set z.tar_usl = null,
        z.sum_usl = null,
        z.sum_uslf = null
    where z.id = :zs_id;

  if ((select coalesce(i.is_nz,0) from invoice i join zs_hdr h on h.name = i.id where h.id = :hdr_id) = 1) then
  begin
    if (target in (9,10,11,13,14,15,16,17)) then exit;

    tar = (select first 1 s.tarif from h_tarif_nz s where s.q_u = iif(:q_u = 4,2,:q_u) and :date1 between s.bp and s.epv);

    if (q_u = 1) then
      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf =:tar
      where d.zs_id = :zs_id and d.code_usl is null;
    else
      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf =:tar
      where d.zs_id = :zs_id;

    if (q_u = 4) then
      update zs z
      set z.tar_usl = :tar,
        z.sum_uslf = z.dcount*:tar
      where id = :zs_id;
    else
    if (q_u = 1) then
      update zs z
      set z.tar_usl = :tar,
        z.sum_uslf = :tar
      where id = :zs_id;
    else
      update zs z
      set z.tar_usl = :tar,
          z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
      where id = :zs_id;
    exit;
  end
   /********************,    ************************/
  if (:q_u = 2 and :target not in (9,10,11,12,13,14,15,16,17,21,22) and (:date1 < '01.01.2018')) then
  begin
    for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin

          select first 1 h.tarif, h.tarif
          from zs a
           join zsd b on a.id = b.zs_id
           join h_tarif_app_tgroup t on a.date_2 between t.bp and t.epv
           join h_tarif_app h on h.tg = t.tg
                                 and a.date_2 between h.bp and h.epv
                                 and (h.target = iif(a.for_pom = 2, 1, 0))
                                 and cast(h.code_spec as varchar(10)) = iif(coalesce(a.vbr,0) = 0, iif(b.code_spec = '16' and a.age < 18, '22', b.code_spec), 0)
           where b.id = :idb
           order by h.target nulls last
           into :tar, :sum_uslf;

          update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0)
           where b.id = :idb;
        end

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce(:sum_uslf, 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;
    exit;
  end

  if (:q_u = 2 and :target not in (9,10,11,12,13,14,15,16,17,21,22) and (:date1 >= '01.01.2018')) then
  begin
    for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin
          if ((select d.code_usl from zsd d where d.id = :idb) = 'A23.30.099.005') then
          begin
            tar = 1670;
            sum_uslf = 1670*(select d.k_uslf from zsd d where d.id = :idb);
          end
          else
          if ((select d.code_usl from zsd d where d.id = :idb) = 'A23.30.099.006') then
          begin
            tar = 1180;
            sum_uslf = 1180*(select d.k_uslf from zsd d where d.id = :idb);
          end
          else
          select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
          from zs a
           join zsd b on a.id = b.zs_id
           join h_usl u on u.code = coalesce(b.code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                           and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1
           where b.id = :idb and b.code_usl is not null and coalesce(u.sumf,0) > 0
           into :tar, :sum_uslf;

          if (:tar is null) then
          select first 1 h.tarif, h.tarif
          from zs a
           join zsd b on a.id = b.zs_id
           join h_tarif_app_tgroup t on a.date_2 between t.bp and t.epv
           join h_tarif_app h on h.tg = t.tg
                                 and a.date_2 between h.bp and h.epv
                                 and (h.target = iif(a.for_pom = 2, 1, 0))
           join h_tarif_app_spec n on n.name_id = h.name_id
                                 and n.code_spec_v021 = iif(coalesce(a.vbr,0) = 0, iif(b.code_spec_v021 = 39 and a.age < 18, 49, b.code_spec_v021), 0)
           where b.id = :idb
           order by h.target nulls last
           into :tar, :sum_uslf;

          update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0)
           where b.id = :idb;

          tar = null;
          sum_uslf = null;
        end

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce(:sum_uslf, 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;
    exit;
  end  

  /********************************************/
  if (:q_u = 4) then
  begin
    tar = (select s.tarif from h_tarif_stom s where :date1 between s.bp and s.epv);

    update zsd d
    set d.tar_usl = :tar,
        d.sum_uslf = d.k_uslf*:tar
    where d.zs_id = :zs_id;
    
    update zs z
    set z.tar_usl = :tar,
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;
  end

  /******************** ************************/
  if (:q_u = 5) then
  begin
--    if (:date1 >= '01.01.2018') then tromb_code = 'A25.30.036';
--    else tromb_code = 'A25.30.035';
    tromb_code = coalesce((select first 1 code_usl from zsd d where d.zs_id = :zs_id and coalesce(code_usl, '') <> ''),'');

    tar = (select s.tarif from h_tarif_smp s where :date1 between s.bp and s.epv);
    tar_usl = coalesce((select coalesce(u.sumf,0) from h_usl u where u.code = :tromb_code
               and u.q_u containing '5' and :date1 between u.datebeg and u.dateend),0);

    update zsd d
    set d.tar_usl = iif(coalesce(d.code_usl,'') = '', :tar, :tar_usl),
        d.sum_uslf = d.k_uslf*iif(coalesce(d.code_usl,'') = '', :tar, :tar_usl)
    where d.zs_id = :zs_id;
    
    update zs z
    set z.tar_usl = (select max(tar_usl) from zsd where zs_id = :zs_id),
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;
  end

  /******************** ************************/
  if ((:q_u = 1) and ((select 1 from zs z where coalesce(z.metod_hmp,0) > 0 and id = :zs_id) = 1)) then
  begin
    select first 1 v.tarif
    from zs z
         join h_metod_hmp h on h.code = z.metod_hmp and z.date_2 between h.bp and h.epv
         join h_tarif_vmp v on v.tg = h.tg and z.date_2 between v.bp and v.epv
    where z.id = :zs_id
    into :tar;

    update zs a set
        a.tar_usl = :tar,
        a.sum_uslf = :tar,
        a.ksg = null,
        a.kslp = null
    where a.id = :zs_id;

    update zsd b set
          b.ksg = null,
          b.sum_uslf = :tar,
          b.kskp = 0,
          b.tar_usl = :tar
    where b.zs_id = :zs_id and coalesce(b.code_usl,'') = '' and b.date_1 = (select min(date_1) from zsd where zs_id = :zs_id and coalesce(code_usl,'') = '');

    exit;
  end

  /********************************************/
  if (:q_u in (1,3) and :date1 < '01.01.2018') then
    execute procedure SP_CALC_STAC(:zs_id);
  else
    if (:q_u in (1,3) and :date1 >= '01.01.2018') then
      execute procedure sp_calc_stac_2018(:zs_id);

  /****************  ***********************************************/
  tar = null;
  sum_uslf = null;
  for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin
          select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
          from zs a
           join zsd b on a.id = b.zs_id
           join h_usl u on u.code = coalesce(b.code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                           and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1
           where b.id = :idb and b.code_usl is not null and coalesce(u.sumf,0) > 0
           into :tar, :sum_uslf;

          if (coalesce(:tar,0) > 0) then
          update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0)
           where b.id = :idb;

          tar = null;
          sum_uslf = null;
        end

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce(:sum_uslf, 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;


  /*********************-*********************************/
  if ((:q_u = 2) and (:target in (21,22))) then
  begin
   for select b.id
    from zsd b
    join zs z on z.id = b.zs_id
    where z.id = :zs_id
    into :idb
    do
    begin
      tar = (select first 1 t.tarif
             from zsd d
                  join h_tomo_code c on c.nms_code = d.code_usl
                  join h_tarif_tomo t on t.group_num = c.group_num and d.date_2 between t.bp and t.epv
             where d.id = :idb);

      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf = :tar
      where d.id = :idb;
    end

    update zs z
    set z.tar_usl = (select sum(tar_usl) from zsd where zs_id = :zs_id),
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;

    exit;
  end
  /******************** - 9  ************************/
  if (:q_u = 2 and :target = 9) then
  begin
    execute procedure sp_calc_app_t09(:zs_id);
    exit;
  end

  /******************** - 10,17  -  ************************/
    if (q_u = 2 and target in (10,17)) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_10 d on d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and :age_y between d.y1 and d.y2
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = coalesce(b.k_uslf * :tar, 0),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end

  /******************** - 13  ************************/
    if (q_u = 2 and target = 13) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                           and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_13_17 d on d.target = a.target
                                          and d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and d.age_grp = a.age_grp
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = coalesce(b.k_uslf * :tar, 0),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end

  /******************** - 14,15  ,  ************************/
    if (q_u = 2 and target in (14,15)) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_14_15 d on d.target = a.target
                                          and d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and d.cat_info = a.cat_info
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = coalesce(b.k_uslf * :tar, 0),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end
  /******************** - 16  ************************/
    if (q_u = 2 and target = 16) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_16 d on a.date_2 between d.bp and d.epv
                                          and d.sex = :sex
                                          and cast(d.code_usl as varchar(20)) = b.code_usl
                                          and d.age_l <= a.age and d.age_r >= a.age
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = coalesce(b.k_uslf * :tar, 0),
               b.tar_base = coalesce(:tar, 0) ,
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end
end;

/* Restore proc. body: SP_CALC_STAC_KSKP_2019 */
ALTER PROCEDURE SP_CALC_STAC_KSKP_2019(IDA INTEGER,
IDB INTEGER,
KSG DM_CHAR_20,
CL_CNT INTEGER)
 RETURNS(KSKP TYPE OF DM_NUM_3_2)
 AS
declare variable KSKP1 type of DM_NUM_3_2;
declare variable KSKP2 type of DM_NUM_3_2;
declare variable KSKP3 type of DM_NUM_3_2;
declare variable KSKP4 type of DM_NUM_3_2;
declare variable KSKP5 type of DM_NUM_3_2;
declare variable KSKP6 type of DM_NUM_3_2;
declare variable KSKP7 type of DM_NUM_3_2;
declare variable KSLP12 DM_NUM_3_2;
declare variable KSLP13 DM_NUM_3_2;
declare variable KSLP14 DM_NUM_3_2;
begin
     kskp6 = 1;

     select
           --    
           iif((a.q_u = 1) and (a.age < 1) and ((select first 1 d.ksg from h_ksg_dop d where d.type_num = 2 and a.date_2 between d.bp and d.epv and d.q_u = 1 and d.ksg = :ksg) is null),
               (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 1), 1),
           iif((a.q_u = 1) and (a.age >= 1) and (a.age < 4), (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 2), 1),
           iif((a.q_u = 1) and (a.age < 4 and a.age < 18 and coalesce(a.chield_with_rop,0) = 1), (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 3), 1),
           iif((a.q_u = 1) and (a.age >= 75) and ((select first 1 d.ksg from h_ksg_dop d where d.type_num = 3 and a.date_2 between d.bp and d.epv and d.q_u = 1 and d.ksg = :ksg) is null),
                (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 4), 1),    -- 4
           iif((a.q_u = 1) and (a.ds1 <> 'R54' and a.ds2 = 'R54' and exists(select first 1 id from zsd b where b.zs_id = a.id and b.profil_k = 16) and
               ((select first 1 d.ksg from h_ksg_dop d where d.type_num = 4 and a.date_2 between d.bp and d.epv and d.q_u = 1 and d.ksg = :ksg) is null)),
                (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 5), 1) --5
--           iif((a.q_u = 3) and exists(select from zsd b where b.zs_id = a.id and b.code_usl in ('A25.20.004.001','A11.20.019',)))
      from zs a
      join patients p on p.id = a.patient_id
      left join zs_hdr h on h.id = a.hdr_id
      left join invoice i on i.id = h.name
      where a.id = :ida
      into :kskp1, :kskp2, :kskp3, :kskp4, :kskp5;

     if (idb is not null) then
      select
            --  
            case
              when (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) > 30 and ((select d.ksg from h_ksg_dop d where d.type_num = 5 and a.date_2 between d.bp and d.epv and d.q_u = 1 and d.ksg = :ksg) is null)) then
                    case
                      when (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) - coalesce(b.orit,0)) >= coalesce(b.orit,0) then 1 + (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) - 30) * 0.25 / 30
                      else 1 + (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) - 30) * 0.4 / 30
                    end
              when (b.k_uslf > 45 and ((select d.ksg from h_ksg_dop d where d.type_num = 5 and a.date_2 between d.bp and d.epv and d.q_u = 1 and d.ksg = :ksg) is not null)) then
                    case
                      when (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) - coalesce(b.orit,0)) >= coalesce(b.orit,0) then 1 + (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) - 45) * 0.25 / 45
                      else 1 + (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) - 45) * 0.4 / 45
                    end
              else 1
            end
       from zs a
       join zsd b on a.id = b.zs_id
       where b.id = :idb
       into :kskp6;


     kskp = kskp1 + (kskp2-1) + (kskp3-1) + (kskp4-1) + (kskp5-1);
     if (kskp > 1.8) then
      kskp = 1.8;
     kskp = kskp + (kskp6-1);
     
     delete from kslp_koef where zs_id = :ida and ksg = :ksg;
     
     if (:kskp1 > 1) then
         insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
            values (1, :kskp1, :ida, :ksg);
     if (:kskp2 > 1) then       
         insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
            values (2, :kskp2, :ida, :ksg);
     if (:kskp3 > 1) then
         insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
            values (3, :kskp3, :ida, :ksg);
     if (:kskp4 > 1) then
         insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
            values (4, :kskp4, :ida, :ksg);
     if (:kskp5 > 1) then
         insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
            values (5, :kskp5, :ida, :ksg);
     if (:kskp6 > 1) then
         insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
            values (6, :kskp6, :ida, :ksg);
            
    suspend;        
end;

/* Restore proc. body: SP_CHECK_DS_GRP */
ALTER PROCEDURE SP_CHECK_DS_GRP(DS DM_DS,
DS_CHECK DM_DS)
 RETURNS(IS_LIKE DM_BOOL)
 AS
begin
  is_like = 0;

  if (position('-' in :ds) <> 0) then
  begin
    if ((substring(:ds from 1 for (position('-' in :ds) - 1)) <= :ds_check)
        and (substring(:ds from (position('-' in :ds) + 1) for (char_length(:ds) - position('-' in :ds))) >= substring(:ds_check from 1 for 3))) then
      is_like = 1;
  end
  else
  if (position('.' in :ds) = 2) then
  begin
    if (substring(:ds_check from 1 for 1) = substring(:ds from 1 for 1)) then
      is_like = 1;
  end
  else
  if (:ds_check = :ds) then
    is_like = 1;
  suspend;
end;

/* Restore proc. body: SP_GET_PATIENTS_DISCOUNT_TYPE */
ALTER PROCEDURE SP_GET_PATIENTS_DISCOUNT_TYPE(PAT_ID INTEGER,
DISCOUNT_TYPE INTEGER)
 RETURNS(DISCOUNT DM_NUM_6_2)
 AS
declare variable SUM_ALL DM_MONEY_15_2;
begin
  sum_all = (select sum(coalesce(i.sum_opl,0)) from patients_invoice i where i.patient_id = :pat_id);
  discount = 0;

  if (:discount_type = 1) then
    discount = (select first 1 coalesce(s.discount, 0) from discount_setting s
                 where (s.min_sum <= :sum_all) and s.discount_type = 1 order by s.min_sum desc);

  if (:discount_type <> 1) then
    discount = (select first 1 s.discount
                from patients p, discount_setting s
                where ((extract(day from p.dr) = extract(day from current_date) and extract(month from p.dr) = extract(month from current_date) and s.discount_type = 3)
                      or (coalesce(p.patient_type,0) = coalesce(s.patient_type,0) and s.discount_type = 2))
                      and s.discount_type = :discount_type
                      and p.id = :pat_id
                order by s.discount desc);

  suspend;
end;

/* Creating trigger... */
CREATE TRIGGER H_KSG_BIU0 FOR H_KSG
ACTIVE BEFORE INSERT OR UPDATE POSITION 0 
AS
begin
  if (new.k_down is null) then
    new.k_down = 1;
end;

CREATE TRIGGER KSG_GRP_BIU0 FOR KSG_GRP
ACTIVE BEFORE INSERT OR UPDATE POSITION 0 
AS
begin
  if (new.sex = '1') then
    new.sex = '';
  else
  if (new.sex = '2') then
    new.sex = '';
end;


/* Altering existing trigger... */
ALTER TRIGGER DOCTORS_PROF_BIU0
AS
begin
  if (coalesce(new.PROF_name,'') = '') then
   NEW.PROF_name = (select v.name from h_CODE_OTD v where v.code = new.prof);
end;

/* Altering existing trigger... */
ALTER TRIGGER PATIENTS_INVOICE_AD0
AS
begin
  update zs
        set sum_usl = coalesce((select sum(i.sum_opl) from patients_invoice i where i.zs_id = OLD.zs_id), 0)
        where id = OLD.zs_id;
  if (old.action_id is not null) then
    update actions a
      set a.profit_fact = (select sum(i.sum_opl) from patients_invoice i where i.action_id = old.action_id),
          a.resp_cnt_fact = (select count(distinct i.patient_id) from patients_invoice i where i.action_id = old.action_id)
      where a.id = old.action_id;
end;

/* Altering existing trigger... */
ALTER TRIGGER PATIENTS_INVOICE_BIU1
AS
declare variable l varchar(250);
begin
  if (coalesce(NEW.discount,0) = 0 and coalesce(NEW.discount_proc,0) <> 0) then
    new.discount = new.discount_proc * new.sumv/100;
  else
  if (coalesce(NEW.discount,0) <> 0 and coalesce(NEW.discount_proc,0) = 0) then
    new.discount_proc = new.discount/new.sumv * 100;

  if (new.sumv_total is not null) then
    update zs z
    set z.sum_usl = new.sumv_total
    where z.id = new.zs_id;

  new.tooth_list = '';

  for select trim(',' from u.tooth_list)
      from patients_invoice_usl u
      where u.hdr_id = new.id
      into :l
      do
      begin
        new.tooth_list = new.tooth_list || l || ',';
      end

  update zs
        set sum_usl = coalesce((select sum(i.sum_opl) from patients_invoice i where i.zs_id = new.zs_id), 0)
        where id = new.zs_id;

  if (new.action_id is not null) then
    update actions a
      set a.profit_fact = (select sum(i.sum_opl) from patients_invoice i where i.action_id = new.action_id),
          a.resp_cnt_fact = (select count(distinct i.patient_id) from patients_invoice i where i.action_id = new.action_id)
      where a.id = new.action_id;
end;

/* Altering existing trigger... */
ALTER TRIGGER ZS_BIU0
AS
declare variable hdr integer;
declare variable dr date;
begin
  if (new.n_zap is null) then
    new.n_zap = new.id;

  if (new.id_case is null) then
    new.id_case = new.id;

  if (new.id_pac is null) then
    new.id_pac = new.id;

  if (new.payment_type_id is null) then
    new.payment_type_id = 1;

  if (bin_and(new.extra_info, 1) = 1) then
    new.chield_with_rop = 1;

  if (new.date_1 is null) then
  begin
    new.date_1 = current_date;
    new.date_2 = current_date;
  end

  if (new.hdr_id is null) then
  begin
    hdr = (select id from zs_hdr h where h.y = extract(year from new.date_2) and h.m = extract(month from new.date_2)
         and h.name = h.m and is_delete = 0);

    if (hdr is not null) then
      new.hdr_id = hdr;
    else
    begin
      execute procedure ADD_PERIOD_HDR(extract(month from new.date_2), extract(year from new.date_2),
                                       (select M2 from SP_MONTH_TO_STRING(extract(month from new.date_2))),
                                       cast(extract(year from new.date_2) as varchar(4))) ;
      hdr = (select id from zs_hdr h where h.y = extract(year from new.date_2) and h.m = extract(month from new.date_2));
      new.hdr_id = :hdr;
    end
  end

  if ((new.n_hist is null) or (new.n_hist = '')) then
  begin
--    new.n_hist_num = (select max(coalesce(n_hist_num,0)) from zs z where z.patient_id = new.patient_id) + 1;
    new.n_hist = cast(gen_id(gen_nhist, 1) as varchar(50));
  end

  if (new.is_chield is null) then
    new.is_chield = 0;

  if ((new.q_u_2016 is not null) and (new.q_u is null)) then
  begin
      if (new.q_u_2016 = 4 and extract(year from new.date_2) > 2015 ) then
        new.q_u = 5;
      else
      if (new.q_u_2016 = 5 and extract(year from new.date_2) > 2015 ) then
        new.q_u = 4;
      else
      if (new.q_u_2016 = 2 and extract(year from new.date_2) > 2015 ) then
        new.q_u = 3;
      else
      if (new.q_u_2016 = 3 and extract(year from new.date_2) > 2015 ) then
      begin
       if (new.idsp = 9) then
       begin
        new.q_u = 4;
        new.q_u_2016 = 5;
       end
       else
        new.q_u = 2;
      end
      else new.q_u = 1;
  end
  else
  if ((new.q_u is not null)) then
  begin
      if (new.q_u = 4 and extract(year from new.date_2) > 2015 ) then
        new.q_u_2016 = 5;
      else
      if (new.q_u = 5 and extract(year from new.date_2) > 2015 ) then
        new.q_u_2016 = 4;
      else
      if (new.q_u = 2 and extract(year from new.date_2) > 2015 ) then
        new.q_u_2016 = 3;
      else
      if (new.q_u = 3 and extract(year from new.date_2) > 2015 ) then
        new.q_u_2016 = 2;
      else new.q_u_2016 = 1;
  end

  if (new.target in (9,10,11,12,13,14,15,16,17)) then
  begin
    if (new.disp_h_group is null) then
    begin
      new.disp_h_group = case
                           when (new.rslt_d in (1)) then '1'
                           when (new.rslt_d in (2)) then '2'
                           when (new.rslt_d in (3)) then '3'
                           when (new.rslt_d in (31)) then '3'
                           when (new.rslt_d in (32)) then '3'
                           when (new.rslt_d in (4)) then '4'
                           when (new.rslt_d in (5)) then '5'
                           when (new.rslt_d in (11)) then '1'
                           when (new.rslt_d in (12)) then '2'
                           when (new.rslt_d in (14)) then '3'
                           when (new.rslt_d in (15)) then '3'
                         end;
    end
  end
  
  if (not inserting) then
  begin
  if (new.q_u = 1) then
    new.k_uslf = iif(new.date_1 = new.date_2, 1, new.date_2 - new.date_1);
    else
    if (new.q_u = 3) then
      new.k_uslf = iif(new.date_1 = new.date_2, 1, new.date_2 - new.date_1 + 1);
      else
      if (new.q_u in (4,5)) then
        new.k_uslf = (select sum(d.k_uslf) from zsd d where d.zs_id = new.id);
        else
        if (new.q_u = 2) then
          new.k_uslf = (select sum(d.k_uslf)
                        from zsd d left join h_usl u on u.code = d.code_usl
                                                        and u.q_u containing new.q_u
                                                        and new.date_1 between u.datebeg and u.dateend
                                                        and u.payment_type_id = new.payment_type_id
                        where d.zs_id = new.id and coalesce(u.is_usl,0) <> 1);
  end

  if (coalesce(new.idsp_not_auto,0) = 0) then
  new.idsp = case
             when (new.q_u = 1) then 33
             when (new.q_u = 3) then 43
             when (new.q_u = 2) and ((new.target < 9) or (new.target = 26)) and (new.for_pom = 2) and new.k_uslf = 1  then 41
             when (new.q_u = 2) and ((new.target < 9) or (new.target = 26)) and (new.for_pom = 2) and new.k_uslf > 1  then 42
             when (new.q_u = 2) and ((new.target < 9) or (new.target = 26)) and (new.for_pom = 3) and new.k_uslf = 1 then 29
             when (new.q_u = 2) and ((new.target < 9) or (new.target = 26)) and (new.for_pom = 3) and new.k_uslf > 1 then 30
             when (new.q_u = 2) and (new.target in (9,10,17)) then 11
             when (new.q_u = 2) and (new.target in (13,14,15,16)) then 30
             when (new.q_u = 2) and (new.target in (21,22,23)) then 28
             when (new.q_u = 4) then 9
             when (new.q_u = 5) then 24
             end;

  dr = (select dr from patients where id = new.patient_id);

  if ((coalesce(new.age_grp_not_auto,0) = 0) and (new.target = 13)) then
    new.age_grp = (select AGE_GRP from SP_CALC_AGE_GRP(:dr, new.date_1));
             
  if (new.chield_with_rop = 1) then
    new.extra_info = 1;
  if (new.extra_info = 1) then
    new.chield_with_rop = 1;


end;

/* Alter Procedure... */
/* Alter (SP_ADD_PATIENTS_INVOICE) */
ALTER PROCEDURE SP_ADD_PATIENTS_INVOICE(ZS_ID INTEGER)
 RETURNS(INV_ID INTEGER)
 AS
declare variable USL_ID integer;
declare variable USL_CNT DM_NUM_6_2;
declare variable TARIF DM_MONEY_15_2;
declare variable SUM_USLF DM_MONEY_15_2;
declare variable DENT_LIST DM_CHAR_250;
declare variable PAT_ID integer;
declare variable DATE2 DM_DATE;
declare variable DISCOUNT DM_MONEY_15_2;
declare variable ACTION_ID integer;
declare variable WITH_OTHER_DISCOUNTS integer;
begin
  pat_id = (select patient_id from zs where id = :zs_id);

  insert into PATIENTS_INVOICE (CH_DATE, ZS_ID, PATIENT_ID, registry_id, doctor_id, is_temp)
  values (current_date, :ZS_ID, :pat_id, (select registry_id from zs where id = :zs_id), (select phys_id from zs where id = :zs_id), 1)
  returning id
  into :inv_id;

  usl_cnt = 1;
  tarif = 0;
  with_other_discounts = 1;

  for select u.id, d.tar_usl, d.k_uslf, d.sum_uslf, coalesce(d.tooth_list, d.tooth_id), d.date_2
      from zsd d
           join zs h on h.id = d.zs_id
           join h_usl u on u.code = d.code_usl and u.q_u containing h.q_u and u.payment_type_id = h.payment_type_id
      where d.zs_id = :zs_id
--      group by 1, 2
      into :usl_id, :tarif, :usl_cnt, :sum_uslf, :dent_list, :date2
      do
      begin
        select first 1 coalesce((iif(a.discount_type = 0, :sum_uslf/100*a.discount, a.discount)),0), a.id, coalesce(c.with_other_discounts,0)
         from actions_usl a
             join actions c on c.id = a.action_id
         where a.usl_id = :usl_id and :date2 between a.bp and a.ep
         order by 1 desc
         into :discount, :action_id, :with_other_discounts;

        insert into PATIENTS_INVOICE_USL (HDR_ID, USL_ID, TARIF, K_USLF, DISCOUNT, DISCOUNT_PROC, SUM_USLF, tooth_list)
        values (:INV_ID, :USL_ID, :TARIF, :usl_cnt,
                :discount,100*:discount/:sum_uslf,
                :sum_uslf - :discount,
                :dent_list);

        if (:action_id is not null) then
        update patients_invoice i
         set i.action_id = :action_id
         where i.id = :inv_id;

        if (:with_other_discounts = 1) then
          update patients_invoice i
           set i.discount_type = (select DISCOUNT_TYPE from SP_GET_PATIENTS_DISCOUNT(:PAT_ID)),
               i.discount_proc = (select DISCOUNT from SP_GET_PATIENTS_DISCOUNT(:PAT_ID))
           where i.id = :inv_id;
      end

  suspend;
end;

/* Alter (SP_ADD_PATIENTS_INVOICE_ANALIZ) */
ALTER PROCEDURE SP_ADD_PATIENTS_INVOICE_ANALIZ(PAT_ANALIZ_ID INTEGER,
PATIENT_ID INTEGER)
 RETURNS(INV_ID INTEGER)
 AS
begin
  insert into PATIENTS_INVOICE (CH_DATE, ZS_ID, PATIENT_ID, doctor_id, is_temp, discount_proc, discount_type, analiz_id)
  values (current_date, null, :patient_id, (select a.doctor_id from patients_analiz a where a.id = :pat_analiz_id), 1,
          (select DISCOUNT from SP_GET_PATIENTS_DISCOUNT(:patient_id)), (select DISCOUNT_TYPE from SP_GET_PATIENTS_DISCOUNT(:patient_id)), :pat_analiz_id)
  returning id
  into :inv_id;

  insert into PATIENTS_INVOICE_USL (HDR_ID, TARIF, K_USLF, SUM_USLF, USL_ID)
    select :inv_id, u.sumf, 1, u.sumf, a.analiz_id
    from patients_analiz a
         join h_usl u on u.id = a.analiz_id
    where a.id = :pat_analiz_id;

  suspend;
end;

/* Alter (SP_ADD_PATIENTS_INVOICE_REG) */
ALTER PROCEDURE SP_ADD_PATIENTS_INVOICE_REG(REG_ID INTEGER,
PATIENT_ID INTEGER)
 RETURNS(INV_ID INTEGER)
 AS
declare variable USL_ID integer;
declare variable USL_CNT DM_NUM_6_2;
declare variable TARIF DM_MONEY_15_2;
declare variable SUM_USLF DM_MONEY_15_2;
declare variable DENT_ID integer;
declare variable ZS_ID integer;
begin
  zs_id = (select first 1 z.id from zs z where z.registry_id = :reg_id order by id desc);

  insert into PATIENTS_INVOICE (CH_DATE, ZS_ID, PATIENT_ID, registry_id, doctor_id, discount_proc, is_temp, discount_type)
  values (current_date, :zs_id, :patient_id, :reg_id, (select doctors_id from registry where id = :reg_id),
          (select DISCOUNT from SP_GET_PATIENTS_DISCOUNT(:patient_id)), 1, (select DISCOUNT_TYPE from SP_GET_PATIENTS_DISCOUNT(:patient_id)))
  returning id
  into :inv_id;

  usl_cnt = 1;
  tarif = 0;

  insert into PATIENTS_INVOICE_USL (HDR_ID, TARIF, K_USLF, SUM_USLF, LAB_PRODUCT_ID)
    select :inv_id, SUM_TOTAL, 1, SUM_TOTAL, PRODUCT_ID
    from LAB_ORDER_PRODUCTS p
         join lab_orders o on o.id = p.order_id
    where o.registry_id = :reg_id;
--
  insert into PATIENTS_INVOICE_USL (HDR_ID, USL_ID, TARIF, K_USLF, SUM_USLF, dent_id)
    select :inv_id, u.id, d.tar_usl, d.k_uslf, d.sum_uslf, d.tooth_id
      from zs h
           join zsd d on d.zs_id = h.id
           join h_usl u on u.code = d.code_usl and u.q_u containing h.q_u
      where h.id = :zs_id;


  suspend;
end;

/* empty dependent procedure body */
/* Clear: SP_CALC_ALL_CH for: SP_CALC_ALL */
ALTER PROCEDURE SP_CALC_ALL_CH(HDR_ID INTEGER)
 AS
 BEGIN EXIT; END;

/* empty dependent procedure body */
/* Clear: SP_ZS_SET_ZACHET for: SP_CALC_ALL */
ALTER PROCEDURE SP_ZS_SET_ZACHET(HDR_ID INTEGER)
 AS
 BEGIN EXIT; END;

/* empty dependent procedure body */
/* Clear: SP_ZSD_LIST_CREATE for: SP_CALC_ALL */
ALTER PROCEDURE SP_ZSD_LIST_CREATE(ZS_ID INTEGER)
 AS
 BEGIN EXIT; END;

/* Alter (SP_CALC_ALL) */
ALTER PROCEDURE SP_CALC_ALL(ZS_ID INTEGER)
 AS
declare variable TAR DM_MONEY_15_2;
declare variable DATE1 DM_DATE;
declare variable Q_U integer;
declare variable TAR_USL DM_MONEY_15_2;
declare variable TARGET integer;
declare variable IDB integer;
declare variable SUM_USLF DM_MONEY_15_2;
declare variable SEX char(1);
declare variable PTYPE integer;
declare variable AGE_Y integer;
declare variable AGE_GRP integer;
declare variable HDR_ID integer;
declare variable TROMB_CODE DM_CHAR_20;
begin
  select z.date_2, z.q_u, z.target, p.sex, z.payment_type_id, extract(year from z.date_2) - extract(year from p.dr), z.hdr_id
  from zs z
  join patients p on p.id = z.patient_id
  where z.id = :zs_id
  into :date1, :q_u, :target, :sex, :ptype, :age_y, :hdr_id;

  if (:ptype in (2,3)) then exit;

  if (:target in (9,10,11,12,13,14,15,16,17)) then
  begin
   if ((select coalesce(t.days_cnt,0) from h_target t where t.id = :target) <> 0) then
   begin
    update zsd d
     set d.zachet = 1
     where d.date_1 < (:date1 - (select t.days_cnt from h_target t where t.id = :target)) and d.zs_id = :zs_id;

    update zsd d
     set d.zachet = 0
     where d.date_1 >= (:date1 - (select t.days_cnt from h_target t where t.id = :target)) and d.zs_id = :zs_id;
   end

   update zsd d
    set d.k_uslf = 0
    where (d.zachet = 1 or d.is_no_get_usl = 1) and d.zs_id = :zs_id;
  end

  update zsd d
    set d.tar_usl = null,
        d.sum_uslf = null,
        d.comment_local = null
    where d.zs_id = :zs_id;

  update zs z
    set z.tar_usl = null,
        z.sum_usl = null,
        z.sum_uslf = null
    where z.id = :zs_id;

  if ((select coalesce(i.is_nz,0) from invoice i join zs_hdr h on h.name = i.id where h.id = :hdr_id) = 1) then
  begin
    if (target in (9,10,11,13,14,15,16,17)) then exit;

    tar = (select first 1 s.tarif from h_tarif_nz s where s.q_u = iif(:q_u = 4,2,:q_u) and :date1 between s.bp and s.epv);

    if (q_u = 1) then
      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf =:tar
      where d.zs_id = :zs_id and d.code_usl is null;
    else
      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf =:tar
      where d.zs_id = :zs_id;

    if (q_u = 4) then
      update zs z
      set z.tar_usl = :tar,
        z.sum_uslf = z.dcount*:tar
      where id = :zs_id;
    else
    if (q_u = 1) then
      update zs z
      set z.tar_usl = :tar,
        z.sum_uslf = :tar
      where id = :zs_id;
    else
      update zs z
      set z.tar_usl = :tar,
          z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
      where id = :zs_id;
    exit;
  end
   /********************,    ************************/
  if (:q_u = 2 and :target not in (9,10,11,12,13,14,15,16,17,21,22) and (:date1 < '01.01.2018')) then
  begin
    for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin

          select first 1 h.tarif, h.tarif
          from zs a
           join zsd b on a.id = b.zs_id
           join h_tarif_app_tgroup t on a.date_2 between t.bp and t.epv
           join h_tarif_app h on h.tg = t.tg
                                 and a.date_2 between h.bp and h.epv
                                 and (h.target = iif(a.for_pom = 2, 1, 0))
                                 and cast(h.code_spec as varchar(10)) = iif(coalesce(a.vbr,0) = 0, iif(b.code_spec = '16' and a.age < 18, '22', b.code_spec), 0)
           where b.id = :idb
           order by h.target nulls last
           into :tar, :sum_uslf;

          update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0)
           where b.id = :idb;
        end

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce(:sum_uslf, 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;
    exit;
  end

  if (:q_u = 2 and :target not in (9,10,11,12,13,14,15,16,17,21,22) and (:date1 >= '01.01.2018')) then
  begin
    for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin
          if ((select d.code_usl from zsd d where d.id = :idb) = 'A23.30.099.005') then
          begin
            tar = 1670;
            sum_uslf = 1670*(select d.k_uslf from zsd d where d.id = :idb);
          end
          else
          if ((select d.code_usl from zsd d where d.id = :idb) = 'A23.30.099.006') then
          begin
            tar = 1180;
            sum_uslf = 1180*(select d.k_uslf from zsd d where d.id = :idb);
          end
          else
          select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
          from zs a
           join zsd b on a.id = b.zs_id
           join h_usl u on u.code = coalesce(b.code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                           and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1
           where b.id = :idb and b.code_usl is not null and coalesce(u.sumf,0) > 0
           into :tar, :sum_uslf;

          if (:tar is null) then
          select first 1 h.tarif, h.tarif
          from zs a
           join zsd b on a.id = b.zs_id
           join h_tarif_app_tgroup t on a.date_2 between t.bp and t.epv
           join h_tarif_app h on h.tg = t.tg
                                 and a.date_2 between h.bp and h.epv
                                 and (h.target = iif(a.for_pom = 2, 1, 0))
           join h_tarif_app_spec n on n.name_id = h.name_id
                                 and n.code_spec_v021 = iif(coalesce(a.vbr,0) = 0, iif(b.code_spec_v021 = 39 and a.age < 18, 49, b.code_spec_v021), 0)
           where b.id = :idb
           order by h.target nulls last
           into :tar, :sum_uslf;

          update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0)
           where b.id = :idb;

          tar = null;
          sum_uslf = null;
        end

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce(:sum_uslf, 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;
    exit;
  end  

  /********************************************/
  if (:q_u = 4) then
  begin
    tar = (select s.tarif from h_tarif_stom s where :date1 between s.bp and s.epv);

    update zsd d
    set d.tar_usl = :tar,
        d.sum_uslf = d.k_uslf*:tar
    where d.zs_id = :zs_id;
    
    update zs z
    set z.tar_usl = :tar,
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;
  end

  /******************** ************************/
  if (:q_u = 5) then
  begin
--    if (:date1 >= '01.01.2018') then tromb_code = 'A25.30.036';
--    else tromb_code = 'A25.30.035';
    tromb_code = coalesce((select first 1 code_usl from zsd d where d.zs_id = :zs_id and coalesce(code_usl, '') <> ''),'');

    tar = (select s.tarif from h_tarif_smp s where :date1 between s.bp and s.epv);
    tar_usl = coalesce((select coalesce(u.sumf,0) from h_usl u where u.code = :tromb_code
               and u.q_u containing '5' and :date1 between u.datebeg and u.dateend),0);

    update zsd d
    set d.tar_usl = iif(coalesce(d.code_usl,'') = '', :tar, :tar_usl),
        d.sum_uslf = d.k_uslf*iif(coalesce(d.code_usl,'') = '', :tar, :tar_usl)
    where d.zs_id = :zs_id;
    
    update zs z
    set z.tar_usl = (select max(tar_usl) from zsd where zs_id = :zs_id),
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;
  end

  /******************** ************************/
  if ((:q_u = 1) and ((select 1 from zs z where coalesce(z.metod_hmp,0) > 0 and id = :zs_id) = 1)) then
  begin
    select first 1 v.tarif
    from zs z
         join h_metod_hmp h on h.code = z.metod_hmp and z.date_2 between h.bp and h.epv
         join h_tarif_vmp v on v.tg = h.tg and z.date_2 between v.bp and v.epv
    where z.id = :zs_id
    into :tar;

    update zs a set
        a.tar_usl = :tar,
        a.sum_uslf = :tar,
        a.ksg = null,
        a.kslp = null
    where a.id = :zs_id;

    update zsd b set
          b.ksg = null,
          b.sum_uslf = :tar,
          b.kskp = 0,
          b.tar_usl = :tar
    where b.zs_id = :zs_id and coalesce(b.code_usl,'') = '' and b.date_1 = (select min(date_1) from zsd where zs_id = :zs_id and coalesce(code_usl,'') = '');

    exit;
  end

  /********************************************/
  if (:q_u in (1,3) and :date1 < '01.01.2018') then
    execute procedure SP_CALC_STAC(:zs_id);
  else
    if (:q_u in (1,3) and :date1 >= '01.01.2018') then
      execute procedure sp_calc_stac_2018(:zs_id);

  /****************  ***********************************************/
  tar = null;
  sum_uslf = null;
  for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin
          select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
          from zs a
           join zsd b on a.id = b.zs_id
           join h_usl u on u.code = coalesce(b.code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                           and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1
           where b.id = :idb and b.code_usl is not null and coalesce(u.sumf,0) > 0
           into :tar, :sum_uslf;

          if (coalesce(:tar,0) > 0) then
          update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0)
           where b.id = :idb;

          tar = null;
          sum_uslf = null;
        end

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce(:sum_uslf, 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;


  /*********************-*********************************/
  if ((:q_u = 2) and (:target in (21,22))) then
  begin
   for select b.id
    from zsd b
    join zs z on z.id = b.zs_id
    where z.id = :zs_id
    into :idb
    do
    begin
      tar = (select first 1 t.tarif
             from zsd d
                  join h_tomo_code c on c.nms_code = d.code_usl
                  join h_tarif_tomo t on t.group_num = c.group_num and d.date_2 between t.bp and t.epv
             where d.id = :idb);

      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf = :tar
      where d.id = :idb;
    end

    update zs z
    set z.tar_usl = (select sum(tar_usl) from zsd where zs_id = :zs_id),
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;

    exit;
  end
  /******************** - 9  ************************/
  if (:q_u = 2 and :target = 9) then
  begin
    execute procedure sp_calc_app_t09(:zs_id);
    exit;
  end

  /******************** - 10,17  -  ************************/
    if (q_u = 2 and target in (10,17)) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_10 d on d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and :age_y between d.y1 and d.y2
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = coalesce(b.k_uslf * :tar, 0),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end

  /******************** - 13  ************************/
    if (q_u = 2 and target = 13) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                           and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_13_17 d on d.target = a.target
                                          and d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and d.age_grp = a.age_grp
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = coalesce(b.k_uslf * :tar, 0),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end

  /******************** - 14,15  ,  ************************/
    if (q_u = 2 and target in (14,15)) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_14_15 d on d.target = a.target
                                          and d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and d.cat_info = a.cat_info
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = coalesce(b.k_uslf * :tar, 0),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end
  /******************** - 16  ************************/
    if (q_u = 2 and target = 16) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_16 d on a.date_2 between d.bp and d.epv
                                          and d.sex = :sex
                                          and cast(d.code_usl as varchar(20)) = b.code_usl
                                          and d.age_l <= a.age and d.age_r >= a.age
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = coalesce(b.k_uslf * :tar, 0),
               b.tar_base = coalesce(:tar, 0) ,
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end
end;

/* Alter (SP_CALC_ALL_CH) */
ALTER PROCEDURE SP_CALC_ALL_CH(HDR_ID INTEGER)
 AS
declare variable ZID integer;
begin

 for select z.id
  from zs z
  where z.hdr_id = :hdr_id
  into :zid
  do
    execute procedure SP_CALC_ALL(:ZID);

  update invoice i
  set i.sumv = (select sum(z.sum_uslf) from zs z where z.hdr_id = :hdr_id),
      i.sump = (select sum(z.sum_usl) from zs z where z.hdr_id = :hdr_id)
  where i.id = (select name from zs_hdr h where h.id = :hdr_id);
end;

/* Alter (SP_ZS_SET_ZACHET) */
ALTER PROCEDURE SP_ZS_SET_ZACHET(HDR_ID INTEGER)
 AS
declare variable ZS_ID integer;
declare variable DATE1 DM_DATE;
begin
  for select z.id, z.date_1
      from zs z
      where z.hdr_id = :hdr_id
      into :zs_id, :date1
      do
      begin
        update zsd d
         set d.zachet = 1
         where d.zs_id = :zs_id and d.date_1 < :date1;

        execute procedure SP_CALC_ALL(:ZS_ID);
      end
end;

/* Alter (SP_ZSD_LIST_CREATE) */
ALTER PROCEDURE SP_ZSD_LIST_CREATE(ZS_ID INTEGER)
 AS
declare variable TARGET integer;
begin
  target = (select target from zs where id = :zs_id);

  if (exists (select id from zsd where zs_id = :zs_id)) then
   exit;

  if (target = 9) then
  begin
      insert into zsd(zs_id, code_usl, is_chield, pmd_close, date_1, date_2, sum_uslf, tar_usl, k_uslf, ds, IS_TEMP)
      select z.id, d.code_usl, 0, 0, z.date_1, z.date_1, d.tarif, d.tarif, 1, 'Z00.8', 1
       from zs z
            join patients p on p.id = z.patient_id
            join h_tarif_disp_09 d on d.stage = z.disp_stage and d.age = extract(year from z.date_1) - extract(year from p.dr)
                                      and d.sex = p.sex and z.date_2 between d.bp and d.epv
       where z.id = :zs_id and d.code_usl is not null and d.tarif is not null;
  end

  if (target in (10,17)) then
  begin
      insert into zsd(zs_id, code_usl, is_chield, pmd_close, date_1, date_2, sum_uslf, tar_usl, k_uslf, ds, IS_TEMP)
      select z.id, d.usl_code, 0, 0, z.date_1, z.date_1, d.tarif, d.tarif, 1, iif(z.age < 3, 'Z00.1', iif(z.age >= 3 and z.age < 15, 'Z00.2', 'Z00.3')), 1
       from zs z
            join patients p on p.id = z.patient_id
            join h_tarif_disp_10 d on d.stage = z.disp_stage and d.sex = p.sex
                                          and z.date_2 between d.bp and d.epv
                                          and z.age between d.y1 and d.y2
       where z.id = :zs_id and d.tarif is not null;
  end

  if (target = 13) then
  begin
      insert into zsd(zs_id, code_usl, is_chield, pmd_close, date_1, date_2, sum_uslf, tar_usl, k_uslf, ds, IS_TEMP)
      select z.id, d.usl_code, 0, 0, z.date_1, z.date_1, d.tarif, d.tarif, 1, iif(z.age < 3, 'Z00.1', iif(z.age >= 3 and z.age < 15, 'Z00.2', 'Z00.3')), 1
       from zs z
            join patients p on p.id = z.patient_id
            join h_tarif_disp_13_17 d on d.target = z.target
                                          and d.stage = z.disp_stage and d.sex = p.sex
                                          and z.date_2 between d.bp and d.epv
                                          and d.age_grp = z.age_grp
       where z.id = :zs_id and d.tarif is not null;
  end

  if (target in (14,15)) then
  begin
      insert into zsd(zs_id, code_usl, is_chield, pmd_close, date_1, date_2, sum_uslf, tar_usl, k_uslf, ds, IS_TEMP)
      select z.id, d.usl_code, 0, 0, z.date_1, z.date_1, d.tarif, d.tarif, 1, iif(z.age < 3, 'Z00.1', iif(z.age >= 3 and z.age < 15, 'Z00.2', 'Z00.3')),1
       from zs z
            join patients p on p.id = z.patient_id
            join h_tarif_disp_14_15 d on d.target = z.target
                                          and d.stage = z.disp_stage and d.sex = p.sex
                                          and z.date_2 between d.bp and d.epv
                                          and d.cat_info = z.cat_info
       where z.id = :zs_id and d.tarif is not null;
  end

  if (target = 16) then
  begin
      insert into zsd(zs_id, code_usl, is_chield, pmd_close, date_1, date_2, sum_uslf, tar_usl, k_uslf, ds, IS_TEMP)
      select z.id, d.code_usl, 0, 0, z.date_1, z.date_1, d.tarif, d.tarif, 1, 'Z00.8', 1
       from zs z
            join patients p on p.id = z.patient_id
            join h_tarif_disp_16 d on z.date_2 between d.bp and d.epv
                                          and d.sex = p.sex
                                          and d.age_l <= z.age and d.age_r >= z.age
       where z.id = :zs_id and d.tarif is not null;
  end

  insert into ZS_DS (DS, DS_TYPE, SECTION, SECTION_ID, PR, IS_TEMP)
    select d.ds, 1, 2, d.id, 0, 1
    from zsd d
    where d.zs_id = :zs_id;

  execute procedure SP_CALC_ALL(:ZS_ID);
end;

