
ALTER TABLE PATIENTS ADD GUID_ID DM_GUID;

/* Alter Procedure... */
/* Alter (SP_GEN_GUID_ZSD) */

ALTER PROCEDURE SP_GEN_GUID_ZSD(HDR_ID INTEGER)
 AS
declare variable PAT_ID integer;
declare variable ZID integer;
declare variable I integer;
begin
  i = 1; -- N_ZAP  1   
  for select id, z.patient_id
      from zs z
      where hdr_id = :hdr_id
      into :zid, :pat_id
      do
      begin
        update zs
         set n_zap = :i,
             id_case = :i
         where id = :zid;
        i = i + 1;
        update zsd d
         set d.guid_id = uuid_to_char(gen_uuid())
         where d.zs_id = :zid and d.guid_id is null;
        update zsd d
         set d.guid_id_usl = uuid_to_char(gen_uuid())
         where d.zs_id = :zid and d.guid_id_usl is null;
        update zsd d
         set d.id_dop = gen_id(gen_zsd_id,1)
         where d.zs_id = :zid and d.id_dop is null;
        update zs z2
         set z2.guid_id = uuid_to_char(gen_uuid())
         where z2.id = :zid and z2.guid_id is null;
        update patients p
         set p.guid_id = uuid_to_char(gen_uuid())
         where p.id = :pat_id and p.guid_id is null;
      end
end;

