
ALTER TABLE ZS ADD DN DM_INT;

DROP VIEW V_ZSD;

/* Create view: V_ZSD */
CREATE VIEW V_ZSD(
ID,
ZS_ID,
DATE_1,
DATE_2,
CODE_SPEC,
CODE_PROF,
USL_TYPE,
OTD_PROF,
IS_CHIELD,
DS,
DS2,
SRVPLACE,
CODE_USL,
K_USLF,
PHYS_ID,
MES_CODE,
FIO,
SPEC_NAME,
SRVPLACE1,
DCOUNT,
KSG,
PCOD,
TAR_USL,
PMD_CLOSE,
SUM_USLF,
ORIT,
MP,
USL_NAME,
Q_U,
TARGET,
DISP_STAGE,
DATE_1_ZS,
TOOTH,
ZACHET,
IS_NO_GET_USL,
KSG_BASE,
SUM_BASE,
TAR_BASE,
KSKP_BASE,
COMMENT_LOCAL,
PODR,
TOOTH_LIST,
PROF_NAME,
FAM,
IM,
OT,
DR,
PHONES,
EMAIL,
Q_U_NAME,
KSG_CRITERION,
ZSD_ID,
P_CEL,
DN,
PROFIL_K,
P_PER,
DS_ONK,
KSG_CRITERION2,
CODE_SPEC_V021,
SER_SP,
NUM_SP,
C_ZAB,
FINE_KOEF_SET_DOCTOR,
DOP_TARIF,
DOP_SUM,
DOP_CODE_USL,
INVOICE_NAME,
VID_VME)
 AS 
select zz.ID, zz.zs_id, zz.DATE_1, zz.DATE_2, iif(z.date_2 >= '01.05.2018', zz.code_spec_v021, zz.code_spec), zz.CODE_prof, zz.usl_type,
       zz.OTD_PROF, zz.IS_CHIELD,
       zz.DS, zz.DS2, zz.SRVPLACE, zz.CODE_USL, zz.K_USLF, 
       zz.PHYS_ID, z.mes_code, 
       iif(zz.phys_id = '', '', (select fio from doctors_fio where id = zz.phys_id)) as fio,
       iif(z.date_2 >= '01.05.2018', (select name from h_spec_v021 where code = zz.code_spec_v021), (select name from h_spec_v015 where code = zz.code_spec)) as spec_name, pl.name as srvplace,
       zz.dcount,zz.ksg, iif(zz.phys_id = '', '', (select pcod from doctors_fio where id = zz.phys_id)) as pcod,
       zz.tar_usl, coalesce(zz.pmd_close,0), zz.sum_uslf, zz.orit, zz.mp,
       (select first 1 name from h_usl u where u.code = zz.code_usl
        and u.q_u containing cast(z.q_u as varchar(1)) and u.payment_type_id = z.payment_type_id
        and z.date_1 between u.datebeg and u.dateend),
       z.q_u, z.target, z.disp_stage, z.date_1, zz.tooth_id, coalesce(zz.zachet,0), coalesce(ZZ.is_no_get_usl,0),
       zz.ksg_base, zz.sum_base, zz.tar_base, zz.kskp_base, zz.comment_local, zz.podr,
       iif((coalesce(zz.tooth_id,0) = 0 or coalesce(zz.tooth_list,'')='') and z.q_u = 4, zz.tooth_id, zz.tooth_list),
       o.name, p.fam, p.im, p.ot, p.dr, p.phones, p.email, q.name, zz.ksg_criterion, zz.zsd_id,
       zz.p_cel, zz.dn, zz.profil_k, zz.p_per, zz.ds_onk, zz.ksg_criterion2, zz.code_spec_v021,
       p.ser_sp, p.num_sp, zz.c_zab, z.fine_koef_set_doctor, zz.dop_tarif, zz.dop_sum, zz.dop_code_usl, h.full_name,
       zz.vid_vme
from ZSd zz
     left join zs z on z.id = zz.zs_id
     join zs_hdr h on h.id = z.hdr_id
     left join patients p on p.id = z.patient_id
--     left join h_spec_v015 cs on cs.code = zz.code_spec
--     left join h_spec_v021 cs2 on cs2.code = zz.code_spec_v021
     left join h_srvplace pl on pl.id = zz.srvplace
     left join h_code_otd o on o.code = zz.code_prof
     left join h_q_u q on q.id = z.q_u
where h.is_delete <> 1
;

/* Alter View (Drop, Create)... */
/* Drop altered view: V_ZS */
DROP VIEW V_ZS;

/* Create altered view: V_ZS */
/* Create view: V_ZS */
CREATE VIEW V_ZS(
ID,
Q_U,
MP,
ORDER_V,
CODE_SPEC,
CODE_PROF,
OTD_PROF,
IS_CHIELD,
N_HIST,
DATE_1,
DATE_2,
DS0,
DS1,
DS2,
TAR_USL,
K_USLF,
K_USL,
IDSP,
TARGET,
RESULT,
PATIENT_ID,
FAM,
IM,
OT,
Q_U_NAME,
TARGET_NAME,
SUM_USLF,
HDR_ID,
DIRECTION_NUM,
DIRECTION_DATE,
DH_INFO,
MES_CODE,
SMP_BRIG,
DS3,
DCOUNT,
UID,
PHYS_ID,
CATEGORY,
DISP_STAGE,
DISP_WORK_STATE,
DISP_RESULT,
DISP_H_GROUP,
OUTCOME,
KSG,
CAT_INFO,
IDSP_NAME,
MP_NAME,
ORDER_V_NAME,
DH_INFO_NAME,
CODE_SPEC_NAME,
CODE_PROF_NAME,
IS_CHIELD_NAME,
SMP_BRIG_NAME,
RESULT_NAME,
OUTCOME_NAME,
FOR_POM,
VID_HMP,
METOD_HMP,
AGE_GRP,
CHIELD_WITH_ROP,
FOR_POM_NAME,
REGISTRY_ID,
PAYMENT_TYPE_ID,
PAYMENT_NAME,
REGISTRY_NAME,
SUM_USL,
DOCTOR_FIO,
DOCTOR_COD,
NUM_SP,
IDCASE,
Q_U_2016,
HAS_ERRORS,
CODE_MES1,
COMENTSL,
SMO,
OKATO_SMO,
OKATO_G,
OKATO_P,
SUM_OPL,
N_ZAP,
ZSP_VPOLIS,
ZSP_SPOLIS,
ZSP_NPOLIS,
ZSP_POLIS_BP,
ZSP_POLIS_EP,
ZSP_SMO_OGRN,
ZSP_SMO_CODE,
ZSP_ENP,
ZSP_SEND_DATE,
ZSP_RESP_DATE,
AGE,
DR,
DOC_SER,
DOC_NUM,
SEX,
PODR,
KSLP,
REG_DATE,
AGE_NAME,
M,
Y,
CH_NUM,
INV_STATE,
KSG_NUM,
KSG_PROF_NUM,
NPR_MO,
PER,
VBR,
TAL_D,
TAL_P,
INV,
RSLT_D,
NAZR,
NAZ_SP,
NAZ_V,
NAZ_PMP,
NAZ_PK,
IDSP_NOT_AUTO,
AGE_GRP_NOT_AUTO,
USER_ID,
USER_FIO,
MSE,
BARTHEL_IDX,
CODE_SPEC_V021,
ID_PAC,
DISP,
P_CEL,
C_ZAB,
KSG_CRITERION,
PR_NOV,
MCOD,
PR_DATE_1,
PR_DATE_2,
DN)
 AS 
select z.id,
       z.q_u,
       z.mp,
       z.order_v,
       z.code_spec,
       z.code_prof,
       z.otd_prof,
       z.is_chield,
       z.n_hist,
       z.date_1,
       z.date_2,
       z.ds0,
       z.ds1,
       z.ds2,
       z.tar_usl,
       z.k_uslf,
       z.k_usl,
       z.idsp,
       z.target,
       z.result,  
       z.patient_id,
       p.fam,
       p.im,
       p.ot,
       q_u.name as q_u_name,
       t.name as target_name,
       z.sum_uslf,
       z.hdr_id,
       z.direction_num,
       z.direction_date,
       z.dh_info as dh_info,
       z.mes_code,
       z.smp_brig,
       z.ds3,
       Z.DCOUNT,
       z.uid,
       z.phys_id,
       z.category,
       z.disp_stage,
       z.disp_work_state,
       z.disp_result,
       z.disp_h_group,
       z.outcome,
       z.ksg,
       z.cat_info,
       i.name as idsp_name,
       m.name as mp_name,
       o.name as order_v_name,
       dh.name as dh_info_name,
       iif(z.date_2 >= '01.05.2018', (select name from h_spec_v021 where code = z.code_spec_v021), (select name from h_spec_v015 where code = z.code_spec)) as code_spec_name,
       co.name as code_prof_name,
       iif(z.is_chield = 1, '', '') as is_chield_name,
       sb.name as smp_brig_name,
       r.name as result_name,
       oc.name as outcome_name,
       z.for_pom,
       z.vid_hmp,
       z.metod_hmp,
       z.age_grp,
       z.chield_with_rop,
       fp.name,
       z.registry_id,
       Z.payment_type_id,
       pt.name,
       reg.name,
       z.sum_usl,
       df.fio,
       DF.pcod,
       p.num_sp,  --iif(z.payment_type_id <> 2, p.num_sp, (select ins.ser || ' ' || ins.num from patients_insurance ins where ins.patients_id = p.id and z.date_1 between ins.db and ins.de)),
       z.id_case,
       z.q_u_2016,
       0,--(select first 1 1 from error_list_local err where err.reestr_hdr_id = z.hdr_id and err.uid = z.uid),
       z.mes_code,
       z.comentsl,
       p.smo,
       p.okato_smo,
       p.okato_l,
       p.okato_r,
       z.sum_usl, --(select sum(pi.sum_opl) from patients_invoice pi where pi.zs_id = z.id),
       z.n_zap n_zap,
       zpr.vpolis,
       zpr.spolis,
       zpr.npolis,
       zpr.polis_bp,
       zpr.polis_ep,
       zpr.smo_ogrn,
       zpr.smo_code,
       zpr.enp,
       zp.send_date,
       zpr.resp_date,
       z.age,
       p.dr,
       p.doc_ser,
       p.doc_num,
       p.sex,
       z.podr,
       z.kslp,
       reg.reg_date,
       cast(floor(z.age) as varchar(3)) || '  ' ||
            cast(iif(extract(day from z.date_1) < extract(day from p.dr),
                 iif(extract(month from z.date_1) > extract(month from p.dr), extract(month from z.date_1) - extract(month from p.dr),
                             iif(extract(month from z.date_1) < extract(month from p.dr), 12 - extract(month from p.dr) + extract(month from z.date_1) - 1,
                                 11)),
                 iif(extract(month from z.date_1) > extract(month from p.dr), extract(month from z.date_1) - extract(month from p.dr),
                             iif(extract(month from z.date_1) < extract(month from p.dr), 12 - extract(month from p.dr) + extract(month from z.date_1),
                                   0))) as varchar(2)) || ' ',
       h.m,
       h.y, 
       h.full_name,
       coalesce(inv.status_id,0),
       ksg.ksg_name,
       ksg.prof_name,
       z.npr_mo,
       z.per,
       z.vbr,
       z.tal_d,
       z.tal_p,
       z.inv,
       Z.rslt_d,
       z.nazr,
       z.naz_sp,
       z.naz_v,
       z.naz_pmp,
       z.naz_pk,
       z.idsp_not_auto,
       Z.age_grp_not_auto,
       z.user_id,
       s.fio,
       z.mse,
       z.barthel_idx ,
       z.code_spec_v021,
       z.id_pac,
       Z.disp,
       z.p_cel,
       z.c_zab,
       z.ksg_criterion,
       z.pr_nov,
       z.mcod, 
       z.pr_date_1,
       z.pr_date_2,
       z.dn
from zs z
join patients p on p.id = z.patient_id
join zs_hdr h on h.id = z.hdr_id
left join invoice inv on inv.id = h.name
left join h_q_u q_u on q_u.id = z.q_u
left join h_target t on t.id = z.target
left join h_idsp i on i.id = z.idsp
left join h_mp m on m.code = z.mp
left join h_order_v o on o.id = z.order_v
left join h_dh_info dh on dh.id = z.dh_info
left join h_spec_v015 cs on cs.code = z.code_spec
left join h_code_otd co on co.code = z.code_prof
left join h_smp_brig sb on sb.id = z.smp_brig
left join h_result r on r.code = z.result
left join h_outcome oc on oc.code = z.outcome
left join h_for_pom fp on fp.code = z.for_pom
left join h_payment_type pt on pt.id = z.payment_type_id
left join v_registry reg on reg.id = z.registry_id
left join doctors_fio df on df.id = z.phys_id
left join zsp zp on zp.zs_id = z.id
left join zsp_resp zpr on zpr.zsp_id = zp.id
left join h_ksg ksg on (cast(ksg.ksg as varchar(50))) = z.ksg and z.q_u = ksg.q_u and z.date_2 between ksg.bp and ksg.epv
left join users s on s.id = z.user_id
where h.is_delete <> 1
;

/* Alter (SP_GEN_APP_TARIF) */
ALTER PROCEDURE SP_GEN_APP_TARIF(TG_CNT INTEGER,
NAME_ID INTEGER,
VID_POM INTEGER,
BP DATE,
EP DATE)
 AS
declare variable TG integer;
begin
  tg = 1;

  while (:tg <= :tg_cnt) do
  begin
    update or insert into H_TARIF_APP (TG, TARGET, BP, EP, NAME_ID, IDSP)
    values (:TG, :vid_pom, :BP, :EP, :NAME_ID, 29)
    matching (TG, TARGET, BP, NAME_ID, IDSP);

    update or insert into H_TARIF_APP (TG, TARGET, BP, EP, NAME_ID, IDSP)
    values (:TG, :vid_pom, :BP, :EP, :NAME_ID, 30)
    matching (TG, TARGET, BP, NAME_ID, IDSP);

    tg = tg + 1;
  end

  if (:ep is null) then
  delete from h_tarif_app a
   where a.tg > :tg_cnt and a.target = :vid_pom and a.name_id = :name_id and bp = :bp and ep is null;
  else
  delete from h_tarif_app a
   where a.tg > :tg_cnt and a.target = :vid_pom and a.name_id = :name_id and bp = :bp and ep = :ep;
end;

CREATE TRIGGER H_TARIF_APP_NAME_BI FOR H_TARIF_APP_NAME
ACTIVE BEFORE INSERT POSITION 0 
as
begin
  if (new.id is null) then
    new.id = gen_id(gen_h_tarif_app_name_id,1);
end;

/* Altering existing trigger... */
ALTER TRIGGER ZSD_BU0
AS
declare variable spec varchar(10);
declare variable otd_prof varchar(20);
declare variable phys integer;
declare variable child integer;
declare variable prof varchar(10);
declare variable podr varchar(12);
declare variable mp integer ;
declare variable spec_v021 integer;
begin
  update zs
  set --k_uslf = (select sum(k_uslf) from zsd where zs_id = new.zs_id),
--      ds0 = (select first 1 zz.ds from zsd zz where zz.zs_id = new.zs_id and zz.date_1 =
--              (select min(date_1) from zsd where zs_id = new.zs_id)),
      dcount = (select count(distinct z.date_1) from zsd z where z.zs_id = new.zs_id)
    where id = new.zs_id;

    if ((select min(date_1) from zsd where zs_id = new.zs_id and coalesce(zachet,0) <> 1) is not null) then
    update zs
    set date_1 = (select min(date_1) from zsd where zs_id = new.zs_id and coalesce(zachet,0) <> 1),
        date_2 = (select max(date_2) from zsd where zs_id = new.zs_id and coalesce(zachet,0) <> 1)
    where id = new.zs_id;



  if (((new.date_2 >= (select date_2 from zs where id = new.zs_id))
      and ((select count(id) from zsd where zs_id = new.zs_id and coalesce(pmd_close,0) = 1) = 0)
      and (new.code_spec_v021 in (49,76)))
     or (new.pmd_close = 1))
  then
   begin
     update zs
     set code_spec = new.code_spec,
         code_spec_v021 = new.code_spec_v021,
         otd_prof = new.otd_prof,
--         ds1 = iif(coalesce(new.ds,'') = '', ds1, new.ds),
         phys_id = new.phys_id,
         is_chield = new.is_chield,
         code_prof = new.code_prof,
         podr = new.podr,
         mp = new.mp,
         ds1 = new.ds,
         ds2 = new.ds2,
         ds_onk = new.ds_onk,
         p_cel = new.p_cel,
         c_zab = new.c_zab,
         ksg_criterion = new.ksg_criterion,
         dn = new.dn
      where id = new.zs_id;
    end
   else
   if (((new.date_2 >= (select date_2 from zs where id = new.zs_id))
      and ((select count(id) from zsd where zs_id = new.zs_id and coalesce(pmd_close,0) = 1) = 0)
      and not exists(select id from zsd where zs_id =new.zs_id and date_2 = new.date_2 and (code_spec_v021 in (49,76))) )
     or (new.pmd_close = 1))
  then
   begin
     update zs
     set code_spec = new.code_spec,
         code_spec_v021 = new.code_spec_v021,
         otd_prof = new.otd_prof,
--         ds1 = iif(coalesce(new.ds,'') = '', ds1, new.ds),
         phys_id = new.phys_id,
         is_chield = new.is_chield,
         code_prof = new.code_prof,
         podr = new.podr,
         mp = new.mp,
         ds1 = new.ds,
         ds2 = new.ds2,
         ds_onk = new.ds_onk,
         p_cel = new.p_cel,
         c_zab = new.c_zab,
         ksg_criterion = new.ksg_criterion,
         dn = new.dn
      where id = new.zs_id;
    end
   else
    begin
      if (new.pmd_close = 0 and old.pmd_close = 1) then
      begin
      for select z.code_spec, z.otd_prof, z.phys_id, z.is_chield, z.code_prof, z.podr, z.mp, z.code_spec_v021 from zsd z
          where  (z.id = (select max(id) from zsd d where d.zs_id = new.zs_id and
                         (d.date_2 = (select max(date_2) from zsd where zs_id = new.zs_id))))
          into :spec, :otd_prof, :phys, :child, :prof, :podr, :mp, :spec_v021
      do
          update zs
          set code_spec = :spec,
              code_spec_v021 = :spec_v021,
             otd_prof = :otd_prof,
--             ds1 = iif(coalesce(:ds1,'') = '', ds1, :ds1),
             phys_id = :phys,
             is_chield = :child,
             code_prof = :prof,
             podr = :podr,
             mp = :mp,
             ds1 = new.ds,
             ds2 = new.ds2,
             ds_onk = new.ds_onk,
             p_cel = new.p_cel,
             c_zab = new.c_zab,
             ksg_criterion = new.ksg_criterion
          where id = new.zs_id;
      end
     end

    if ((select z.payment_type_id from zs z where z.id = new.zs_id) in (3,2)) then
    begin
        update zs
        set sum_uslf = (select sum(sum_uslf) from zsd where zs_id = new.zs_id),
            sum_usl = coalesce((select sum(i.sum_opl) from patients_invoice i where i.zs_id = new.zs_id), 0),
            tar_usl = null
        where id = new.zs_id and payment_type_id <> 1;
    end
    else
    if (((select q_u from zs where id = new.zs_id) = 2) and (coalesce(new.code_usl,'') <> '')
       and ((select target from zs where id = new.zs_id) = 1))  then
       if (exists(select id from h_usl where code = new.code_usl and q_u containing '4' and payment_type_id = 1 and new.date_2 between datebeg and dateend)) then
        update zs z
         set z.q_u = 4
         where id = new.zs_id;

   if (coalesce(new.code_usl,'') <> '') then
    if ((select first 1 1 from h_tomo_code c where c.nms_code = new.code_usl) = 1) then
      update zs z
       set z.target = iif((select first 1 c.group_num from h_tomo_code c where c.nms_code = new.code_usl) in (1,2), 21, 22)
       where z.id = new.zs_id and z.q_u = 2;
end;


