ALTER PROCEDURE SP_CALC_ALL(ZS_ID INTEGER)
 AS
 BEGIN EXIT; END;

/* Empty SP_CALC_STAC for drop ZSD(KSKP) */
ALTER PROCEDURE SP_CALC_STAC(IDA INTEGER)
 AS
 BEGIN EXIT; END;

/* Empty SP_CALC_STAC_2018 for drop ZSD(KSKP) */
ALTER PROCEDURE SP_CALC_STAC_2018(IDA INTEGER)
 AS
 BEGIN EXIT; END;

/* Empty SP_ZSD_DUPLICATE for drop ZSD(KSKP) */
ALTER PROCEDURE SP_ZSD_DUPLICATE(ZSD_ID INTEGER,
ZS_ID INTEGER = null)
 AS
 BEGIN EXIT; END;

ALTER PROCEDURE SP_CALC_ALL_CH(HDR_ID INTEGER)
 AS
 BEGIN EXIT; END;

/* empty dependent procedure body */
/* Clear: SP_ZS_SET_ZACHET for: SP_CALC_ALL */
ALTER PROCEDURE SP_ZS_SET_ZACHET(HDR_ID INTEGER)
 AS
 BEGIN EXIT; END;

/* empty dependent procedure body */
/* Clear: SP_ZSD_LIST_CREATE for: SP_CALC_ALL */
ALTER PROCEDURE SP_ZSD_LIST_CREATE(ZS_ID INTEGER)
 AS
 BEGIN EXIT; END;

/* Alter (SP_CALC_ALL) */
ALTER PROCEDURE SP_CALC_ALL(ZS_ID INTEGER)
 AS
declare variable TAR DM_MONEY_15_2;
declare variable DATE1 DM_DATE;
declare variable Q_U integer;
declare variable TAR_USL DM_MONEY_15_2;
declare variable TARGET integer;
declare variable IDB integer;
declare variable SUM_USLF DM_MONEY_15_2;
declare variable SEX char(1);
declare variable PTYPE integer;
declare variable AGE_Y integer;
declare variable AGE_GRP integer;
declare variable HDR_ID integer;
declare variable TROMB_CODE DM_CHAR_20;
declare variable TAR_USL_DOP DM_MONEY_15_2;
declare variable SUM_USLF_DOP DM_MONEY_15_2;
declare variable IDSP integer;
declare variable MMB DM_NUM_3_2;
declare variable OKATO DM_OKATO;
begin
  select z.date_2, z.q_u, z.target, p.sex, z.payment_type_id, extract(year from z.date_2) - extract(year from p.dr), z.hdr_id, iif(coalesce(z.vbr,0) = 0, 1, 1.2)
  from zs z
  join patients p on p.id = z.patient_id
  where z.id = :zs_id
  into :date1, :q_u, :target, :sex, :ptype, :age_y, :hdr_id, :mmb;

  okato = (select first 1 c.tf_okato from contragents c where c.type_id = 1);

  if (:okato is null) then okato = '71140';

  if (:ptype in (2,3)) then exit;

  if (:target in (9,10,11,12,13,14,15,16,17)) then
  begin
   if ((select coalesce(t.days_cnt,0) from h_target t where t.id = :target) <> 0) then
   begin
    update zsd d
     set d.zachet = 1
     where d.date_1 < (:date1 - (select t.days_cnt from h_target t where t.id = :target)) and d.zs_id = :zs_id;

    update zsd d
     set d.zachet = 0
     where d.date_1 >= (:date1 - (select t.days_cnt from h_target t where t.id = :target)) and d.zs_id = :zs_id;
   end

   update zsd d
    set d.k_uslf = 0
    where (d.zachet = 1 or d.is_no_get_usl = 1) and d.zs_id = :zs_id;
  end

  update zsd d
    set d.tar_usl = null,
        d.sum_uslf = null,
        d.comment_local = null,
        d.dop_tarif = null,
        d.dop_sum = null
    where d.zs_id = :zs_id;

  update zs z
    set z.tar_usl = null,
        z.sum_usl = null,
        z.sum_uslf = null
    where z.id = :zs_id;

  if ((select coalesce(i.is_nz,0) from invoice i join zs_hdr h on h.name = i.id where h.id = :hdr_id) = 1) then
  begin
    if (target in (9,10,11,13,14,15,16,17)) then exit;

    tar = (select first 1 s.tarif from h_tarif_nz s where s.q_u = iif(:q_u = 4,2,:q_u) and :date1 between s.bp and s.epv);

    if (q_u = 1) then
      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf =:tar
      where d.zs_id = :zs_id and d.code_usl is null;
    else
      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf =:tar
      where d.zs_id = :zs_id;

    if (q_u = 4) then
      update zs z
      set z.tar_usl = :tar,
        z.sum_uslf = z.dcount*:tar
      where id = :zs_id;
    else
    if (q_u = 1) then
      update zs z
      set z.tar_usl = :tar,
        z.sum_uslf = :tar
      where id = :zs_id;
    else
      update zs z
      set z.tar_usl = :tar,
          z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
      where id = :zs_id;
    exit;
  end
   /********************,    ************************/
  if (:q_u = 2 and :target not in (9,10,11,12,13,14,15,16,17,21,22) and (:date1 < '01.01.2018')) then
  begin
    for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin

          select first 1 h.tarif, h.tarif
          from zs a
           join zsd b on a.id = b.zs_id
           join h_tarif_app_tgroup t on a.date_2 between t.bp and t.epv
           join h_tarif_app h on h.tg = t.tg
                                 and a.date_2 between h.bp and h.epv
                                 and (h.target = iif(a.for_pom = 2, 1, 0))
                                 and cast(h.code_spec as varchar(10)) = iif(coalesce(a.vbr,0) = 0, iif(b.code_spec = '16' and a.age < 18, '22', b.code_spec), 0)
           where b.id = :idb
           order by h.target nulls last
           into :tar, :sum_uslf;

          update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0)
           where b.id = :idb;
        end

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce(:sum_uslf, 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;
    exit;
  end

  if (:q_u = 2 and :target not in (9,10,11,12,13,14,15,16,17,21,22) and (:date1 >= '01.01.2018')) then
  begin
    for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin
          select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
          from zs a
           join zsd b on a.id = b.zs_id
           join h_usl u on u.code = coalesce(b.code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                           and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1
           where b.id = :idb and b.code_usl is not null and coalesce(u.sumf,0) > 0
           into :tar, :sum_uslf;

          tar_usl_dop = null;
          sum_uslf_dop = null;

          if ((select d.dop_code_usl from zsd d where d.id = :idb) is not null) then
              select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
              from zs a
               join zsd b on a.id = b.zs_id
               join h_usl u on u.code = coalesce(b.dop_code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                               and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1 and u.finans_type is not null
               where b.id = :idb and b.dop_code_usl is not null and coalesce(u.sumf,0) > 0
               into :tar_usl_dop, :sum_uslf_dop;

          if (:tar is null) then
          select first 1 h.tarif, h.tarif, a.idsp
          from zs a
           join zsd b on a.id = b.zs_id
           join h_tarif_app_tgroup t on a.date_2 between t.bp and t.epv
           left join h_tarif_app h on h.tg = t.tg
                                 and a.date_2 between h.bp and h.epv
                                 and (h.target = iif(a.for_pom = 2, 1, 0))
                                 and h.idsp = a.idsp
           join h_tarif_app_spec n on n.name_id = h.name_id
                                 and n.code_spec_v021 = iif(b.code_spec_v021 = 39 and a.age < 18, 49, b.code_spec_v021)
           where b.id = :idb
           order by h.target nulls last
           into :tar, :sum_uslf, :idsp;

          if (:okato = '71140') then
          update ZSD b set
           b.tar_usl = iif(:idsp = 30, 0, coalesce(:tar, 0)),
           b.sum_uslf = cast(iif(:idsp = 30, 0, coalesce(:sum_uslf, 0))*:mmb as int),
           b.dop_tarif = coalesce(:tar_usl_dop,0),
           b.dop_sum = coalesce(:sum_uslf_dop,0)
           where b.id = :idb;
          else
           update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0),
           b.dop_tarif = coalesce(:tar_usl_dop,0),
           b.dop_sum = coalesce(:sum_uslf_dop,0)
           where b.id = :idb;

          if (:idsp <> 30) then
          begin
            tar = null;
            sum_uslf = null;
          end
        end

     if ((:idsp = 30) and (:okato = '71140')) then
       update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = cast(coalesce(:sum_uslf, 0)*:mmb as int)
           where b.id = :idb;

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id) + (select sum(coalesce(b.dop_sum,0)) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce(:sum_uslf, 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;
    exit;
  end  

  /********************************************/
  if (:q_u = 4) then
  begin
    tar = (select s.tarif from h_tarif_stom s where :date1 between s.bp and s.epv);

    update zsd d
    set d.tar_usl = :tar,
        d.sum_uslf = cast(d.k_uslf*:tar*:mmb as numeric(15,2))
    where d.zs_id = :zs_id;
    
    update zs z
    set z.tar_usl = :tar,
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;
  end

  /******************** ************************/
  if (:q_u = 5) then
  begin
--    if (:date1 >= '01.01.2018') then tromb_code = 'A25.30.036';
--    else tromb_code = 'A25.30.035';
    tromb_code = coalesce((select first 1 code_usl from zsd d where d.zs_id = :zs_id and coalesce(code_usl, '') <> ''),'');

    tar = (select s.tarif from h_tarif_smp s where :date1 between s.bp and s.epv);
    tar_usl = coalesce((select coalesce(u.sumf,0) from h_usl u where u.code = :tromb_code
               and u.q_u containing '5' and :date1 between u.datebeg and u.dateend),0);

    update zsd d
    set d.tar_usl = iif(coalesce(d.code_usl,'') = '', :tar, :tar_usl),
        d.sum_uslf = d.k_uslf*iif(coalesce(d.code_usl,'') = '', :tar, :tar_usl)
    where d.zs_id = :zs_id;
    
    update zs z
    set z.tar_usl = (select max(tar_usl) from zsd where zs_id = :zs_id),
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;
  end

  /******************** ************************/
  if ((:q_u = 1) and ((select 1 from zs z where coalesce(z.metod_hmp,0) > 0 and id = :zs_id) = 1)) then
  begin
    select first 1 v.tarif
    from zs z
         join h_metod_hmp h on h.code = z.metod_hmp and z.date_2 between h.bp and h.epv
         join h_tarif_vmp v on v.tg = h.tg and z.date_2 between v.bp and v.epv
    where z.id = :zs_id
    into :tar;

    update zs a set
        a.tar_usl = :tar,
        a.sum_uslf = :tar,
        a.ksg = null,
        a.kslp = null
    where a.id = :zs_id;

    update zsd b set
          b.ksg = null,
          b.sum_uslf = :tar,
          b.kskp = 0,
          b.tar_usl = :tar
    where b.zs_id = :zs_id and coalesce(b.code_usl,'') = '' and b.date_1 = (select min(date_1) from zsd where zs_id = :zs_id and coalesce(code_usl,'') = '');

    exit;
  end

  /********************************************/
  if (:q_u in (1,3) and :date1 < '01.01.2018') then
    execute procedure SP_CALC_STAC(:zs_id);
  else
    if (:q_u in (1,3) and :date1 >= '01.01.2018') then
      execute procedure sp_calc_stac_2018(:zs_id);

  /****************  ***********************************************/
  if (q_u <> 4) then
  begin
  tar = null;
  sum_uslf = null;
  for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin
          select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
          from zs a
           join zsd b on a.id = b.zs_id
           join h_usl u on u.code = coalesce(b.code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                           and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1
           where b.id = :idb and b.code_usl is not null and coalesce(u.sumf,0) > 0
           into :tar, :sum_uslf;

          tar_usl_dop = null;
          sum_uslf_dop = null;

          if ((select d.dop_code_usl from zsd d where d.id = :idb) is not null) then
              select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
              from zs a
               join zsd b on a.id = b.zs_id
               join h_usl u on u.code = coalesce(b.dop_code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                               and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1 and u.finans_type is not null
               where b.id = :idb and b.dop_code_usl is not null and coalesce(u.sumf,0) > 0
               into :tar_usl_dop, :sum_uslf_dop;

          if (coalesce(:tar,0) > 0) then
          update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0),
           b.dop_tarif = coalesce(:tar_usl_dop,0),
           b.dop_sum = coalesce(:sum_uslf_dop,0)
           where b.id = :idb;

          tar = null;
          sum_uslf = null;
        end

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id) + (select sum(coalesce(b.dop_sum,0)) from zsd b where b.zs_id = :zs_id);
     tar = (select sum(b.tar_usl) from zsd b where b.zs_id = :zs_id) + (select sum(coalesce(b.dop_tarif,0)) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce(:tar, 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;
   end

  /*********************-*********************************/
  if ((:q_u = 2) and (:target in (21,22))) then
  begin
   for select b.id
    from zsd b
    join zs z on z.id = b.zs_id
    where z.id = :zs_id
    into :idb
    do
    begin
      tar = (select first 1 t.tarif
             from zsd d
                  join h_tomo_code c on c.nms_code = d.code_usl
                  join h_tarif_tomo t on t.group_num = c.group_num and d.date_2 between t.bp and t.epv
             where d.id = :idb);

      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf = :tar
      where d.id = :idb;
    end

    update zs z
    set z.tar_usl = (select sum(tar_usl) from zsd where zs_id = :zs_id),
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;

    exit;
  end
  /******************** - 9  ************************/
  if ((:q_u = 2 and :target = 9) or (q_u = 2 and :target = 16 and date1 >= '01.05.2019'))  then
  begin
    execute procedure sp_calc_app_t09(:zs_id);
    exit;
  end

  /******************** - 10,17  -  ************************/
    if (q_u = 2 and target in (10,17)) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_10 d on d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and :age_y between d.y1 and d.y2
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = cast(coalesce(b.k_uslf * :tar, 0)*:mmb as int),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end

  /******************** - 13  ************************/
    if (q_u = 2 and target = 13) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                           and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_13_17 d on d.target = a.target
                                          and d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and d.age_grp = a.age_grp
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = cast(coalesce(b.k_uslf * :tar, 0)*:mmb as int),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end

  /******************** - 14,15  ,  ************************/
    if (q_u = 2 and target in (14,15)) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_14_15 d on d.target = a.target
                                          and d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and d.cat_info = a.cat_info
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = cast(coalesce(b.k_uslf * :tar, 0)*:mmb as int),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end
  /******************** - 16  ************************/
    if (q_u = 2 and target = 16 and date1 < '01.05.2019') then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join zs_hdr h on h.id = a.hdr_id
                   join patients p on p.id = a.patient_id
                   join h_tarif_disp_16 d on a.date_2 between d.bp and d.epv
                                          and d.sex = :sex
                                          and cast(d.code_usl as varchar(20)) = b.code_usl
                                          and d.age_l <= (h.y - extract(year from p.dr)) and d.age_r >= (h.y - extract(year from p.dr))
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = cast(coalesce(b.k_uslf * :tar, 0)*:mmb as int),
               b.tar_base = coalesce(:tar, 0) ,
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end
end;

/* Alter (SP_CALC_ALL_CH) */
ALTER PROCEDURE SP_CALC_ALL_CH(HDR_ID INTEGER)
 AS
declare variable ZID integer;
begin

 for select z.id
  from zs z
  where z.hdr_id = :hdr_id
  into :zid
  do
    execute procedure SP_CALC_ALL(:ZID);

  update invoice i
  set i.sumv = (select sum(z.sum_uslf) from zs z where z.hdr_id = :hdr_id),
      i.sump = (select sum(z.sum_usl) from zs z where z.hdr_id = :hdr_id)
  where i.id = (select name from zs_hdr h where h.id = :hdr_id);
end;

/* Alter (SP_CALC_APP_T09) */
ALTER PROCEDURE SP_CALC_APP_T09(IDA INTEGER)
 AS
declare variable O integer;
declare variable AGE integer;
declare variable CNT85 integer;
declare variable STAGE integer;
declare variable TAR_BASE DM_MONEY;
declare variable COMPLEX_TAR DM_MONEY_15_2;
declare variable IDB integer;
declare variable USL_CNT integer;
declare variable SEX char(1);
declare variable MMB DM_NUM_3_2;
declare variable COMPLEX_SUM DM_MONEY_15_2;
declare variable DATE_2 DM_DATE;
declare variable TARGET integer;
begin
     select a.disp_stage, extract(year from a.date_1) - extract(year from p.dr), p.sex, iif(coalesce(a.vbr,0) = 0, 1, 1.2),
            a.date_2, a.target
      from zs a
      join patients p on p.id = a.patient_id
      where a.id = :ida
      into :stage, :age, :sex, :mmb, :date_2, :target;

     if (:stage = 1) then
     begin
       ------------    ---------------
       select count(*)                      -- 
        from zs a
        join zsd b on a.id = :ida
        where b.zs_id = :ida
        into :o;

        ------------  85%   ----------------------------------
       /*$$IBEC$$ select d.cnt_85
       from zs a
        join disp_range85 d on d.target = a.target and d.age = :age
                               and d.sex = :sex
                               and a.date_2 between d.bp and d.epv
        where a.id = :ida
        into :cnt85;

        if (((age in (49,53,55,59,61,65,67,71,73)) and (:sex = '')) or
           ((age in (49,53,55,59,61,65,67,71,73,50,52,56,58,62,64,68,70)) and (:sex = ''))) then
        cnt85 = 2;

        if (:cnt85 is null) then
        begin
          update zsd z
          set z.comment_local = '   '
          where z.zs_id = :ida;

          exit;
        end $$IBEC$$*/
      end

        -------------    ----------------------------------------
--        if ((o >= cnt85) or (:stage = 2))  then
--        begin
         --      
         for select b.ID, 0
          from zs a
          join zsd b on a.id = b.zs_id
          where b.zs_id = :ida
                and b.date_1 between a.date_1 and a.date_2     --  
                and coalesce(b.is_no_get_usl, 0) <> 1          --  
          into :idb, :tar_base
          do
          begin
            select d.tarif
             from zs a
             join zsd b on a.id = b.zs_id
             join h_tarif_disp_09 d on d.stage = a.disp_stage
                                       and d.sex = :sex
                                       and d.age = :age
                                       and d.code_usl = b.code_usl
                                       and a.date_2 between d.bp and d.epv
            where b.id = :idb
            into :tar_base;

           update zsd b set
            b.sum_uslf = cast(coalesce(b.k_uslf * :tar_base, 0)*:mmb as int),
            b.tar_usl = coalesce(:tar_base, 0)
            where b.id = :idb;
          end 

          update zsd b set
            b.sum_uslf = 0,
            b.tar_usl = 0,
            b.k_uslf = 0
            where b.tar_usl is null and b.zs_id = :ida;
--        end
--           else
        -----------    --------------------------
--          update zsd z
--          set z.comment_local = '  '
--          where z.zs_id = :ida;

       -----------------------------------------------------------------------
       select sum(b.tar_usl), sum(b.k_uslf )
       from zsd b
       where b.zs_id = :ida
       into :tar_base, :usl_cnt;

       tar_base = coalesce(tar_base, 0);
       complex_sum = coalesce((select sum(cast(d.tarif*:mmb as int))
                         from zs a
                         join h_tarif_disp_09 d on d.stage = a.disp_stage
                                                   and d.sex = :sex
                                                   and d.age = :age
                                                   and a.date_2 between d.bp and d.epv
                         join h_usl u on u.code = d.code_usl  and d.bp between u.datebeg and u.dateend
                        where a.id = :ida and u.target containing cast(a.target as varchar(2)) and u.q_u containing '2'),0);

       if ((:sex = '') and (:target = 16) and (:age > 39)) then
         complex_sum = coalesce((select sum(cast(d.tarif*:mmb as int))
                         from zs a
                         join h_tarif_disp_09 d on d.stage = a.disp_stage
                                                   and d.sex = :sex
                                                   and d.age = :age
                                                   and a.date_2 between d.bp and d.epv
                         join h_usl u on u.code = d.code_usl  and d.bp between u.datebeg and u.dateend
                        where a.id = :ida and u.target containing cast(a.target as varchar(2)) and u.q_u containing '2'
                              and d.code_usl <> 'B04.001.002.099' ),0);

       complex_tar = coalesce((select sum(d.tarif)
                         from zs a
                         join h_tarif_disp_09 d on d.stage = a.disp_stage
                                                   and d.sex = :sex
                                                   and d.age = :age
                                                   and a.date_2 between d.bp and d.epv
                         join h_usl u on u.code = d.code_usl  and d.bp between u.datebeg and u.dateend
                        where a.id = :ida and u.target containing cast(a.target as varchar(2)) and u.q_u containing '2'),0);

       if ((:sex = '') and (:target = 16) and (:age > 39)) then
         complex_tar = coalesce((select sum(d.tarif)
                         from zs a
                         join h_tarif_disp_09 d on d.stage = a.disp_stage
                                                   and d.sex = :sex
                                                   and d.age = :age
                                                   and a.date_2 between d.bp and d.epv
                         join h_usl u on u.code = d.code_usl  and d.bp between u.datebeg and u.dateend
                        where a.id = :ida and u.target containing cast(a.target as varchar(2)) and u.q_u containing '2'
                              and d.code_usl <> 'B04.001.002.099' ),0);

       if ((:date_2 >= '01.07.2019') and (:stage = 1)) then
       update zs a set
        a.tar_usl = :complex_tar,
        a.sum_uslf = :complex_sum,
        a.k_uslf = coalesce(:usl_cnt, 0)
        where a.id = :ida;
       else
       update zs a set
        a.tar_usl = :tar_base,
        a.sum_uslf = :tar_base,
        a.k_uslf = coalesce(:usl_cnt, 0)
        where a.id = :ida;
end;

/* Alter (SP_CALC_STAC) */
ALTER PROCEDURE SP_CALC_STAC(IDA INTEGER)
 AS
declare variable KSG type of DM_CHAR_50;
declare variable DS type of DM_DS;
declare variable IDB integer;
declare variable SUM_USLF type of DM_MONEY;
declare variable KSKP type of DM_NUM_3_2;
declare variable Q_U integer;
declare variable FINE_KOEF type of DM_NUM_3_2;
declare variable TARIF numeric(15,6);
declare variable Y integer;
declare variable TARIF_USL DM_MONEY;
declare variable DATE2 date;
declare variable IS_TRANSFER DM_INT;
declare variable CL_CNT integer;
declare variable ERR_CODE integer;
declare variable K_DOWN DM_NUM_6_2;
begin
     cl_cnt = (select count(distinct b.ds_class) from ZSD b where b.ZS_ID = :ida);
     is_transfer = (select sum(iif(b.code_usl is null, 1, 0)) from ZSD b where b.ZS_ID = :ida);

     select a.q_u, extract(year from a.date_2), a.date_2
      from zs a
      where a.id = :ida
      into :q_u, :y, :date2;

     for select sp.KSG, sp.ERR_CODE, b.ds, b.id, coalesce(bs.tarif * k.k_down * k.kz *
                iif((select 1 from h_ksg_dop d where d.type_num = 1 and a.date_2 between d.bp and d.epv and d.q_u = a.q_u and d.ksg = sp.ksg) IS NULL , lf.kus, 1.0), 0)
      from zs a
      join zsd b on a.id = b.zs_id
      join patients p on p.id = a.patient_id
      join lpu_factors lf on lf.q_u = a.q_u and a.date_2 between lf.bp and lf.epv
      join h_tarif_bs bs on bs.q_u = a.q_u and a.date_2 between bs.bp and bs.epv
      left join sp_ksg_get(b.ds, p.dr, a.date_2, b.code_usl, p.sex, b.k_uslf, a.q_u, b.ds2, b.id) sp on 1=1
      left join h_ksg k on k.ksg = sp.ksg and a.date_2 between k.bp and k.epv and k.q_u = a.q_u
      where b.zs_id = :ida
      into :ksg, :err_code, :ds, :idb, :tarif
      do
      begin
        kskp = 1;
        fine_koef = null;

        if ((q_u = 1) and (y < 2017)) then
          kskp = (select KSKP from SP_CALC_STAC_KSKP(:ida, :idb, :ksg, :cl_cnt));
        if ((q_u = 1) and (y >= 2017) and (y < 2018)) then
          kskp = (select KSKP from sp_calc_stac_kskp_2017(:ida, :idb, :ksg, :cl_cnt));
--        if ((q_u = 1) and (y >= 2018)) then
--          kskp = (select KSKP from sp_calc_stac_kskp_2018(:ida, :idb, :ksg, :cl_cnt));

        fine_koef = (select FINE_KOEF from sp_calc_stac_fine(:ida, :idb, :ksg, :cl_cnt));

        sum_uslf = cast(tarif * kskp * fine_koef as int);

        update zsd b set
         b.ksg_base = :ksg,
         b.tar_base = cast(:tarif as integer),
         b.sum_base = :sum_uslf,
         b.kskp_base = :kskp
         where b.id = :idb;
      end 
--------------------------------------------------------------------------------
      --    6  + 
      if (q_u = 1) then
       if (exists (select 1 from zsd b where b.zs_id = :ida and ((b.ksg in (2) and b.k_uslf >= 6) or (b.ksg in ('O14.1','O34.2','O36.3','O36.4','O42.2') and b.k_uslf >= 2) ))
          and exists (select 1 from zsd b where b.zs_id = :ida and b.ksg in (4, 5))) then
          begin
            --    
            select first 1 b.ksg_base, b.ds
            from zs a
             join zsd b on a.id = b.zs_id
             where b.zs_id = :ida and b.ksg in (4, 5)
             into :ksg, :ds;
       
            update zsd d
            set d.tar_usl = d.tar_base,
                d.sum_uslf = d.sum_base,
                d.ksg = d.ksg_base,
                d.kskp = d.kskp_base
            where d.zs_id = :ida;

            --   
            select coalesce(sum(b.sum_uslf), 0) from zsd b where b.zs_id = :ida
             into :sum_uslf;
    
            update zs a set
             a.tar_usl = :tarif,
             a.sum_uslf = :sum_uslf,
             a.sum_usl = :sum_uslf,
             a.ksg = :ksg,
             a.ds1 = :ds,
             a.kslp = :kskp
             where a.id = :ida;

            exit;
          end
--------------------------------------------------------------------------------
      if ((is_transfer < 2) or (cl_cnt < 2))  then  --   
      begin
        --     
        select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base
         from zsd b
         where b.zs_id = :ida
         order by b.tar_base desc
         into :idb, :ksg, :sum_uslf, :tarif;

         --      
         update zsd b set
          b.ksg = :ksg, 
          b.sum_uslf = :sum_uslf,
          b.kskp = b.kskp_base,
          b.tar_usl = b.tar_base
          where b.id = :idb;

         update zsd b set
          b.ksg = null,
          b.sum_uslf = 0,
          b.kskp = 1,
          b.tar_usl = 0
          where b.id <> :idb and b.zs_id = :ida;
 
         update zs a set
          a.tar_usl = :tarif,
          a.sum_uslf = :sum_uslf,
          a.sum_usl = :sum_uslf,
          a.ksg = :ksg,
          a.kslp = :kskp
          where a.id = :ida;
 
      end else
      begin
        select first 1 b.ksg_base, b.sum_base
        from zs a
         join zsd b on a.id = b.zs_id
         where b.zs_id = :ida and b.ksg is not null and b.ds = a.ds1
         order by b.sum_base desc
         into :ksg, :sum_uslf;

        update zsd d
         set d.tar_usl = d.tar_base,
             d.sum_uslf = d.sum_base,
             d.ksg = d.ksg_base,
             d.kskp = d.kskp_base
         where d.zs_id = :ida;
   
        select coalesce(sum(b.sum_uslf), 0), coalesce(sum(b.tar_base), 0) from zsd b
         join zs a on a.id = b.zs_id
         where b.zs_id = :ida and b.ksg is not null
         into :sum_uslf, :tarif;

        update zs a set
         a.tar_usl = :tarif,
         a.sum_uslf = :sum_uslf,
         a.sum_usl = :sum_uslf,
         a.ksg = :ksg,
         a.kslp = :kskp
         where a.id = :ida;
 
      end

      ---------------------------------------------------------------------------------
      --   2016 
      if (exists(select first 1 1 from zsd b
                  join h_tarif_dializ d on d.code_usl = b.code_usl and b.date_2 between d.bp and d.epv
                  and d.q_u containing :q_u where b.zs_id = :ida) and :y = 2016) then
      begin
         for select d.tarif, b.id
             from zsd b
                  join h_tarif_dializ d on d.code_usl = b.code_usl and d.bp <= :date2 and d.epv >= :date2 and d.q_u containing :q_u
             where b.zs_id = :ida
             into :tarif_usl, :idb
             do
             begin
               update zsd b
               set b.sum_uslf = :tarif_usl,
                   b.tar_usl = :tarif_usl
               where b.id = :idb;

               update zs a set
                  a.tar_usl = iif (coalesce(a.tar_usl,0) = 0, :sum_uslf, a.tar_usl),
                  a.sum_uslf = a.sum_uslf + :tarif_usl,
                  a.sum_usl = a.sum_usl + :tarif_usl
                  where a.id = :ida;
 
               update zs a set
                  a.tar_usl = cast(a.sum_uslf/coalesce(a.k_uslf, 1) as integer)
                  where a.id = :ida;

             end
         exit;
      end

end;

/* Alter (SP_CALC_STAC_2018) */
ALTER PROCEDURE SP_CALC_STAC_2018(IDA INTEGER)
 AS
declare variable KSG type of DM_CHAR_50;
declare variable DS type of DM_DS;
declare variable IDB integer;
declare variable SUM_USLF type of DM_MONEY;
declare variable KSKP numeric(6,6);
declare variable Q_U integer;
declare variable FINE_KOEF type of DM_NUM_3_2;
declare variable TARIF numeric(10,6);
declare variable DATE2 date;
declare variable IS_TRANSFER DM_INT;
declare variable CL_CNT integer;
declare variable ERR_CODE integer;
declare variable K_DOWN DM_NUM_6_2;
declare variable DS_CLASS DM_CHAR_10;
declare variable KZ DM_NUM_2_5;
declare variable KD DM_NUM_2_5;
declare variable KUS DM_NUM_2_5;
declare variable BS DM_NUM_6_2;
declare variable PROF_NUM integer;
declare variable DATE1 date;
declare variable FINE_KOEF_SET_DOCTOR DM_BOOLEAN;
declare variable IS_ROUND_JANAO integer;
declare variable OKATO DM_OKATO;
declare variable DOP_CODE DM_CHAR_40;
begin
  select c.tf_okato
   from zs_hdr h
        join zs z on z.hdr_id = h.id
        join invoice i on i.id = h.name
        join contragents c on c.id = i.contragent_id
   where z.id = :ida
   into :okato;

   if (:okato is  null) then
     okato = (select first 1 c.tf_okato from contragents c where c.type_id = 1);

    if (okato = '71140') then
      is_round_janao = 1;

    update zsd d
      set d.ds_class = (select MKB_CLASS from SP_GET_MKB_CLASS(D.ds))
      where d.zs_id = :ida;

    update zsd d
     set d.ksg = null, 
         d.ksg_base = null,
         d.tar_base = null,
         d.sum_base = null,
         d.kskp_base = null,
         d.sum_uslf = 0,
         d.tar_usl = 0,
         d.comment_local = null
     where d.zs_id = :ida;

    update zs z
     set z.ksg = null,
         z.tar_usl = 0,
         z.sum_usl = 0
     where z.id = :ida;

     cl_cnt = (select count(distinct b.ds_class) from ZSD b where b.ZS_ID = :ida and coalesce(b.code_usl,'') = '');
--     if (cl_cnt is null) then cl_cnt =1;
     is_transfer = (select sum(iif(b.code_usl is null, 1, 0)) from ZSD b where b.ZS_ID = :ida);
     delete from kslp_koef where zs_id = :ida ;

     select a.q_u, a.date_2, coalesce(a.fine_koef_set_doctor,0)
      from zs a
      where a.id = :ida
      into :q_u, :date2, :fine_koef_set_doctor;

     for select sp.KSG, sp.ERR_CODE, b.ds, b.id, iif(:is_round_janao = 1,
                coalesce(bs.tarif * kd.kd * k.k_down * k.kz *
                iif((select 1 from h_ksg_dop d where d.type_num = 1 and a.date_2 between d.bp and d.epv and d.q_u = a.q_u and d.ksg = sp.ksg) IS NULL , lf.kus, 1.0), 0),
                coalesce(bs.tarif * kd.kd * k.k_down * k.kz *
                iif((select 1 from h_ksg_dop d where d.type_num = 1 and a.date_2 between d.bp and d.epv and d.q_u = a.q_u and d.ksg = sp.ksg) IS NULL , lf.kus, 1.0), 0)),
                k.kz, kd.kd,
                iif((select 1 from h_ksg_dop d where d.type_num = 1 and a.date_2 between d.bp and d.epv and d.q_u = a.q_u and d.ksg = sp.ksg) IS NULL , lf.kus, 1.0),
                bs.tarif, k.k_down, k.prof_num, b.date_1, coalesce(b.fine_koef,1)
      from zs a
      join zsd b on a.id = b.zs_id
      join patients p on p.id = a.patient_id
      join lpu_factors lf on lf.q_u = a.q_u and a.date_2 between lf.bp and lf.epv and lf.okato is not distinct from :okato
      join h_tarif_bs bs on bs.q_u = a.q_u and a.date_2 between bs.bp and bs.epv and bs.okato is not distinct from :okato
      join h_tarif_kd kd on a.date_2 between kd.bp and kd.epv and kd.okato is not distinct from :okato
      left join sp_ksg_get(b.ds, p.dr, a.date_2, b.code_usl, p.sex,
                           (select sum(b1.k_uslf) from ZSD b1 where b1.ZS_ID = :ida and b1.ds_class = b.ds_class and b1.code_usl is null), -- -     
                           a.q_u, b.ds2, b.id, b.ksg_criterion,b.ksg_criterion2) sp on 1=1
      left join h_ksg k on k.ksg = sp.ksg and a.date_2 between k.bp and k.epv and k.q_u = a.q_u
      where b.zs_id = :ida
      order by b.code_usl
      into :ksg, :err_code, :ds, :idb, :tarif, :kz, :kd, :kus, :bs, :k_down, :prof_num, :date1, :fine_koef
      do
      begin
        kskp = 1;

        if (:okato = '70000') then
        begin
          select first 1 u.code_1, u.code_2
           from zsd d
                join h_usl u on u.code = d.code_usl and u.payment_type_id = 1 and :date1 between u.datebeg and u.dateend and u.q_u containing :q_u
           where d.id = :idb
          into :ksg, :dop_code;
        end

        if ((q_u = 1) and (err_code is null) and (date2 < '01.01.2019')) then
          kskp = (select KSKP from sp_calc_stac_kskp_2018(:ida, :idb, :ksg, :cl_cnt));

        if ((q_u in (1,3)) and (err_code is null) and (date2 >= '01.01.2019')) then
          kskp = (select KSKP from sp_calc_stac_kskp_2019(:ida, :idb, :ksg, :cl_cnt));

        if (kskp is null) then kskp = 1;

        if (fine_koef_set_doctor = 0) then
          fine_koef = (select FINE_KOEF from sp_calc_stac_fine_2018(:ida, :idb, :ksg, :cl_cnt));

        if (is_round_janao = 1) then
          sum_uslf = cast(cast(tarif * kskp as int) * fine_koef as int);
        else
          sum_uslf = cast(tarif * kskp as numeric(15,2)) * fine_koef;

--        tarif = sum_uslf;

        if (:ksg is not null) then
        begin
            /*$$IBEC$$ if (:code_usl <> '') then
            begin
                select first 1 d.id, iif(:fine_koef_set_doctor = 1, d.fine_koef, :fine_koef)
                from zs z
                     join zsd d on d.zs_id = z.id
                where d.zs_id = :ida and coalesce(d.code_usl,'') = ''
                       and :date1 between d.date_1 and d.date_2
                       and not exists(select id from zsd d2 where d2.zs_id = :ida and coalesce(d2.code_usl,'') = '' and d2.date_1 = d.date_2)
                into :idb, :fine_koef;

                if (is_round_janao = 1) then
                  sum_uslf = cast(cast(tarif * kskp as int) * fine_koef as int);
                else
                  sum_uslf = tarif * kskp * fine_koef;
            end $$IBEC$$*/

--            idb = (select first 1 id from zsd b where b.zs_id = :ida and b.date_1 <= :zsd_date1 and b.date_2 >= :zsd_date2 order by b.date_1 desc, b.date_2 desc);
--            if ((select first 1 d.id from zsd d where d.zs_id = :ida and d.ksg_base = :ksg) is null) then
            update zsd b set
             b.ksg_base = :ksg,
             b.tar_base = iif(:is_round_janao = 1, cast(:tarif*coalesce(:kskp,1) as int), cast(:tarif*coalesce(:kskp,1) as numeric(15,2))),
             b.sum_base = :sum_uslf,
             b.kskp_base = :kskp,
             b.koef_z = :kz, 
             b.koef_d = :kd,
             b.koef_u = :kus,
             b.bs = :bs,
             b.koef_up = :k_down,
             b.reab = iif(:prof_num = 37,1,null),
             b.fine_koef = :fine_koef,
             b.dop_code_usl = iif(:okato = '70000', :dop_code, b.dop_code_usl)
             where b.id = :idb;
         end
      end 
--------------------------------------------------------------------------------
      --    6  + 
      if (q_u = 1) then
       if (exists (select 1 from zsd b where b.zs_id = :ida and ((b.ksg in ('2','st02.001') and b.k_uslf >= 6) or (b.ksg in ('O14.1','O34.2','O36.3','O36.4','O42.2') and b.k_uslf >= 2) ))
          and exists (select 1 from zsd b where b.zs_id = :ida and b.ksg in ('4', '5', 'st02.003', 'st02.004'))) then
          begin
            --    
            select first 1 b.ksg_base, b.ds
            from zs a
             join zsd b on a.id = b.zs_id
             where b.zs_id = :ida and b.ksg in ('4', '5', 'st02.003', 'st02.004')
             into :ksg, :ds;
       
            update zsd d
            set d.tar_usl = d.tar_base,
                d.sum_uslf = d.sum_base,
                d.ksg = d.ksg_base,
                d.kskp = d.kskp_base
            where d.zs_id = :ida;

            --   
            select coalesce(sum(b.sum_uslf), 0) from zsd b where b.zs_id = :ida
             into :sum_uslf;
    
            update zs a set
             a.tar_usl = :tarif,
             a.sum_uslf = :sum_uslf,
             a.sum_usl = :sum_uslf,
             a.ksg = :ksg,
             a.ds1 = :ds,
             a.kslp = :kskp
             where a.id = :ida;

            exit;
          end
--------------------------------------------------------------------------------
      if ((is_transfer < 2) or (cl_cnt < 2))  then  --   
      begin
        --     ,   
        ksg = null;
--        select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base, b.kskp_base, b.koef_z, b.koef_d, b.koef_u, b.bs, b.koef_up,
--             b.fine_koef
--             from zsd b
--             where b.zs_id = :ida and b.ksg_base is not null --and ((:q_u = 1 and b.ksg_base >= '325' and b.ksg_base <= '343') or
--                                                                                                  (:q_u = 3 and b.ksg_base >= '123' and b.ksg_base <= '134'))
--             order by b.code_usl desc, b.sum_base desc
--             into :idb, :ksg, :sum_uslf, :tarif, :kskp, :kz, :kd, :kus, :bs, :k_down, :fine_koef;

        if (:ksg is null)  then
        begin
         select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base, b.date_1,
             b.kskp_base, b.koef_z, b.koef_d, b.koef_u, b.bs, b.koef_up,
             b.fine_koef
             from zsd b
             where b.zs_id = :ida and b.ksg_base is not null
             order by b.code_usl desc, b.sum_base desc
             into :idb, :ksg, :sum_uslf, :tarif, :date1,
                  :kskp, :kz, :kd, :kus, :bs, :k_down, :fine_koef;

         if (((select coalesce(d.code_usl,'') from zsd d where d.id = :idb) <> '')
            and (exists(select d.id from zsd d where d.zs_id = :ida and d.id <> :idb and coalesce(d.code_usl,'') = '' and :date1 between d.date_1 and d.date_2))) then
         select first 1 d.id
             from zsd d
             where d.zs_id = :ida and d.id <> :idb and coalesce(d.code_usl,'') = '' and :date1 between d.date_1 and d.date_2
             order by d.date_1 desc, d.date_2 desc
             into :idb;
        end

         --      
         update zsd b set
             b.ksg = :ksg,
             b.sum_uslf = :sum_uslf,
             b.ksg_base = :ksg,
             b.tar_usl = :tarif,
             b.tar_base = :tarif,
             b.sum_base = :sum_uslf,
             b.kskp_base = :kskp,
             b.koef_z = :kz, 
             b.koef_d = :kd,
             b.koef_u = :kus,
             b.bs = :bs,
             b.koef_up = :k_down,
             b.reab = iif(:prof_num = 37,1,null),
             b.fine_koef = :fine_koef
          where b.id = :idb;

         update zsd b set
             b.ksg = null,
             b.sum_uslf = 0,
             b.kskp = 1,
             b.tar_usl = 0
--             b.ksg_base = null,
--             b.tar_base = null,
--             b.sum_base = 0,
--             b.kskp_base = null,
--             b.koef_z = null,
--             b.koef_d = null,
--             b.koef_u = null,
--             b.bs = null,
--             b.koef_up = null,
--             b.fine_koef = null
          where b.id <> :idb and b.zs_id = :ida;
 
         update zs a set
          a.tar_usl = :tarif,
          a.sum_uslf = :sum_uslf,
          a.sum_usl = :sum_uslf,
          a.ksg = :ksg,
          a.kslp = :kskp
          where a.id = :ida;
 
      end else
      begin
        for select d.ds_class
         from zsd d
         where d.zs_id = :ida
         group by 1
         into :ds_class
         do
         begin
            if (((select count(dc.id) from ksg_dont_choice dc join zsd z on z.ksg_base = dc.ksg_ter or z.ksg_base = dc.ksg_surg
                    where z.zs_id = :ida and z.ds_class = :ds_class and :date2 between dc.bp and dc.epv) > 0) and (:q_u = 1)) then
               --    
            select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base
             from zsd b
             where b.zs_id = :ida and b.ksg_base is not null and b.ds_class = :ds_class and b.code_usl is not null
             order by b.code_usl desc, b.sum_base desc
             into :idb, :ksg, :sum_uslf, :tarif;
            else
               --     
            begin
              select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base, b.date_1,
                 b.kskp_base, b.koef_z, b.koef_d, b.koef_u, b.bs, b.koef_up,
                 b.fine_koef
                 from zsd b
                 where b.zs_id = :ida and b.ksg_base is not null and b.ds_class = :ds_class
                 order by b.code_usl desc, b.sum_base desc
                 into :idb, :ksg, :sum_uslf, :tarif, :date1,
                      :kskp, :kz, :kd, :kus, :bs, :k_down, :fine_koef;
    
             if (((select coalesce(d.code_usl,'') from zsd d where d.id = :idb) <> '')
                and (exists(select d.id from zsd d where d.zs_id = :ida and d.id <> :idb and coalesce(d.code_usl,'') = '' and :date1 between d.date_1 and d.date_2))) then
             select first 1 d.id
                 from zsd d
                 where d.zs_id = :ida and d.id <> :idb and coalesce(d.code_usl,'') = '' and :date1 between d.date_1 and d.date_2
                 into :idb;
            end
    
             --      
             update zsd b set
                 b.ksg = :ksg,
                 b.sum_uslf = :sum_uslf,
                 b.ksg_base = :ksg,
                 b.tar_usl = :tarif,
                 b.sum_base = :sum_uslf,
                 b.kskp_base = :kskp,
                 b.koef_z = :kz, 
                 b.koef_d = :kd,
                 b.koef_u = :kus,
                 b.bs = :bs,
                 b.koef_up = :k_down,
                 b.reab = iif(:prof_num = 37,1,null),
                 b.fine_koef = :fine_koef
              where b.id = :idb;
    
             update zsd b set
                 b.ksg = null,
                 b.sum_uslf = 0,
                 b.kskp = 1,
                 b.tar_usl = 0
--                 b.ksg_base = null,
--                 b.tar_base = null,
--                 b.sum_base = 0,
--                 b.kskp_base = null,
--                 b.koef_z = null,
--                 b.koef_d = null,
--                 b.koef_u = null,
--                 b.bs = null,
--                 b.koef_up = null,
--                 b.fine_koef = null
              where b.id <> :idb and b.zs_id = :ida and b.ds_class = :ds_class;
         end

        select first 1 b.ksg_base, b.sum_base
        from zs a
         join zsd b on a.id = b.zs_id
         where b.zs_id = :ida and b.ksg is not null and b.ds = a.ds1
         order by b.sum_base desc
         into :ksg, :sum_uslf;

--        update zsd d
--         set d.tar_usl = d.tar_base,
--             d.sum_uslf = d.sum_base,
--             d.ksg = d.ksg_base,
--             d.kskp = d.kskp_base
--         where d.zs_id = :ida;
   
        select coalesce(sum(b.sum_uslf), 0), coalesce(sum(b.tar_base), 0)
         from zsd b
         join zs a on a.id = b.zs_id
         where b.zs_id = :ida and b.ksg is not null
         into :sum_uslf, :tarif;

        update zs a set
         a.tar_usl = :tarif,
         a.sum_uslf = :sum_uslf,
         a.sum_usl = :sum_uslf,
         a.ksg = :ksg,
         a.kslp = :kskp
         where a.id = :ida;
 
      end
end;

/* Alter (SP_ZS_SET_ZACHET) */
ALTER PROCEDURE SP_ZS_SET_ZACHET(HDR_ID INTEGER)
 AS
declare variable ZS_ID integer;
declare variable DATE1 DM_DATE;
begin
  for select z.id, z.date_1
      from zs z
      where z.hdr_id = :hdr_id
      into :zs_id, :date1
      do
      begin
        update zsd d
         set d.zachet = 1
         where d.zs_id = :zs_id and d.date_1 < :date1;

        execute procedure SP_CALC_ALL(:ZS_ID);
      end
end;

/* empty dependent procedure body */
/* Clear: SP_ZS_DUBLICATE for: SP_ZSD_DUPLICATE */
ALTER PROCEDURE SP_ZS_DUBLICATE(ZS_ID INTEGER,
NEW_ZS_ID INTEGER)
 AS
 BEGIN EXIT; END;

/* Alter (SP_ZSD_DUPLICATE) */
ALTER PROCEDURE SP_ZSD_DUPLICATE(ZSD_ID INTEGER,
ZS_ID INTEGER = null)
 AS
declare variable NEW_ZSD_ID integer;
declare variable NEW_ONK_USL_ID integer;
declare variable ONK_USL_ID integer;
begin
  new_zsd_id = gen_id(gen_zsd_id,1);

  insert into ZSD (ID, ZS_ID, CODE_PROF, IS_CHIELD, DATE_1, DATE_2, DS, CODE_USL, K_USLF, TAR_USL, SUM_USLF, CODE_SPEC,
                 PHYS_ID, OTD_PROF, SRVPLACE, USL_TYPE, DCOUNT, KSG, PMD_CLOSE, ORIT, MP, DS2, DS3, TOOTH_ID,
                 VID_VME, COMENTU, KSKP, EXTRA_INFO, ZACHET, IS_NO_GET_USL, DS_CLASS, KSG_BASE, SUM_BASE, TAR_BASE,
                 KSKP_BASE, COMMENT_LOCAL, PODR, TARIF_TEST, SUMV_TEST, TOOTH_LIST, VBR, DS1_PR, KSG_CRITERION,
                 P_CEL, DN, PROFIL_K, P_PER, DS_ONK, KSG_CRITERION2, KOEF_Z, KOEF_D, KOEF_U, KOEF_UP, BS, REAB,
                 CODE_SPEC_V021, C_ZAB, FINE_KOEF, DOP_TARIF, DOP_SUM, DOP_CODE_USL, ID_DOP)
  select :new_zsd_id, iif(:zs_id is null, ZS_ID, :zs_id), CODE_PROF, IS_CHIELD, DATE_1, DATE_2, DS, CODE_USL, K_USLF, TAR_USL, SUM_USLF, CODE_SPEC, PHYS_ID,
       OTD_PROF, SRVPLACE, USL_TYPE, DCOUNT, KSG, PMD_CLOSE, ORIT, MP, DS2, DS3, TOOTH_ID, VID_VME, COMENTU, KSKP,
       EXTRA_INFO, ZACHET, IS_NO_GET_USL, DS_CLASS, KSG_BASE, SUM_BASE, TAR_BASE, KSKP_BASE, COMMENT_LOCAL, PODR,
       TARIF_TEST, SUMV_TEST, TOOTH_LIST, VBR, DS1_PR, KSG_CRITERION, P_CEL, DN, PROFIL_K, P_PER, DS_ONK,
       KSG_CRITERION2, KOEF_Z, KOEF_D, KOEF_U, KOEF_UP, BS, REAB, CODE_SPEC_V021, C_ZAB, FINE_KOEF,
       DOP_TARIF, DOP_SUM, DOP_CODE_USL, ID_DOP
  from ZSD z
  where z.id = :zsd_id;

  insert into ZS_DS (DS, DS_TYPE, SECTION, SECTION_ID, PR, IS_TEMP, DN)
    select DS, DS_TYPE, SECTION, :new_zsd_id, PR, IS_TEMP, DN
    from ZS_DS d
    where d.section = 2 and d.section_id = :zsd_id;

  insert into ONK_CONS (PR_CONS, DT_CONS, ZSD_ID)
    select PR_CONS, DT_CONS, :new_zsd_id
    from ONK_CONS c
    where c.zsd_id = :zsd_id;

  insert into ONK_DIAG (ONK_SL_ID, DIAG_TIP, DIAG_RSLT, DIAG_CODE, IS_TEMP, REC_RSLT, DIAG_DATE)
    select :new_zsd_id, DIAG_TIP, DIAG_RSLT, DIAG_CODE, IS_TEMP, REC_RSLT, DIAG_DATE
    from ONK_DIAG c
    where c.onk_sl_id = :zsd_id;

 for select id
     from onk_usl u
     where u.zsd_id = :zsd_id
     into :onk_usl_id
     do
     begin
         new_onk_usl_id = gen_id(gen_onk_usl_id, 1);

         insert into ONK_USL (ID, ZSD_ID, PR_CONS, USL_TIP, HIR_TIP, LEK_TIP_L, LEK_TIP_V, LUCH_TIP, PPTR)
            select :new_onk_usl_id, :new_zsd_id, PR_CONS, USL_TIP, HIR_TIP, LEK_TIP_L, LEK_TIP_V, LUCH_TIP, PPTR
            from ONK_USL c
            where c.id = :onk_usl_id;
        
         insert into ONK_LEK_PR (REGNUM, CODE_SH, ONK_USL_ID, DATE_INJ, TIME_INJ)
            select REGNUM, CODE_SH, :new_onk_usl_id, DATE_INJ, TIME_INJ
            from ONK_LEK_PR c
            where c.onk_usl_id = :onk_usl_id;
     end

  insert into ONK_NAPR (NAPR_DATE, NAPR_V, MET_ISSL, NAPR_USL, ZSD_ID, MO_CODE)
    select NAPR_DATE, NAPR_V, MET_ISSL, NAPR_USL, :new_zsd_id, MO_CODE
    from ONK_NAPR c
    where c.zsd_id = :zsd_id;

  insert into ONK_PROT (ONK_SL_ID, PROT, D_PROT)
    select :new_zsd_id, PROT, D_PROT
    from ONK_PROT c
    where c.onk_sl_id = :zsd_id;

  insert into ONK_SL (ZSD_ID, STAD, ONK_T, ONK_N, ONK_M, MTSTZ, SOD, DS1_T, K_FR, WEI, HEI, BSA)
    select :new_zsd_id, STAD, ONK_T, ONK_N, ONK_M, MTSTZ, SOD, DS1_T, K_FR, WEI, HEI, BSA
    from ONK_SL c
    where c.zsd_id = :zsd_id;
end;

/* Alter (SP_ZSD_LIST_CREATE) */
ALTER PROCEDURE SP_ZSD_LIST_CREATE(ZS_ID INTEGER)
 AS
declare variable TARGET integer;
declare variable DE date;
begin
  target = (select target from zs where id = :zs_id);
  de = (select z.date_2 from zs z where id = :zs_id);

  if (exists (select id from zsd where zs_id = :zs_id)) then
   exit;

  if (target = 9) then
  begin
      insert into zsd(zs_id, code_usl, is_chield, pmd_close, date_1, date_2, sum_uslf, tar_usl, k_uslf, ds, IS_TEMP)
      select z.id, d.code_usl, 0, 0, z.date_1, z.date_1, d.tarif, d.tarif, 1, 'Z00.8', 1
       from zs z
            join patients p on p.id = z.patient_id
            join h_tarif_disp_09 d on d.stage = z.disp_stage and d.age = extract(year from z.date_1) - extract(year from p.dr)
                                      and d.sex = p.sex and z.date_2 between d.bp and d.epv
            join h_usl u on u.code = d.code_usl  and d.bp between u.datebeg and u.dateend
       where z.id = :zs_id and d.code_usl is not null and d.tarif is not null and
             u.target containing '9' and u.q_u containing '2' and z.date_2 between bp and epv;
  end

  if (target in (10,17)) then
  begin
      insert into zsd(zs_id, code_usl, is_chield, pmd_close, date_1, date_2, sum_uslf, tar_usl, k_uslf, ds, IS_TEMP)
      select z.id, d.usl_code, 0, 0, z.date_1, z.date_1, d.tarif, d.tarif, 1, iif(z.age < 3, 'Z00.1', iif(z.age >= 3 and z.age < 15, 'Z00.2', 'Z00.3')), 1
       from zs z
            join patients p on p.id = z.patient_id
            join h_tarif_disp_10 d on d.stage = z.disp_stage and d.sex = p.sex
                                          and z.date_2 between d.bp and d.epv
                                          and z.age between d.y1 and d.y2
       where z.id = :zs_id and d.tarif is not null;
  end

  if (target = 13) then
  begin
      insert into zsd(zs_id, code_usl, is_chield, pmd_close, date_1, date_2, sum_uslf, tar_usl, k_uslf, ds, IS_TEMP)
      select z.id, d.usl_code, 0, 0, z.date_1, z.date_1, d.tarif, d.tarif, 1, iif(z.age < 3, 'Z00.1', iif(z.age >= 3 and z.age < 15, 'Z00.2', 'Z00.3')), 1
       from zs z
            join patients p on p.id = z.patient_id
            join h_tarif_disp_13_17 d on d.target = z.target
                                          and d.stage = z.disp_stage and d.sex = p.sex
                                          and z.date_2 between d.bp and d.epv
                                          and d.age_grp = z.age_grp
       where z.id = :zs_id and d.tarif is not null;
  end

  if (target in (14,15)) then
  begin
      insert into zsd(zs_id, code_usl, is_chield, pmd_close, date_1, date_2, sum_uslf, tar_usl, k_uslf, ds, IS_TEMP)
      select z.id, d.usl_code, 0, 0, z.date_1, z.date_1, d.tarif, d.tarif, 1, iif(z.age < 3, 'Z00.1', iif(z.age >= 3 and z.age < 15, 'Z00.2', 'Z00.3')),1
       from zs z
            join patients p on p.id = z.patient_id
            join h_tarif_disp_14_15 d on d.target = z.target
                                          and d.stage = z.disp_stage and d.sex = p.sex
                                          and z.date_2 between d.bp and d.epv
                                          and d.cat_info = z.cat_info
       where z.id = :zs_id and d.tarif is not null;
  end

  if ((target = 16) and (:de < '01.05.2019')) then
  begin
      insert into zsd(zs_id, code_usl, is_chield, pmd_close, date_1, date_2, sum_uslf, tar_usl, k_uslf, ds, IS_TEMP)
      select z.id, d.code_usl, 0, 0, z.date_1, z.date_1, d.tarif, d.tarif, 1, 'Z00.8', 1
       from zs z
            join patients p on p.id = z.patient_id
            join zs_hdr h on h.id = z.hdr_id
            join h_tarif_disp_16 d on z.date_2 between d.bp and d.epv
                                          and d.sex = p.sex
                                          and d.age_l <= (h.y - extract(year from p.dr)) and d.age_r >= (h.y - extract(year from p.dr))
       where z.id = :zs_id and d.tarif is not null;
  end

  if ((target = 16) and (:de >= '01.05.2019')) then
  begin
      insert into zsd(zs_id, code_usl, is_chield, pmd_close, date_1, date_2, sum_uslf, tar_usl, k_uslf, ds, IS_TEMP)
      select z.id, d.code_usl, 0, 0, z.date_1, z.date_1, d.tarif, d.tarif, 1, 'Z00.8', 1
       from zs z
            join patients p on p.id = z.patient_id
            join zs_hdr h on h.id = z.hdr_id
            join h_tarif_disp_09 d on d.stage = z.disp_stage and d.age = extract(year from z.date_1) - extract(year from p.dr)
                                      and d.sex = p.sex and z.date_2 between d.bp and d.epv
            join h_usl u on u.code = d.code_usl  and d.bp between u.datebeg and u.dateend
       where z.id = :zs_id and d.tarif is not null and
             u.target containing '16' and u.q_u containing '2' and z.date_2 between bp and epv
             and ((u.code <> iif(((extract(year from z.date_1) - extract(year from p.dr)) > 39) and (p.sex = ''), 'B04.001.002.099', '')));
  end

  insert into ZS_DS (DS, DS_TYPE, SECTION, SECTION_ID, PR, IS_TEMP)
    select d.ds, 1, 2, d.id, 0, 1
    from zsd d
    where d.zs_id = :zs_id;

  execute procedure SP_CALC_ALL(:ZS_ID);
end;

/* Restore proc. body: SP_ZS_DUBLICATE */
ALTER PROCEDURE SP_ZS_DUBLICATE(ZS_ID INTEGER,
NEW_ZS_ID INTEGER)
 AS
declare variable ZSD_ID integer;
begin
  insert into ZS (ID, Q_U, MP, ORDER_V, CODE_SPEC, CODE_PROF, OTD_PROF, IS_CHIELD, N_HIST, DATE_1, DATE_2, DS0, DS1, DS2,
                TAR_USL, K_USLF, K_USL, SUM_USLF, SUM_USL, IDSP, TARGET, RESULT, PHYS_ID, MES_CODE, PATIENT_ID, HDR_ID,
                DIRECTION_NUM, DIRECTION_DATE, DH_INFO, DCOUNT, KSG, SMP_BRIG, DS3, CATEGORY, PRZ, DISP_STAGE,
                DISP_WORK_STATE, DISP_RESULT, DISP_H_GROUP, OUTCOME, CAT_INFO, FOR_POM, VID_HMP, METOD_HMP, AGE_GRP,
                CHIELD_WITH_ROP, AGE, REGISTRY_ID, PAYMENT_TYPE_ID, N_HIST_NUM, Q_U_2016, ID_PAC,
                RSLT_D, VNOV_D, NPR_MO, PODR, VNOV_M, COMENTSL, EXTRA_INFO, USL_OK, KSLP, TARIF_TEST, SUMV_TEST, PER,
                VBR, TAL_D, TAL_P, INV, NAZR, NAZ_SP, NAZ_V, NAZ_PMP, NAZ_PK, IDSP_NOT_AUTO, AGE_GRP_NOT_AUTO, USER_ID,
                MSE, BARTHEL_IDX, VB_P, CODE_SPEC_V021, DS_ONK, FINE_KOEF_SET_DOCTOR, DISP)
    select :new_zs_id, Q_U, MP, ORDER_V, CODE_SPEC, CODE_PROF, OTD_PROF, IS_CHIELD, N_HIST, DATE_1, DATE_2, DS0, DS1, DS2, TAR_USL,
           K_USLF, K_USL, SUM_USLF, SUM_USL, IDSP, TARGET, RESULT, PHYS_ID, MES_CODE, PATIENT_ID, HDR_ID, DIRECTION_NUM,
           DIRECTION_DATE, DH_INFO, DCOUNT, KSG, SMP_BRIG, DS3, CATEGORY, PRZ, DISP_STAGE, DISP_WORK_STATE,
           DISP_RESULT, DISP_H_GROUP, OUTCOME, CAT_INFO, FOR_POM, VID_HMP, METOD_HMP, AGE_GRP, CHIELD_WITH_ROP, AGE,
           REGISTRY_ID, PAYMENT_TYPE_ID, N_HIST_NUM, Q_U_2016, ID_PAC, RSLT_D, VNOV_D, NPR_MO, PODR, VNOV_M,
           COMENTSL, EXTRA_INFO, USL_OK, KSLP, TARIF_TEST, SUMV_TEST, PER, VBR, TAL_D, TAL_P, INV, NAZR, NAZ_SP, NAZ_V,
           NAZ_PMP, NAZ_PK, IDSP_NOT_AUTO, AGE_GRP_NOT_AUTO, USER_ID, MSE, BARTHEL_IDX, VB_P, CODE_SPEC_V021, DS_ONK,
           FINE_KOEF_SET_DOCTOR, DISP
    from ZS   
    where id = :zs_id;

    for select d.id
        from zsd d
        where d.zs_id = :zs_id
        into :zsd_id
        do
          execute procedure SP_ZSD_DUPLICATE(:ZSD_ID, :new_zs_id);
end;

/* Alter Procedure... */
/* Alter (SP_ZS_DUBLICATE) */
ALTER PROCEDURE SP_ZS_DUBLICATE(ZS_ID INTEGER,
NEW_ZS_ID INTEGER)
 AS
declare variable ZSD_ID integer;
begin
  insert into ZS (ID, Q_U, MP, ORDER_V, CODE_SPEC, CODE_PROF, OTD_PROF, IS_CHIELD, N_HIST, DATE_1, DATE_2, DS0, DS1, DS2,
                TAR_USL, K_USLF, K_USL, SUM_USLF, SUM_USL, IDSP, TARGET, RESULT, PHYS_ID, MES_CODE, PATIENT_ID, HDR_ID,
                DIRECTION_NUM, DIRECTION_DATE, DH_INFO, DCOUNT, KSG, SMP_BRIG, DS3, CATEGORY, PRZ, DISP_STAGE,
                DISP_WORK_STATE, DISP_RESULT, DISP_H_GROUP, OUTCOME, CAT_INFO, FOR_POM, VID_HMP, METOD_HMP, AGE_GRP,
                CHIELD_WITH_ROP, AGE, REGISTRY_ID, PAYMENT_TYPE_ID, N_HIST_NUM, Q_U_2016, ID_PAC,
                RSLT_D, VNOV_D, NPR_MO, PODR, VNOV_M, COMENTSL, EXTRA_INFO, USL_OK, KSLP, TARIF_TEST, SUMV_TEST, PER,
                VBR, TAL_D, TAL_P, INV, NAZR, NAZ_SP, NAZ_V, NAZ_PMP, NAZ_PK, IDSP_NOT_AUTO, AGE_GRP_NOT_AUTO, USER_ID,
                MSE, BARTHEL_IDX, VB_P, CODE_SPEC_V021, DS_ONK, FINE_KOEF_SET_DOCTOR, DISP)
    select :new_zs_id, Q_U, MP, ORDER_V, CODE_SPEC, CODE_PROF, OTD_PROF, IS_CHIELD, N_HIST, DATE_1, DATE_2, DS0, DS1, DS2, TAR_USL,
           K_USLF, K_USL, SUM_USLF, SUM_USL, IDSP, TARGET, RESULT, PHYS_ID, MES_CODE, PATIENT_ID, HDR_ID, DIRECTION_NUM,
           DIRECTION_DATE, DH_INFO, DCOUNT, KSG, SMP_BRIG, DS3, CATEGORY, PRZ, DISP_STAGE, DISP_WORK_STATE,
           DISP_RESULT, DISP_H_GROUP, OUTCOME, CAT_INFO, FOR_POM, VID_HMP, METOD_HMP, AGE_GRP, CHIELD_WITH_ROP, AGE,
           REGISTRY_ID, PAYMENT_TYPE_ID, N_HIST_NUM, Q_U_2016, ID_PAC, RSLT_D, VNOV_D, NPR_MO, PODR, VNOV_M,
           COMENTSL, EXTRA_INFO, USL_OK, KSLP, TARIF_TEST, SUMV_TEST, PER, VBR, TAL_D, TAL_P, INV, NAZR, NAZ_SP, NAZ_V,
           NAZ_PMP, NAZ_PK, IDSP_NOT_AUTO, AGE_GRP_NOT_AUTO, USER_ID, MSE, BARTHEL_IDX, VB_P, CODE_SPEC_V021, DS_ONK,
           FINE_KOEF_SET_DOCTOR, DISP
    from ZS   
    where id = :zs_id;

    for select d.id
        from zsd d
        where d.zs_id = :zs_id
        into :zsd_id
        do
          execute procedure SP_ZSD_DUPLICATE(:ZSD_ID, :new_zs_id);
end;


