
ALTER PROCEDURE SP_GEN_GUID_ZSD(HDR_ID INTEGER)
 AS
 BEGIN EXIT; END;

/* Empty SP_GEN_IDCASE_N_ZAP for drop ZS(ID_CASE) */
ALTER PROCEDURE SP_GEN_IDCASE_N_ZAP(HDR_ID INTEGER = null,
ZS_ID INTEGER = null,
ID_CASE INTEGER = null,
N_ZAP INTEGER = null,
ID_PAC INTEGER = null)
 AS
 BEGIN EXIT; END;

/* Empty SP_UPDATE_IDCASE for drop ZS(ID_CASE) */
ALTER PROCEDURE SP_UPDATE_IDCASE(HDR_ID INTEGER)
 AS
 BEGIN EXIT; END;

/* Empty SP_UPDATE_IDCASE_AND_N_ZAP for drop ZS(ID_CASE) */
ALTER PROCEDURE SP_UPDATE_IDCASE_AND_N_ZAP(HDR_ID INTEGER)
 AS
 BEGIN EXIT; END;


ALTER PROCEDURE SP_CHECK_OKATO_SMO(INV_ID INTEGER)
 RETURNS(ROWS_UPDATED INTEGER)
 AS
 BEGIN SUSPEND; END;

DROP VIEW REESTR_ZS;

DROP VIEW V_REESTR;

DROP VIEW V_ZS;

DROP VIEW V_ZS_SHORT;

DROP VIEW V_ZSD;

ALTER TRIGGER ZS_BIU0
 AS Declare variable I integer;
BEGIN I = 0; END;


ALTER TABLE ZS ALTER COLUMN ID_CASE TYPE DM_BIGINT;

/* Create view: REESTR_ZS */
CREATE VIEW REESTR_ZS(
ID_ZS_HDR,
NAME_ZS_HDR,
PARENT_ID,
FULL_NAME,
IS_DELETE,
M,
Y,
ID_ZS,
Q_U,
MP,
ORDER_V,
CODE_SPEC,
CODE_PROF,
OTD_PROF,
IS_CHIELD,
N_HIST,
DATE_1,
DATE_2,
DS0,
DS1,
DS2,
TAR_USL,
K_USLF,
K_USL,
SUM_USLF,
SUM_USL,
IDSP,
TARGET,
RESULT,
PHYS_ID,
MES_CODE,
PATIENT_ID,
HDR_ID,
ID_PAT,
SS,
FAM,
IM,
OT,
SEX,
DR,
ADRES,
DOC_TYPE,
DOC_SER,
DOC_NUM,
SER_SP,
NUM_SP,
SMO,
OKATO_SMO,
STATUS,
PS_PRZ,
ID_ROP,
FAM_ROP,
IM_ROP,
OT_ROP,
DR_ROP,
SEX_ROP,
SER_SP_ROP,
NUM_SP_ROP,
PAT_ID,
DH_INFO,
SMP_BRIG,
DS3,
DCOUNT,
KSG,
OKATO_R,
OKATO_L,
UID,
CATEGORY,
DISP_STAGE,
DISP_WORK_STATE,
DISP_RESULT,
DISP_H_GROUP,
PRZ,
ENP,
OUTCOME,
CAT_INFO,
FOR_POM,
VID_HMP,
METOD_HMP,
AGE_GRP,
CHIELD_WITH_ROP,
POLIS_TYPE,
ID_CASE,
SMO_OGRN,
SMO_NAM,
VNOV_M,
VNOV_D,
CONTRAGENT_ID,
LPU_1,
NOVOR,
USL_OK,
PODR,
RSLT_D)
 AS 
select h.ID, h.NAME, h.PARENT_ID, h.FULL_NAME, h.IS_DELETE, h.M, h.Y,
       z.ID, z.Q_U, z.MP, z.ORDER_V, z.CODE_SPEC, z.CODE_PROF, z.OTD_PROF, z.IS_CHIELD, z.N_HIST,
       z.DATE_1, z.DATE_2, z.DS0, z.DS1, z.DS2, z.TAR_USL, z.K_USLF, z.K_USL, z.SUM_USLF,
       z.SUM_USL, z.IDSP, z.TARGET, z.RESULT, z.PHYS_ID, z.MES_CODE, z.PATIENT_ID, z.HDR_ID,
       p.ID, p.SS, p.FAM, p.IM, p.OT, p.SEX, p.DR, p.ADRES, p.DOC_TYPE, p.DOC_SER, p.DOC_NUM,
       p.SER_SP, p.NUM_SP, p.SMO, p.OKATO_SMO, p.STATUS, p.PS_PRZ,
       r.ID, r.FAM, r.IM, r.OT, r.DR, r.SEX, r.SER_SP, r.NUM_SP, r.PAT_ID, z.dh_info,
       z.smp_brig, z.ds3, z.dcount, z.ksg, p.okato_r, p.okato_l, z.uid, z.category,
       Z.disp_stage, z.disp_work_state, z.disp_result, z.disp_h_group, Z.prz, p.enp,z.outcome,
       z.cat_info, z.for_pom, z.vid_hmp, z.metod_hmp, z.age_grp, z.chield_with_rop, p.polis_type, Z.id_case,
       p.smo_ogrn, p.smo_nam, z.vnov_m, z.vnov_d, i.contragent_id, I.lpu, p.novor, Z.usl_ok, Z.podr,
       coalesce(z.rslt_d,0)
from zs_hdr h
left join zs z on z.hdr_id = h.id
left join patients p on p.id = z.patient_id
left join pat_rop r on r.pat_id = p.id
LEFT join invoice i on i.id = h.name
where h.is_delete = 0
;

/* Create view: V_REESTR */
CREATE VIEW V_REESTR(
ID,
Q_U,
MP,
ORDER_V,
CODE_SPEC,
CODE_PROF,
OTD_PROF,
IS_CHIELD,
N_HIST,
DATE_1,
DATE_2,
DS0,
DS1,
DS2,
TAR_USL,
K_USLF,
K_USL,
SUM_USLF,
SUM_USL,
IDSP,
TARGET,
RESULT,
PHYS_ID,
MES_CODE,
PATIENT_ID,
HDR_ID,
DIRECTION_NUM,
DIRECTION_DATE,
DH_INFO,
DCOUNT,
KSG,
SMP_BRIG,
DS3,
UID,
CATEGORY,
PRZ,
DISP_STAGE,
DISP_WORK_STATE,
DISP_RESULT,
DISP_H_GROUP,
OUTCOME,
CAT_INFO,
ID1,
SS,
FAM,
IM,
OT,
SEX,
DR,
ADRES,
DOC_TYPE,
DOC_SER,
DOC_NUM,
SER_SP,
NUM_SP,
SMO,
OKATO_SMO,
STATUS,
PS_PRZ,
IS_PAID,
JOB,
JOB_ADRES,
POST,
PHONES,
OKATO_R,
OKATO_L,
BPLACE,
ENP,
ID2,
NAME,
ID3,
NAME1,
PARENT_ID,
FULL_NAME,
IS_DELETE,
M,
Y,
TEMP_ID,
TABLE_ID,
ID4,
M1,
Y1,
CH_NUM,
CH_DATE,
STATUS_ID,
CONTRAGENT_ID,
IS_MTR,
LPU,
ID5,
ORG_CODE,
SHORT_NAME,
FULL_NAME1,
ADRES1,
OKPO,
INN,
PHONES1,
EMAILS,
WWW,
TYPE_ID,
IS_MES,
OGRN,
BANK,
RS,
KPP,
OKONH,
BIK,
PARENT_ID1,
CONTRACT_NUM,
CONTRACT_DATE)
 AS 
select r.ID, r.Q_U, r.mp, r.ORDER_V, r.CODE_SPEC, r.CODE_PROF, r.OTD_PROF, r.IS_CHIELD, r.N_HIST, r.DATE_1, r.DATE_2,
       r.DS0, r.DS1, r.DS2, r.TAR_USL, r.K_USLF, r.K_USL, r.SUM_USLF, r.SUM_USL, r.IDSP, r.TARGET, r.RESULT, r.PHYS_ID,
       r.MES_CODE, r.PATIENT_ID, r.HDR_ID, r.DIRECTION_NUM, r.DIRECTION_DATE, r.DH_INFO, r.DCOUNT, r.KSG, r.SMP_BRIG,
       r.DS3, r.UID, r.CATEGORY, r.PRZ, r.DISP_STAGE, r.DISP_WORK_STATE, r.DISP_RESULT, r.DISP_H_GROUP, r.OUTCOME,
       r.CAT_INFO, p.ID, p.SS, p.FAM, p.IM, p.OT, p.SEX, p.DR, p.ADRES, p.DOC_TYPE, p.DOC_SER, p.DOC_NUM,
       p.SER_SP, p.NUM_SP, p.SMO, p.OKATO_SMO, p.STATUS, p.PS_PRZ, p.is_paid, p.JOB, p.JOB_ADRES, p.POST, p.PHONES,
       p.OKATO_R, p.OKATO_L, p.BPLACE, p.ENP, ut.id, ut.NAME, h.ID, h.NAME, h.PARENT_ID, h.FULL_NAME, h.IS_DELETE,
       h.M, h.Y, t.TEMP_ID, t.TABLE_ID, i.ID, i.M, i.Y, i.CH_NUM, i.CH_DATE, i.STATUS_ID, i.CONTRAGENT_ID, i.IS_MTR,
       i.LPU, c.ID, c.ORG_CODE, c.SHORT_NAME, c.FULL_NAME, c.ADRES, c.OKPO, c.INN, c.PHONES, c.EMAILS, c.WWW, c.TYPE_ID,
       c.IS_MES, c.OGRN, c.BANK, c.RS, c.KPP, c.OKONH, c.BIK, c.PARENT_ID, c.CONTRACT_NUM, c.CONTRACT_DATE
          from zs r
          left join patients p on p.id=r.patient_id
          left join h_q_u ut on ut.id = r.q_u
          left join zs_hdr h on h.id = r.hdr_id
          left join sys$temp_id t on t.temp_id = h.id
          left join invoice i on i.id = h.name
          left join contragents c on c.org_code = i.lpu                                                                                                               
where h.is_delete = 0    and t.temp_id is not null
order by h.id
;

/* Create view: V_ZS */
CREATE VIEW V_ZS(
ID,
Q_U,
MP,
ORDER_V,
CODE_SPEC,
CODE_PROF,
OTD_PROF,
IS_CHIELD,
N_HIST,
DATE_1,
DATE_2,
DS0,
DS1,
DS2,
TAR_USL,
K_USLF,
K_USL,
IDSP,
TARGET,
RESULT,
PATIENT_ID,
FAM,
IM,
OT,
Q_U_NAME,
TARGET_NAME,
SUM_USLF,
HDR_ID,
DIRECTION_NUM,
DIRECTION_DATE,
DH_INFO,
MES_CODE,
SMP_BRIG,
DS3,
DCOUNT,
UID,
PHYS_ID,
CATEGORY,
DISP_STAGE,
DISP_WORK_STATE,
DISP_RESULT,
DISP_H_GROUP,
OUTCOME,
KSG,
CAT_INFO,
IDSP_NAME,
MP_NAME,
ORDER_V_NAME,
DH_INFO_NAME,
CODE_SPEC_NAME,
CODE_PROF_NAME,
IS_CHIELD_NAME,
SMP_BRIG_NAME,
RESULT_NAME,
OUTCOME_NAME,
FOR_POM,
VID_HMP,
METOD_HMP,
AGE_GRP,
CHIELD_WITH_ROP,
FOR_POM_NAME,
REGISTRY_ID,
PAYMENT_TYPE_ID,
PAYMENT_NAME,
REGISTRY_NAME,
SUM_USL,
DOCTOR_FIO,
DOCTOR_COD,
NUM_SP,
IDCASE,
Q_U_2016,
HAS_ERRORS,
CODE_MES1,
COMENTSL,
SMO,
OKATO_SMO,
OKATO_G,
OKATO_P,
SUM_OPL,
N_ZAP,
ZSP_VPOLIS,
ZSP_SPOLIS,
ZSP_NPOLIS,
ZSP_POLIS_BP,
ZSP_POLIS_EP,
ZSP_SMO_OGRN,
ZSP_SMO_CODE,
ZSP_ENP,
ZSP_SEND_DATE,
ZSP_RESP_DATE,
AGE,
DR,
DOC_SER,
DOC_NUM,
SEX,
PODR,
KSLP,
REG_DATE,
AGE_NAME,
M,
Y,
CH_NUM,
INV_STATE,
KSG_NUM,
KSG_PROF_NUM,
NPR_MO,
PER,
VBR,
TAL_D,
TAL_P,
INV,
RSLT_D,
NAZR,
NAZ_SP,
NAZ_V,
NAZ_PMP,
NAZ_PK,
IDSP_NOT_AUTO,
AGE_GRP_NOT_AUTO,
USER_ID,
USER_FIO,
MSE,
BARTHEL_IDX,
CODE_SPEC_V021,
ID_PAC,
DISP,
P_CEL,
C_ZAB,
KSG_CRITERION,
PR_NOV,
MCOD,
PR_DATE_1,
PR_DATE_2,
DN,
JOB_NAME,
LPU,
SET_USL_AUTO,
PROFIL_K,
P_PER_NAME)
 AS 
select z.id,
       z.q_u,
       z.mp,
       z.order_v,
       z.code_spec,
       z.code_prof,
       z.otd_prof,
       z.is_chield,
       z.n_hist,
       z.date_1,
       z.date_2,
       z.ds0,
       z.ds1,
       z.ds2,
       z.tar_usl,
       z.k_uslf,
       z.k_usl,
       z.idsp,
       z.target,
       z.result,  
       z.patient_id,
       p.fam,
       p.im,
       p.ot,
       q_u.name as q_u_name,
       t.name as target_name,
       z.sum_uslf,
       z.hdr_id,
       z.direction_num,
       z.direction_date,
       z.dh_info as dh_info,
       z.mes_code,
       z.smp_brig,
       z.ds3,
       Z.DCOUNT,
       z.uid,
       z.phys_id,
       z.category,
       z.disp_stage,
       z.disp_work_state,
       z.disp_result,
       z.disp_h_group,
       z.outcome,
       z.ksg,
       z.cat_info,
       i.name as idsp_name,
       m.name as mp_name,
       o.name as order_v_name,
       dh.name as dh_info_name,
       iif(z.date_2 >= '01.05.2018', (select name from h_spec_v021 where code = z.code_spec_v021), (select name from h_spec_v015 where code = z.code_spec)) as code_spec_name,
       co.name as code_prof_name,
       iif(z.is_chield = 1, ' ', '') as is_chield_name,
       sb.name as smp_brig_name,
       r.name as result_name,
       oc.name as outcome_name,
       z.for_pom,
       z.vid_hmp,
       z.metod_hmp,
       z.age_grp,
       z.chield_with_rop,
       fp.name,
       z.registry_id,
       Z.payment_type_id,
       pt.name,
       reg.name,
       z.sum_usl,
       df.fio,
       DF.pcod,
       z.npolis,  --iif(z.payment_type_id <> 2, p.num_sp, (select ins.ser || ' ' || ins.num from patients_insurance ins where ins.patients_id = p.id and z.date_1 between ins.db and ins.de)),
       z.id_case,
       z.q_u_2016,
       0,--(select first 1 1 from error_list_local err where err.reestr_hdr_id = z.hdr_id and err.uid = z.uid),
       z.mes_code,
       z.comentsl,
       z.smo,
       p.okato_smo,
       p.okato_l,
       p.okato_r,
       z.sum_usl, --(select sum(pi.sum_opl) from patients_invoice pi where pi.zs_id = z.id),
       z.n_zap n_zap,
       zpr.vpolis,
       zpr.spolis,
       zpr.npolis,
       zpr.polis_bp,
       zpr.polis_ep,
       zpr.smo_ogrn,
       zpr.smo_code,
       zpr.enp,
       zp.send_date,
       zpr.resp_date,
       z.age,
       p.dr,
       p.doc_ser,
       p.doc_num,
       p.sex,
       z.podr,
       z.kslp,
       reg.reg_date,
       cast(floor(z.age) as varchar(3)) || '  ' ||
            cast(iif(extract(day from z.date_1) < extract(day from p.dr),
                 iif(extract(month from z.date_1) > extract(month from p.dr), extract(month from z.date_1) - extract(month from p.dr),
                             iif(extract(month from z.date_1) < extract(month from p.dr), 12 - extract(month from p.dr) + extract(month from z.date_1) - 1,
                                 11)),
                 iif(extract(month from z.date_1) > extract(month from p.dr), extract(month from z.date_1) - extract(month from p.dr),
                             iif(extract(month from z.date_1) < extract(month from p.dr), 12 - extract(month from p.dr) + extract(month from z.date_1),
                                   0))) as varchar(2)) || ' ',
       h.m,
       h.y, 
       h.full_name,
       coalesce(inv.status_id,0),
       ksg.ksg_name,
       ksg.prof_name,
       z.npr_mo,
       z.per,
       z.vbr,
       z.tal_d,
       z.tal_p,
       z.inv,
       Z.rslt_d,
       z.nazr,
       z.naz_sp,
       z.naz_v,
       z.naz_pmp,
       z.naz_pk,
       z.idsp_not_auto,
       Z.age_grp_not_auto,
       z.user_id,
       s.fio,
       z.mse,
       z.barthel_idx ,
       z.code_spec_v021,
       z.id_pac,
       Z.disp,
       z.p_cel,
       z.c_zab,
       z.ksg_criterion,
       z.pr_nov,
       z.mcod, 
       z.pr_date_1,
       z.pr_date_2,
       z.dn,
       contr.short_name,
       inv.lpu,
       z.set_usl_auto,
       z.profil_k,
       pp.name
from zs z
join patients p on p.id = z.patient_id
join zs_hdr h on h.id = z.hdr_id
left join invoice inv on inv.id = h.name
left join h_q_u q_u on q_u.id = z.q_u
left join h_target t on t.id = z.target
left join h_idsp i on i.id = z.idsp
left join h_mp m on m.code = z.mp
left join h_order_v o on o.id = z.order_v
left join h_dh_info dh on dh.id = z.dh_info
left join h_spec_v015 cs on cs.code = z.code_spec
left join h_code_otd co on co.code = z.code_prof
left join h_smp_brig sb on sb.id = z.smp_brig
left join h_result r on r.code = z.result
left join h_outcome oc on oc.code = z.outcome
left join h_for_pom fp on fp.code = z.for_pom
left join h_payment_type pt on pt.id = z.payment_type_id
left join v_registry reg on reg.id = z.registry_id
left join doctors_fio df on df.id = z.phys_id
left join zsp zp on zp.zs_id = z.id
left join zsp_resp zpr on zpr.zsp_id = zp.id
left join h_ksg ksg on (cast(ksg.ksg as varchar(50))) = z.ksg and z.q_u = ksg.q_u and z.date_2 between ksg.bp and ksg.epv
left join users s on s.id = z.user_id
left join contragents contr on contr.id = p.job_id
left join h_p_per pp on pp.code = z.p_per and z.date_2 between pp.datebeg and pp.epv
where h.is_delete <> 1
;

/* Create view: V_ZS_SHORT */
CREATE VIEW V_ZS_SHORT(
ID,
CONCATENATION)
 AS 
select z.id, z.date_1 || ' - ' || z.date_2 || ' (' || z.ds1 || ')   ' || z.sum_uslf
from zs z
;

/* Create view: V_ZSD */
CREATE VIEW V_ZSD(
ID,
ZS_ID,
DATE_1,
DATE_2,
CODE_SPEC,
CODE_PROF,
USL_TYPE,
OTD_PROF,
IS_CHIELD,
DS,
DS2,
SRVPLACE,
CODE_USL,
K_USLF,
PHYS_ID,
MES_CODE,
FIO,
SPEC_NAME,
SRVPLACE1,
DCOUNT,
KSG,
PCOD,
TAR_USL,
PMD_CLOSE,
SUM_USLF,
ORIT,
MP,
USL_NAME,
Q_U,
TARGET,
DISP_STAGE,
DATE_1_ZS,
TOOTH,
ZACHET,
IS_NO_GET_USL,
KSG_BASE,
SUM_BASE,
TAR_BASE,
KSKP_BASE,
COMMENT_LOCAL,
PODR,
TOOTH_LIST,
PROF_NAME,
FAM,
IM,
OT,
DR,
PHONES,
EMAIL,
Q_U_NAME,
KSG_CRITERION,
ZSD_ID,
P_CEL,
DN,
PROFIL_K,
P_PER,
DS_ONK,
KSG_CRITERION2,
CODE_SPEC_V021,
SER_SP,
NUM_SP,
C_ZAB,
FINE_KOEF_SET_DOCTOR,
DOP_TARIF,
DOP_SUM,
DOP_CODE_USL,
INVOICE_NAME,
VID_VME,
ZACHET_STAC,
KOEF_Z,
KOEF_D,
KOEF_U,
FINE_KOEF,
KSLP,
KOEF_UP,
KSG_SET_DOCTOR)
 AS 
select zz.ID, zz.zs_id, zz.DATE_1, zz.DATE_2, iif(z.date_2 >= '01.05.2018', zz.code_spec_v021, zz.code_spec), zz.CODE_prof, zz.usl_type,
       zz.OTD_PROF, zz.IS_CHIELD,
       zz.DS, zz.DS2, zz.SRVPLACE, zz.CODE_USL, zz.K_USLF, 
       zz.PHYS_ID, z.mes_code, 
       iif(zz.phys_id = '', '', (select fio from doctors_fio where id = zz.phys_id)) as fio,
       iif(z.date_2 >= '01.05.2018', (select name from h_spec_v021 where code = zz.code_spec_v021), (select name from h_spec_v015 where code = zz.code_spec)) as spec_name, pl.name as srvplace,
       zz.dcount,zz.ksg, iif(zz.phys_id = '', '', (select pcod from doctors_fio where id = zz.phys_id)) as pcod,
       zz.tar_usl, coalesce(zz.pmd_close,0), zz.sum_uslf, zz.orit, zz.mp,
       (select first 1 name from h_usl u where u.code = zz.code_usl
        and u.q_u containing cast(z.q_u as varchar(1)) and u.payment_type_id = z.payment_type_id
        and z.date_1 between u.datebeg and u.dateend),
       z.q_u, z.target, z.disp_stage, z.date_1, zz.tooth_id, coalesce(zz.zachet,0), coalesce(ZZ.is_no_get_usl,0),
       zz.ksg_base, zz.sum_base, zz.tar_base, zz.kskp_base, zz.comment_local, zz.podr,
       iif((coalesce(zz.tooth_id,0) = 0 or coalesce(zz.tooth_list,'')='') and z.q_u = 4, zz.tooth_id, zz.tooth_list),
       o.name, p.fam, p.im, p.ot, p.dr, p.phones, p.email, q.name, zz.ksg_criterion, zz.zsd_id,
       zz.p_cel, zz.dn, zz.profil_k, zz.p_per, zz.ds_onk, zz.ksg_criterion2, zz.code_spec_v021,
       p.ser_sp, p.num_sp, zz.c_zab, z.fine_koef_set_doctor, zz.dop_tarif, zz.dop_sum, zz.dop_code_usl, h.full_name,
       zz.vid_vme, zz.zachet_stac, zz.koef_z, zz.koef_d, zz.koef_u, zz.fine_koef, zz.kskp, zz.koef_up,
       zz.ksg_set_doctor
from ZSd zz
     left join zs z on z.id = zz.zs_id
     join zs_hdr h on h.id = z.hdr_id
     left join patients p on p.id = z.patient_id
--     left join h_spec_v015 cs on cs.code = zz.code_spec
--     left join h_spec_v021 cs2 on cs2.code = zz.code_spec_v021
     left join h_srvplace pl on pl.id = zz.srvplace
     left join h_code_otd o on o.code = zz.code_prof
     left join h_q_u q on q.id = z.q_u
where h.is_delete <> 1
;

ALTER PROCEDURE SP_CHECK_OKATO_SMO(INV_ID INTEGER)
 RETURNS(ROWS_UPDATED INTEGER)
 AS
declare variable PAT_ID integer;
declare variable OKATO type of DM_OKATO;
begin
     rows_updated = 0;

     for select z.id_pat, h.okato from REESTR_ZS z
      join h_smo h on h.code = z.smo
      where z.id_zs_hdr = :inv_id and coalesce(z.okato_smo, '') = ''
      into :pat_id, :okato
      do
      begin
       update patients p set
        p.okato_smo = :okato
        where p.id = :pat_id;
       rows_updated = rows_updated + 1;
      end

      suspend;
end;

/* Alter (SP_GEN_GUID_ZSD) */
ALTER PROCEDURE SP_GEN_GUID_ZSD(HDR_ID INTEGER)
 AS
declare variable PAT_ID integer;
declare variable ZID integer;
declare variable I integer;
begin
  i = 1; -- N_ZAP  1   
  for select id, z.patient_id
      from zs z
      where hdr_id = :hdr_id
      into :zid, :pat_id
      do
      begin
        update zs
         set n_zap = :i,
             id_case = :i
         where id = :zid;
        i = i + 1;
        update zsd d
         set d.guid_id = uuid_to_char(gen_uuid())
         where d.zs_id = :zid and d.guid_id is null;
        update zsd d
         set d.guid_id_usl = uuid_to_char(gen_uuid())
         where d.zs_id = :zid and d.guid_id_usl is null;
        update zsd d
         set d.id_dop = gen_id(gen_zsd_id,1)
         where d.zs_id = :zid and d.id_dop is null;
        update zs z2
         set z2.guid_id = uuid_to_char(gen_uuid())
         where z2.id = :zid and z2.guid_id is null;
        update patients p
         set p.guid_id = uuid_to_char(gen_uuid())
         where p.id = :pat_id and p.guid_id is null;
      end
end;

/* Alter (SP_GEN_IDCASE_N_ZAP) */
ALTER PROCEDURE SP_GEN_IDCASE_N_ZAP(HDR_ID INTEGER = null,
ZS_ID INTEGER = null,
ID_CASE INTEGER = null,
N_ZAP INTEGER = null,
ID_PAC INTEGER = null)
 AS
begin
  if (:id_case is null and :n_zap is null and :id_pac is null) then
    exit;

  if (:id_case is not null) then
  begin
    if (:zs_id is not null) then
      update zs z
       set z.id_case = z.id
       where z.id = :zs_id;
    else
    if (:hdr_id is not null) then
      update zs z
       set z.id_case = z.id
       where z.hdr_id = :hdr_id;
  end
  else
  if (:n_zap is not null) then
  begin
    if (:zs_id is not null) then
      update zs z
       set z.n_zap = z.id
       where z.id = :zs_id;
    else
    if (:hdr_id is not null) then
      update zs z
       set z.n_zap = z.id
       where z.hdr_id = :hdr_id;
  end
  else
  if (:id_pac is not null) then
  begin
    if (:zs_id is not null) then
      update zs z
       set z.id_pac = z.id
       where z.id = :zs_id;
    else
    if (:hdr_id is not null) then
      update zs z
       set z.id_pac = z.id
       where z.hdr_id = :hdr_id;
  end
end;

/* Alter (SP_UPDATE_IDCASE) */
ALTER PROCEDURE SP_UPDATE_IDCASE(HDR_ID INTEGER)
 AS
declare variable Z_ID integer;
declare variable IDCASE integer;
begin
  update zs z
    set z.id_case = ID
    where z.hdr_id = :hdr_id;

  for select h.id
    from zs_hdr h
    where h.parent_id = :hdr_id
    into :z_id
    do
    begin
        update zs z
        set z.id_case = ID
        where z.hdr_id = :z_id;
    end
end;

/* Alter (SP_UPDATE_IDCASE_AND_N_ZAP) */
ALTER PROCEDURE SP_UPDATE_IDCASE_AND_N_ZAP(HDR_ID INTEGER)
 AS
begin
  update zs z
   set z.id_case = z.id
   where z.hdr_id = :hdr_id and z.id_case is null;
  update zs z
   set z.n_zap = z.id
   where z.hdr_id = :hdr_id and z.id_case is null;
  update zs z
   set z.id_pac = z.id
   where z.hdr_id = :hdr_id and z.id_pac is null;
end;

/* Altering existing trigger... */
ALTER TRIGGER ZS_BIU0
AS
declare variable hdr integer;
declare variable dr date;
begin
  select p.dr from patients p where p.id = new.patient_id
  into :dr;
  new.age = ((new.date_1 - :dr)/365.25);

  if (new.n_zap is null) then
    new.n_zap = new.id;

  if (new.id_case is null) then
    new.id_case = new.id;

  if (new.id_pac is null) then
    new.id_pac = new.id;

  if (new.payment_type_id is null) then
    new.payment_type_id = 1;

  if (bin_and(new.extra_info, 1) = 1) then
    new.chield_with_rop = 1;

  if (new.date_1 is null) then
  begin
    new.date_1 = current_date;
    new.date_2 = current_date;
  end

  new.spolis = (select first 1 i.ser from patients_insurance i where i.patients_id = new.patient_id and i.type_id = new.payment_type_id and i.db <= new.date_2 and coalesce(i.de,'31.12.2999') >= new.date_2);
  new.npolis = (select first 1 i.num from patients_insurance i where i.patients_id = new.patient_id and i.type_id = new.payment_type_id and i.db <= new.date_2 and coalesce(i.de,'31.12.2999') >= new.date_2);
  new.smo = (select first 1 i.smo from patients_insurance i where i.patients_id = new.patient_id and i.type_id = new.payment_type_id and i.db <= new.date_2 and coalesce(i.de,'31.12.2999') >= new.date_2);

  if (new.hdr_id is null) then
  begin
    hdr = (select id from zs_hdr h where h.y = extract(year from new.date_2) and h.m = extract(month from new.date_2)
         and h.name = h.m and is_delete = 0);

    if (hdr is not null) then
      new.hdr_id = hdr;
    else
    begin
      execute procedure ADD_PERIOD_HDR(extract(month from new.date_2), extract(year from new.date_2),
                                       (select M2 from SP_MONTH_TO_STRING(extract(month from new.date_2))),
                                       cast(extract(year from new.date_2) as varchar(4))) ;
      hdr = (select id from zs_hdr h where h.y = extract(year from new.date_2) and h.m = extract(month from new.date_2));
      new.hdr_id = :hdr;
    end
  end

  if ((new.n_hist is null) or (new.n_hist = '')) then
  begin
--    new.n_hist_num = (select max(coalesce(n_hist_num,0)) from zs z where z.patient_id = new.patient_id) + 1;
    new.n_hist = cast(gen_id(gen_nhist, 1) as varchar(50));
  end

  if (new.is_chield is null) then
    new.is_chield = 0;

  if ((new.q_u_2016 is not null) and (new.q_u is null)) then
  begin
      if (new.q_u_2016 = 4 and extract(year from new.date_2) > 2015 ) then
        new.q_u = 5;
      else
      if (new.q_u_2016 = 5 and extract(year from new.date_2) > 2015 ) then
        new.q_u = 4;
      else
      if (new.q_u_2016 = 2 and extract(year from new.date_2) > 2015 ) then
        new.q_u = 3;
      else
      if (new.q_u_2016 = 3 and extract(year from new.date_2) > 2015 ) then
      begin
       if (new.idsp = 9) then
       begin
        new.q_u = 4;
        new.q_u_2016 = 5;
       end
       else
        new.q_u = 2;
      end
      else new.q_u = 1;
  end
  else
  if ((new.q_u is not null)) then
  begin
      if (new.q_u = 4 and extract(year from new.date_2) > 2015 ) then
        new.q_u_2016 = 5;
      else
      if (new.q_u = 5 and extract(year from new.date_2) > 2015 ) then
        new.q_u_2016 = 4;
      else
      if (new.q_u = 2 and extract(year from new.date_2) > 2015 ) then
        new.q_u_2016 = 3;
      else
      if (new.q_u = 3 and extract(year from new.date_2) > 2015 ) then
        new.q_u_2016 = 2;
      else new.q_u_2016 = 1;
  end

  if (new.target in (9,10,11,12,13,14,15,16,17)) then
  begin
    if (new.disp_h_group is null) then
    begin
      new.disp_h_group = case
                           when (new.rslt_d in (1)) then '1'
                           when (new.rslt_d in (2)) then '2'
                           when (new.rslt_d in (3)) then '3'
                           when (new.rslt_d in (31)) then '3'
                           when (new.rslt_d in (32)) then '3'
                           when (new.rslt_d in (4)) then '4'
                           when (new.rslt_d in (5)) then '5'
                           when (new.rslt_d in (11)) then '1'
                           when (new.rslt_d in (12)) then '2'
                           when (new.rslt_d in (14)) then '3'
                           when (new.rslt_d in (15)) then '3'
                         end;
    end
  end
  
  if (not inserting) then
  begin
  if (new.q_u = 1) then
    new.k_uslf = iif(new.date_1 = new.date_2, 1, new.date_2 - new.date_1);
    else
    if (new.q_u = 3) then
    begin
      if (coalesce(new.ksg,'') = '') then
        new.k_uslf = (select sum(d.k_uslf) from zsd d where d.zs_id = new.id and coalesce(d.ksg,'') = '');
      else
        new.k_uslf = (select max(d.k_uslf) from zsd d where d.zs_id = new.id and coalesce(d.ksg,'') <> '');
--        iif(new.date_1 = new.date_2, 1, new.date_2 - new.date_1 + 1);
    end
      else
      if (new.q_u in (4,5)) then
        new.k_uslf = (select sum(d.k_uslf) from zsd d where d.zs_id = new.id);
        else
        if (new.q_u = 2 and new.target in (9,10,13,16,17)) then
          new.k_uslf = (select sum(d.k_uslf)
                        from zsd d left join h_usl u on u.code = d.code_usl
                                                        and u.q_u containing new.q_u
                                                        and new.date_1 between u.datebeg and u.dateend
                                                        and u.payment_type_id = new.payment_type_id
                        where d.zs_id = new.id and coalesce(u.is_usl,0) <> 1);
        else
        if (new.q_u = 2 and new.target not in (9,10,13,16,17)) then
          new.k_uslf = (select sum(d.k_uslf)
                        from zsd d
                        where d.zs_id = new.id);
  end

  if (coalesce(new.idsp_not_auto,0) = 0) then
  new.idsp = case
             when (new.q_u = 1) then 33
             when (new.q_u = 3) then 33
             when (new.q_u = 2) and exists(select first 1 id from zsd d where d.zs_id = new.id and
                                                  ((coalesce(d.code_usl,'') starting 'A06')
                                                  or (coalesce(d.code_usl,'') starting 'A05')
                                                  or (coalesce(d.code_usl,'') starting 'A04')
                                                  or (coalesce(d.code_usl,'') starting 'A03')
                                                  or (coalesce(d.code_usl,'') starting 'A08')
                                                  or (coalesce(d.code_usl,'') starting 'A27')
                                                  or (coalesce(d.code_usl,'') starting 'A07'))) then 28
             when (new.q_u = 5) and exists(select first 1 id from zsd d where d.zs_id = new.id and coalesce(d.code_usl,'') <> '') then 28
             when (new.q_u = 2) and (new.target < 9) and new.k_uslf = 1 then 29
             when (new.q_u = 2) and (new.target < 9) and (new.for_pom = 3) and new.k_uslf > 1 then 30
             when (new.q_u = 2) and (new.target in (9,10,17,13,14,15,16)) then 30
             when (new.q_u = 2) and (new.target in (21,22,23)) then 28
             when (new.q_u = 5) then 36
             when (new.q_u = 4) and (new.target < 9) and new.dcount = 1 then 29
             when (new.q_u = 4) and (new.target < 9) and (new.for_pom = 3) and new.dcount > 1 then 30
             end;

  dr = (select dr from patients where id = new.patient_id);

  if ((coalesce(new.age_grp_not_auto,0) = 0) and (new.target = 13)) then
    new.age_grp = (select AGE_GRP from SP_CALC_AGE_GRP(:dr, new.date_1));
             
  if (new.chield_with_rop = 1) then
    new.extra_info = 1;
  if (new.extra_info = 1) then
    new.chield_with_rop = 1;

  new.usl_ok = case
               when (new.q_u = 1) then 1
               when (new.q_u = 2) then 3
               when (new.q_u = 3) then 2
               when (new.q_u = 5) then 4
               when (new.q_u = 4) then 3
               end;
end;
